#INCLUDE "PROTHEUS.CH"
#INCLUDE "CSAR010.CH"

/*


Ŀ
Funo       CSAR010   Autor  Emerson Grassi Rocha   Data   22/06/06  
Ĵ
Descrio    Relatorio de Graduacao de Fatores (Personalizavel)           
Ĵ
Sintaxe      CSAR010(void)                                                
Ĵ
Parametros                                                                
Ĵ
 Uso         CSAR010	 	                                              
Ĵ
           ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.               
Ĵ
Programador    Data      BOPS   Motivo da Alteracao                     
Ĵ
Emerson Grassi28/09/2006100288Relatorio convertido para o formato perso-
Tania 	                     nalizavel, para o release 4.              
Luiz Gustavo  |30/01/2007MelhorRetiradas funcoes de ajuste de dicionario.
Leandro Dr.   01/04/2009|005878Alteracao no tamanho do relatorio para "M"
                        |      no R3.                                    
Mauricio MR   05/06/09  14096/Ajustada a referencia ao alias da query   
                        2009  para impressao correta da descricao deta- 
                              lhada do fator.                           
ٱ

Ŀ
Programador   Data      FNC              Motivo da Alteracao                      
ĳ
Rogerio R.   29/07/200900000018278/2009Compatibilizacao dos fontes para aumento do
                                       campo filial e gesto corporativa.         
			    		   	            										     
Fco Junior   23/10/200900000025338/2009Compatibilizao com V. Corporativa 	     
Luciana S.   10/08/201100000016958/2011Ajuste na exibicao do Titulo Fator do      
                                       relatorio.                                 
ٱ

*/
Function CSAR010()
Local oReport
Local aArea := GetArea()


If FindFunction("TRepInUse") .And. TRepInUse()	//Verifica se relatorio personalizal esta disponivel
	//Ŀ
	// Verifica as perguntas selecionadas                           
	//
	  
	pergunte("CS010R",.F.)
	oReport := ReportDef()
	oReport:PrintDialog()	
Else       
	CSAR010R3()	
EndIf  

RestArea( aArea )

Return

/*

Ŀ
Funo    ReportDef()  Autor  Emerson Grassi Rocha Data  22/06/06 
Ĵ
Descrio Definicao do Componente de Impressao do Relatorio           
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function ReportDef()

Local oReport
Local oSection1
Local oSection2         
Local cAliasQry := "SQ0"

#IFDEF TOP
	cAliasQry := GetNextAlias()
#ENDIF 
//Ŀ
//Criacao do componente de impressao                                      
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
oReport:=TReport():New("CSAR010",STR0007,"CS010R",{|oReport| PrintReport(oReport,cAliasQry)},STR0001+" "+STR0002+" "+STR0003)	//"RELACAO DE GRADUACAO DE FATORES "###"Relao de Graduao de Fatores"###"Ser impresso de acordo com os parametros solicitados pelo"###"usuario."

oReport:SetTotalInLine(.F.) //Totaliza em linha

//Ŀ
//Criacao da celulas da secao do relatorio                                
//TRCell():New                                                            
//ExpO1 : Objeto TSection que a secao pertence                            
//ExpC2 : Nome da celula do relatrio. O SX3 ser consultado              
//ExpC3 : Nome da tabela de referencia da celula                          
//ExpC4 : Titulo da celula                                                
//        Default : X3Titulo()                                            
//ExpC5 : Picture                                                         
//        Default : X3_PICTURE                                            
//ExpC6 : Tamanho                                                         
//        Default : X3_TAMANHO                                            
//ExpL7 : Informe se o tamanho esta em pixel                              
//        Default : False                                                 
//ExpB8 : Bloco de cdigo para impressao.                                 
//        Default : ExpC2                                                 
//

//Ŀ
// Secao de Grupo			  
// 
oSection1 := TRSection():New(oReport,STR0008,{"SQ0"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//"RELACAO DE GRADUACAO DE FATORES "
oSection1:SetTotalInLine(.F.)     
TRCell():New(oSection1,"Q0_GRUPO","SQ0")		//Codigo do Grupo
TRCell():New(oSection1,"Q0_DESCRIC","SQ0","")	//Descricao do Grupo  

//Ŀ
// Secao de Fator			  
//
oSection2 := TRSection():New(oSection1,STR0009,{"SQ1"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//Fatores de Avaliacao
oSection2:SetTotalInLine(.F.) 
TRCell():New(oSection2,"Q1_FATOR","SQ1",,,10,.T.) 											//Codigo do Fator
TRCell():New(oSection2,"Q1_DESCSUM","SQ1")											//Descricao do Fator
#IFDEF TOP
	TRCell():New(oSection2,"Q1_MEMO1","SQ1",,,,,{|| MSMM((cAliasQry)->Q1_DESCDET,,,,3) })		//Descricao Detalhada   
#ELSE	
	TRCell():New(oSection2,"Q1_MEMO1","SQ1",,,,,{|| MSMM(SQ1->Q1_DESCDET,,,,3) })		//Descricao Detalhada   
#ENDIF
oSection2:Cell("Q1_MEMO1"):SetLineBreak()

//Ŀ
// Secao de Graduacao 		  
//
oSection3 := TRSection():New(oSection2,STR0010,{"SQ2"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//Graduacao Fatores
oSection3:SetTotalInLine(.F.) 
TRCell():New(oSection3,"Q2_GRAU","SQ2") 	//Codigo do Grau
TRCell():New(oSection3,"Q2_DESC","SQ2")		//Descricao do Grau
TRCell():New(oSection3,"Q2_PONTOSI","SQ2") 	//Pontos Informados

Return oReport

/*

Ŀ
Funo    PrintReport  Autor  Emerson Grassi Rocha Data  22/06/06 
Ĵ
Descrio Impressao do Relatorio 						              
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function PrintReport(oReport,cAliasQry)

Local oSection1 := oReport:Section(1)
Local oSection2 := oReport:Section(1):Section(1)  
Local oSection3 := oReport:Section(1):Section(1):Section(1)  

#IFDEF TOP
	Local lQuery    := .F. 
#ELSE	
	Local cFiltro := ""
#ENDIF

//Ŀ
// Variaveis utilizadas na pergunte                                 
// MV_PAR01				// Filial	                             
// MV_PAR02				// Grupo		                         
// MV_PAR03				// Fator	                             
// MV_PAR04				// Grau			                         
// MV_PAR05				// Imprime Pontos dos Fatores S/N        
// MV_PAR06				// Imprime Desc. Detalhada do Fator S/N  
//

#IFNDEF TOP
	//-- Transforma parametros Range em expressao (intervalo)
	MakeAdvplExpr("CS010R") 	
#ELSE	
	//-- Transforma parametros Range em expressao SQL
	MakeSqlExpr("CS010R")
#ENDIF

#IFNDEF TOP
	cFiltro:= xFilial("SQ0", MV_PAR01)
	cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
	cFiltro += MV_PAR02 
	oSection1:SetFilter(cFiltro)
	
	cFiltro := MV_PAR03
	oSection2:SetFilter(cFiltro)
	
	cFiltro := MV_PAR04 
	oSection3:SetFilter(cFiltro)
	
	TRPosition():New(oSection2,"SQ1",1,{|| RhFilial("SQ1") +SQ0->Q0_GRUPO})
	oSection2:SetRelation({|| xFilial("SQ1")+SQ0->Q0_GRUPO},"SQ1",1,.T.)    
	oSection2:SetParentFilter({|cParam| SQ1->Q1_GRUPO == cParam},{|| SQ0->Q0_GRUPO}) 
	
	oSection3:SetRelation({|| xFilial("SQ2")+SQ1->Q1_GRUPO+SQ1->Q1_FATOR},"SQ2",1,.T.)
	oSection3:SetParentFilter({|cParam| SQ2->Q2_GRUPO + SQ2->Q2_FATOR == cParam},{|| SQ1->Q1_GRUPO + SQ1->Q1_FATOR})
	
#ELSE	


	
	If Empty(xFilial("SQ0"))
		MV_PAR01 := Space(FWGETTAMFILIAL)
	EndIf
	
	//-- Filtragem do relatrio
	//-- Query do relatrio da secao 1
	lQuery := .T.          
	cOrder := "%Q2_FILIAL, Q2_GRUPO, Q2_FATOR, Q2_GRAU%"        
	
	oReport:Section(1):BeginQuery()	

	BeginSql Alias cAliasQry

		SELECT	Q0_FILIAL, Q0_GRUPO, Q0_DESCRIC, Q1_FILIAL, Q1_GRUPO, Q1_FATOR, Q1_DESCSUM,Q1_DESCDET, Q2_FILIAL, Q2_GRUPO, Q2_FATOR, Q2_GRAU, Q2_DESC, Q2_PONTOSI //Nao colocar memo(virtual) 								
				
		FROM 	%table:SQ0% SQ0
		
		LEFT JOIN %table:SQ1% SQ1
			ON Q1_FILIAL = %xFilial:SQ1%
			AND Q1_GRUPO = Q0_GRUPO
			AND SQ1.%NotDel%      

		LEFT JOIN %table:SQ2% SQ2
			ON Q2_FILIAL = %xFilial:SQ2%
			AND Q2_GRUPO = Q1_GRUPO
			AND Q2_FATOR = Q1_FATOR
			AND SQ2.%NotDel%
		
		WHERE SQ0.%NotDel%   	
												
		ORDER BY %Exp:cOrder%                 		
		
	EndSql
	
	//Ŀ
	//Metodo EndQuery ( Classe TRSection )                                    
	//Prepara o relatrio para executar o Embedded SQL.                       
	//ExpA1 : Array com os parametros do tipo Range                           
	//
	oReport:Section(1):EndQuery( {MV_PAR01, MV_PAR02, MV_PAR03, MV_PAR04} )//Array com os parametros do tipo Range

	oSection2:SetParentFilter({|cParam| (cAliasQry)->Q1_FILIAL + (cAliasQry)->Q1_GRUPO == cParam},{|| (cAliasQry)->Q0_FILIAL + (cAliasQry)->Q0_GRUPO}) 
	oSection3:SetParentFilter({|cParam| (cAliasQry)->Q2_FILIAL + (cAliasQry)->Q2_GRUPO + (cAliasQry)->Q2_FATOR == cParam},{|| (cAliasQry)->Q1_FILIAL + (cAliasQry)->Q1_GRUPO + (cAliasQry)->Q1_FATOR})
	
	//Ŀ
	// Utiliza a query do Pai  
	//
	oSection2:SetParentQuery()
	oSection3:SetParentQuery()

#ENDIF

//Ŀ
// Impressao do Relatorio    
//
oReport:SetMeter((cAliasQry)->(LastRec()))

//Ŀ
// Imprime Pontos dos Fatores
//
If MV_PAR05 == 2 //Nao   
	oSection3:Cell("Q2_PONTOSI"):Disable()
EndIf                          

//Ŀ
// Imp. Desc. Detal. do Fator
//
If MV_PAR06 == 2 //Nao   
	oSection2:Cell("Q1_DESCDET"):Disable()
EndIf                   	
	
oSection1:Print()	 //Imprimir

Return Nil






//=====>>> Daqui para baixo, trata-se de release 3 ou anterior.
/*


Ŀ
Funo     CSAR010R3 Autor  Cristina Ogura         Data  14.04.00 
Ĵ
Descrio  Relatorio de Graduacao de Fatores                          
Ĵ
Sintaxe    CSAR010(void)                                              
Ĵ
Parametros                                                            
Ĵ
 Uso       CSAR010			                                          
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Emerson G.R.22/01/03xxxxxxNao estava considerando Grupo De/Ate.	   
Fco Junior  13/10/09025338Compatibilizacao versao  Corporativa.     
ٱ

*/
Function CSAR010R3()
Local cDesc1  	:= STR0001		//"Relao de Graduao de Fatores"
Local cDesc2  	:= STR0002		//"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  	:= STR0003		//"usuario."
Local cString 	:= "SQ0"
Local aOrd    	:= {}  //Ordem

Private aReturn  := { STR0004,1,STR0005,2,2,1,"",1 }		//"Zebrado"###"Administrao"
Private NomeProg := "CSAR010"
Private aLinha   := {}
Private nLastKey := 0
Private AT_PRG   := "CSAR010"
Private wCabec0  := 1
Private wCabec1  := STR0006		//"GRAU  DESCRICAO                                                   "
Private Contfl   := 1
Private Li       := 0
Private nTamanho := "M"

//Ŀ
// Verifica as perguntas selecionadas                           
//
pergunte( "CSR010",.F.)
TITULO  := STR0007	//"RELACAO DE GRADUACAO DE FATORES "

//Ŀ
// Envia controle para a funcao SETPRINT                        
//
wnrel:="CSAR010"            //Nome Default do relatorio em Disco
wnrel:=SetPrint(cString,wnrel,"CSR010",@TITULO,cDesc1,cDesc2,cDesc3,.F.,aOrd)

//Ŀ
// Variaveis utilizadas na pergunte                                 
// MV_PAR01				// Filial De                             
// MV_PAR02				// Filial Ate                            
// MV_PAR03				// Grupo De                              
// MV_PAR04				// Grupo Ate                             
// MV_PAR05				// Imprime Pontos dos Fatores S/N        
// MV_PAR06				// Imprime Desc. Detalhada do Fator S/N  
//

If nLastKey == 27
	Return
EndIf

SetDefault(aReturn,cString)

If nLastKey = 27
	Return
EndIf

RptStatus({|lEnd| CSR010Imp(@lEnd,wnRel,cString)},TITULO)

Return

/*


Ŀ                                          
Funo     CSR010Imp Autor  Cristina Ogura         Data  14.04.00 
Ĵ
Descrio  Relacao de Graduacao de Fatores                            
Ĵ
Sintaxe    CSR010IMP(lEnd,WnRel,cString)                              
Ĵ
Parametros lEnd        - Ao do Codelock                             
           wnRel       - Ttulo do relatrio                          
           cString     - Mensagem                                     
Ĵ
 Uso       CSAR010                                                    
ٱ

*/
Static Function CSR010Imp(lEnd,WnRel,cString)
Local lPulaPag 	:= .F.
Local lImp		:= .F.     
Local cAcessaSQ0:= &("{ || " + ChkRH(FunName(),"SQ0","2") + "}")
Local cFil		:= ""
Local cDescDet	:= ""
Local nLinha	:= 0
Local nBegin	:= 0

// Imprimir os pontos dos Fatores 
If MV_PAR05 == 1		// Sim
	wCabec1 := wCabec1 + STR0010	//"PONTOS"
EndIf	

dbSelectArea("SQ0")
cFil := xFilial("SQ0", MV_PAR01)
dbSeek(cFil + MV_PAR03 , .T.)

SetRegua(SQ0->(RecCount()))
While  !Eof()                                           

    IncRegua()

	If lEnd
		Exit
	EndIf

    If SQ0->Q0_FILIAL > MV_PAR02 
        Exit
    Endif  
    
	If !Eval(cAcessaSQ0)
		dbSkip()  
		Loop
	EndIf
	
    If SQ0->Q0_GRUPO > MV_PAR04
    	dbSkip()
    	Loop
    EndIf
    
    cGrupo := SQ0->Q0_GRUPO

    If lPulaPag
        IMPR( "","P" )
    EndIf
    lImp := .T.
    cDet := Space(05)+STR0008+cGrupo+" - "+SQ0->Q0_DESCRIC		//"Grupo: "
    
    IMPR(cDet,"C")
    IMPR("","C")

    dbSelectArea("SQ1")    
    dbSetOrder(1)
	If dbSeek(xFilial("SQ1")+cGrupo)
	    While !Eof() .And. SQ1->Q1_FILIAL+SQ1->Q1_GRUPO == xFilial("SQ1")+cGrupo
    	    cFator 	:= SQ1->Q1_FATOR
	        cDet 	:= Space(10)+STR0009+cFator+" - "+SQ1->Q1_DESCSUM		//"Fator: "
    	    IMPR(cDet,"C")
	        IMPR("","C")

			//Ŀ
			// Impressao da Descricao Detalhada do Fator. 
			//
			If MV_PAR06 == 1		// Sim
				cDet	:= Space(15) + STR0011	//"DESCRICAO DETALHADA DO FATOR"
				IMPR(cDet,"C")
			
				cDescDet := MSMM(SQ1->Q1_DESCDET,,,,3)	
			
				nLinha	:= MLCount(cDescDet,63)
				If nLinha > 0				
					For nBegin := 1 To nLinha
						cDet := Space(17)+ Memoline(cDescDet,63,nBegin,,.T.)
						IMPR(cDet,"C")
					Next nBegin
				Else
					cDet := Space(14)+ STR0012	//" *** Nao existe Descricao detalhada do Fator *** "
					IMPR(cDet,"C")
				EndIf
				cDet := ""
				IMPR(cDet,"C")
			EndIf

			dbSelectArea("SQ2")
			If dbSeek(xFilial("SQ2")+cGrupo+cFator)
		        While !Eof() .And. SQ2->Q2_FILIAL+SQ2->Q2_GRUPO+SQ2->Q2_FATOR == xFilial("SQ2")+cGrupo+cFator
		        
    	        	cDet := Space(11)+SQ2->Q2_GRAU+Space(3)+SQ2->Q2_DESC+Space(19)
    	        	
    	        	// Imprime os pontos dos Fatores
    	        	If MV_PAR05 == 1		// Sim
						cDet := cDet + Trans(Q2_PONTOSI,"999.999" )
					EndIf
						
    	        	IMPR( cDet,"C")
    	        	
		            dbSkip()
		        EndDo
			EndIf        
			
        	IMPR(Replicate("-",80),"C")
	        IMPR("","C")
        
	        dbSelectArea( "SQ1" )
    	    dbSkip()
	    EndDo
    EndIf
    lPulaPag := .T.
    dbSelectArea("SQ0")
    dbSkip()
EndDo

If lImp
	Impr("","F")
EndIf	

Set Device To Screen

If aReturn[5] = 1
	Set Printer To
	Commit
	ourspool(wnrel)
Endif

MS_FLUSH()      

Return .T.


