#INCLUDE "Protheus.CH"
#INCLUDE "CSAR030.CH"

/*


Ŀ
Funo     CSAR030   Autor  R.H. - Cristina Ogura  Data  19/09/00 
Ĵ
Descrio  Relatorio de Aumento Salarial conforme Tabela              
Ĵ
Sintaxe    CSAR030(void)                                              
Ĵ
Parametros                                                            
Ĵ
 Uso       Generico                                                   
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Eduardo Ju  03/04/08141828     Aviso em caso de RBR/BR6 exclusivos. 
Tatiane V.M.25/08/0920388/2009Compatibilizacao dos fontes para      
                               aumento do campo filial e gesto     
                               corporativa.                          
Fco Junior  13/10/09025338Compatibilizacao versao  Corporativa.     
Allyson M.  09/06/1010199/Ajuste para somente aplicar o reajuste    
                      2010  na ultima versao da tabela salarial.      
Mauricio MR 09/12/10027484 Ajuste para uso da Filial na Gestao Cor- 
                      2010 porativa.								  
ٱ

*/ 

Function CSAR030()
//Ŀ
// Define Variaveis Locais(Basicas)                             
//
Local cDesc1  	:= STR0001						//"Emisso do Aumento Salarial."
Local cDesc2  	:= STR0002						//"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  	:= STR0003						//"usurio."
Local cString 	:= "SRA"						// Alias do arquivo principal (Base)
Local aOrd 		:= {STR0004,STR0005,STR0006} 	//"Matricula"###"Centro de Custo"###"Funcao"

//Ŀ
// Define Variaveis Private(Basicas)                            
//
Private aReturn := {STR0007, 1,STR0008, 2, 2, 1, "",1 }	//"Zebrado"###"Administrao"
Private NomeProg:= "CSAR030"
Private aLinha  := {}
Private nLastKey:= 0
Private cPerg   := "CSR030"
Private nOrdem  := 0

//Ŀ
// Define Variaveis Private(Programa)                           
//
Private nAtualiza	:= 0
Private nPerAum		:= 0
Private nVlAum		:= 0
Private nTipoRel	:= 0
Private nCriterio	:= 0
Private nArredonda	:= 0
Private cTabela		:= ""
Private cNivDe		:= ""
Private cNivAte		:= ""
Private cFilDe		:= ""
Private cFilAte		:= ""
Private cClasseDe	:= ""
Private cClasseAte	:= ""

//Ŀ
// Variaveis Utilizadas na funcao IMPR                          
//
Private Titulo	:= ""
Private AT_PRG  := "CSAR030"
Private wCabec0 := 1
Private wCabec1 := STR0009+Dtoc(dDataBase)		//"Data Base: "
Private CONTFL  := 1
Private LI      := 0
Private nTamanho:= "M"

pergunte("CSR030",.F.)             

//Ŀ
// Variaveis utilizadas na pergunte                                 
// mv_par01				// Atualizacao Tabela  1-Simulacao 2-Real
// mv_par02				// Tabela Salarial                       
// mv_par03				// Nivel da Tabela De                    
// mv_par04				// Nivel da Tabela Ate                   
// mv_par05				// Filial De                             
// mv_par06				// Filial Ate                            
// mv_par07				// % Aumento                             
// mv_par08				// Valor Aumento                         
// mv_par09 				// Arred No Calculo  No / Normal / Acima
// mv_par10      			// Arredondamento Sobre o Calculo        
// mv_par11				// Imprimir      1-Sintetico 2-Analitico 
// mv_par12				// Classe Salarial De 					 
// mv_par13				// Classe Salarial Ate 					 
//
Titulo := STR0010			// "RELACAO DE AUMENTO SALARIAL CONFORME TABELA"

//Ŀ
// Envia controle para a funcao SETPRINT                        
//
wnrel:="CSAR030"            //Nome Default do relatorio em Disco
wnrel:=SetPrint(cString,wnrel,cPerg,@Titulo,cDesc1,cDesc2,cDesc3,.F.,aOrd,,nTamanho)

nAtualiza	:=	If(!Empty(mv_par01),mv_par01,1)
cTabela		:=	If(!Empty(mv_par02),mv_par02,"  ")
cNivDe		:=	If(!Empty(mv_par03),mv_par03,"  ")
cNivAte		:=	If(!Empty(mv_par04),mv_par04,"99")
cFilDe		:=	If(!Empty(mv_par05),mv_par05,Space(FWGetTamFilial))
cFilAte		:=	If(!Empty(mv_par06),mv_par06,Space(FWGetTamFilial))
nPerAum		:=	If(!Empty(mv_par07),mv_par07,0)
nVlAum 		:=	If(!Empty(mv_par08),mv_par08,0)
nCriterio 	:=	If(!Empty(mv_par09),mv_par09,2)
nArredonda	:=	If(!Empty(mv_par10),mv_par10,0)
nTipoRel	:=	If(!Empty(mv_par11),mv_par11,1)
cClasseDe	:=	If(!Empty(mv_par12),mv_par12,"   ")
cClasseAte	:=	If(!Empty(mv_par13),mv_par13,"999")  

//Ŀ
// Aviso caso o modo de acesso das tabelas seja exclusivo  
//
dbSelectArea("SX2")
dbSetOrder(1)
If dbSeek("RB6") 
	If SX2->X2_MODO == "E" .And. cFilDe <> cFilAte
		Aviso(STR0030,STR0031,{"OK"}) //"Ateno"#"Os parmetros 'Filial De/Ate' devem ser preenchidos com a filial corrente j que a Tabela Salarial 'RBR/RB6' est em Modo de Acesso Exclusivo"
		Return .F.          
	EndIf
EndIf 
                           
cFilDe := xFilial("RB6",cFilDe)

nOrdem := aReturn[8]
Titulo := STR0011			//"RELACAO DE AUMENTO SALARIAL"	

If nOrdem == 3
	Titulo := Titulo + "-"+ STR0025	//"POR FUNCAO"
EndIf	

wCabec1+="  "
wCabec1+="  "

If nLastKey == 27
	Return
EndIf

SetDefault(aReturn,cString)

If nLastKey == 27
	Return
EndIf

RptStatus({|lEnd| Cs030Imp(@lEnd,wnRel,cString)},Titulo)

Return

/*


Ŀ
Funo     CSAR030   Autor  R.H. - Cristina Ogura  Data  19/09/00 
Ĵ
Descrio  Aumento Salarial                                           
Ĵ
Sintaxe    CS030Imp(lEnd,wnRel,cString)                               
Ĵ
Parametros lEnd        - Ao do Codelock                             
           wnRel       - Ttulo do relatrio                          
           cString     - Mensagem			                          
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function Cs030Imp(lEnd,WnRel,cString)
Local nSalario  := 0
Local nSalMes 	:= 0
Local nSalDia 	:= 0
Local nSalHora 	:= 0
Local nVlTab	:= 0
Local nValArre	:= 0
Local nPos		:= 0
Local nNovoSal	:= 0
Local nHNovoSal := 0
Local cAcessaRB6:= &("{ || " + ChkRH(FunName(),"RB6","2") + "}")
Local cAcessaSRA:= &("{ || " + ChkRH(FunName(),"SRA","2") + "}")
Local lTestar	:= .F.
Local nTipoVl	:= 1

Private aPosicao1	:= {}
Private aTotFun1  	:= {}
Private aTotCc1   	:= {}
Private aTotFil1  	:= {}
Private aTotEmp1  	:= {}
Private aInfo     	:= {}
Private aTabela	  	:= {}	
Private cInicio     := ""
Private cFim		:= ""
Private cFilialAnt 	:= Space(FWGetTamFilial)
Private cCcAnt     	:= Space(9)
Private cFuAnt     	:= Space(4)
Private cFunAnt    	:= SPace(4)

// Montar array com a tabela reajustado
dbSelectArea("RB6")
dbSetOrder(1)
If !dbSeek(xFilial("RB6")+cTabela)
	Help("",1,"Cs030NOTAB")
	Return
EndIf	   

nTipoVl	:= RB6->RB6_TIPOVL
wCabec1	:= wCabec1 + STR0026+cTabela+"-"+RB6->RB6_DESCTA	//"Tabela Salarial: "

While !Eof() .And. xFilial("RB6")+cTabela == RB6->RB6_FILIAL+RB6->RB6_TABELA
	
    If 	RB6->RB6_NIVEL < cNivDe  .Or.;
    	RB6->RB6_NIVEL > cNivAte .Or.;
    	RB6->RB6_FILIAL < cFilDe .Or.;
    	RB6->RB6_FILIAL > cFilAte .Or.;
    	RB6->RB6_CLASSE < cClasseDe .Or.;
    	RB6->RB6_CLASSE > cClasseAte .Or.;
    	RB6->RB6_ATUAL <> "1"
    	dbSkip()
    	Loop
    EndIf	              
    
   	If !Eval(cAcessaRB6)
		dbSkip()  
		Loop
	EndIf
    
	nValArre:= 0    
 	nVlTab 	:= RB6->RB6_VALOR * (1+(nPerAum/100))
 	nVlTab 	:= nVlTab + nVlAum

	If 	nCriterio == 1			// Nao Arredondar
		nVlTab:= NoRound(nVlTab)
	ElseIf nCriterio == 2		// Arredondamento Padrao
		nVlTab := Round(nVlTab,2)
	Else				
		If 	nVlTab - Round(nVlTab,2) > 0.00
			nVlTab := NoRound((nVlTab+.01),2)
		Else
			nVlTab := Round(nVlTab,2)
		Endif
	EndIf
	If nArredonda # 0
		CalcArre(@nVlTab, @nArredonda, @nValArre)
	EndIf   
	
	Aadd(aTabela,{RB6->RB6_NIVEL,RB6->RB6_FAIXA,nVlTab,nValArre,RB6->RB6_VALOR})		// {Nivel, Faixa, Valor, Arredondamento}
	
	// Atualiza a tabela com o aumento dos parametros
	If nAtualiza == 2
		RecLock("RB6",.F.)
			Replace RB6->RB6_VALOR With	nVlTab
		MsUnlock()
	EndIf
                    
	lTestar := .T.
	
	dbSelectArea("RB6")
	dbSkip()		
EndDo

If lTestar
	dbSelectArea( "SRA" )
	If nOrdem == 1
		dbSetOrder(1)
	ElseIf nOrdem == 2
		dbSetOrder(2)
	ElseIf nOrdem == 3
		dbSetOrder(7)
	Endif
	                              
	dbGoTop()      
	dbSeek(cFilDe, .T. )
	cInicio := "SRA->RA_FILIAL"
	cFim 	:= cFilAte
	
	SetRegua(SRA->(RecCount()))
	
	While	!EOF() .And. &cInicio <= cFim
	
	    If SRA->RA_FILIAL # cFilialAnt
			If !fInfo(@aInfo,SRA->RA_FILIAL)
				Exit
			EndIf
			dbSelectArea( "SRA" )
			cFilialAnt := SRA->RA_FILIAL
		EndIf
	
		If 	SRA->RA_SITFOLH == "D" 	.Or.;
			SRA->RA_TABELA # cTabela 	.Or.;
			SRA->RA_TABNIVE < cNivDe 	.Or.;
			SRA->RA_TABNIVE > cNivAte
			FTestaTotal()
			Loop
		EndIf		
		
	   	If !Eval(cAcessaSRA)
			FTestaTotal()
			Loop
		EndIf
		
		//Ŀ
		// Movimenta Regua Processamento                                
		//
		IncRegua()
	
		If lEnd
			@Prow()+1,0 PSAY cCancel
			Exit
		Endif	 
	   
		//Ŀ
		// Calcula Salario Mes , Dia , Hora do Funcionario              
		//
		fSalario(@nSalario,@nSalHora,@nSalDia,@nSalMes,"A")
	          
		nPos 	 := 0
		nNovoSal := 0
		nHNovoSal:= 0
		nSalBase := 0              
		nValArre := 0
		nPos 	 := Ascan(aTabela, { |x| x[1]+x[2]== SRA->RA_TABNIVE+SRA->RA_TABFAIX })
		If nPos > 0 
			If  nTipoVl == 1 .Or. nTipoVl == 3 						//Valores Exatos
				nNovoSal := aTabela[nPos][3]
				nValArre := aTabela[nPos][4]
			Else                      				// Intervalo
				nNovoSal := SRA->RA_SALARIO *(1+(nPerAum/100))
			 	nNovoSal += nVlAum

				If 	nCriterio == 1			// Nao Arredondar
					nNovoSal := NoRound(nNovoSal)
				ElseIf nCriterio == 2		// Arredondamento Padrao
					nNovoSal := Round(nNovoSal,2)
				Else				
					If 	nNovoSal - Round(nNovoSal,2) > 0.00
						nNovoSal := NoRound((nNovoSal+.01),2)
					Else
						nNovoSal := Round(nNovoSal,2)
					Endif
				EndIf
				If nArredonda # 0
					CalcArre(@nNovoSal, @nArredonda, @nValArre)
				EndIf   
			EndIf
		EndIf
	    
		If 	nOrdem # 3
			nSalBase := IF( SRA->RA_CATFUNC $ "M*C*P*A*E*S", nSalMes , nSalHora )
			nNovoSal := IF( SRA->RA_CATFUNC $ "M*C*P*A*E*S", nNovoSal , nNovoSal * SRA->RA_HRSMES )
			nHNovoSal:= IF( SRA->RA_CATFUNC $ "H*T*G"		, nNovoSal , nNovoSal / SRA->RA_HRSMES ) 
		Else
			dbSelectArea( "SRJ" )
			dbSeek( xFilial("SRJ",SRA->RA_FILIAL) + SRA->RA_CODFUNC )
			nSalBase := SRJ->RJ_SALARIO	
			nSalHora := 0
			nHNovoSal:= 0
		EndIf	
		
		dbSelectArea("SRA")
			 
		//Ŀ
		// Calcula o Bloco para o Funcionario                           
		//
		aPosicao1:={} // Limpa Arrays
		Aadd(aPosicao1,{0,0,0,0,0,0,0,0})
			
		//Ŀ
		// Atualiza o Bloco para os Totalizadores                       
		//
		nPos0 := nSalMes
		nPos1 := nSalHora
		nPos2 := nPerAum
		nPos3 := nVlAum
		nPos4 := nNovoSal - nSalMes
		nPos5 := nNovoSal
		nPos6 := nHNovoSal
		nPos7 := nValArre
									
		//Ŀ
		// Quando o Tipo de Pagamento For Semanal e as Categorias forem 
		// Semanalista ou Tarefeiro, converte para o Salario da Semana  
		//
		IF 	SRA->( RA_TIPOPGT = "S" .and. RA_CATFUNC $ "S*T" )
	    	nNovoSal := ( ( nNovoSal / 30 ) * 7 ) 
		EndIF
			
		Atualiza(@aPosicao1,1,nPos0,nPos1,nPos2,nPos3,nPos4,nPos5,nPos6,nPos7)
			
		//Ŀ
		// Atualizando Totalizadores                                    
		//
		fAtuCont(@aToTFun1) // Funcao		
		fAtuCont(@aToTCc1)  // Centro de Custo
		fAtuCont(@aTotFil1) // Filial
		fAtuCont(@aTotEmp1) // Empresa
		      
		fImpFun()	
		fTestaTotal()  // Quebras e Skips
	Enddo
	
	FImpTab()                                   
	
EndIf
	
//Ŀ
// Termino do relatorio                                         
//
dbSelectArea("RB6")
Set Filter To
dbSetOrder(1)

dbSelectArea("SRA")
Set Filter To
dbSetOrder(1)

Set Device To Screen
If aReturn[5] = 1
	Set Printer To
	Commit
	//Ŀ
	// Spool caso Opcao seja de Relatorio, senao sai apresenta-lo.  
	//
	ourspool(wnrel)
Endif

MS_FLUSH()

Return Nil

/*


Ŀ
Funo     FTestaTotal   Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Testa as quebras do relatorio conforme ordem selecionada   
Ĵ
Sintaxe    FTestaTotal()                                              
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function FTestaTotal()

dbSelectArea( "SRA" )
cFilialAnt := SRA->RA_FILIAL              // Iguala Variaveis
cCcAnt     := SRA->RA_CC
cFuAnt     := SRA->RA_CODFUNC
dbSkip()

If Eof() .Or. &cInicio > cFim
	fImpFu()
	fImpCc()
	fImpFil()
	fImpEmp()
Elseif cFilialAnt # SRA->RA_FILIAL
	fImpFu()
	fImpCc()
	fImpFil()
Elseif cCcAnt # SRA->RA_CC
	fImpCc()
Elseif cFuAnt # SRA->RA_CODFUNC
	fImpFu()
Endif

Return Nil

/*


Ŀ
Funo     FImpFun       Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Imprime os dados dos funcionarios                          
Ĵ
Sintaxe    FImpFun()                                                  
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function FImpFun()
Local lRetu1 := .T.

If nTipoRel == 2
	cDet := STR0012+SRA->RA_FILIAL+STR0013+SRA->RA_CC+STR0014+SRA->RA_MAT	//"FILIAL: "###" CCTO: "###" MAT: "
	cDet += STR0015+SRA->RA_NOME+STR0016+DtoC(SRA->RA_ADMISSA)				//" NOME: "###" DT.ADMISSAO: "
	Impr(cDet,"C")

	Impr("","C")

	lRetu1 := fImpComp(aPosicao1,1,.T.)

	cDet := Repl("-",132)
	Impr(cDet,"C")
	Impr("","C")
EndIf	

Return Nil

/*


Ŀ
Funo     FImpFu        Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Imprime os dados da funcao do funcionario                  
Ĵ
Sintaxe    FImpFu()                                                   
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function FImpFu()
Local lRetu1 := .T.

If Len(aTotFun1) == 0 .Or. nOrdem # 3
	Return Nil
Endif

cDet:=STR0017+cFilialAnt+STR0018+cFuAnt+" - "+DescFun(cFuAnt,cFilialAnt)	//"FILIAL: "###" FUNCAO: "
Impr(cDet,"C")
Impr("","C")

lRetu1 := fImpComp(aTotFun1,1) // Imprime

aTotFun1 :={}      // Zera

cDet := Repl("=",132)
Impr(cDet,"C")
Impr("","C")

Return Nil

/*


Ŀ
Funo     FImpCC        Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Imprime os dados do centro de custo                        
Ĵ
Sintaxe    FImpCC()                                                   
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function fImpCc()
Local lRetu1 := .T.

If Len(aTotCc1) == 0 .Or. nOrdem # 2
	Return Nil
Endif

cDet:=STR0019+cFilialAnt+STR0020+cCcAnt+" - "+DescCc(cCcAnt,cFilialAnt)	//"FILIAL: "###" CCTO: "
Impr(cDet,"C")
Impr("","C")

lRetu1 := fImpComp(aTotCc1,1) // Imprime

aTotCc1 := {}      // Zera

cDet := Repl("=",132)
Impr(cDet,"C")
Impr("","C")

Return Nil

/*


Ŀ
Funo     FImpFil       Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Imprime os dados da filial                                 
Ĵ
Sintaxe    FImpFil()                                                  
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function FImpFil()
Local lRetu1 	:= .T.
Local cDescFil  := ""

If Len(aTotFil1) == 0
	Return Nil
Endif

cDescFil := aInfo[1] + Space(25)
cDet     := STR0021+cFilialAnt+" - "+cDescFil	//"FILIAL: "
Impr(cDet,"C")
Impr("","C")

lRetu1 := fImpComp(aTotFil1,1) // Imprime

aTotFil1 := {}      // Zera

cDet := Repl("=",132)
Impr(cDet,"C")
Impr("","C")
Return Nil

/*


Ŀ
Funo     FImpEmp       Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Imprime os dados da Empresa                                
Ĵ
Sintaxe    FImpEmp()                                                  
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function FImpEmp()
Local lRetu1 := .T.

If Len(aTotEmp1) == 0
	Return Nil
Endif

cDet:=STR0022+aInfo[3]		//"EMPRESA: "
Impr(cDet,"C")
Impr("","C")

lRetu1 := fImpComp(aTotEmp1,1) // Imprime

aTotEmp1 := {}      // Zera

Return Nil

/*


Ŀ
Funo     FImpComp      Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Imprime os dados ou do funcionario ou da funcao            
Ĵ
Sintaxe    FImpFil(aArray, posicao)                                   
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function FImpComp(aPosicao,nLugar)
//Ŀ
// aPosicao = Array Contendo o que Vai ser Impresso            
//
Local cCab1		:= cCab2 := ""
Local nResImp 	:= 0
Local lRet		:= .T.

AeVal(aPosicao,{ |X| nResImp += X[1] })  // Testa se a Soma == 0

//Ŀ
// Imprime se Possui Valores                                   
//
If nResImp > 0
	If nOrdem # 3
		cDet := STR0023	//" SALARIO ANTIGO  SALARIO HORA ANTIGO  PERCENTUAL + VALOR ADICIONAL   =   REAJUSTE  SALARIO NOVO  SALARIO HORA NOVO  ARREDONDAMENTO"
		Impr(cDet,"C")		
		cDet := "   "      +TRANSFORM(aPosicao[1,1],"@E 999999999.99")
		cDet += "         "+TRANSFORM(aPosicao[1,2],"@E 999999999.99")
		cDet += "  "       +TRANSFORM(aPosicao[1,3],"@E 999.999999")
		cDet += "      "   +TRANSFORM(aPosicao[1,4],"@E 999999999.99")
		cDet += "   "      +TRANSFORM(aPosicao[1,5],"@E 999999999.99")
		cDet += "  "       +TRANSFORM(aPosicao[1,6],"@E 999999999.99")
		cDet += "       "  +TRANSFORM(aPosicao[1,7],"@E 999999999.99")
		cDet += "    "     +TRANSFORM(aPosicao[1,8],"@E 999999999.99")
		Impr(cDet,"C")
	Else
		cDet := STR0024	//" SALARIO ANTIGO  PERCENTUAL + VALOR ADICIONAL   =   REAJUSTE  SALARIO NOVO  ARREDONDAMENTO"
		Impr(cDet,"C")		
		cDet := "   "      +TRANSFORM(aPosicao[1,1],"@E 999999999.99")
		cDet += "  "       +TRANSFORM(aPosicao[1,3],"@E 999.999999")
		cDet += "      "   +TRANSFORM(aPosicao[1,4],"@E 999999999.99")
		cDet += "   "      +TRANSFORM(aPosicao[1,5],"@E 999999999.99")
		cDet += "  "       +TRANSFORM(aPosicao[1,6],"@E 999999999.99")
		cDet += "    "     +TRANSFORM(aPosicao[1,8],"@E 999999999.99")
		Impr(cDet,"C")
	Endif
	Li++
	lRet := .T.
Else
	lRet := .F.
Endif
Return lRet

/*


Ŀ
Funo     FAtuCont      Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Totaliza os arrays com os dados do funcionario             
Ĵ
Sintaxe    FAtuCont(aArray)                                           
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function FAtuCont(aArray1)
Local x := 0
Local z := 1
If  Len(aArray1) > 0
	For x:= 1 To 8 
		If x != 3	// Soma Valores # Percentual
			aArray1[z,x] += aPosicao1[z,x]
		EndIf
	Next
Else
	aArray1 := aClone(aPosicao1)
EndIf
Return Nil

/*


Ŀ
Funo     CalcArre      Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Calcula o arredondamento conforme parametro                
Ĵ
Sintaxe    CalcArre()                                                 
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function CalcArre(nValor,nArred,nValArred)
Local nResto := 0

nResto := Mod(nValor,nArred)

If Round(nResto,2) > 0.00
	nValArred := nArred - nResto
	nValor    := nValor + nValArred
Else
	nValArred := 0.00
EndIf

Return( .T. )

/*


Ŀ
Funo     Atualiza      Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Carrega o array com os dados necessarios                   
Ĵ
Sintaxe    Atualiza()                                                 
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function Atualiza(aMatriz,nElem,nPos0,nPos1,nPos2,nPos3,nPos4,nPos5,nPos6,nPos7)

aMatriz[nElem,1] := nPos0
aMatriz[nElem,2] := nPos1
aMatriz[nElem,3] := nPos2
aMatriz[nElem,4] := nPos3
aMatriz[nElem,5] := nPos4
aMatriz[nElem,6] := nPos5
aMatriz[nElem,7] := nPos6
aMatriz[nElem,8] := nPos7
Return Nil

/*


Ŀ
Funo     FImpTab       Autor  R.H- Cristina Ogura Data 19/09/00 
Ĵ
Descrio  Imprime os dados da tabela com os valores reajustados      
Ĵ
Sintaxe    FImpTab())                                                 
Ĵ
 Uso       CSAR030                                                    
ٱ

*/
Static Function FImpTab()                     
Local nx	:= 0

dbSelectArea("RB6")
dbSetOrder(1)
dbSeek(xFilial("RB6")+cTabela)
                        
// Dados da tabela com o reajuste
IMPR("","P")
cDet := STR0027+ Transform(nPerAum,"999.999999")+ Space(05)+STR0028+ Transform(nVlAum,"999999999.99") 	//"% Aumento: "###"Valor Aumento: "
IMPR(cDet,"C")
IMPR("","C")              

cDet :=	STR0029		//"Nivel Faixa   Vl. Reajustado   Vl. Anterior"
					//"   99    99     999999999999	  999999999999"						
IMPR(cDet,"C")
		
For nx := 1 To Len(aTabela)
	cDet := ""
	cDet := Space(03)+aTabela[nx][1]
	cDet += Space(04)+aTabela[nx][2]
	cDet += Space(05)+Transform(aTabela[nx][3],"999999999.99")
	cDet += Space(03)+Transform(aTabela[nx][5],"999999999.99")
	IMPR(cDet,"C")
Next nx                                                          

IMPR("","F")

Return Nil
