#INCLUDE "PROTHEUS.CH"
#INCLUDE "RWMAKE.CH"
#INCLUDE "GPER560.CH"

/*


ͻ
Programa  GPER560   Autor  Alexandre Silva	   Data   02/04/03  
͹
Desc.     Hace la impresion de la planilla de personal Fijo           
                                                                      
͹
Uso        Liquidacion - Republica Dominicana                         
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Luiz Gustavo|29/01/07116748Retiradas funcoes de ajuste de dicionario.|  
ٱ

Ŀ
Programador   Data      FNC              Motivo da Alteracao                      
ĳ
Rogerio R.   29/07/200900000018278/2009Compatibilizacao dos fontes para aumento do
                                       campo filial e gesto corporativa.         
Alex         04/11/200900000026596/2009Adaptao Gesto Corporativa               
                                                                                  
ٱ

*/
Function GPER560()

Private NomeProg 	:= "GPER560"
Private WnRel		:=	"GPER560"    //Nome Default do relatorio em Disco
Private cPerg    	:= "GPR560"
Private Titulo		:= FunDesc()

/*Ŀ
   Variaveis utilizadas para parametros                         
   mv_par01        //  Filial De                                
   mv_par02        //  Filial Ate                               
   mv_par03        //  Centro de Custo De                       
   mv_par04        //  Centro de Custo Ate                      
   mv_par05        //  Matricula De                             
   mv_par06        //  Matricula Ate                            
   mv_par07        //  Nome De                                  
   mv_par08        //  Nome Ate                                 
   mv_par09        //  Chapa De                                 
   mv_par10        //  Chapa Ate                                
   mv_par11        //  Situaes                                
   mv_par12        //  Categorias                                
   mv_par13        //  Ano Referencia                           
   mv_par14        //  Tipo do relatorio/Na impressora/Arquivo  
  */

If Pergunte("GPR560",.T.)
	RptStatus({|lEnd| Gper560Imp(@lEnd,wnRel,"SRA")},Titulo)
EndIf    

Return

/*

Ŀ
Funo     Gper560Imp   Autor   Alexandre Silva     Data 03/04/03 
Ĵ
Descrio  Faz a impressao do Relatorio.                              
ٱ

*/
Function Gper560Imp(lEnd,wnRel,cAlias)

Local	cFilDe    	:= mv_par01
Local cFilAte   	:= mv_par02
Local cCcDe     	:= mv_par03
Local cCcAte    	:= mv_par04
Local cMatDe    	:= mv_par05
Local cMatAte   	:= mv_par06
Local cNomeDe   	:= mv_par07
Local cNomeAte  	:= mv_par08
Local cChapaDe  	:= mv_par09
Local cChapaAte 	:= mv_par10
Local cSituacao 	:= mv_par11
Local cCategoria	:= mv_par12
Local nDestino  	:= mv_par14
Local nOrdem     	:= mv_par15
Local nLin			:= 50
Local nPag			:= 01
Local nContFun		:= 26
Local nArquivo		:= 00
Local cInicio  	:= ""
Local cFim			:= ""
Local cArqGravar 	:= ""
Local cSitFunc		:= ""
Local cFilialAnt 	:= Space(FWGETTAMFILIAL)
Local cFuncaoAnt 	:= Space(4)
Local cCcAnt     	:= Space(9)
Local cMatAnt    	:= Space(6)
Local aInfoFil		:= {}
Local aCodFol		:= {}
Local lPerNome		:= .T.

Private cAnoRef   	:= mv_par13
Private cPictSal	:= PesqPict("SRA","RA_SALARIO",20)
Private oFont08  	:= TFont():New( "Corrier New",,10,,.f.,,,,,.f. )
Private oFont10  	:= TFont():New( "Corrier New",,14,,.F.,,,,.t.,.f. )
Private oImp 		:= TMSPrinter():New()

dbSelectArea( "SRA" )
If nOrdem == 1
	dbSetOrder( 1 )
ElseIf nOrdem == 2
	dbSetOrder( 2 )
ElseIf nOrdem == 3
	dbSetOrder(3)
Endif

dbGoTop()

If nOrdem == 1
	dbSeek(cFilDe + cMatDe,.T.)
	cInicio := "SRA->RA_FILIAL + SRA->RA_MAT"
	cFim    := cFilAte + cMatAte
ElseIf nOrdem == 2
	dbSeek(cFilDe + cCcDe + cMatDe,.T.)
	cInicio := "SRA->RA_FILIAL + SRA->RA_CC + SRA->RA_MAT"
	cFim    := cFilAte + cCcAte + cMatAte
ElseIf nOrdem == 3
	DbSeek(cFilDe + cNomeDe + cMatDe,.T.)
	cInicio := "SRA->RA_FILIAL + SRA->RA_NOME + SRA->RA_MAT"
	cFim    := cFilAte + cNomeAte + cMatAte
Endif

SetRegua(SRA->(RecCount()))

cFilialAnt 	:= Space(FWGETTAMFILIAL)
cFuncaoAnt 	:= Space(4)
cCcAnt     	:= Space(9)
cMatAnt    	:= Space(6)

While !EOF() .And. &cInicio <= cFim .And.(SRA->RA_FILIAL+SRA->RA_MAT <> cFilialAnt+cMatAnt)

  	IncRegua()  // Incrementa a regua

   If lEnd
		@Prow()+1,0 PSAY cCancel
		Exit
	Endif

/*Ŀ
  |        Incio Consistencia da Parametrizacao do Intervalo de Impressao          |
  */
	If (SRA->RA_CHAPA < cChapaDe).Or. (SRA->Ra_CHAPa > cChapaAte).Or. ;
	   (SRA->RA_NOME < cNomeDe)  .Or. (SRA->Ra_NOME > cNomeAte)  .Or. ;
	   (SRA->RA_MAT < cMatDe)    .Or. (SRA->Ra_MAT > cMatAte)    .Or. ;
	   (SRA->RA_CC < cCcDe)      .Or. (SRA->Ra_CC > cCcAte)
		SRA->(dbSkip(1))
		Loop
	EndIf

	//Ŀ
	// Verifica Data Demissao         
	//
	cSitFunc := SRA->RA_SITFOLH
	dDtPesqAf:= CTOD("01/" + Substr(MV_PAR13,3,2) +  "/" + Left(MV_PAR13,4),"DDMMYY")
	If cSitFunc == "D" .And. (!Empty(SRA->RA_DEMISSA) .And. MesAno(SRA->RA_DEMISSA) > MesAno(dDtPesqAf))
		cSitFunc := " "
	Endif	
	/*Ŀ
	   Consiste situacao e categoria dos funcionarios			        |
	  */
	If !( cSitFunc $ cSituacao ) .OR. !( SRA->RA_CATFUNC $ cCategoria )
	   SRA->(dbSkip())
	   Loop
	Endif

  
	If SRA->RA_FILIAL # cFilialAnt
		If ! Fp_CodFol(@aCodFol,Sra->Ra_Filial)
	 		Exit
	   Endif
	   If ! fInfo(@aInfoFil,Sra->Ra_Filial)
			Exit
		Endif
	   cFilialAnt := SRA->RA_FILIAL
	Endif

	If SRA->RA_CODFUNC # cFuncaoAnt           // Descricao da Funcao
		DescFun(Sra->Ra_Codfunc,Sra->Ra_Filial)
		cFuncaoAnt:= Sra->Ra_CodFunc
	Endif

	If SRA->RA_CC # cCcAnt                   // Centro de Custo
		DescCC(Sra->Ra_Cc,Sra->Ra_Filial)
		cCcAnt:=SRA->RA_CC
	Endif

	If Val(cAnoRef) < Year(SRA->RA_ADMISSA)
		SRA->(dbSkip())		
		Loop		
	EndIf

/*Ŀ
  |        Fim Consistencia da Parametrizacao do Intervalo de Impressao   		     |
  */
	If nContFun > 25 .And. nDestino == 1 &&Se for impressora.
		nLin 		:= 320
		Gper560Cab(@nLin,aInfoFil)
		nContFun := 1
	EndIf		
	If nDestino == 1 
		Gper560Det(@nLin)
		If nContFun == 25
			oImp:EndPage()
		EndIf
		nContFun++
	Else
      If Empty(cArqGravar) .And. lPerNome
			cArqGravar := cGetFile(STR0001,OemToAnsi(STR0002),,"C:\",.T.,GETF_LOCALHARD) //"Arquivo Texto|*.TXT"###"Salvar Pesquisa..."
			nArquivo := fOpen(cArqGravar,1)
			If nArquivo == -1 .And. !Empty(cArqGravar)
				nArquivo := fCreate(cArqGravar)
			Else
				lPerNome := .F.
			Endif
		EndIf
		If nArquivo != 0
			Gper560Txt(nArquivo)
		EndIf			
	EndIf		
	SRA->(dbSkip())
Enddo

If nDestino == 1
	oImp:EndPage()
	oImp:Setup()
	oImp:Preview()
	MS_FLUSH()
Else
	If nArquivo != 0
		fClose(nArquivo)
	EndIf
EndIf	

Return

/*

Ŀ
Funo     Gper560Cab   Autor   Alexandre Silva     Data 03/04/03 
Ĵ
Descrio  Faz do cabecalho do Relatorio.                             
ٱ

*/
Static Function Gper560Cab(nLin,aInfoFil)

Local cIDSS			:= ""
Local cApolice		:= ""
Local cEmpregador	:= ""
Local cNomeInst	:= ""
Local cEndEletro	:= ""
Local cRamoAtivid := ""
Local	cCGC 			:= aInfoFil[08] 
Local cRazSocial	:= aInfoFil[03] 
Local	cRua      	:= aInfoFil[04] 
Local	cBairro   	:= aInfoFil[13] 
Local	cMunicipio	:= aInfoFil[05] 
Local cTelefone	:= aInfoFil[10]
Local	cEstado   	:= Substr(fDesc("SX5","12"+aInfoFil[6],"X5DESCRI()"),1,20)
Local nCol			:= 0

oImp:StartPage()

If FpHist82(xFilial("SRX"),"99") 
	cIDSS    	:= SubStr(SRX->RX_TXT ,001,11) //Numero de IDSS
	cApolice 	:= SubStr(SRX->RX_TXT ,012,10) // Numero da Apolice
	cEmpregador	:= SubStr(SRX->RX_TXT ,022	,30) // Nombre del Empleador o Representante
	FpHist82(xFilial("SRX"),"99","2") 
	cNomeInst	:= SubStr(SRX->RX_TXT ,001	,30)
 	cRamoAtivid := SubStr(SRX->RX_TXT ,031	,20)
	FpHist82(xFilial("SRX"),"99","3") 
	cEndEletro	:= SubStr(SRX->RX_TXT ,001	,30)
Endif

oImp:Say(nLin+=000,nCol:=0500,cCGC 		,oFont10,50)
oImp:Say(nLin+=100,nCol:=0500,cIDSS    	,oFont10,50)
oImp:Say(nLin+=100,nCol:=0650,cApolice 	,oFont10,50)
oImp:Say(nLin+=100,nCol:=0500,cRazSocial	,oFont10,50)
oImp:Say(nLin+=000,nCol+=2900,cEmpregador,oFont10,50)
oImp:Say(nLin+=100,nCol:=0800,cNomeInst  ,oFont10,50)

oImp:Say(nLin+=100,nCol:=0600,cRua       ,oFont10,50)
oImp:Say(nLin+=000,nCol+=1500,cBairro    ,oFont10,50)
oImp:Say(nLin+=000,nCol+=1000,cMunicipio ,oFont10,50)
oImp:Say(nLin+=000,nCol+=1000,cEstado    ,oFont10,50)

oImp:Say(nLin+=100,nCol:=0500,cTelefone  ,oFont10,50)
oImp:Say(nLin+=000,nCol+=1400,cEndEletro ,oFont10,50)

oImp:Say(nLin+=080,nCol:=0760,cRamoAtivid,oFont10,50)
nLin+=292

Return     

/*

Ŀ
Funo     Gper560Det   Autor   Alexandre Silva     Data 03/04/03 
Ĵ
Descrio  Faz a impressao do Detalhe do Relatorio.                   
ٱ

*/
Static Function Gper560Det(nLin)

Local nX
Local cNacion	:= ""
Local cFuncao	:= ""
Local dFerDe,DFerAte 	
Local cFerDe,cFerAte	
Local nCol		:= 150
Local aFeriados	:=	RetFeriados()

dFerDe := Ctod(STRZERO(Day(SRA->RA_ADMISSA),2)+"/"+Strzero(Month(SRA->RA_ADMISSA),2)+"/"+cAnoRef,"ddmmyy")
For nX := 1 to 6
	If Dow(dFerDe) <> 2 
		dFerDe +=1
	Endif	
Next
While Ascan(aFeriados,DTOS(dFerDe)) <> 0
	dFerDe+=1
EndDo

dFerAte := LocFimFer(dFerDe,14,'1',.T.,.T.,.T.)-1
cFerDe  := DTOC(dFerDe)
cFerATe :=DTOC(dFerAte)  

SX5->(dbSetOrder(1))
SRJ->(dbSetOrder(1))
SX5->(dbSeek(xFilial("SX5")+"34"+SRA->RA_NACIONA))
SRJ->(dbSeek(xFilial("SRJ")+SRA->RA_CODFUNC))
cNacion	:= Alltrim(X5Descri())
cFuncao	:= Substr(Alltrim(SRJ->RJ_DESC),1,15)

oImp:Say(nLin,nCol+=0000,SRA->RA_NOME										,oFont08,50)
oImp:Say(nLin,nCol+=1300,Alltrim(SRA->RA_RG)							,oFont08,50)
oImp:Say(nLin,nCol+=0470,DtoC(SRA->RA_NASC)								,oFont08,50)
nCol+=370
oImp:Say(nLin,nCol+Iif(SRA->RA_SEXO == "M",0,80),"X"					,oFont08,50)
oImp:Say(nLin,nCol+=0250,cNacion												,oFont08,50)
oImp:Say(nLin,nCol+=0450,DtoC(SRA->RA_ADMISSA)							,oFont08,50)
oImp:Say(nLin,nCol+=0300,cFuncao											 	,oFont08,50)
If SRA->RA_CATFUNC == "H"
	oImp:Say(nLin,nCol+=0200, Trim(Trans((SRA->RA_SALARIO * SRA->RA_HRSMES),cPictSal))	,oFont08,50)
ElseIf SRA->RA_CATFUNC == "D"
	oImp:Say(nLin,nCol+=0200, Trim(Trans((SRA->RA_SALARIO * 30),cPictSal))	,oFont08,50)
ElseIf SRA->RA_CATFUNC == "M"
	oImp:Say(nLin,nCol+=0200, Trim(Trans(SRA->RA_SALARIO,cPictSal))	,oFont08,50)
Endif
oImp:Say(nLin,nCol+=0600,SRA->RA_TNOTRAB									,oFont08,50)
oImp:Say(nLin,nCol+=0280,Subst(cFerDe	,1,Rat("/",cFerDe )-1)+ " - " + Subst(cFerAte	,1,Rat("/",cFerAte)-1),oFont08,50)

nLin += 63

Return 

/*

Ŀ
Funo     Gper560Txt   Autor   Alexandre Silva     Data 03/04/03 
Ĵ
Descrio  Faz a geracao do Arquivo de exportacao no formato TXT.     
ٱ

*/
Static Function Gper560Txt(nArquivo)

Local cLinha	:= ""
Local cNacion	:= ""
Local cFuncao	:= ""
Local dFerDe,DFerAte 	
Local cFerDe,cFerAte	
Local aFeriados	:=	RetFeriados()
Local nX

dFerDe := Ctod(STRZERO(Day(SRA->RA_ADMISSA),2)+"/"+Strzero(Month(SRA->RA_ADMISSA),2)+"/"+cAnoRef,"ddmmyy")
For nX := 1 to 6
	If Dow(dFerDe) <> 2 
		dFerDe +=1
	Endif	
Next
While Ascan(aFeriados,DTOS(dFerDe)) <> 0
	dFerDe+=1
EndDo

dFerAte := LocFimFer(dFerDe,14,'1',.T.,.T.,.T.)-1
cFerDe  := DTOC(dFerDe)
cFerATe :=DTOC(dFerAte)  

SX5->(dbSetOrder(1))
SRJ->(dbSetOrder(1))
SX5->(dbSeek(xFilial("SX5")+"34"+SRA->RA_NACIONA))
SRJ->(dbSeek(xFilial("SRJ")+SRA->RA_CODFUNC))
cNacion	:= Alltrim(X5Descri())
cFuncao	:= Substr(Alltrim(SRJ->RJ_DESC),1,15)

cLinha 	:= SRA->RA_NOME 	+ "|"
cLinha 	+= Alltrim(SRA->RA_RG)+ "|"
cLinha 	+= DtoC(SRA->RA_NASC)+ "|"
cLinha 	+=	Iif(SRA->RA_SEXO == "M","X| |"," |X|")
cLinha 	+= cNacion + "|" 
cLinha	+= DtoC(SRA->RA_ADMISSA)+ "|" 
cLinha	+= cFuncao + "|" 
If SRA->RA_CATFUNC == "H"
	cLinha	+=	rTrim(Trans((SRA->RA_SALARIO * SRA->RA_HRSMES),cPictSal))+ "|" 
ElseIf SRA->RA_CATFUNC == "D"
	cLinha	+=	rTrim(Trans((SRA->RA_SALARIO * 30),cPictSal))+ "|" 
ElseIf SRA->RA_CATFUNC == "M"
	cLinha	+=	rTrim(Trans(SRA->RA_SALARIO,cPictSal))+ "|" 
Endif
cLinha	+= SRA->RA_TNOTRAB + "|" 
cLinha	+= Subst(cFerDe	,1,Rat("/",cFerDe )-1)+ " - " + Subst(cFerAte	,1,Rat("/",cFerAte)-1)

If nArquivo != -1
	fSeek(nArquivo,0,2)
	fWrite(nArquivo,cLinha+chr(13)+chr(10)) 
EndIf

Return 
