#INCLUDE "protheus.CH"
#Include "GPEA110.CH"
#Include "report.CH"
#IFDEF TOP
	#INCLUDE "TOPCONN.CH"
#ENDIF
                
/*/


Ŀ
Funcao     GPER570  Autor  Natie Sugahara          Data   30/12/03  
Ĵ
Descricao  Relaciona os Lancamento Futuros do SRK                       
                                                                        
                                                                        
                                                                        
Ĵ
Sintaxe    GPER570()                                                    
Ĵ
 Uso       Advanced Protheus                                            
Ĵ
 Alteracoes desde sua construcao inicial                                 
Ĵ
Programador  Data      BOPS   Motivo da Alteracao                     
Ĵ
Tania       18/04/2006|088714|O relatorio foi alterado para formato ho- 
                      |      |rizontal, e foi incluida a coluna Parc.Pg.
                      |      |para apresentar as parcelas ja pagas.     
Natie       16/10/2006|100227|Reajuste R4                               
Pedro Eloy  23/02/2007|117458|Melhoria- criacao dos parametros Cat/Sit. 
Natie       16/05/2007|122939|Ajuste na Impressao do total da quebra de 
                      |      |filial ( R3) e subst. xfilial()           
Francisco Jr30/11/2009028378Compatibilizar fonte com projeto corporati
                            vo.                                       
                                                                      
Luciana     12/07/2011010070Habilitao do campo RK_REGRADS para       
                        2011exibicao na tela de cadastro dos Valores   
                            Futuros.                                  
Ŀ
Programador  Data      FNC / CHAMADO    Motivo da Alteracao                  		
Ĵ
Luis Ricardo30/05/201200000013734/2012Tratamento para permitir impressao no relat.
Cinalli	   		  Chamado: TEWDGI personalizavel (R4) para usuario que possui 
			   		  				   restricao de acesso para Empresa e Filial.	
			   		  				   Ajuste no Grupo de Perguntas GPR570 para im-
			   		  				   pressao do relat. nao personalizavel.		
ٱ

/*/               
Function GPER570() 

Local oReport 
Private cTitulo		:= OemToAnsi(STR0009)			//"VAlores Futuros "
Private cAliasSRK	:= "SRK"
Private cCategoria	:= ""
Private cSituacao	:= ""

//Efetua ajuste do campo RK_REGRADS
AjustaSX3()

If FindFunction("TRepInUse") .And. TRepInUse()

	//-- Interface de impressao
	Pergunte("GP570R",.F.)
   	oReport := ReportDef()
	oReport:PrintDialog()

Else
	GPER570R3()
EndIF    

Return

/*


Ŀ
Funo     ReportDef Autor  R.H. - Tatiane Matias  Data  12.06.06 
Ĵ
Descrio  Definicao do relatorio                                     
ٱ

*/
Static Function ReportDef()

Local oReport 
Local oSection1
Local oSection2
Local aOrd		:= { OemToansi(STR0019)}	//-- Matricula + PD 
Local cTit		:= ""

	DEFINE REPORT oReport NAME "GPER570" TITLE cTitulo PARAMETER "GP570R" ACTION {|oReport| PrintReport(oReport)}  DESCRIPTION  OemToAnsi(STR0045)  //-- Esta rotina gera um extrato para cada funcionrio dos valores futuros lancados e que sero gerados em  folha de pagamento conforme  a data de vencimento.
	oReport:SetTotalInLine(.F.)
	oReport:FunctionBefore(.T.)
   	
		DEFINE SECTION oSection1 OF oReport TABLES "SRK", "SRA" ORDERS aOrd TITLE STR0039 	//-- Valores Futuros 
		oSection1:SetTotalInLine(.F.)
		oSection1:SetLineStyle()										//-- Faz a impressao das celulas sequencialmente		
		
			DEFINE CELL NAME "RK_FILIAL" 	OF oSection1 ALIAS "SRK"
			DEFINE CELL NAME "RK_MAT" 		OF oSection1 ALIAS "SRK"
			DEFINE CELL NAME "RA_NOME"		OF oSection1 ALIAS "SRA"

			TRPosition():New(oSection1,"SRA",1,{|| SRK->RK_FILIAL+SRK->RK_MAT})

		DEFINE SECTION oSection2 OF oSection1 TABLES "SRK", "SRV" TITLE STR0009
		
			DEFINE CELL NAME "RK_PD" 		OF oSection2 ALIAS "SRK"
			DEFINE CELL NAME "RV_DESC"		OF oSection2 ALIAS "SRV"   
			DEFINE CELL NAME "RK_VALORTO"	OF oSection2 ALIAS "SRK"
			DEFINE CELL NAME "RK_PARCELA"	OF oSection2 ALIAS "SRK"
			DEFINE CELL NAME "RK_VALORPA"	OF oSection2 ALIAS "SRK"
			DEFINE CELL NAME "RK_JUROANO"	OF oSection2 ALIAS "SRK" 
			DEFINE CELL NAME "RK_JUROMES"	OF oSection2 ALIAS "SRK"
			DEFINE CELL NAME "VLCOMJUROS"	OF oSection2 ALIAS "   " TITLE oEmToAnsi(STR0041) PICTURE "@E 999,999,999.99"  //-- VLR C/jUROS 
			DEFINE CELL NAME "RK_VLRPAGO"	OF oSection2 ALIAS "SRK"
			DEFINE CELL NAME "RK_PARCPAG"	OF oSection2 ALIAS "SRK"
			DEFINE CELL NAME "RK_VALORAR"	OF oSection2 ALIAS "SRK"
			DEFINE CELL NAME "RK_DTVENC"	OF oSection2 ALIAS "SRK"
			DEFINE CELL NAME "RK_DTMOVI"	OF oSection2 ALIAS "SRK"

			TRPosition():New(oSection2,"SRV",1,{|| RHFilial( "SRV", SRK->RK_FILIAL) + SRK->RK_PD})
			
		DEFINE BREAK oBreak OF oReport WHEN oSection1:Cell("RK_FILIAL") TITLE oemtoAnsi(STR0021)		//--"Total da Filial"  
		oBreak:FunctionBefore(.T.)
		
		DEFINE COLLECTION OF oSection2 FUNCTION COUNT FORMULA {||oSection2:Cell("RK_PD"):GetValue(.T.) + " - " + oSection2:Cell("RV_DESC"):GetValue(.T.)} CONTENT oSection2:Cell("RK_PD") 	    BREAK oBreak  TITLE OemToAnsi(STR0046) 	NO END SECTION  
		DEFINE COLLECTION OF oSection2 FUNCTION SUM FORMULA  oSection2:Cell("RK_PD") CONTENT oSection2:Cell("RK_VALORTO") 	BREAK oBreak  TITLE OemToAnsi(STR0040) PICTURE "@E 999,999,999.99" 	NO END SECTION
		DEFINE COLLECTION OF oSection2 FUNCTION SUM FORMULA  oSection2:Cell("RK_PD") CONTENT oSection2:Cell("RK_VALORPA") 	BREAK oBreak  TITLE OemToAnsi(STR0042) PICTURE "@E 999,999,999.99" 	NO END SECTION
		DEFINE COLLECTION OF oSection2 FUNCTION SUM FORMULA  oSection2:Cell("RK_PD") CONTENT oSection2:Cell("VLCOMJUROS") 	BREAK oBreak  TITLE OemToAnsi(STR0041) PICTURE "@E 999,999,999.99" 	NO END SECTION
		DEFINE COLLECTION OF oSection2 FUNCTION SUM FORMULA  oSection2:Cell("RK_PD") CONTENT oSection2:Cell("RK_VLRPAGO") 	BREAK oBreak  TITLE OemToAnsi(STR0043) PICTURE "@E 999,999,999.99" 	NO END SECTION
		DEFINE COLLECTION OF oSection2 FUNCTION SUM FORMULA  oSection2:Cell("RK_PD") CONTENT oSection2:Cell("RK_VALORAR") 	BREAK oBreak  TITLE OemToAnsi(STR0044) PICTURE "@E 999,999.99" 		NO END SECTION

		DEFINE FUNCTION FROM oSection2:Cell("RK_VALORTO") FUNCTION SUM BREAK oBreak NO END SECTION TITLE OemToAnsi(STR0040) Of oSection1
		DEFINE FUNCTION FROM oSection2:Cell("VLCOMJUROS") FUNCTION SUM BREAK oBreak NO END SECTION TITLE OemToAnsi(STR0041) Of oSection1
		DEFINE FUNCTION FROM oSection2:Cell("RK_VALORPA") FUNCTION SUM BREAK oBreak NO END SECTION TITLE OemToAnsi(STR0042) Of oSection1
		DEFINE FUNCTION FROM oSection2:Cell("RK_VLRPAGO") FUNCTION SUM BREAK oBreak NO END SECTION TITLE OemToAnsi(STR0043) Of oSection1
		DEFINE FUNCTION FROM oSection2:Cell("RK_VALORAR") FUNCTION SUM BREAK oBreak NO END SECTION TITLE OemToAnsi(STR0044) Of oSection1
		                          
		//Ŀ
		// Personaliza titulos das quebras                              
		//
		oBreak:OnBreak({|x,y|,cTit:=oemtoAnsi(STR0021)+x  })
    	oBreak:SetTotalText({||cTit})
		
Return oReport

/*


Ŀ
Funo     ReportDef Autor  R.H. - Tatiane Matias  Data  12.06.06 
Ĵ
Descrio  Definicao do relatorio                                     
ٱ

*/
Static Function PrintReport(oReport)
                     
//-- Objeto
Local oSection1 	:= oReport:Section(1)
Local oSection2 	:= oReport:Section(1):Section(1)

//-- String
Local cFiltro		:= ""  
Local cFilSRV		:= ""
Local cFilSRK		:= ""
Local cQVerba		:= ""  
Local cAcessaSRK	:= &( " { || " + ChkRH( "GPER570" , "SRK" , "2" ) + " } " )

//-- Numerica
Local nVer			:= 0
Local nReg			:= 0
Private lCorpManage	:= fIsCorpManage( FWGrpCompany() )	// Verifica se o cliente possui Gesto Corporativa no Grupo Logado                        
 
		oSection2:Cell("VLCOMJUROS"):SetBlock({|| Val(oSection2:Cell("RK_VALORPA"):GetText()) * Val(oSection2:Cell("RK_PARCELA"):GetText())}) 
	
	/*Ŀ
	   Acessa parametros do relatorio...                                        
	   Variaveis utilizadas para parametros                                     
	  */
	cVerbas 		:= mv_par06		//--  Verbas 

	//Ŀ
	// Faz filtro no arquivo...                                                 
	//
	#IFDEF TOP
		cFilSRK := " SRK.RK_FILIAL = SRA.RA_FILIAL "
		cFilSRK := "%" + cFilSRK + "%"
		
	   	If lCorpManage
	   		cFilSRV := "RV_FILIAL = '"	+ xFilial( "SRV", SRA->RA_FILIAL ) + "'"
	 	Else
			cFilSRV := If ( SRV->(xFilial()) == Space(FWGETTAMFILIAL) , "SRV.RV_FILIAL = '"+ Space(FWGETTAMFILIAL)+"'", " SRV.RV_FILIAL = SRA.RA_FILIAL ")
		Endif
		cFilSRV:= "%" + cFilSRV + "%"
		
		cAliasSRK := GetNextAlias()

		MakeSqlExpr("GP570R")
	
		cQVerba := ""
		For nReg:=1 to Len(cVerbas) Step 3
			cQVerba += "'"+Subs(cVerbas,nReg,3)+"'"
			If ( nReg+3 ) <= Len(cVerbas)
				cQVerba += "," 
			Endif
		Next nReg
		cQVerba := "%" + cQVerba + "%"

		oSection1:BeginQuery()
	
		BeginSql alias cAliasSRK 

			SELECT 	SRK.RK_FILIAL   , SRK.RK_MAT, SRA.RA_NOME, SRK.RK_PD, SRV.RV_DESC, 
					SRK.RK_VALORTO  , SRK.RK_PARCELA, SRK.RK_VALORPA, SRK.RK_JUROANO, SRK.RK_JUROMES,
					(SRK.RK_VALORPA * SRK.RK_PARCELA),
					SRK.RK_VLRPAGO  , SRK.RK_PARCPAG, SRK.RK_VALORAR, SRK.RK_DTVENC, SRK.RK_DTMOVI
		
			FROM %table:SRK% SRK, %table:SRA% SRA, %table:SRV% SRV
                                                           
			WHERE %exp:cFilSRK%  AND 
		  		  %exp:cFilSRV%  AND
				  SRK.RK_MAT    = SRA.RA_MAT AND
				  SRK.RK_PD     = SRV.RV_COD AND
				  SRK.RK_PD IN (%exp:Upper(cQVerba)%) AND
				  SRK.%notDel%   AND   
				  SRV.%notDel%   AND
  				  SRA.%notDel% 

			ORDER BY SRK.RK_FILIAL,SRK.RK_MAT,SRK.RK_PD
			
		EndSql 
		oSection1:EndQuery({mv_par01, mv_par02, mv_par03, mv_par04, mv_par05})
	
		oSection2:SetParentQuery()
	#ELSE                      
		cAliasSRK := "SRK"
		
		MakeAdvplExpr("GP570R")  

		//-- Filial
		If !Empty(mv_par01)
			cFiltro += mv_par01 
		EndIf

		//-- Matricula
		If !Empty(mv_par02)   
			cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
			cFiltro += mv_par02 
		EndIf

		//-- Centro de Custo
		If !Empty(mv_par03)
			cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
			cFiltro += mv_par03
		EndIf

		//-- Data de Movimento
		If !Empty(mv_par04)   
			cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
			cFiltro += mv_par04
		EndIf

		//-- Data de Vencimento
		If !Empty(mv_par05)   
			cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
			cFiltro += mv_par05 
		EndIf
                                
		//-- Monta o as Verbas                                            
		cVerbas 	:= Alltrim(cVerbas)
		For nVer := 1 To Len(cVerbas) Step 3
			cQVerba	+= Substr(cVerbas,nVer,3)
			cQVerba 	+= "*"
		Next               
		cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
		cFiltro += 'RK_PD $ "' + cQVerba + '"'

	  	oSection1:SetFilter(cFiltro) 
	#ENDIF	
	cSituacao	:= mv_par07
	cCategoria	:= mv_par08
	
	oSection2:SetParentFilter({|cParam| (cAliasSRK)->RK_FILIAL + (cAliasSRK)->RK_MAT == cParam},{|| (cAliasSRK)->RK_FILIAL + (cAliasSRK)->RK_MAT })
	
	//Ŀ
	// Personaliza titulos                                          
	//
	cTitulo := If(AllTrim(oReport:Title())==AllTrim(cTitulo),cTitulo ,oReport:Title()  ) 
	oReport:SetTitle(cTitulo)
		
	dbSelectArea("SRK")
	dbSetOrder(1)

	oSection1:SetLineCondition({|| (cAliasSRK)->( ( RK_FILIAL $ fValidFil() ) .And. Eval( cAcessaSRK )  .And. fSitCatR570()  )} )
	oSection1:Print()
Return


/*


ͻ
Programa  GPER570   Autor  Microsiga            Data   02/23/07   
͹
Desc.                                                                 
                                                                      
͹
Uso        AP                                                        
ͼ


*/

Function fSitCatR570()
Local lRet			:= .f.
Local aArmazAlias	:= GetArea()

dbSelectArea("SRA")
dbSetOrder(1)
If dbSeek( (cAliasSRK)->RK_FILIAL + (cAliasSRK)->RK_MAT )
	If	( SRA->RA_SITFOLH $ cSituacao ) .And.  ( SRA->RA_CATFUNC $ cCategoria )
		lRet	:= .T.
	Endif
Endif

RestArea(aArmazAlias)
Return(lRet)




/*/


Ŀ
Funcao    GPER570R3 Autor  Natie Sugahara          Data   30/12/03  
Ĵ
Descricao  Relaciona os Lancamento Futuros do SRK                       
                                                                        
                                                                        
                                                                        
Ĵ
Sintaxe    GPER570R3()                                                  
Ĵ
 Uso       Advanced Protheus                                            
ٱ
Ĵ
Programador  Data      BOPS   Motivo da Alteracao                     
Ĵ
Pedro Eloy  23/02/2007|117458|Melhoria- criacao dos parametros Cat/Sit. 


/*/               
Function GPER570R3() 

/*Ŀ
   Define variaveis padroes para todos os relatorios...                     
  */
PRIVATE wnRel
PRIVATE cNomeProg   := "GPER570"
PRIVATE nLimite     := 132
PRIVATE nTamanho    := "G"
PRIVATE Titulo		:= oEmToAnsi(STR0009)				//-- LANCAMENTOS FUTUROS 
PRIVATE cDesc1      := oEmToAnsi(STR0009)
PRIVATE cDesc2      := ""
PRIVATE cDesc3      := "" 
PRIVATE cAliasSRK   := "SRK" 
PRIVATE cPerg       := "GPR570" 
PRIVATE Li         	:= 0
PRIVATE m_pag       := 1
PRIVATE lCompres    := .F.
PRIVATE lDicion     := .F.
PRIVATE lFiltro     := .T.
PRIVATE lCrystal    := .F.
PRIVATE aReturn     := { "", 1,"" , 2, 1, 1, "",1 } 
PRIVATE aOrd		:= { oemToansi(STR0019)}														//-- Matricula + PD 
PRIVATE lAbortPrint := .F.
PRIVATE cCabec1     := ""
PRIVATE cCabec2     := ""

//Ŀ
// Variaveis Utilizadas na funcao IMPR                          
//
PRIVATE cCabec 
PRIVATE Colunas		:= 132 
PRIVATE AT_PRG  	:= "GPER570" 
PRIVATE wCabec0 	:= 1
PRIVATE wCabec1		:= oEmToAnsi(STR0020)
PRIVATE wCabec2		:=""
PRIVATE wCabec3		:=""
PRIVATE wCabec4		:=""
PRIVATE wCabec5		:=""
PRIVATE wCabec6		:=""
PRIVATE wCabec7		:=""
PRIVATE wCabec8		:=""
PRIVATE wCabec9		:=""
PRIVATE CONTFL		:=1
PRIVATE cPathPict	:= ""

// Ajuste no Sx1 para a incluso categoria/situao
AjustaSX1()

/*Ŀ
   Carrega parametros de Impressao                              
  */
Pergunte( cPerg, .F. )

/*Ŀ
   Envia controle para a funcao SETPRINT                        
  */
wnrel:="GPER570"					           //Nome Default do relatorio em Disco 
wnrel:=SetPrint(cAliasSRK,wnrel,cPerg,@Titulo,cDesc1,cDesc2,cDesc3,.F.,aOrd,,nTamanho) 

/*Ŀ
  | Verifica se foi cancelada a operacao                                     
  */
If nLastKey  == 27
	Return
Endif
/*Ŀ
   Configura impressora                                                     
  */
SetDefault(aReturn,cAliasSRK)
If nLastKey = 27
	Return
Endif 

MsAguarde({|lEnd| R570Imp(@lEnd,wnRel,cAliasSRK)},Titulo)
Return

/*/ 


Ŀ
Programa    R570Imp   Autor  Natie Sugahara         Data  30/12/03 
Ĵ
Descricao   Emite relatorio                                            
ٱ

*/
Static Function R570Imp(lEnd,WnRel,cString)

//Ŀ
// Define Variaveis Locais (Programa)                           
//
Local cFil_Ant	:= ""
Local cFilMat	:= ""							
Local cQVerba	:= ""							//-- Verbas
Local aAreaSRA	:= GetArea("SRA")
Local aTotal 	:= {}							//-- array dos totalizadores
Local x	:= 0 

/*
Ŀ
 Variaveis de Acesso do Usuario                               
*/
Local cAcessaSRK	:= &( " { || " + ChkRH( "GPER570" , "SRK" , "2" ) + " } " )
Local cAcessaSRD	:= &( " { || " + ChkRH( "GPER570" , "SRD" , "2" ) + " } " )

Private aInfo   	:= {}         // Matriz com dados da empresa     
Private aTitulo   	:= {} 

//Ŀ
// Variaveis totalizadores                                      
//
Private nTotGPrin	:= 0
Private nTotGParc	:= 0
Private nTotGPago	:= 0
Private nTotGResi	:= 0
Private nTotGJuros	:= 0

//Ŀ
// Define Ordem Do Relatorio                                    
//
nOrdem  := aReturn[8] 

/*Ŀ
   Acessa parametros do relatorio...                                        
   Variaveis utilizadas para parametros                                     
  */
cFilDe		:= mv_par01      	//--  FiLial De
cFilAte		:= mv_par02      	//--  FiLial Ate  
cMatDe		:= mv_par03      	//--  Matricula De  
cMatAte		:= mv_par04      	//--  Matricula Ate 
cCCDe		:= mv_par05     	//--  Centro De Custo De
cCCAte		:= mv_par06     	//--  Centro De Custo Ate
dDtMovDe	:= mv_par07     	//--  Data Movimento De
dDtMovAte	:= mv_par08     	//--  Data Movimento Ate
dDtVctoDe	:= mv_par09     	//--  Data Vencimento De 
dDtvctoAte	:= mv_par10   		//--  Data Vencimento Ate
cVerbas 	:= mv_par11 		//--  Verbas 
cCategoria	:= mv_par12         // Categoria
cSituacao	:= mv_par13			// Situacao

//Ŀ
// Monta o as Verbas                                            
//
cVerbas 	:= Alltrim(cVerbas)
For X=1 To len(cVerbas) step 3
	cQVerba	+= substr(cVerbas,X,3)
	cQVerba += "*"
Next
   
//Ŀ
// Posiciona no Primeiro Registro Selecionado                   
//
dbSelectArea("SRK")
dbSetOrder(1) 

SRK->( dbSeek( cFilDe + cMatDe, .T. ) )
cInicio  := "SRK->RK_FILIAL + SRK->RK_MAT"
cFim     := cFilAte + cMatAte 

//Ŀ
// Carrega Regua de Processamento                               
//
cFilMat := Replicate("!", FWGETTAMFILIAL)
cFil_Ant	:= SRK->RK_FILIAL
While SRK->( !Eof() .And. &cInicio <= cFim )

	If lEnd 
		@Prow()+1,0 PSAY cCancel
		Exit 
    Endif

	//Ŀ
	// Imprime os totais da qeubra de filial                        
	//
   	IF cFil_Ant != SRK->RK_FILIAL  .and. Len(aTotal) > 0 
		ImprTotais(aTotal)	
		aTotal 	:= {}
		cFil_Ant := SRK->RK_FILIAL 
	Endif

	//Ŀ
	// Consiste Parametrizacao do Intervalo de Impressao            
	//
	If (SRK->RK_MAT < cMatDe) .Or. (SRK->RK_MAT > cMatAte)    .Or. ; 
		(SRK->RK_CC  < cCCDe) .Or. (SRK->RK_CC  > cCcAte )    .or. ;  
		(dtos(SRK->RK_DTMOVI) < dtos(dDtMovDe)) .or. (dtos(SRK->RK_DTMOVI) > dtos(dDtMovAte)) .or. ;
		(dtos(SRK->RK_DTVENC) < dtos(dDtVctoDe)) .or.(dtos(SRK->RK_DTVENC) >  dtos(dDtVctoAte))
		SRK->(dbSkip()) 
		Loop 
	EndIf   
	      
	//Ŀ
	// Consiste Verbas                                              
	//
	If 	!(SRK->RK_PD $ cQVerba) 
		SRK->(dbSkip()) 
		Loop 
	Endif
	/*
	Ŀ
	Consiste Filiais e Acessos                                             
	*/
	IF SRK->( !( RK_FILIAL $ fValidFil() ) .or. !Eval( cAcessaSRK ) )
      	SRK->( dbSkip() )
       	Loop
	EndIf
	//Ŀ
	// Despreza Registros Conforme Situacao e Categoria Funcionarios
	//
	dbSelectArea("SRA")
	dbSetOrder(1)
	dbSeek(SRK->RK_FILIAL + SRK->RK_MAT )
	If	!( SRA->RA_SITFOLH $ cSituacao ) .OR.  !( SRA->RA_CATFUNC $ cCategoria )
      	SRK->( dbSkip() )
       	Loop
	Endif

	/*
	         10        20        30        40        50        60        70        80        90       100       110        120      130       140       150       160       170       180
	0123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456
    Cod.  Descricao Verba       Vlr. Principal     Parc.      Vlr. Parcela    Jrs. ano    Jrs. Mes      Valor c/Juros         Valor Pago     Parc.Pg.     Vlr.Residuo      Dt.Vcto      Dt.Mvto
	999   xxxxxxxxxxxxxxxxx     999,999,999.99      999     999,999,999.99      999,99      999.99     999,999,999.99     999,999,999.99        999        999,999.99     99/99/99     99/99/99*/

	If cFilMat <>  SRK->(RK_FILIAL + RK_MAT )
		Impr("","C")
		cDet	:= oemtoAnsi(STR0011)+ SPACE(1) + SRK->RK_FILIAL  + SPACE(1) +  SRK->RK_MAT + SPACE(1) + left(SRA->RA_NOME,30)  //LEFT(fDesc("SRA", SRK->RK_MAT,"RA_NOME"),30) 
		Impr(cDet,"C") 
		cFilMat	:= SRK->(RK_FILIAL + RK_MAT )
	Endif                                                                                       
	cDet	:= SRK->RK_PD + SPACE(3)+ left(fDesc("SRV", SRK->RK_PD,"RV_DESC" ),17) + space(5) 
	cDet	+= Transform(SRK->RK_VALORTO,"@E 999,999,999.99") + space(6) + Transform(SRK->RK_PARCELA,"@E 999" )   + space(5) 
	cDet	+= Transform(SRK->RK_VALORPA,"@E 999,999,999.99") + space(6) + Transform(SRK->RK_JUROANO,"@E 999.99") + space(6)
	cDet	+= Transform(SRK->RK_JUROMES, "@E 999.99")        + SPACE(5) + Transform((SRK->RK_VALORPA * SRK->RK_PARCELA),"@E 999,999,999.99") + space(5)
	cDet	+= Transform(SRK->RK_VLRPAGO,"@E 999,999,999.99") + Space(9) + Transform(SRK->RK_PARCPAG, "@E 999")   + space(7)
	cDet	+= Transform(SRK->RK_VALORAR,"@E 999,999.99")     + space(5) + dToC(SRK->RK_DTVENC,"DDMMYY")  + SPACE(5)
	cDet	+= dToC(SRK->RK_DTMOVI,"DDMMYY")  
	
	Impr(cDet,"C") 
	
	//Ŀ
	// Totalizadores                                                
	//
	fTotalVlr( @aTotal )
	SRK->( dbSkip() ) 
Enddo
//Ŀ
// Imprime os totais                                            
//
If len(aTotal ) > 0 

	ImprTotais(aTotal)
	/*Ŀ
	   Total Geral                                                  
	  */
	Impr("","C")
	cDet:= oemToAnsi(STR0022) + Space(10)
 	cDet+= Transform(nTotGPrin ,"@E 999,999,999.99") + Space(14)	 						//-- Valor Principal 
 	cDet+= Transform(nTotGParc ,"@E 999,999,999.99") + Space(29)							//-- Valor Parcela 
	cDet+= Transform(nTotGJuros,"@E 999,999,999.99") + space(5)							//-- Valor Total c/Juros 
	cDet+= Transform(nTotGPago ,"@E 999,999,999.99") + Space(19)							//-- Valor pago 
  	cDet+= Transform(nTotGResi ,"@E 999,999.99") 											//-- Valor Residuo  
	Impr(cDet,"C")
Endif	
//Ŀ
// Termino do relatorio                                         
//
If (aReturn[5] = 1 )
	Set Printer To
	Commit
	ourspool(wnrel)
Endif             
//Ŀ
// Restaura Area de Trabalho                                    
//
RestArea(aAreaSRA)
MS_FLUSH()       
Return

/*/ 


Ŀ
Programa    fTotalVlr Autor  Natie Sugahara         Data  30/12/03 
Ĵ
Descricao   Efetua totalizacao dos valores                             
ٱ

*/
Static Function  fTotalVlr(aTot)
Local nPos	:= 0 
 
nPos := Ascan(aTot,{ |x| x[1] + x[2]  == SRK->RK_FILIAL + SRK->RK_PD } ) 
If nPos > 0 
	aTot[nPos,3]+= SRK->RK_VALORTO 
	aTot[nPos,4]+= (SRK->RK_VALORPA * SRK->RK_PARCELA)
	aTot[nPos,5]+= SRK->RK_VALORPA 
	aTot[nPos,6]+= SRK->RK_VLRPAGO 
	aTot[nPos,7]+= SRK->RK_VALORAR 
Else 
	aadd(aTot,{ SRK->RK_FILIAL ,SRK->RK_PD , SRK->RK_VALORTO ,(SRK->RK_VALORPA * SRK->RK_PARCELA) ,SRK->RK_VALORPA,SRK->RK_VLRPAGO,SRK->RK_VALORAR }) 
Endif

Return()

/*/ 


Ŀ
Programa   ImprTotais Autor  Natie Sugahara         Data  30/12/03 
Ĵ
Descricao  Impressao dos Totais da Filial                              
ٱ

*/
Static Function ImprTotais(aTotal) 
Local cDet 		:= ""
Local cFilTot	:= ""
Local nX		:= 0
Local nTotPrin	:= 0
Local nTotParc	:= 0
Local nTotPago	:= 0
Local nTotResi	:= 0
Local nTotJuros	:= 0
		
Impr("","C") 
For nX:= 1 to Len(aTotal) 
	cDet:= aTotal[nX,2]+ space(3) + Left(fDesc("SRV", aTotal[nX,2],"RV_DESC" ),17) + space(5) //-- Verba 
 	cDet+= Transform(aTotal[nX,3],"@E 999,999,999.99") + Space(14)	 							//-- Valor Principal 
 	cDet+= Transform(aTotal[nX,5],"@E 999,999,999.99") + Space(29)								//-- Valor Parcela 
	cDet+= Transform(aTotal[nX,4],"@E 999,999,999.99") + Space(5)								//-- Valor total c/Juros
	cDet+= Transform(aTotal[nX,6],"@E 999,999,999.99") + Space(19)								//-- Valor pago 
  	cDet+= Transform(aTotal[nX,7],"@E 999,999.99") 											//-- Valor Residuo  
	Impr(cDet,"C")        
	cFilTot		:= aTotal[nX,1]
	nTotPrin	+= aTotal[nX,3]
	nTotJuros	+= aTotal[nX,4]
	nTotParc	+= aTotal[nX,5]
	nTotPago	+= aTotal[nX,6]
	nTotResi	+= aTotal[nX,7]
	nTotGPrin	+= aTotal[nX,3]
	nTotGJuros	+= aTotal[nX,4]
	nTotGParc	+= aTotal[nX,5]
	nTotGPago	+= aTotal[nX,6]
	nTotGResi	+= aTotal[nX,7]

Next nX    
/*Ŀ
   Total da Filial                                              
  */
cDet:= oemToAnsi(STR0021) + cFilTot + space(8)
cDet+= Transform(nTotPrin ,"@E 999,999,999.99") + Space(14)	 							//-- Valor Principal 
cDet+= Transform(nTotParc ,"@E 999,999,999.99") + Space(29)							//-- Valor Parcela 
cDet+= Transform(nTotJuros,"@E 999,999,999.99") + space(5)								//-- Valor total c/Juros
cDet+= Transform(nTotPago ,"@E 999,999,999.99") + Space(19)								//-- Valor pago 
cDet+= Transform(nTotResi ,"@E 999,999.99") 											//-- Valor Residuo  
Impr(cDet,"C")

Return

/*                                	
Ŀ
Funo     AjustaSX1		Autor Luis Ricardo Cinalli  Data 30/05/2012
Ĵ
Descrio  Ajuste do Grupo de Perguntas R3 - GPR570                      
Ĵ
Sintaxe    < Vide Parametros Formais >								   
Ĵ
 Uso       GPER570                                                       
Ĵ
 Retorno   aRotina													   
Ĵ
Parametros < Vide Parametros Formais >								   
*/
Static Function AjustaSX1()
Local aArea		:= GetArea()
Local aAreaSX1	:= SX1->( GetArea() )
Local aSX1Cpos	:= {}
Local nSeq		:= 5
Local cSeq		:= "5"

DbSelectArea( "SX1" )
SX1->( dbSetOrder( 1 ) )

If SX1->( DbSeek( PadR( "GPR570", 10 ) + "05" ) )

	If Upper( SX1->( X1_VARIAVL ) ) <> 'MV_CH5'
	  	While SX1->( ! Eof() ) .and. SX1->( X1_GRUPO ) == PadR( "GPR570", 10 )

			RecLock( "SX1", .F. )
				SX1->X1_VARIAVL := 'MV_CH' + cSeq
			SX1->( MsUnlock() )

			nSeq++
			If nSeq < 10
				cSeq := Alltrim( Str( nSeq ) )
			ElseIf nSeq == 10
				cSeq := "A"
			ElseIf nSeq == 11
				cSeq := "B"
			ElseIf nSeq == 12
				cSeq := "C"
			ElseIf nSeq == 13
				cSeq := "D"
			Else
				Exit
			EndIf
			SX1->( DbSkip() )
		EndDo
	EndIf
EndIf	

aAdd( aSX1Cpos, { 'GPR570', '12', 'Categorias ?'	, 'Categorias por Calc. ?'	, 'Categories to Calculate ?'	, 'MV_CHC', 'C', 15, 0, 0, 'G', 'fCategoria()'	, 'mv_par12', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'S', {},{},{}, '.RHCATEG.' } )
aAdd( aSX1Cpos, { 'GPR570', '13', 'Situaes ?'		, 'Situaciones ?'			, 'Status ?'					, 'MV_CHD', 'C', 05, 0, 1, 'G', 'fSituacao()'	, 'mv_par13', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'S', {},{},{}, '.RHSITUA.' } )

ValidPerg( aSX1Cpos, "GPR570" )

RestArea( aAreaSX1 )
RestArea( aArea )
Return
