#INCLUDE "PROTHEUS.CH"
#INCLUDE "RSPR002.CH"

/*/

Ŀ
Funo     RSPR002   Autor  Cristina Ogura         Data  03.02.98 
Ĵ
Descrio  Executa a pesquisa selecionada                             
Ĵ
Uso        RSPR002                                                    
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Emerson G.R.13/01/05xxxxxxAjustes p/leitura de arq.em ambiente Linux
ٱ

/*/
Function RSPR002()
Local cFile		:= ""
Local cFileFPT	:= ""
Local cArquivo 	:= ""
Local nPos 		:= 0
Local aOK		:= {}
Local lArqLocal := .F.
Local cPathSrv  := ""
Local cArqFPT	:= ""
Local cArqSrv	:= ""

While .T.            

	cFile:=cGetFile("*.PES |*.PES",OemToAnsi(STR0001),0,,.T.,GETF_ONLYSERVER+GETF_LOCALFLOPPY) //"Selecione o Arquivo"
	If Empty(cFile)
		Return .T.
	EndIf
	If !MSFile(cFile,,__LocalDriver)
		Aviso("",OemtoAnsi(STR0002),{"OK"})    //"Nao existe arquivo selecionado"
		cFile:=""
		Loop
    EndIf
    
   	If  AT(".",cFile) # 0
		nPos := AT(".",cFile)-1
	Else
		nPos := Len(cFile)
		cFile := cFile+".PES"
	EndIf

	cFileFPT 	:= Substr(cFile,1,nPos)+".FPT"
	If ( nPos := At(':', cFile) ) > 0	// Drive Local
		lArqLocal 	:= .T.
		
		IF !Empty ( AllTrim( cPathSrv := GetPvProfString( GetEnvServer(), "StartPath", "", GetADV97() ) ) )
			IF !( Subst( cPathSrv , 1 , 1 ) $ "\/" )
				cPathSrv := "\"+cPathSrv
			EndIF
			IF !( Subst( cPathSrv , -1	) $ "\/" )
				cPathSrv+= "\"
			EndIF  
			
			cArquivo 	:= cFile    
			cArqFPT		:= cFileFPT
			If ( nPos := At(':', cArquivo) ) > 0
				cArquivo := SubS(cArquivo, nPos+1) 
				cArqFPT	:= Subs(cArqFPT, nPos+1)
			EndIf
			Do While At('\', cArquivo) > 0 .Or. At('/', cArquivo)> 0
				If (nPos := At('\', cArquivo)) > 0 .Or. (nPos := At('/', cArquivo)) > 0
					cArquivo := SubS(cArquivo, nPos+1) 
					cArqFPT	:= Subs(cArqFPT, nPos+1)
				EndIf
			EndDo
	
			cArqSrv := RetArq( __LocalDriver , cPathSrv + cArquivo , .T. )
			CpyT2S( cFile , cPathSrv  , .F. )

       		If File(cFileFPT)
				cArqSrvFPT 	:= RetArq( __LocalDriver , cPathSrv + cArqFPT , .T. )
				CpyT2S( cFileFPT, cPathSrv, .F. )
			EndIf
			
			IF MsFile( cArqSrv , , __LocalDriver )
				MsOpenDbf( .T. , __LocalDriver , cArqSrv , "TRB" , .F. , .F. )
			Else
				Aviso("",OemtoAnsi(STR0002),{"OK"})    //"Nao existe arquivo selecionado"   
				Loop
			EndIF
		EndIf
	Else	// Servidor

		dbUseArea(.T.,__LocalDriver, cFile, "TRB", .F., .F.)
	EndIf	
	
	If NETERR()
		Aviso("",OemtoAnsi(STR0003),{"OK"}) //"Arquivo esta sendo usado"
		cFile:=""
		Loop
	EndIf
	aOk:=DBSTRUCT()		
	If aOk[2][1] # "CURRIC" .And. aOK[3][1] # "NOME"
		Aviso("",OemtoAnsi(STR0004),{"OK"}) //"Este arquivo nao pertence a pesquisa"
		If Select("TRB") != 0
			dbSelectArea("TRB")
			dbCloseArea()
		EndIf
		cFile:=""
		Loop
	EndIf
	Exit
EndDo

// Chamada a funcao no programa RSPA090
A090IMPRI("RSPR002")

If Select("TRB") != 0
	dbSelectArea("TRB")
	dbCloseArea()
EndIf

If lArqLocal
	Ferase(cArquivo)
	Ferase(cArqFPT)
EndIf

dbSelectArea("SQG")

Return .T.
