#INCLUDE "RSPR004.CH"

/*


Ŀ
Funo     RSPR004   Autor  Fernando Joly          Data  05.03.98 
Ĵ
Descrio  Relao de Vagas                                           
Ĵ
Sintaxe    Clipper 5.3                                                
Ĵ
Parametros Avoid                                                      
Ĵ
Uso        SIGARSP                                                    
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alterao                     
Ĵ
Emerson G.R.25/11/04xxxxxxConverter letras minusculas em maiusculas 
			   			   no filtro Solicitante De/Ate. 			  
Eduardo Ju  06/02/06092099Filtro por Situacao das Vagas.            
ٱ

*/
Function RSPR004

//Ŀ
// Define Variaveis Locais (Basicas)                            
//
Local cDesc1     := STR0001 //'Relao de Vagas'
Local cDesc2     := STR0002 //'Sera impresso de acordo com os parametros solicitados pelo'
Local cDesc3     := STR0003 //'usuario.'
Local cString    := 'SQS'
Local aOrd       := {STR0004,STR0005,STR0006} //'Vaga'###'Area'###'Cliente'
Local cNomePrg   := 'RSPR004'

//Ŀ
// Define Variaveis PRIVATE(Basicas)                            
//
Private aReturn  := {STR0007, 1, STR0008, 1, 2, 1, '',1 } //'Zebrado'###'Administracao'
Private cPerg    := 'RSR004'
Private aDriver  := LeDriver()
Private lEnd     := .F.

//Ŀ
// Variaveis Utilizadas na funcao IMPR                          
//
Private Titulo	:= OemToAnsi(STR0009) //'Relacao de Vagas'
Private cCabec	:= ''
Private AT_PRG	:= cNomePrg
Private wCabec0	:= 1
Private wCabec1	:= STR0010 //'Vaga                                                          Solicitante                      Vagas Prazo Dt.Abert.  Dt.Fecham. Fech. Valor           Area                       Cliente  Processo'
Private ContFl	:= 1
Private Li      := 0
Private nTamanho:= 'G'
Private Colunas	:= 220

RSR004SX1()	//Retirar Funcao nas proximas versoes do Protheus
Pergunte(cPerg, .F.)
	
//Ŀ
// Variaveis utilizadas para parametros                         
// mv_par01        //  Vaga De                                  
// mv_par02        //  Vaga At                                 
// mv_par03        //  Centro de Custo De                       
// mv_par04        //  Centro de Custo Ate                      
// mv_par05        //  Cargo De                                 
// mv_par06        //  Cargo Ate                                
// mv_par07        //  Cliente De                               
// mv_par08        //  Cliente Ate                              
// mv_par09        //  Prazo De                                 
// mv_par00        //  Prazo At                                
// mv_par11        //  rea De                                  
// mv_par12        //  rea At                                 
// mv_par13        //  Solicitante De                           
// mv_par14        //  Solicitante At                          
//
	
//Ŀ
// Envia controle para a funcao SETPRINT                        
//
WnRel := cNomePrg
WnRel := SetPrint(cString, WnRel, cPerg, Titulo, cDesc1, cDesc2, cDesc3, .F., aOrd, .T., nTamanho)

If nLastKey == 27
	Return 
EndIf	

SetDefault(aReturn,cString)

If nLastKey == 27
	Return 
EndIf	
	
RptStatus({|lEnd| RSR004Imp(@lEnd, WnRel, cString)}, Titulo)

Return Nil
	
/*


Ŀ
Funo     RSR004Imp Autor  Fernando Joly          Data  05.03.98 
Ĵ
Descrio  Impresso da Relao de Vagas                              
Ĵ
Sintaxe    RSR004Imp(lEnd, WnRel, cString)                            
Ĵ
Parametros lEnd        - Ao do Codelock                             
           WnRel       - Ttulo do relatrio                          
Parametros cString     - Mensagem                                     
Ĵ
 Uso       Generico                                                   
ٱ

*/
Static Function RSR004Imp(lEnd, WnRel, cString)

//-- Variaveis Locais
Local cDet       := ''
Local cVagaDe    := ''
Local cVagaAte   := ''
Local cCCDe      := ''
Local cCCAte     := ''
Local cFuncaoDe  := ''
Local cFuncaoAte := ''
Local cClienteDe := ''
Local cClienteAte:= ''
Local nPrazoDe   := 0
Local nPrazoAte  := 0
Local cAreaDe    := ''
Local cAreaAte   := ''
Local cSoliDe    := ''
Local cSoliAte   := ''
Local cInicio    := ''
Local cFim       := ''
Local cArqNtx    := ''
Local cCCAnt     := Replicate('', Len(SQS->QS_CC))
Local nOrdem     := aReturn[8]
Local cDescArea  := ''
Local nSituacao	 := 0

//-- Define Ttulo do Relatrio
Titulo := If(!Empty(AllTrim(NewHead)), AllTrim(NewHead), Titulo)

//Ŀ
// Carregando variaveis mv_par?? para Variaveis do Sistema.     
//
cVagaDe     := mv_par01
cVagaAte    := mv_par02
cCCDe       := mv_par03
cCCAte      := mv_par04
cFuncaoDe   := mv_par05
cFuncaoAte	:= mv_par06
cClienteDe  := Upper(mv_par07)
cClienteAte := Upper(mv_par08)
nPrazoDe    := mv_par09
nPrazoAte   := mv_par10
cAreaDe     := mv_par11
cAreaAte    := mv_par12
cSoliDe     := Upper(mv_par13)
cSoliAte    := Upper(mv_par14)
nSituacao	:= mv_par15		//Situacao das Vagas 

//-- Designa Nome para Arquivo de ndice Temporrio
cArqNtx := CriaTrab(Nil, .F.)

dbSelectArea('SQS')
If nOrdem == 1
	cInicio := 'QS_FILIAL + QS_CC + QS_VAGA'
	cFim    := xFilial('SQS') + cCCAte + cVagaAte
ElseIf nOrdem == 2
	cInicio := 'QS_FILIAL + QS_CC + QS_AREA + QS_FUNCAO + QS_VAGA'
	cFim    := xFilial('SQS') + cCCAte + cAreaAte + cFuncaoAte + cVagaAte
ElseIf nOrdem == 3
	cInicio := 'QS_FILIAL + QS_CC + QS_CLIENTE + QS_VAGA'
	cFim    := xFilial('SQS') + cCCAte + cClienteAte + cVagaAte
EndIf
IndRegua('SQS', cArqNtx, cInicio,,, STR0011) //'Incluindo Quebras de Centro de Custo...'
dbGoTop()

//-- Inicializa Rgua de Impresso
SetRegua(SQS->(RecCount()))

Begin Sequence

	Do While !SQS->(Eof()) .And. &(cInicio) <= cFim
	
		//-- Incrementa a Rgua de Impresso
		IncRegua()
		
	   //-- Cancela a Impresso case se pressione Ctrl + A
	   If lEnd
	   	IMPR(cCancela,'C')
	      Break
	  	EndIF
		
		//Ŀ
		// Consiste Parametrizacao do Intervalo de Impressao            
		//
		If 	( Upper(SQS->QS_CLIENTE) 	< cClienteDe )	.Or. ( Upper(SQS->QS_CLIENTE)	> cClienteAte ) 	.Or. ;
			( Upper(SQS->QS_SOLICIT) 	< cSoliDe ) 	.Or. ( Upper(SQS->QS_SOLICIT)	> cSoliAte )		.Or. ;
			( SQS->QS_PRAZO 			< nPrazoDe ) 	.Or. ( SQS->QS_PRAZO 			> nPrazoAte ) 		.Or. ;
			( SQS->QS_FUNCAO 			< cFuncaoDe )	.Or. ( SQS->QS_FUNCAO 			> cFuncaoAte ) 		.Or. ;
			( SQS->QS_VAGA 				< cVagaDe ) 	.Or. ( SQS->QS_VAGA 			> cVagaAte ) 		.Or. ;
			( SQS->QS_AREA 				< cAreaDe ) 	.Or. ( SQS->QS_AREA 			> cAreaAte ) 		.Or. ;
			( SQS->QS_CC 				< cCCDe ) 		.Or. ( SQS->QS_CC 				> cCCAte )
	      	
	      	SQS->(dbSkip())
			Loop
		Endif
		
		//Ŀ
		// Situacao das Vagas: Aberta - Fechada - Ambas                 
		//		
		If (nSituacao == 1 .And. SQS->QS_NRVAGA <= SQS->QS_VAGAFEC) .Or.; //Aberto
			(nSituacao == 2 .And. SQS->QS_NRVAGA > SQS->QS_VAGAFEC)		//Fechado		    
        	SQS->(dbSkip())
			Loop
        EndIf
		
		Set Device To Printer

		//-- Processa a Quebra de Centro de Custo
		If SQS->QS_CC # cCCAnt
			cCCAnt := SQS->QS_CC 
			Impr("","C") 
			cDet := Repl("-",Colunas)
			Impr(cDet, "C")
			cDet := STR0012 + SQS->QS_CC + ' - ' + DescCC(SQS->QS_CC, If(!Empty(SQS->QS_FILIAL),SQS->QS_FILIAL, Nil)) //'CENTRO DE CUSTO: '
			ImpR(cDet, 'C')
			cDet := Repl("-",Colunas)
			Impr(cDet, "C")
		EndIf

		//-- Monta String a ser impresso
		cDet := SQS->QS_VAGA + " - "+SQS->QS_DESCRIC + Space(03)
		cDet += SQS->QS_SOLICIT + Space(3)
		cDet += StrZero(SQS->QS_NRVAGA, 3) + Space(3)
		cDet += StrZero(SQS->QS_PRAZO, 3) + Space(3)
		cDet += DtoC(SQS->QS_DTABERT) + If(__SetCentury(),Space(1),Space(3))
		cDet += DtoC(SQS->QS_DTFECH) + If(__SetCentury(),Space(1),Space(3))
		cDet += StrZero(SQS->QS_VAGAFEC,3) + Space(3)
		cDet += Transform(SQS->QS_VCUSTO, '@E 99,999,999.99') + Space(3)
		cDet += SQS->QS_AREA + ' - ' + Left(fDescTab('R1', SQS->QS_AREA), 18) + Space(3)
		cDet += SQS->QS_CLIENTE + Space(03)
		cDet += SQS->QS_PROCESS + " - " + Fdesc("SQE",SQS->QS_PROCESS,"QE_DESCRIC",20)
		ImpR(cDet, 'C')
		
		SQS->(dbSkip())
		
	Enddo

End Sequence

If Len(cDet) > 0
	ImpR('', 'F')
EndIf

//-- Apaga indice Temporrio
If File(cArqNtx+OrdBagExt())
	RetIndex("SQS")
	FErase(cArqNtx+OrdBagExt())
	Set Filter to
Endif

//Ŀ
// Trmino do Relatrio                                         
//
dbSelectArea('SQS')
dbSetOrder(1)
Set Device To Screen

If aReturn[5] == 1
	Set Printer To
	dbCommit()
	OurSpool(WnRel)
Endif
MS_FLUSH()

Return Nil

/*


Ŀ
Funo     fDescTab  Autor  Fernando Joly          Data  06.03.98 
Ĵ
Descrio  Retorna a Descrio do Item de uma Tebala Cadastrada       
Ĵ
Sintaxe    fDescTab(cTab, cItem)                                      
Ĵ
Parametros cTab        - Tabela a ser Perquizada                      
           cItem       - Item da Tabela a ser Pesquizado              
Ĵ
Retirno    Retorna a descrio do Item ou a mensagem "Nao Cadastrado" 
Ĵ
 Uso       Generico                                                   
ٱ

*/
Function fDescTab(cTab, cItem)

//-- Inicializa Variaveis Locais
Local cDescArea := Space(Len(X5Descri()))
Local cOldRecno := SX5->(Recno())

If SX5->(dbSeek(xFilial('SX5') + cTab + cItem, .F.))
	cDescArea := X5Descri()
Else
	cDescArea := STR0013 + Space(35) //'** Nao Cadastrado **'
EndIf

SX5->(dbGoto(cOldRecno))

Return(cDescArea)

/*

Ŀ
Funcao    RSR004SX1  Autor Eduardo Ju              Data 06.02.06  
Ĵ
Descrio Criacao do Pergunte Situacao da Vaga                        
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosNenhum                                                      
Ĵ
Uso       SIGARSP                                                     
ٱ

*/ 
Static Function RSR004SX1()             

Local aSaveArea := GetArea()
Local aRegs		:= {}
Local cPerg		:= "RSR004" 
Local aHelpP1	:= {}
Local aHelpE1	:= {}
Local aHelpS1	:= {}      

/*-----------------------MV_PAR20--------------------------*/
Aadd( aHelpP1, "Escolha a situacao das vagas para          " )  
Aadd( aHelpP1, "serem consideradas na impressao:           " )
Aadd( aHelpP1, "1 - Vagas em Aberto                        " )
Aadd( aHelpP1, "2 - Vagas Fechadas                         " )
Aadd( aHelpP1, "3 - Vagas em Aberto e Fechadas             " )

Aadd( aHelpE1, "Choose a vacancy status to be              " )  
Aadd( aHelpE1, "considered while printing:                 " )
Aadd( aHelpE1, "1 - Open Vacancies                         " )
Aadd( aHelpE1, "2 - Closed Vacancies                       " )
Aadd( aHelpE1, "3 - Open and Closed Vacancies              " )

Aadd( aHelpS1, "Seleccione la situacion de las             " )
Aadd( aHelpS1, "vacantes para considerarse en              " )  
Aadd( aHelpS1, "la impresion:                              " )
Aadd( aHelpS1, "1 - Vacantes Pendientes                    " )
Aadd( aHelpS1, "2 - Vacantes Cerradas                      " )
Aadd( aHelpS1, "3 - Vacantes Pendientes y Cerradas         " )


/*    
Ŀ
           Grupo  	Ordem 	Pergunta Portugues  Pergunta Espanhol       Pergunta Ingles         Variavel 	Tipo  	Tamanho Decimal Presel  GSC   	Valid       Var01      	Def01           DefSPA1        	DefEng1      	Cnt01           Var02  	Def02    		DefSpa2         DefEng2	   	Cnt02  		Var03 	Def03      			DefSpa3    			DefEng3  		Cnt03  	Var04  	Def04     	DefSpa4    	DefEng4  	Cnt04  	Var05  	Def05       DefSpa5		DefEng5   	Cnt05  	XF3  	GrgSxg  cPyme	aHelpPor	aHelpEng	aHelpSpa    cHelp        	 
*/
Aadd(aRegs,{cPerg	,"15"	,"Considera Vagas?"	,"Considera Vacantes?"  		,"Consider Vacancies?"  		,"mv_chf"  	,"N"	,1			,0		,3		,"C"	,""			,"mv_par15", "1-Em aberto"		,"1-Pendientes"  	,"1-Open", ""				,""		,"2-Fechadas"		,"2-Cerradas"			,"2-Closed" 		,""			,""		,"3-Ambas"		,"3-Ambas"		,"3-Both"				,""		,""		,""			,""			,""			,""		,""      ,""			,""			,""			,""		,""		,""		,"S"		,aHelpP1		,aHelpE1		,aHelpS1		,""})
        
ValidPerg(aRegs,cPerg)

RestArea(aSaveArea)

Return(NIL)
