#INCLUDE "PROTHEUS.CH"
#INCLUDE "TRMR010.CH"

/*

Ŀ
Programa   TRMR010   Autor  Eduardo Ju             Data  20/06/06 
Ĵ
Descrio  Relatorio de Cargos do Treinamento                         
Ĵ
Sintaxe    TRMR010                                                    
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Leandro Dr. 01/04/09|005878Ajuste para quebrar linha quando descricao
                    |      do fator ou grau ultrapassar 30 caracteres
ٱ

Ŀ
Programador   Data      FNC              Motivo da Alteracao                      
ĳ
Rogerio R.   29/07/200900000018271/2009Compatibilizacao dos fontes para aumento do
                                       campo filial e gesto corporativa.          
Luciana S.   10/08/201100000016958/2011Ajuste na exibicao dos titulos do relatorio
Gustavo M.   04/04/201200000006233/2012Ajuste para evitar quebras de pagina desne-
                                       cessarias. Considerar tambem o CC no Person
ٱ

*/
Function TRMR010()

Local oReport
Local aArea := GetArea()

If FindFunction("TRepInUse") .And. TRepInUse()	//Verifica se relatorio personalizal esta disponivel
	//Ŀ
	// Verifica as perguntas selecionadas                           
	//
	TR010RSX1()	//Criacao do Pergunte (SX1)
	Pergunte("TR010R",.F.)
	oReport := ReportDef()
	oReport:PrintDialog()	
Else
	TRMR010R3()	
EndIf  

RestArea( aArea )

Return

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  20.06.06 
Ĵ
Descrio Definicao do Componente de Impressao do Relatorio           
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function ReportDef()

Local oReport
Local oSection1	
Local oSection2         
Local oSection3
Local oSection4
Local oSection5
Local oSection6
Local oSection7
Local oSection8

//Ŀ
//Criacao do componente de impressao                                      
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
oReport:=TReport():New("TRMR010",STR0001,"TR010R",{|oReport| PrintReport(oReport)},STR0007)	//"Relatorio de Cargos"#"Ser impresso de acordo com os parametros solicitados pelo usuario"

//Ŀ
// Criacao da Primeira Secao: Cargo 
// 
oSection1 := TRSection():New(oReport,STR0001,{"SQ3","SQ0","SQB","SI3"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	
oSection1:SetTotalInLine(.F.)      

TRCell():New(oSection1,"Q3_CARGO","SQ3",,,10,.T.)				//Cargo
TRCell():New(oSection1,"Q3_DESCSUM","SQ3","")			//Descricao do Cargo  
TRCell():New(oSection1,"Q3_GRUPO","SQ3",,,10,.T.)				//Grupo
TRCell():New(oSection1,"Q0_DESCRIC","SQ0","")			//Descricao do Grupo
TRCell():New(oSection1,"Q3_DEPTO","SQ3",STR0031)		//Codigo do Depto 
TRCell():New(oSection1,"QB_DESCRIC","SQB","")			//Descricao do Depto 
TRCell():New(oSection1,"Q3_CC","SQ3",,,20,.T.)					//Centro de Custo
TRCell():New(oSection1,"I3_DESC","SI3","") 			//Descricao do CC

TRPosition():New(oSection1,"SQ0",1,{|| RhFilial("SQ0",SQ3->Q3_FILIAL) + SQ3->Q3_GRUPO})
TRPosition():New(oSection1,"SQB",1,{|| RhFilial("SQB",SQ3->Q3_FILIAL) + SQ3->Q3_DEPTO})
TRPosition():New(oSection1,"SI3",1,{|| RhFilial("SI3",SQ3->Q3_FILIAL) + SQ3->Q3_CC})

//Ŀ
// Criacao da Segunda Secao: Descricao Detalhada do Cargo 
//
oSection2 := TRSection():New(oSection1,STR0009,{"SQ3"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	
oSection2:SetTotalInLine(.F.)  
oSection2:SetHeaderBreak()
oSection2:ShowHeader(.T.) 	//Imprime Cabecalho da Secao
oSection2:SetLeftMargin(2)	//Identacao da Secao    
    
TRCell():New(oSection2,"Q3_DESCDET","SQ3")		//Codigo da Descricao Detalhada do Cargo #SUPRIMIR 
TRCell():New(oSection2,"Q3_MEMO1","SQ3","",/*Picture*/,,/*lPixel*/,{|| MSMM(SQ3->Q3_DESCDET,,,,3)}) //Descricao Detalhada do Cargo
oSection2:Cell("Q3_MEMO1"):SetLineBreak(.T.)//Imprime Campo Memmo  
oSection2:Cell("Q3_DESCDET"):Disable()

//Ŀ
// Criacao da Terceira Secao: Descricao das Responsabilidades do Cargo 
//
oSection3 := TRSection():New(oSection1,STR0021,{"SQ3"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	
oSection3:SetTotalInLine(.F.)  
oSection3:SetHeaderBreak()
oSection3:ShowHeader(.T.) 	//Imprime Cabecalho da Secao
oSection3:SetLeftMargin(2)	//Identacao da Secao   

TRCell():New(oSection3,"Q3_DRESP","SQ3")			//Codigo da Responsabilidade do Cargo #SUPRIMIR 		
TRCell():New(oSection3,"Q3_MEMO2","SQ3","",/*Picture*/,,/*lPixel*/,{|| MSMM(SQ3->Q3_DRESP,,,,3)}) //Descricao Responsabilidade do Cargo  		

oSection3:Cell("Q3_MEMO2"):SetLineBreak(.T.) //Imprime Campo Memmo
oSection3:Cell("Q3_DRESP"):Disable() 

//Ŀ
// Criacao da Quarta Secao: Descricao Relacionamento Interno do Cargo  
//
oSection4 := TRSection():New(oSection1,STR0023,{"SQ3"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	
oSection4:SetTotalInLine(.F.)  
oSection4:SetHeaderBreak()
oSection4:ShowHeader(.T.) 	//Imprime Cabecalho da Secao
oSection4:SetLeftMargin(2)	//Identacao da Secao 
                
TRCell():New(oSection4,"Q3_DRELINT","SQ3")			//Codigo do Relacionamento do Cargo #SUPRIMIR 
TRCell():New(oSection4,"Q3_MEMO3","SQ3","",/*Picture*/,,/*lPixel*/,{|| MSMM(SQ3->Q3_DRELINT,,,,3)}) //Descricao Relacionamento do Cargo

oSection4:Cell("Q3_MEMO3"):SetLineBreak(.T.) //Imprime Campo Memmo
oSection4:Cell("Q3_DRELINT"):Disable() 

//Ŀ
// Criacao da Quinta Secao: Descricao das Habilidades do Cargo 
//
oSection5 := TRSection():New(oSection1,STR0025,{"SQ3"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	
oSection5:SetTotalInLine(.F.)  
oSection5:SetHeaderBreak()
oSection5:ShowHeader(.T.) 	//Imprime Cabecalho da Secao
oSection5:SetLeftMargin(2)	//Identacao da Secao  
                               
TRCell():New(oSection5,"Q3_DHABILI","SQ3")			//Codigo das Habilidades do Cargo #SUPRIMIR 
TRCell():New(oSection5,"Q3_MEMO4","SQ3","",/*Picture*/,,/*lPixel*/,{|| MSMM(SQ3->Q3_DHABILI,,,,3)}) //Descricao Relacionamento do Cargo
oSection5:Cell("Q3_MEMO4"):SetLineBreak(.T.) //Imprime Campo Memmo
oSection5:Cell("Q3_DHABILI"):Disable() 

//Ŀ
// Criacao da Sexta Secao: Graduacao dos Cargos 
//
oSection6 := TRSection():New(oSection1,STR0011,{"SQ4","SQ1","SQ2"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	
oSection6:SetTotalInLine(.F.)  
oSection6:SetHeaderBreak()
oSection6:ShowHeader(.T.) 	//Imprime Cabecalho da Secao
oSection6:SetLeftMargin(2)	//Identacao da Secao  
                              
TRCell():New(oSection6,"Q4_FATOR","SQ4",,,10,.T.)		//Codigo do Fator
TRCell():New(oSection6,"Q1_DESCSUM","SQ1","")	   		//Descricao do Fator 
TRCell():New(oSection6,"Q4_GRAU","SQ4",,,10,.T.)		//Codigo do Grau
TRCell():New(oSection6,"Q2_DESC","SQ2","")				//Descricao do Grau
TRCell():New(oSection6,"Q4_PONTOS","SQ4",,"@E 9999.99",15,.T.)//Pontos   

TRPosition():New(oSection6,"SQ1",3,{|| RhFilial("SQ1",SQ4->Q4_FILIAL) + SQ4->Q4_FATOR})
TRPosition():New(oSection6,"SQ2",2,{|| RhFilial("SQ2",SQ4->Q4_FILIAL) + SQ4->Q4_FATOR + SQ4->Q4_GRAU})	

If MV_PAR12 == 1 
	oSection6:SetTotalText({|| STR0032 })  //"Total de Pontos"
	TRFunction():New(oSection6:Cell("Q4_PONTOS"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,"@E 9999.99"/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
EndIf	

//Ŀ
// Criacao da Setima Secao: Cursos dos Cargos 
//
oSection7 := TRSection():New(oSection1,STR0015,{"RA5","RA1"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	
oSection7:SetTotalInLine(.F.)  
oSection7:SetHeaderBreak()
oSection7:ShowHeader(.T.) 	//Imprime Cabecalho da Secao
oSection7:SetLeftMargin(2)	//Identacao da Secao  

TRCell():New(oSection7,"RA5_CURSO","RA5",STR0033)	//Codigo do Curso  
TRCell():New(oSection7,"RA1_DESC","RA1","")		//Descricao do Curso 
TRCell():New(oSection7,"RA5_VALIDA","RA5")			//Validade
TRCell():New(oSection7,"RA5_HORAS","RA5")			//Horas Minima
TRCell():New(oSection7,"RA5_NOTA","RA5")			//Nota Minima 
TRCell():New(oSection7,"RA5_FREQUE","RA5")			//% Frequencia Minima  
TRCell():New(oSection7,"RA5_PRIORI","RA5")			//Prioridade
TRCell():New(oSection7,"RA5_UNPRIO","RA5")			//Unidade da Prioridade

TRPosition():New(oSection7,"RA1",1,{|| RhFilial("RA1",RA5->RA5_FILIAL) + RA5->RA5_CURSO }) 

//Ŀ
// Criacao da Oitava Secao: Competencias/Habilidades 
//
oSection8 := TRSection():New(oSection1,STR0027,{"RBH","RBG","RBK","RBL"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	
oSection8:SetTotalInLine(.F.)  
oSection8:SetHeaderBreak()
oSection8:ShowHeader(.T.) 	//Imprime Cabecalho da Secao
oSection8:SetLeftMargin(2)	//Identacao da Secao  

TRCell():New(oSection8,"RBH_CODCOM","RBH")			//Codigo da Competencia
TRCell():New(oSection8,"RBH_ITECOM","RBH")			//Codigo do Item da Competencia
TRCell():New(oSection8,"RBH_HABIL","RBH")		  	//Codigo da Habilidade
TRCell():New(oSection8,"RBG_DESC","RBG","",,20)	//Descricao da Habilidade
TRCell():New(oSection8,"RBH_ESCALA"	,"RBH") 		//Escala
TRCell():New(oSection8,"RBK_DESCRI"	,"RBK","",,20) 	//Descricao da Escala
TRCell():New(oSection8,"RBH_ITESCA"	,"RBH") 		//Item de Escala
TRCell():New(oSection8,"RBL_DESCRI"	,"RBL","",,20)	//Descricao do Item de Escala 
TRCell():New(oSection8,"RBH_IMPORT"	,"RBH")			//Grau de Importancia
TRCell():New(oSection8,"RBK_DESCRI"	,"RBK","",,20) 	//Descricao do Grau de Importancia
TRCell():New(oSection8,"RBH_ITIMPO"	,"RBH")			//Item de Importancia  
TRCell():New(oSection8,"RBL_DESCRI"	,"RBL","",,20,,{|| FDesc("RBL",RBH->RBH_IMPORT + RBH->RBH_ITIMPO,"RBL_DESCRI",20) })	//Descricao do Item de Importancia 

TRPosition():New(oSection8,"RBG",1,{|| RhFilial("RBG",RBH->RBH_FILIAL) + RBH->RBH_HABIL }) 
TRPosition():New(oSection8,"RBK",1,{|| RhFilial("RBK",RBH->RBH_FILIAL) + RBH->RBH_ESCALA }) 
TRPosition():New(oSection8,"RBL",1,{|| RhFilial("RBL",RBH->RBH_FILIAL) + RBH->RBH_ESCALA + RBH->RBH_ITESCA })

Return oReport          

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  21.06.06 
Ĵ
Descrio Impressao do Relatorio                                      
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function PrintReport(oReport)

Local oSection1 := oReport:Section(1)
Local oSection2 := oReport:Section(1):Section(1)  
Local oSection3 := oReport:Section(1):Section(2)
Local oSection4 := oReport:Section(1):Section(3)
Local oSection5 := oReport:Section(1):Section(4)
Local oSection6 := oReport:Section(1):Section(5)
Local oSection7 := oReport:Section(1):Section(6)
Local oSection8 := oReport:Section(1):Section(7)
Local cAcessaSQ3:= &("{ || " + ChkRH(FunName(),"SQ3","2") + "}")
Local cFiltro 	:= ""
Local cFiltroSQ4:= ""

//Ŀ
// Variaveis utilizadas para parametros               
// MV_PAR01 - "Filial ?"                              
// MV_PAR02 - "Cargo ?"                               
// MV_PAR03 - "Grupo ?"                               
// MV_PAR04 - "Impr Descr Detalh ?"                   
// MV_PAR05 - "Impr.Responsabilid. do Cargo ?"        
// MV_PAR06 - "Impr.Relacionamento do Cargo ?"        
// MV_PAR07 - "Impr.Habilidades do Cargo ?"           
// MV_PAR08 - "Impr Graduacao ?"                      
// MV_PAR09 - "Fator Graduacao De ?"                  
// MV_PAR10 - "Impr Graduac Detalh ?"                 
// MV_PAR11 - "Imprime Pontos ?"                      
// MV_PAR12 - "Somente Totais Ptos ?"                 
// MV_PAR13 - "Impr Cursos ?"                         
// MV_PAR14 - "Competencias/Habilidades ?"            
// MV_PAR15 - "Impr Cargo p/Folha ?"                  
//

//Ŀ
// Descricao Detalhada do Cargo 
//
If MV_PAR04 <> 1
	oSection2:Disable()
EndIf

//Ŀ
// Descricao das Responsabilidades do Cargo 
//
If MV_PAR05 <> 1
	oSection3:Disable()
EndIf

//Ŀ
// Descricao Relacionamento Interno do Cargo 
//
If MV_PAR06 <> 1
	oSection4:Disable()
EndIf

//Ŀ
// Descricao das Habilidades do Cargo 
//
If MV_PAR07 <> 1
	oSection5:Disable()
EndIf

//Ŀ
// Graduacao do Cargo 
//
If MV_PAR08 <> 1
	oSection6:Disable()
EndIf

//Ŀ
// Cursos do Cargo 
//
If MV_PAR13 <> 1
	oSection7:Disable()
Endif

//Ŀ
// Competencias/Habilidades 
//
If MV_PAR14 <> 1 
	oSection8:Disable()
EndIf

//Ŀ
// Imprime Cargo por Folha   
//
If MV_PAR15 == 1   		
	oSection1:SetPageBreak(.T.) //Salta Pagina		
EndIf

//Ŀ
// Transforma parametros Range em expressao (intervalo) 
//
MakeAdvplExpr("TR010R")	                                  

If !Empty(MV_PAR01)
	cFiltro:= MV_PAR01
EndIf  

If !Empty(MV_PAR02) 
	cFiltro += Iif(!Empty(cFiltro)," .And. ","")
	cFiltro += MV_PAR02 
EndIf  
       
If !Empty(MV_PAR03)
	cFiltro += Iif(!Empty(cFiltro)," .And. ","")
	cFiltro += MV_PAR03
EndIf  

If !Empty(MV_PAR09)
	cFiltroSQ4 := MV_PAR09
EndIf  

//Ŀ
// Filtra Tabela Principal e Secundaria  
//
oSection1:SetFilter(cFiltro)   
oSection1:Setfilter(cFiltroSQ4,,,"SQ4")

oSection1:SetLineCondition(cAcessaSQ3)
       
//Ŀ
// Condicao para Impressao   
// 
oSection2:SetParentRecno()
oSection3:SetParentRecno()
oSection4:SetParentRecno()
oSection5:SetParentRecno()

oSection6:SetRelation({|| xFilial("SQ4")+SQ3->Q3_CARGO},"SQ4",1,.T.)
oSection6:SetParentFilter({|cParam| SQ4->Q4_CARGO == cParam},{|| SQ3->Q3_CARGO})	                             

oSection7:SetRelation({|| xFilial("RA5")+SQ3->Q3_CARGO},"RA5",1,.T.)
oSection7:SetParentFilter({|cParam| RA5->RA5_CARGO + RA5->RA5_CC == cParam},{|| SQ3->Q3_CARGO + SQ3->Q3_CC})	

oSection8:SetRelation({|| xFilial("RBH")+SQ3->Q3_GRUPO + SQ3->Q3_CARGO},"RBH",1,.T.)
oSection8:SetParentFilter({|cParam| RBH->RBH_GRUPO + RBH->RBH_CARGO == cParam},{|| SQ3->Q3_GRUPO + SQ3->Q3_CARGO})	
                              
oReport:SetMeter(SQ3->(LastRec()))	
oSection1:Print() //Imprimir 
	
Return Nil

/*

Ŀ
Funcao    TR010RSX1  Autor Eduardo Ju              Data  31.08.06 
Ĵ
Descricao Criacao do Pergunte TR010R no Dicionario SX1                
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosNenhum                                                      
Ĵ
Uso       TR010RSX1                                                   
ٱ

*/ 
Static Function TR010RSX1()             

Local aRegs		:= {} 
Local cPerg		:= "TR010R"  

aHelp := {	"Informe intervalo de filiais que ",;
			"deseja considerar para impressao ",;
			"do relatorio." }
aHelpE:= {	"Informe intervalo de sucursales que ",;
			"desea considerar para impresion ",;
			"del informe" }
aHelpI:= {	"Enter branch range to be considered ",;
			"to print report." }
cHelp := ".RHFILIAL."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)

/*
Ŀ
           Grupo  	Ordem 	Pergunta Portugues  Pergunta Espanhol       Pergunta Ingles         Variavel 	Tipo  	Tamanho Decimal Presel  GSC   	Valid       Var01      	Def01           DefSPA1        	DefEng1      	Cnt01           Var02  	Def02    		DefSpa2         DefEng2	   	Cnt02  		Var03 	Def03      			DefSpa3    			DefEng3  		Cnt03  	Var04  	Def04     	DefSpa4    	DefEng4  	Cnt04  	Var05  	Def05       DefSpa5		DefEng5   	Cnt05  	XF3  	GrgSxg  cPyme	aHelpPor	aHelpEng	aHelpSpa    cHelp            
*/
Aadd(aRegs,{cPerg	,"01"	,"Filial  ?"	   			,"Sucursal ?"     			,"Branch        ?"										,"mv_ch1"  			,"C"	,99			,0		,0		,"R"	,""				,"MV_PAR01"	,""					,""					,""					,"Q3_FILIAL"	,""		,""					,""					,""				,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,"XM0"	,"","S"	,{}			,{}			,{}			,cHelp})

aHelp := {	"Informe intervalo de cargos que",;
			"deseja considerar para ",;
			"impresso do Relatrio." }
aHelpE:= {	"Informe intervalo de cargos que",;
			"desea considerar para la ",;
			"impresion del Informe." }
aHelpI:= {	"Inform the position interval to",;
			"be considered to print the ",;
			"Report." }
cHelp := ".RHCARGO."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)
Aadd(aRegs,{cPerg	,"02"	,"Cargo  ?"				,"Cargo ?"  				,"Position            ?"	    						,"mv_ch2"  			,"C"	,99			,0		,0		,"R"	,""				,"MV_PAR02"	,""			   		,""					,""					,"Q3_CARGO"		,""		,""					,""					,""				,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,"SQ3"	,"","S"	,{}			,{}			,{}			,cHelp})

aHelp := {	"Informe ou Selecione cdigo do",;
			"Grupo Funcional  para filtro ",;
			"dos dados." }
aHelpE:= {	"Informe o Seleccione codigo",;
			"del Grupo Funcional  para ",;
			"filtro de los datos." }
aHelpI:= {	"Inform or Select the ",;
			"Functional Group code",;
			"to filter data." }
cHelp := ".RHGRUPR."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)

Aadd(aRegs,{cPerg	,"03"	,"Grupo ?" 				,"Grupo ?"   				,"Group         ?"								,"mv_ch3"  			,"C"	,99			,0		,0		,"R"	,""				,"MV_PAR03"	,""					,""					,""					,"Q3_GRUPO"		,""		,""					,""					,""				,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,"SQ0"	,"","S"	,{}			,{}			,{}			,cHelp})
Aadd(aRegs,{cPerg	,"04"	,"Impr Descr Detalh ?"	,"Impr Descr Detall. ?"	,"Print Detailed Descript.?"					,"mv_ch4"  			,"N"	,1			,0		,2		,"C"	,""				,"MV_PAR04"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01007."})
Aadd(aRegs,{cPerg	,"05"	,"Impr.Responsabilid. do Cargo ?","Impr.Responsabilid. de Cargo","Print Respons.Position?" 	    ,"mv_ch5"  			,"N"	,1			,0		,2		,"C"	,""				,"MV_PAR05"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01016."})
Aadd(aRegs,{cPerg	,"06"	,"Impr.Relacionamento do Cargo ?","Imprime Relacion del Cargo ?","Print Posit. Rerlationships?"	,"mv_ch6"  			,"N"	,1			,0		,2		,"C"	,""				,"MV_PAR06"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01017."})
Aadd(aRegs,{cPerg	,"07"	,"Impr.Habilidades do Cargo ?"	,"Impr.Habilidades del Cargo ?","Print Posit.Skills?"	    		,"mv_ch7"  			,"N"	,1			,0		,2		,"C"	,""				,"MV_PAR07"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01018."})
Aadd(aRegs,{cPerg	,"08"	,"Impr Graduacao ?"				,"Impr Graduacion ?","Print Graduation?"							,"mv_ch8"  			,"N"	,1			,0		,1		,"C"	,""				,"MV_PAR08"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01008."})

aHelp := {	"Informe intervalo de Fator de ",;
			"Graduacao que deseja considerar",;
			" para emissao do relatorio." }
aHelpE:= {	"Informe el intervalo de Factor",;
			" de Graduacion que desea considerar",;
			" para emision del informe." }
aHelpI:= {	"Inform  Graduation Factor range ",;
			" to be considered to print to ",;
			"report." }
cHelp := ".TR010R09."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)

Aadd(aRegs,{cPerg	,"09"	,"Fator Graduacao  ?"			,"Factor Graduac. ?"  ,"Grad. Factor?"	 			    			,"mv_ch9"  			,"C"	,99			,0		,0		,"R"	,""				,"MV_PAR09"	,""					,""					,""					,"Q4_FATOR"		,""		,""					,""					,""				,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S",aHelp  ,aHelpI   ,aHelpE  ,cHelp})
Aadd(aRegs,{cPerg	,"10"	,"Impr Graduac Detalh ?"		,"Impr Det.Graduac. ?","Print Detailed Graduat.?"					,"mv_cha"  			,"N"	,1			,0		,1		,"C"	,""				,"MV_PAR10"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01009."})
Aadd(aRegs,{cPerg	,"11"	,"Imprime Pontos ?"				,"Imprime Puntos ?" 	,"Print Score?"								,"mv_chb"  			,"N"	,1			,0		,1		,"C"	,""				,"MV_PAR11"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01012."})
Aadd(aRegs,{cPerg	,"12"	,"Somente Totais Ptos ?"		,"Solo Total Puntos ?" ,"Only Score Total?"						,"mv_chc"  			,"N"	,1			,0		,1		,"C"	,""				,"MV_PAR12"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01013."})
Aadd(aRegs,{cPerg	,"13"	,"Impr Cursos ?"				,"Imprime Cursos ?" 	,"Print Courses?"							,"mv_chd" 			,"N"	,1			,0		,1		,"C"	,""				,"MV_PAR13"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01010."})
Aadd(aRegs,{cPerg	,"14"	,"Competencias/Habilidades ?"	,"Competencias/Habilidades ?"	,"Skills/Qualifications?"	    ,"mv_che" 			,"N"	,1			,0		,1		,"C"	,""				,"MV_PAR14"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01019."})
Aadd(aRegs,{cPerg	,"15"	,"Impr Cargo p/Folha ?"			,"Impr Func. p/Planilla ?"	,"Print Job f/ Payroll?"		   		,"mv_chf" 			,"N"	,1			,0		,1		,"C"	,""				,"MV_PAR15"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".TRR01018."})

ValidPerg(aRegs,cPerg)

Return Nil

/*
PROGRAMA FONTE ORIGINAL ABAIXO
*/

/*

Ŀ
Funo     TRMR010R3 Autor  Cristina Ogura         Data  08.11.99 
Ĵ
Descrio  Relatorio de Cargos do treinamento                         
Ĵ
Sintaxe    TRMR010R3(void)                                            
Ĵ
 Uso       Generico                                                   
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
			   			   										  
Emerson G.R.22/06/04071935Correcao na busca de cargo por C.C.		  
Emerson G.R.22/11/04xxxxxxUtilizacao da funcao RhDescCC().		  
Emerson G.R.07/12/04xxxxxxNao estava imp.desc.de alguns itens Escala
ٱ

*/
Function TRMR010R3()

Local cString := "SQ3"       	// Alias do arquivo principal (Base)
Local cDesc1  := STR0001		//"Relatorio de Cargos."
Local cDesc2  := STR0002		//"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  := STR0003		//"usurio."
Local aOrd    := {STR0004}    	// "Cargo"

Private aReturn := {STR0005,1,STR0006,2,2,1,"",1 }		//"Zebrado"###"Administrao"
Private NomeProg:= "TRMR010"
Private aLinha  := {}
Private nLastKey:= 0
Private cPerg   := "TRR010"

//Ŀ
// Variaveis Utilizadas na funcao IMPR                          
//
Private Titulo  := STR0007		//"Relatorio de Cargos dos Funcionarios"
Private Colunas := 0
Private AT_PRG  := "TRR010"
Private wCabec0 := 1
Private wCabec1 := ""
Private Contfl  := 1
Private Li      := 0
Private nTamanho:= ""
Private c1Det	:= ""
Private c2Det	:= ""

TRR010SX1()
pergunte("TRR010",.T.)  

//Imprime Relatorio Comprimido ou Extendido 
If MV_PAR19 == 2 //Nao
	Colunas := 132
	nTamanho:= "M"
Else
	Colunas := 220
	nTamanho:= "G"		 
EndIf	

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial  De                               
// MV_PAR02        //  Filial  Ate                              
// MV_PAR03        //  Cargo De                                 
// MV_PAR04        //  Cargo Ate                                
// MV_PAR05        //  Grupo De                                 
// MV_PAR06        //  Grupo Ate                                
// MV_PAR07        //  Impr. Descricao Detalhada do Cargo  S/N  
// MV_PAR08        //  Impr. Graduacao S/N                      
// MV_PAR09        //  Impr. Graducao Detalhada S/N             
// MV_PAR10        //  Impr. Cursos S/N                         
// MV_PAR11        //  Impr. um cargo por folha S/N             
// MV_PAR12        //  Impr. Pontos  S/N                        
// MV_PAR13        //  Impr. Somente Totais dos Pontos S/N      
// MV_PAR14        //  Fator Graduacao De                       
// MV_PAR15        //  Fator Graduacao Ate                      
// MV_PAR16        //  Impr. Responsabilidades do Cargo S/N     
// MV_PAR17        //  Impr. Relacionamento do Cargo S/N     	 
// MV_PAR18        //  Impr. Habilidades do Cargo S/N    		 
// MV_PAR19        //  Impr. Competencias/Habilidades S/N  	 
//

wnrel:="TRMR010"            //Nome Default do relatorio em Disco
wnrel:=SetPrint(cString,wnrel,,@Titulo,cDesc1,cDesc2,cDesc3,.F.,aOrd,.f.,ntamanho)

If nLastKey = 27
	Return
EndIf

SetDefault(aReturn,cString)

If nLastKey = 27
	Return
EndIf

RptStatus({|lEnd| Tr010Imp(@lEnd,wnRel,cString)},Titulo)

Return

/*


Ŀ
Funo     Tr010Imp  Autor  Cristina Ogura         Data  08.11.99 
Ĵ
Descrio  Funcao que imprime os cargos                               
Ĵ
Sintaxe    Tr010Imp(lEnd,wnRel,cString)                               
Ĵ
Parametros lEnd        - Ao do Codelock                             
           wnRel       - Ttulo do relatrio                          
           cString     - Mensagem			                          
Ĵ
 Uso       TRMR010                                                    
ٱ

*/
Static Function Tr010Imp(lEnd,WnRel,cString )

Local CbTxt       // Ambiente
Local CbCont
Local nLinaux   := 0
Local nRegistro := 1 
Local aDriver   := LeDriver()
Local cCompac   := aDriver[1]
Local cNormal   := aDriver[2]
Local cDet		:= ""
Local cAuxDet	:= ""
Local nLinha	:= 0
Local nBegin	:= 0
Local nOrdem 	:= aReturn[8]
Local lImp	    := .F.
Local cAcessaSQ3:= &("{ || " + ChkRH(FunName(),"SQ3","2") + "}")
Local cDescGrupo:= ""
Local cDescDepto:= ""
Local cDescCC	:= ""
Local lSelec	:= .F.  

dbSelectArea("SQ3")
dbGoTop()

If nOrdem == 1			// Cargo
	dbSetOrder(1)
	wcabec1 := STR0008	//"CARGO DESCRICAO                       GRUPO DESCRICAO       DEPTO DESCRICAO             CENTRO DE CUSTO     "
						// 01234 0123456789012345678901234567890    01 012345678901234   012 012345678901234567890 12345678901234567890
EndIf	

dbSelectArea("SQ3")
cFil := xFilial("SQ3", MV_PAR01)
dbSeek(cFil + MV_PAR03 , .T.)
cInicio  := "SQ3->Q3_FILIAL + SQ3->Q3_CARGO"
cFim     := MV_PAR02 + MV_PAR04

If SQ3->Q3_FILIAL > MV_PAR02
	Help("",1,"TRR010FILI")		// Nao existe cargo neste intervalo de filial
	Return Nil
EndIf

SetRegua(SQ3->(RecCount()))

While !Eof() .And. &cInicio <= cFim

	IncRegua()
	
	If lEnd
		Exit
	EndIf
               
	If !Eval(cAcessaSQ3)
		dbSkip()  
		Loop
	EndIf
	
	If 	SQ3->Q3_CARGO < MV_PAR03 .Or. SQ3->Q3_CARGO > MV_PAR04 .Or. ;		// Grupo De/Ate
		SQ3->Q3_GRUPO < MV_PAR05 .Or. SQ3->Q3_GRUPO > MV_PAR06			// Depto De/Ate
		dbSelectArea( "SQ3" )
		dbSkip()
		Loop
	EndIf	
	lImp := .T.
	
	cDescGrupo	:= TrmDesc("SQ0",SQ3->Q3_GRUPO	,"SQ0->Q0_DESCRIC",SQ3->Q3_FILIAL)
	cDescDepto	:= TrmDesc("SQB",SQ3->Q3_DEPTO	,"SQB->QB_DESCRIC",SQ3->Q3_FILIAL)
	cDescCC		:= RhDescCC(SQ3->Q3_CC)
	
//"CARGO DESCRICAO                       GRUPO DESCRICAO       DEPTO DESCRICAO             CENTRO DE CUSTO     "
// 01234 0123456789012345678901234567890    01 012345678901234   012 012345678901234567890 12345678901234567890	
	                            
	IMPR(__PrtThinLine(),"C")
				
	c1Det := SQ3->Q3_CARGO + SPACE(01) + SQ3->Q3_DESCSUM + SPACE(05)
	c1Det += SQ3->Q3_GRUPO + SPACE(01) + cDescGrupo + SPACE(03) 
	c1Det += SQ3->Q3_DEPTO + SPACE(01) + cDescDepto + SPACE(01)
	c1Det += SQ3->Q3_CC 	+ SPACE(01) + cDescCC 
			 
	// Imprime descricao detalhada do cargo
	If MV_PAR07 == 1		// 1- Sim 
		lSelec := .T.
		nLinha := Tr010lin("SQ3",1)
	 	IMPR(c1Det,"C")
		IMPR(__PrtThinLine(),"C") 
		Tr010ImpDesc() 






	EndIf
		
	// Impr. Responsabilidades do Cargo S/N     
	If MV_PAR16 == 1 		// 1- Sim         
		If !lSelec
			lSelec := .T.    




			IMPR(c1Det,"C")
			IMPR(__PrtThinLine(),"C") 
			Tr010Resp()
		Else
			Tr010Resp()
		Endif	 
	EndIf

	// Impr. Relacionamento do Cargo S/N     	       
	If MV_PAR17 == 1		// 1- Sim
		If !lSelec
			lSelec := .T.     
			IMPR(c1Det,"C")
			IMPR(__PrtThinLine(),"C")
			Tr010Relac() 
		Else
			Tr010Relac() 
		Endif




	EndIf

	// Impr. Habilidades do Cargo S/N    		     
	If MV_PAR18 == 1		// 1- Sim
		If !lSelec
			lSelec := .T.     
			IMPR(c1Det,"C")
			IMPR(__PrtThinLine(),"C")
	  		Tr010Habil()
		Else




			Tr010Habil()
		Endif 
	EndIf
	
	// Imprime as graduacao dos cargos
	If MV_PAR08 == 1		// 1- Sim 
		If !lSelec
		  	lSelec := .T.     
			IMPR(c1Det,"C")




			IMPR(__PrtThinLine(),"C")
		  	Tr010ImpGrad(SQ3->Q3_CARGO,SQ3->Q3_GRUPO,SQ3->Q3_CC)
		 Else
		   	Tr010ImpGrad(SQ3->Q3_CARGO,SQ3->Q3_GRUPO,SQ3->Q3_CC)
		 Endif
	EndIf
	
	// Imprime os cursos dos cargos
	If MV_PAR10 == 1		// 1- Sim
		If !lSelec
	   		lSelec := .T.     
			IMPR(c1Det,"C")




			IMPR(__PrtThinLine(),"C")
  			Tr010ImpCurso(SQ3->Q3_CARGO,SQ3->Q3_CC)
  	   	Else
  	  		Tr010ImpCurso(SQ3->Q3_CARGO,SQ3->Q3_CC) 
  	 	Endif 
	EndIf
	  
	// Impr. Competencias/Habilidades S/N  
	If MV_PAR19 == 1 		// 1- Sim
		If !lSelec
	   		lSelec := .T.     




			IMPR(c1Det,"C")
			IMPR(__PrtThinLine(),"C")
			Tr010CompHab(SQ3->Q3_GRUPO,SQ3->Q3_CARGO,SQ3->Q3_CC)
		Else
			Tr010CompHab(SQ3->Q3_GRUPO,SQ3->Q3_CARGO,SQ3->Q3_CC) 
		Endif		
	EndIf
	
	If !lSelec
		IMPR(c1Det,"C")
		IMPR(__PrtThinLine(),"C")
	Endif
		
	// Imprime um cargo por folha
	If MV_PAR11 == 1 		// 1- Sim
		cDet := ""
		IMPR(cDet,"P")
	EndIf 

	dbSelectArea("SQ3")
	dbSkip()	
	
	lSelec:= .F.
EndDo

If lImp
	Impr("","F")
EndIf	

dbSelectArea("SQ3")
Set Filter to 
dbSetOrder(1)

If aReturn[5] = 1
	Set Printer To
	Commit
	ourspool(wnrel)
Endif

MS_FLUSH()

Return Nil


/*

Ŀ
Funo	  Tr010ImpDesc  Autor  Equipe R.H.        Data  08.11.99 
Ĵ
Descrio  Imprime a Descricao do Cargo         					  
Ĵ
Sintaxe	  Tr010ImpDesc()											  
Ĵ
 Uso       TRMR010  											  	  
ٱ

*/
Static Function Tr010ImpDesc() 

Local aSaveArea	:= GetArea()
Local cDet 		:= ""
Local nLinha	:= 0
Local nBegin	:= 0

IMPR(__PrtThinLine(),"C")   // Imprime uma linha para separar informacaoes impressas

cDet := Space(05) + STR0009	//"DESCRICAO DETALHADA DO CARGO"
IMPR(cDet,"C")

IMPR(__PrtThinLine(),"C")
		
cAuxDet 	:= MSMM(SQ3->Q3_DESCDET,,,,3)	// Leitura do campo memo da descricao detalhada
nLinha	:= MLCount(cAuxDet,80)

If nLinha > 0
	For nBegin := 1 To nLinha
		cDet := Space(08)+Memoline(cAuxDet,80,nBegin,,.T.)
		IMPR(cDet,"C")
	Next nBegin
Else
	cDet := Space(08) + STR0010	//" *** Nao existe Descricao detalhada do Cargo *** "
	IMPR(cDet,"C")	
EndIf	

cDet := ""
IMPR(cDet,"C")		

RestArea(aSaveArea)

Return Nil	
         
/*

Ŀ
Funo	  Tr010Resp     Autor  Equipe R.H.        Data  08.11.99 
Ĵ
Descrio  Imprime as Responsabilidades do Cargo   					  
Ĵ
Sintaxe	  Tr010Resp()											      
Ĵ
 Uso       TRMR010  											  	  
ٱ

*/
Static Function Tr010Resp()   

Local aSaveArea	:= GetArea()
Local cDet 		:= ""
Local nLinha	:= 0
Local nBegin	:= 0

IMPR(__PrtThinLine(),"C")

cDet := Space(05) + STR0021	//"DESCRICAO DAS RESPONSABILIDADES DO CARGO"
IMPR(cDet,"C")                     

IMPR(__PrtThinLine(),"C")
		
cAuxDet	:= MSMM(SQ3->Q3_DRESP,,,,3)	// Leitura do campo memo das Responsabilidades
nLinha	:= MLCount(cAuxDet,80)

If nLinha > 0
	For nBegin := 1 To nLinha
		cDet := Space(08)+Memoline(cAuxDet,80,nBegin,,.T.)
		IMPR(cDet,"C")
	Next nBegin
Else
	cDet := Space(08) + STR0022	//" *** Nao existe Descricao das Responsabilidades do Cargo *** "
	IMPR(cDet,"C")	
EndIf	

cDet := ""
IMPR(cDet,"C")		

RestArea(aSaveArea)

Return Nil	

/*

Ŀ
Funo	  Tr010Relac    Autor  Equipe R.H.        Data  08.11.99 
Ĵ
Descrio  Imprime a Relacionamento do Cargo   					      
Ĵ
Sintaxe	  Tr010Relac()											      
Ĵ
 Uso       TRMR010  											  	  
ٱ

*/
Static Function Tr010Relac() 
	
Local aSaveArea	:= GetArea()
Local cDet 		:= ""
Local nLinha	:= 0
Local nBegin	:= 0

IMPR(__PrtThinLine(),"C")

cDet := Space(05) + STR0023	//"DESCRICAO RELACIONAMENTO INTERNO DO CARGO"
IMPR(cDet,"C")                     

IMPR(__PrtThinLine(),"C")
		
cAuxDet := MSMM(SQ3->Q3_DRELINT,,,,3)	// Leitura do campo memo do Relacionamento Interno do Cargo
nLinha	:= MLCount(cAuxDet,80)

If nLinha > 0
	For nBegin := 1 To nLinha
		cDet := Space(08)+Memoline(cAuxDet,80,nBegin,,.T.)
		IMPR(cDet,"C")
	Next nBegin
Else
	cDet := Space(08) + STR0024	//" *** Nao existe Descricao do Relacionamento Interno do Cargo *** "
	IMPR(cDet,"C")	
EndIf	

cDet := ""
IMPR(cDet,"C")		

RestArea(aSaveArea)

Return Nil	
 
/*

Ŀ
Funo	  Tr010Habil    Autor  Equipe R.H.        Data  08.11.99 
Ĵ
Descrio  Imprime as Habilidades do Cargo   					      
Ĵ
Sintaxe	  Tr010Habil()											      
Ĵ
 Uso       TRMR010  											  	  
ٱ

*/
Static Function Tr010Habil() 

Local aSaveArea	:= GetArea()
Local cDet 		:= ""
Local nLinha	:= 0
Local nBegin	:= 0

IMPR(__PrtThinLine(),"C")

cDet := Space(05) + STR0025	//"DESCRICAO DAS HABILIDADES DO CARGO"
IMPR(cDet,"C")                     

IMPR(__PrtThinLine(),"C")
		
cAuxDet := MSMM(SQ3->Q3_DHABILI,,,,3)	// Leitura do campo memo das Habilidades do Cargo
nLinha	:= MLCount(cAuxDet,80)

If nLinha > 0
	For nBegin := 1 To nLinha
		cDet := Space(08)+Memoline(cAuxDet,80,nBegin,,.T.)
		IMPR(cDet,"C")
	Next nBegin
Else
	cDet := Space(08) + STR0026	//" *** Nao existe Descricao das Habilidades do Cargo *** "
	IMPR(cDet,"C")	
EndIf	

cDet := ""
IMPR(cDet,"C")		

RestArea(aSaveArea)

Return Nil	

/*

Ŀ
Funo	  Tr010ImpGrad  Autor  Equipe R.H.        Data  08.11.99 
Ĵ
Descrio  Imprime a graduacao dos fatores do Cargos  			      
Ĵ
Sintaxe	  Tr010ImpGrad(cCargo,cGrupo,cCC)						      
Ĵ
 Uso       TRMR010  											  	  
ٱ

*/
Static Function Tr010ImpGrad(cCargo,cGrupo,cCC)

Local aSaveArea	 := GetArea()
Local cDet		 := ""
Local cDescDet	 := ""
Local cDescFat   := ""
Local cDescGra   := ""
Local cDscFatAux := ""
Local cDscGraAux := ""
Local cFator	 := ""
Local cGrau      := ""
Local nLinha	 := 0
Local nBegin     := 0
Local nx		 := 0
Local i			 := 0
Local l1Vez 	 := .T.
Local lPriVez    := .T.
Local nCargo	 := 0
Local aFator 	 := {}

IMPR(__PrtThinLine(),"C")

cDet := Space(05) + STR0011	//"GRADUACAO DOS CARGOS"
IMPR(cDet,"C")                     

IMPR(__PrtThinLine(),"C")

FMontaFator(,,cCargo,,cGrupo,,@aFator,cCC)

For nx := 1 To Len(aFator)

	nCargo := nCargo + aFator[nx][5]
	
	// Imprimir os pontos e so imprimir os totais dos pontos
	If MV_PAR12 ==1 .And. MV_PAR13==1          
		l1Vez:= .F.
		Loop
	EndIf	

	// Verificar os parametros do Fator de Graduacao
	If 	aFator[nx][1] < MV_PAR14 .Or.;
		aFator[nx][1] > MV_PAR15
		dbSkip()
		Loop
	EndIf								 
	
	If l1Vez						 
		l1Vez 	:= .F.
		cDet	:= Space(08)+ STR0012	//"FATOR DESCRICAO                      GRAU DESCRICAO     "
										//  01 012345678901234567890123456789   01 012345678901234567890123456789
		// Imprime por pontos												
		If MV_PAR12 == 1  	// Sim
			cDet += Space(19) + STR0019 		//"PONTOS"
		EndIf
		IMPR(cDet,"C")								 
	EndIf	

	cDescFat := TrmDesc("SQ1",cGrupo+aFator[nx][1],"Q1_DESCSUM")
	cDescGra := TrmDesc("SQ2",cGrupo+aFator[nx][1]+aFator[nx][3],"Q2_DESC")
	cFator   := aFator[nx][1]
	cGrau    := aFator[nx][3]

    nLinha := Max( MlCount(cDescFat,30) , MlCount(cDescGra,30) ) //Verifica a quantidade de linhas para a maior descricao
    lPriVez := .T.

    For i := 1 to nLinha
        
		cDscFatAux := Memoline(cDescFat,30,i,,.T.)
		cDscGraAux := Memoline(cDescGra,30,i,,.T.)
		
		cDscFatAux := If (Empty(cDscFatAux),Space(30),cDscFatAux)
		cDscGraAux := If (Empty(cDscGraAux),Space(30),cDscGraAux)			

		cDet	:= Space(11) + cFator + Space(01) + cDscFatAux + Space(03)
		cDet	+= cGrau + Space(01) + cDscGraAux
		
		cFator   := Space(2)
		cGrau    := Space(2)

		//Imprime por pontos
		If MV_PAR12 == 1 .and. lPriVez
			cDet += Space(02)+ Transform(aFator[nx][5],"@E 9999.99")
			lPriVez := .F.
		EndIf
	
		IMPR(cDet,"C")
    Next i
		
	// Imprime graduacao detalhada
	If MV_PAR09 == 1		// Sim

		IMPR(__PrtThinLine(),"C")
		cDet	:= Space(15) + STR0013	//"DESCRICAO DETALHADA DO FATOR"
		IMPR(cDet,"C")                      

		IMPR(__PrtThinLine(),"C")
					
		dbSelectArea("SQ1")
		dbSetOrder(1)
		cFil := xFilial("SQ1", SQ4->Q4_FILIAL)
		If dbSeek(cFil+cGrupo+aFator[nx][1])
			cDescDet := MSMM(SQ1->Q1_DESCDET,,,,3)	
		EndIf
			
		nLinha	:= MLCount(cDescDet,80)
		
		If nLinha > 0				
			For nBegin := 1 To nLinha
				cDet := Space(17)+ Memoline(cDescDet,80,nBegin)
				IMPR(cDet,"C")
			Next nBegin
		Else
			cDet := Space(14) + STR0014	//" *** Nao existe Descricao detalhada do Fator *** "
			IMPR(cDet,"C")
		EndIf
		
		cDet := ""
		IMPR(cDet,"C")
	EndIf
Next nx	                                                           

If MV_PAR12 != 2 .And. !l1Vez
	cDet :=""
	IMPR(cDet,"C")                  
	// Imprimir os pontos e somente os totais
	If MV_PAR12 == 1 .And. MV_PAR13 == 1       
		cDet := Space(08) + STR0012		//"FATOR DESCRICAO                      GRAU DESCRICAO     "	
		cDet += Space(19) + STR0019 	//"PONTOS"                                                      
		IMPR(cDet,"C")
	EndIf
	cDet := Space(60)+ STR0020		// "T O T A L :"
	cDet += Space(11)+ Transform(nCargo,"@E 9999.99")
	IMPR(cDet,"C")
EndIf

If l1Vez
	cDet := Space(08) + STR0018	//"*** Nao existe Graduacao para este cargo ***"
	IMPR(cDet,"C")
EndIf

RestArea(aSaveArea)

Return Nil

/*

Ŀ
Funo	  Tr010ImpCurso Autor  Equipe R.H.        Data  08.11.99 
Ĵ
Descrio  Imprime os Cursos necessarios para este Cargo              
Ĵ
Sintaxe	  Tr010ImpCurso(cCargo,cCC)                                  
Ĵ
 Uso       TRMR010  											  	  
ٱ

*/
Static Function Tr010ImpCurso(cCargo,cCC)

Local aSaveArea	:= GetArea()
Local cDet		:= ""
Local cDescCurso:= ""
Local cDescPri	:= ""
Local l1Vez 	:= .T.

IMPR(__PrtThinLine(),"C")

cDet :=  Space(05) + STR0015	//"CURSOS DO CARGO"
IMPR(cDet,"C")                     

IMPR(__PrtThinLine(),"C")

dbSelectArea("RA5")
dbSetOrder(2)
cFil := xFilial("RA5", SQ3->Q3_FILIAL)
If dbSeek(cFil+cCargo+cCC)	// Cargo + cCusto da Tabela SQ3
	While !Eof() .And. cFil+cCargo+cCC ==;
							 RA5->RA5_FILIAL+RA5->RA5_CARGO+RA5->RA5_CC

		If l1Vez							 
			l1Vez	:= .F.
			cDet 	:= Space(08) + STR0016	//"CURSO DESCRICAO                      VALIDADE  HRS MIN  NOTA MIN FREQ MIN  PRIORIDADE    " 
											//  0123 012345678901234567890123456789  0123456   012345    012345   012345  012 0123456789
			IMPR(cDet,"C")							 
		EndIf
							 
		cDescCurso 	:= TrmDesc("RA1",RA5->RA5_CURSO,"RA1->RA1_DESC",RA5->RA5_FILIAL)					 
		cDescPri	:= Substr(TrmDesc("SX5","R5"+RA5->RA5_UNPRIO,"SX5->X5_DESCRI",RA5->RA5_FILIAL),1,30)
		
		cDet := Space(09) + RA5->RA5_CURSO + Space(01) + cDescCurso	+ Space(02)
		cDet += Transform(RA5->RA5_VALIDA,"@E 9999.99") + Space(03) 
		cDet += Transform(RA5->RA5_HORAS,"@E 9999.99") + Space(04)
		cDet += Transform(RA5->RA5_NOTA,"@E 999.99") + Space(03)
		cDet += Transform(RA5->RA5_FREQUE,"@E 999.99") + Space(02)
		cDet += RA5->RA5_PRIORI + cDescPri
		
		IMPR(cDet,"C")
					
		dbSkip()						 
	EndDo						 	
EndIf

If l1Vez
	cDet := Space(08) + STR0017	//"*** Nao existe Curso para este cargo ***"
	IMPR(cDet,"C")
EndIf

cDet:=""
IMPR(cDet,"C")

RestArea(aSaveArea)

Return Nil  

/*

Ŀ
Funcao	  Tr010CompHab  Autor  Eduardo Ju         Data  17.02.04 
Ĵ
Descrio  Imprime as Competencias/Habilidades do Cargo               
Ĵ
Sintaxe	  Tr010CompHab(cCargo,cCC)                                   
Ĵ
 Uso       TRMR010  											  	  
ٱ

*/
Static Function Tr010CompHab(cGrupo,cCargo,cCC)

Local aSaveArea	:= GetArea()
Local cDet		:= ""
Local cDescHabil:= ""
Local cDescEscal:= "" 
Local cDescItEsc:= ""
Local cDescImpor:= ""
Local cDescItImp:= ""
Local l1Vez 	:= .T.

IMPR(__PrtThinLine(),"C")

cDet :=  Space(05) + OemToAnsi(STR0027)	//"COMPETENCIAS/HABILIDADES"
IMPR(cDet,"C")                     

IMPR(__PrtThinLine(),"C")

dbSelectArea("RBH")
dbSetOrder(2)
cFil := xFilial("RBH", SQ3->Q3_FILIAL)
If dbSeek(cFil+cGrupo+cCargo+cCC) .Or. dbSeek(cFil+cCargo)
	While !Eof() .And. cFil+cGrupo+cCargo+cCC == RBH->RBH_FILIAL+RBH->RBH_GRUPO+RBH->RBH_CARGO+RBH->RBH_CC
		If l1Vez							 
			l1Vez	:= .F.
            
            cDet := Space(08)+OemToAnsi(STR0028)	//"COD.     ITEM     COD.     DESCRICAO                                                      ESCALA   DESCRICAO              ITEM     DESCRICAO              GRAU   DESCRICAO              ITEM   DESCRICAO"
			IMPR(cDet,"C")
			cDet := Space(08)+OemToAnsi(STR0029)	//"COMPET   COMPET   HABIL.   DA HABILIDADE                                                           DA ESCALA              ESCALA   ITEM ESCALA            IMP.   GRAU IMPORTANCIA       IMP.   ITEM IMPORTANCIA"
			IMPR(cDet,"C")							 
		EndIf			 
	                
		cDescHabil := FDesc("RBG",RBH->RBH_HABIL,"RBG_DESC",60)
		cDescEscal := FDesc("RBK",RBH->RBH_ESCALA,"RBK_DESCRI",20) 
		cDescItEsc := FDesc("RBL",RBH->RBH_ESCALA + RBH->RBH_ITESCA,"RBL_DESCRI",20) 
		cDescImpor := FDesc("RBK",RBH->RBH_IMPORT,"RBK_DESCRI",20) 
		cDescItImp := FDesc("RBL",RBH->RBH_IMPORT + RBH->RBH_ITIMPO,"RBL_DESCRI",20)
				
		cDet := Space(08) + Alltrim(RBH->RBH_CODCOM) + Space(03)
		cDet += Alltrim(RBH->RBH_ITECOM) + Space(03)  
		cDet += Alltrim(RBH->RBH_HABIL) + Space(03)
		cDet += cDescHabil + Space(07)
		cDet += Alltrim(RBH->RBH_ESCALA) + Space(03)
		cDet += cDescEscal + Space(07) 
		cDet += Alltrim(RBH->RBH_ITESCA) + Space(03)
		cDet += cDescItEsc + Space(05)
		cDet += Alltrim(RBH->RBH_IMPORT) + Space(03)
		cDet += cDescImpor + Space(05)
		cDet += Alltrim(RBH->RBH_ITIMPO) + Space(03)
		cDet += cDescItImp
				
		IMPR(cDet,"C")			
		dbSkip()						 
	EndDo						 	
EndIf

If l1Vez
	cDet := Space(08) + OemToAnsi(STR0030)	//"*** Nao existe Competencia/Habilidade para este cargo ***"
	IMPR(cDet,"C")
EndIf

cDet:=""
IMPR(cDet,"C")

RestArea(aSaveArea)

Return Nil      

/*

Ŀ
Funcao	  Tr010lin      Autor  Eduardo Ju         Data  27.02.04 
Ĵ
Descrio  Checagem do numero de linhas para impressao                
Ĵ
Sintaxe	  Tr010lin                                                   
Ĵ
 Uso       TRMR010  											  	  
ٱ

*/
Static Function Tr010lin(cAlias,nTipo)

Local aSaveArea := GetArea()
Local cFil		:= ""
Local nLinhas	:= 0
Local cDescDet  := ""

Do Case   
    Case cAlias == ("SQ3")  
        If !Empty(SQ3->Q3_DESCDET) .And. nTipo == 1
        	cDescDet:= MSMM(SQ3->Q3_DESCDET,,,,3)	// Leitura do campo memo da descricao detalhada do cargo
			nLinhas	:= MLCount(cDescDet,80)      
		ElseIf !Empty(SQ3->Q3_DRESP) .And. nTipo == 2
			cDescDet:= MSMM(SQ3->Q3_DRESP,,,,3)	// Leitura do campo memo das Responsabilidades do Cargo
			nLinhas	:= MLCount(cDescDet,80)  
		ElseIf !Empty(SQ3->Q3_DRELINT) .And. nTipo == 3
			cDescDet:= MSMM(SQ3->Q3_DRELINT,,,,3)	// Leitura do campo memo do Relacionamento Interno do Cargo
			nLinhas	:= MLCount(cDescDet,80)			
    	ElseIf !Empty(SQ3->Q3_DHABILI).And. nTipo == 4
			cDescDet:= MSMM(SQ3->Q3_DHABILI,,,,3)	// Leitura do campo memo do Descricao das Habilidades do Cargo
			nLinhas	:= MLCount(cDescDet,80)
		EndIf	    
	
	Case cAlias == ("SQ1") //Graduacao dos Cargos
		dbSelectArea("SQ1")
		dbSetOrder(1)
		cFil := xFilial("SQ1", SQ1->Q1_FILIAL)
		If dbSeek(cFil+SQ3->Q3_GRUPO)//Ver Fator
			cDescDet:= MSMM(SQ1->Q1_DESCDET,,,,3)				
			nLinhas	:= MLCount(cDescDet,80) 
		EndIf	
	
	Case cAlias == ("RA5") //Cursos do Cargo
		dbSelectArea("RA5")
		dbSetOrder(2)
		cFil := xFilial("RA5", SQ3->Q3_FILIAL)
			If dbSeek(cFil+SQ3->Q3_CARGO+SQ3->Q3_CC) .Or. dbSeek(cFil+SQ3->Q3_CARGO)
				While !Eof() .And. cFil+SQ3->Q3_CARGO+SQ3->Q3_CC == RA5->RA5_FILIAL+RA5->RA5_CARGO+RA5->RA5_CC .Or.;
									cFil+SQ3->Q3_CARGO == RA5->RA5_FILIAL+RA5->RA5_CARGO  
		    		nLinhas ++
		    		DbSkip()
		    	EndDo	
			Endif									      
	Case cAlias == ("RBH") //Competencias/Habilidades
		dbSelectArea("RBH")
		dbSetOrder(2)
		cFil := xFilial("RBH", SQ3->Q3_FILIAL)
		If dbSeek(cFil+SQ3->Q3_GRUPO+SQ3->Q3_CARGO+SQ3->Q3_CC) .Or. dbSeek(cFil+SQ3->Q3_CARGO)
			While !Eof() .And. cFil+SQ3->Q3_GRUPO+SQ3->Q3_CARGO+SQ3->Q3_CC == RBH->RBH_FILIAL+RBH->RBH_GRUPO+RBH->RBH_CARGO+RBH->RBH_CC
		    	nLinhas ++
		    	DbSkip()
		    EndDo	
		Endif		
EndCase    

RestArea(aSaveArea)

Return(nLinhas) 

/*

Ŀ
Funcao    TRR010SX1  Autor Eduardo Ju              Data  24.01.08 
Ĵ
Descricao Atualizacao do Pergunte TRR010 03 e 04 no Dicionario SX1.   
Ĵ
Retorno   Nenhum                                                      
Ĵ
ParametrosNenhum                                                      
Ĵ
Uso       TRR010SX1                                                   
ٱ

*/ 
Static Function TRR010SX1()             

Local aRegs		:= {}  
Local cPerg		:= "TRR010"   
 
//Ŀ
//           Grupo  	 Ordem 	 Pergunta Portugues  Pergunta Espanhol       Pergunta Ingles         Variavel 	 Tipo  	 Tamanho  Decimal  Presel    GSC   	Valid        Var01       Def01               DefSPA1        	DefEng1      	     Cnt01               Var02   Def02    		     DefSpa2             DefEng2	   	Cnt02  		Var03 	Def03      			DefSpa3    			DefEng3  		Cnt03  	Var04  	Def04     	DefSpa4    	DefEng4  	Cnt04  	Var05  	Def05       DefSpa5		DefEng5   	Cnt05  	 XF3   GrgSxg  cPyme aHelpPor	aHelpEng	aHelpSpa    cHelp  
//

Aadd(aRegs,{cPerg	,"03"	,"Cargo de   ?"	,"De Cargo ?"  ,"From Position ?"	,"mv_ch3"  	,"C"	,5			,0		,0		,"G"	,""		,"MV_PAR03"	,""					,""					,""					,""		,""		,""					,""					,""				,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,"SQ3",""    ,"S"	,{}			,{}			,{}			,".RHCGD."})
Aadd(aRegs,{cPerg	,"04"	,"Cargo ate  ?"	,"A  Cargo ?"  ,"To Position ?"	,"mv_ch4" 	,"C"	,5			,0		,0		,"G","naovazio"		,"MV_PAR04"	,""					,""					,""					,""		,""		,""					,""					,""				,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,"SQ3",""    ,"S"	,{}			,{}			,{}			,".RHCGAT."})

ValidPerg(aRegs,cPerg)

Return Nil