#INCLUDE "PROTHEUS.CH"
#INCLUDE "TRMR030.CH"
#INCLUDE "REPORT.CH"

/*

Ŀ
Programa   TRMR030   Autor  Eduardo Ju             Data  03/07/06 
Ĵ
Descrio  Planejado x Realizado                                      
Ĵ
Sintaxe    TRMR020                                                    
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Leandro Dr. 16/12/08|009882|Efetuado ajuste para que seja considerado 
                    |      |decimais na soma das horas e valores e que
                    |      |somente no final da soma seja arredondado 
ٱ

Ŀ
Programador   Data      FNC              Motivo da Alteracao                      
ĳ
Rogerio R.   29/07/200900000018271/2009Compatibilizacao dos fontes para aumento do
                                       campo filial e gesto corporativa.         
Allyson M.   10/11/200900000024550/2009Ajuste para imprimir os valores do planeja-
                                       mento na celula correta e so dos meses que 
                                       o usuario desejar.						 	
Leandro Dr.  12/01/201200000000575/2012Ajuste para que impressa cursos de todas as
                                       filiais, de acordo com parametrizacao.     
ٱ

*/
Function TRMR030()

Local oReport
Local aArea := GetArea()

Private nQuantos 	:= 0
Private nMvPlan  	:= GetMV("MV_CUSTCUR") // Somar o custo do curso na 1-Dt Inicio Curso0 2-Dt Fim do curso 3-Ratear pelos dias
Private aMeses	  	:= {}
Private cQual	  	:= ""
Private cTitAux	:= ""
Private cAno		:= ""

If FindFunction("TRepInUse") .And. TRepInUse()	//Verifica se relatorio personalizal esta disponivel
	//Ŀ
	// Verifica as perguntas selecionadas                           
	//
	Pergunte("TRX030",.F.)
	oReport := ReportDef()
	oReport:PrintDialog()	
Else
	TRMR030R3()	
EndIf  

RestArea( aArea )

Return

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  30.05.06 
Ĵ
Descrio Definicao do Componente de Impressao do Relatorio           
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function ReportDef()

Local oReport
Local oSection1
Local oSection2 //Ora por Valores, Ora por Horas
Local oSection3	//Horas
Local aOrdem    := {}    

//Ŀ
//Criacao do componente de impressao                                      
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
oReport:=TReport():New("TRMR030",STR0011,"TRX030",{|oReport| PrintReport(oReport)},STR0052)	//"Planejado x Realizado"#"Ser impresso de acordo com os parametros solicitados pelo usuario"
oReport:SetLandscape()	//Imprimir Somente Paisagem
oReport:SetTotalInLine(.F.) //Totaliza em linha

Pergunte("TRX030",.F.)

Aadd( aOrdem, STR0004)	// "Curso"
Aadd( aOrdem, STR0005)	// "Centro de Custo"
Aadd( aOrdem, STR0006)	// "Grupo+Depto"
Aadd( aOrdem, STR0007) 	// "Cargo"

//Ŀ
//Criacao da celulas da secao do relatorio                                
//TRCell():New                                                            
//ExpO1 : Objeto TSection que a secao pertence                            
//ExpC2 : Nome da celula do relatrio. O SX3 ser consultado              
//ExpC3 : Nome da tabela de referencia da celula                          
//ExpC4 : Titulo da celula                                                
//        Default : X3Titulo()                                            
//ExpC5 : Picture                                                         
//        Default : X3_PICTURE                                            
//ExpC6 : Tamanho                                                         
//        Default : X3_TAMANHO                                            
//ExpL7 : Informe se o tamanho esta em pixel                              
//        Default : False                                                 
//ExpB8 : Bloco de cdigo para impressao.                                 
//        Default : ExpC2                                                 
//
//Ŀ
// Criacao da Primeira Secao:
// 
oSection1 := TRSection():New(oReport,STR0011,{"RA4"},aOrdem,/*Campos do SX3*/,/*Campos do SIX*/)
oSection1:SetTotalInLine(.F.)  
oSection1:SetHeaderBreak(.T.) 

TRCell():New(oSection1,"RA4_CURSO","RA4",STR0004,,,,{|| cCurso })				//Codigo do Curso    
TRCell():New(oSection1,"RA1_DESC","RA1","")									//Descricao do Curso
TRCell():New(oSection1,"I3_CC","SI3",STR0005,,,,{|| cCC })						//Codigo do Centro de Custo    
TRCell():New(oSection1,"I3_DESC","SI3","")										//Descricao do Centro de Custo      
TRCell():New(oSection1,"Q0_GRUPO","SQ0",STR0014,,,,{|| Substr(cGrupo,1,2) })	//Codigo do Grupo
TRCell():New(oSection1,"Q0_DESCRIC","SQ0","")									//Descricao do Grupo
TRCell():New(oSection1,"QB_DEPTO"," ",STR0015,,,,{|| Substr(cGrupo,3,3) })	//Codigo do Depto    
TRCell():New(oSection1,"QB_DESCRIC","SQB","")									//Descricao do Depto
TRCell():New(oSection1,"Q3_CARGO","SQ3",STR0007,,,,{|| cCargo }) 				//Codigo do Cargo    
TRCell():New(oSection1,"Q3_DESCSUM","SQ3","")									//Descricao do Cargo

//Ŀ                            
// Criacao da Segunda Secao: 
//
oSection2 := TRSection():New(oSection1,STR0001,,/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)
oSection2:SetTotalInLine(.F.)  
oSection2:SetHeaderBreak(.T.)
oSection2:AutoSize()
                
TRCell():New(oSection2,"CURSOS"	,"   ","",,9)	//PLANEJADO OU REALIZADO 
TRCell():New(oSection2,"JANEIRO"	,"   ",	STR0040	,"99999999",8)
TRCell():New(oSection2,"FUNCJAN"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"FEVEREIRO"	,"   ", STR0041	,"99999999",8)       
TRCell():New(oSection2,"FUNCFEV"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"MARCO"		,"   ", STR0042	,"99999999",8)
TRCell():New(oSection2,"FUNCMAR"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"ABRIL"		,"   ", STR0043	,"99999999",8)
TRCell():New(oSection2,"FUNCABR"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"MAIO"		,"   ", STR0044	,"99999999",8)  
TRCell():New(oSection2,"FUNCMAI"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"JUNHO"		,"   ", STR0045	,"99999999",8)
TRCell():New(oSection2,"FUNCJUN"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"JULHO"		,"   ", STR0046	,"99999999",8) 
TRCell():New(oSection2,"FUNCJUL"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"AGOSTO"		,"   ", STR0047	,"99999999",8)
TRCell():New(oSection2,"FUNCAGO"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"SETEMBRO"	,"   ", STR0048	,"99999999",8)
TRCell():New(oSection2,"FUNCSET"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"OUTUBRO"	,"   ", STR0049	,"99999999",8) 
TRCell():New(oSection2,"FUNCOUT"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"NOVEMBRO"	,"   ", STR0050	,"99999999",8)
TRCell():New(oSection2,"FUNCNOV"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"DEZEMBRO"	,"   ", STR0051	,"99999999",8)
TRCell():New(oSection2,"FUNCDEZ"	,"   ",	STR0036	,"9999",4)
TRCell():New(oSection2,"TOTAL"		,"   ", STR0038	,"99999999",8)
TRCell():New(oSection2,"FUNC"		,"   ",	STR0036	,"9999",4)

oSection2:Cell("JANEIRO"):SetHeaderAlign("RIGHT")
oSection2:Cell("FEVEREIRO"):SetHeaderAlign("RIGHT")
oSection2:Cell("MARCO"):SetHeaderAlign("RIGHT")
oSection2:Cell("ABRIL"):SetHeaderAlign("RIGHT")
oSection2:Cell("MAIO"):SetHeaderAlign("RIGHT")
oSection2:Cell("JUNHO"):SetHeaderAlign("RIGHT")
oSection2:Cell("JULHO"):SetHeaderAlign("RIGHT")
oSection2:Cell("AGOSTO"):SetHeaderAlign("RIGHT")
oSection2:Cell("SETEMBRO"):SetHeaderAlign("RIGHT")
oSection2:Cell("OUTUBRO"):SetHeaderAlign("RIGHT")
oSection2:Cell("NOVEMBRO"):SetHeaderAlign("RIGHT")
oSection2:Cell("DEZEMBRO"):SetHeaderAlign("RIGHT")
oSection2:Cell("TOTAL"):SetHeaderAlign("RIGHT")

oSection2:Cell("JANEIRO"):Disable()
oSection2:Cell("FUNCJAN"):Disable()
oSection2:Cell("FEVEREIRO"):Disable()
oSection2:Cell("FUNCFEV"):Disable()
oSection2:Cell("MARCO"):Disable()
oSection2:Cell("FUNCMAR"):Disable()
oSection2:Cell("ABRIL"):Disable()
oSection2:Cell("FUNCABR"):Disable()
oSection2:Cell("MAIO"):Disable()
oSection2:Cell("FUNCMAI"):Disable()
oSection2:Cell("JUNHO"):Disable()
oSection2:Cell("FUNCJUN"):Disable()
oSection2:Cell("JULHO"):Disable()
oSection2:Cell("FUNCJUL"):Disable()
oSection2:Cell("AGOSTO"):Disable()
oSection2:Cell("FUNCAGO"):Disable()
oSection2:Cell("SETEMBRO"):Disable()
oSection2:Cell("FUNCSET"):Disable()
oSection2:Cell("OUTUBRO"):Disable()
oSection2:Cell("FUNCOUT"):Disable()
oSection2:Cell("NOVEMBRO"):Disable()
oSection2:Cell("FUNCNOV"):Disable()
oSection2:Cell("DEZEMBRO"):Disable()
oSection2:Cell("FUNCDEZ"):Disable()

Return oReport

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  04.07.06 
Ĵ
Descrio Impressao do Relatorio                                      
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function PrintReport(oReport)

Local cOrder:= ""

Local aFields 	:= {}
Local cFiltro	:= ""
Local cIndCond	:= ""
Local cFor		:= ""
Local cCodPlan  := ""
Local cFil		:= "" 
Local cAuxFil	:= ""
Local cAcessaRA1:= &("{ || " + ChkRH(FunName(),"RA1","2") + "}")
Local cAcessaRA4:= &("{ || " + ChkRH(FunName(),"RA4","2") + "}")
Local lReal		:= .F.
Local cCargo	:= ""

Private aVlReal
Private aHrReal
Private aNrReal
Private aVlPlan
Private aHrPlan
Private aNrPlan

Private cArqDbf	:= ""
Private cArq	:= ""
Private nOrdem 	:=	oReport:Section(1):GetOrder()

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial  De                               
// MV_PAR02        //  Filial  Ate                              
// MV_PAR03        //  Planejamento De                          
// MV_PAR04        //  Planejamento Ate                         
// MV_PAR05        //  Periodo De                               
// MV_PAR06        //  Periodo Ate                              
// MV_PAR07        //  Curso De                                 
// MV_PAR08        //  Curso Ate                                
// MV_PAR09        //  Cargo De                                 
// MV_PAR10        //  Cargo Ate                                
// MV_PAR11        //  Grupo De                                 
// MV_PAR12        //  Grupo Ate                                
// MV_PAR13        //  Departamento De                          
// MV_PAR14        //  Departamento Ate                         
// MV_PAR15        //  Centro de Custo De                       
// MV_PAR16        //  Centro de Custo Ate                      
// MV_PAR17        //  Imprimir por Horas Valor Ambos           
// MV_PAR18        //  Rateia planejamento Sim/Nao              
//

// Valida os periodos do parametro
If 	MV_PAR05 > MV_PAR06 .Or.;
	(MV_PAR06 - MV_PAR05) > 365
	Help("",1,"Tr030Data")	// Verifique as datas do periodo
	Return .F.
EndIf                  

// Monta as strings do cabecalho
Tr30MesesRP()

Declare aVlReal[nQuantos]
Declare aHrReal[nQuantos]
Declare aNrReal[nQuantos]
Declare aVlPlan[nQuantos]
Declare aHrPlan[nQuantos]
Declare aNrPlan[nQuantos]

FZeraRP(oReport)

// Variaveis do relatorio
lRet := .T.
cArqDBF   := CriaTrab(NIL,.f.)                                                

// Cria arquivo que sera armazenado os dados dos cursos
AADD(aFields,{"TR_FILIAL", "C", FWGETTAMFILIAL,          0                        } )
AADD(aFields,{"TR_CC"     ,"C", TamSx3("RA_CC")[1],      TamSx3("RA_CC")[2]       } )
AADD(aFields,{"TR_CURSO"  ,"C", TamSx3("RA4_CURSO")[1],  TamSx3("RA4_CURSO")[2]   } )
AADD(aFields,{"TR_DTINI"  ,"D", TamSx3("RA4_DATAIN")[1], TamSx3("RA4_DATAIN")[2]  } )
AADD(aFields,{"TR_DTFIM"  ,"D", TamSx3("RA4_DATAFI")[1], TamSx3("RA4_DATAFI")[2]  } )
AADD(aFields,{"TR_GRUPO"  ,"C", TamSx3("Q3_GRUPO")[1],   TamSx3("Q3_GRUPO")[2]    } )
AADD(aFields,{"TR_DEPTO"  ,"C", TamSx3("Q3_DEPTO")[1],   TamSx3("Q3_DEPTO")[2]    } )
AADD(aFields,{"TR_CARGO"  ,"C", TamSx3("Q3_CARGO")[1],   TamSx3("Q3_CARGO")[2]    } )
AADD(aFields,{"TR_VALOR"  ,"N", TamSx3("RA4_VALOR")[1],  TamSx3("RA4_VALOR")[2]   } )
AADD(aFields,{"TR_HORAS"  ,"N", TamSx3("RA4_HORAS")[1],  TamSx3("RA4_HORAS")[2]   } )
                      
dbCreate(cArqDbf, aFields)
dbUseArea(.T., NIL, cArqDbf, "TRA", .F.)

If nOrdem == 1 		// Planejamento
	cIndCond := "TR_CURSO"
ElseIf nOrdem == 2	// Centro de Custo
	cIndCond := "TR_FILIAL + TR_CC + TR_CURSO"
ElseIf nOrdem == 3	// Grupo + Departamento	
	cIndCond := "TR_FILIAL + TR_GRUPO + TR_DEPTO + TR_CURSO"
ElseIf nOrdem == 4	// Cargo
	cIndCond := "TR_FILIAL + TR_CARGO + TR_CURSO"
EndIf

cArq := CriaTrab(NIL,.f.)
IndRegua("TRA",cArq,cIndCond,,,STR0012) //"Selecionando Registros..."
dbGoTop()

dbSelectArea("RA1")
dbSetOrder(1)
cFil := xFilial("RA1", MV_PAR01)
dbSeek(cFil+MV_PAR07,.T.)

While !Eof() .And. RA1->RA1_FILIAL <= MV_PAR02 

	If RA1->RA1_CURSO > MV_PAR08
		dbSkip()
		Loop
	EndIf
    
	If !Eval(cAcessaRA1)
		dbSkip()  
		Loop
	EndIf
	
	//Verifica os cursos realizados
    dbSelectArea("RA4")
    dbSetOrder(2)                                                
    lReal := .F.
    dbSeek(xFilial("RA4",MV_PAR01)+RA1->RA1_CURSO,.T.)
    While !Eof() //.And. xFilial("RA4")+RA1->RA1_CURSO == RA4->RA4_FILIAL+RA4->RA4_CURSO
    	If RA4->RA4_FILIAL > MV_PAR02
    		dbSkip()
    		Loop
    	EndIf
    	
    	If !(RA4->RA4_CURSO == RA1->RA1_CURSO)
    		dbSkip()
    		Loop
    	EndIf

 		If !Eval(cAcessaRA4)
			dbSkip()  
			Loop
		EndIf    	        
	
    	If 	(RA4->RA4_DATAIN < MV_PAR05) .Or. (RA4->RA4_DATAIN > MV_PAR06) 
   			dbSkip()
   			Loop
		EndIf
	
		If !Empty(oReport:Section(1):GetAdvplExp()) .AND. !&(oReport:Section(1):GetAdvplExp())
			dbSkip()
			Loop
		EndIF

		// Verifica o funcionario
		dbSelectArea("SRA")
		dbSetOrder(1)                                     
		cFil := xFilial("SRA", RA4->RA4_FILIAL)
		If dbSeek(cFil+RA4->RA4_MAT)
			If 	(SRA->RA_CC < MV_PAR15) .Or.;
				(SRA->RA_CC > MV_PAR16)  //.Or.;
			   	 //SRA->RA_SITFOLH == "D"
			   	 
				 dbSelectArea("RA4")
				 dbSetOrder(2)
				 dbSkip()
				 Loop
			EndIf
	
			cCargo := fGetCargo(SRA->RA_MAT,SRA->RA_FILIAL)			
			
			If cCargo < MV_PAR09 .Or. cCargo > MV_PAR10
				 
				dbSelectArea("RA4")
				dbSetOrder(2)
				dbSkip()
				Loop
			EndIf
				
			dbSelectArea( "SQ3" )
			dbSetOrder(1)
			cFil := xFilial("SQ3", SRA->RA_FILIAL)
			If dbSeek(cFil + cCargo + SRA->RA_CC) .Or. dbSeek(cFil + cCargo)
				If	SQ3->Q3_GRUPO < MV_PAR11 .Or.;
					SQ3->Q3_GRUPO > MV_PAR12 .Or.;
					SQ3->Q3_DEPTO < MV_PAR13 .Or.;
					SQ3->Q3_DEPTO > MV_PAR14
				
					dbSelectArea("RA4")
					dbSetOrder(2)
					dbSkip()
					Loop
				EndIf
			EndIf
					
	 		RecLock("TRA",.T.)
				Replace TRA->TR_FILIAL		With SRA->RA_FILIAL
				Replace TRA->TR_CC			With SRA->RA_CC
				Replace TRA->TR_CURSO		With RA4->RA4_CURSO
				Replace TRA->TR_GRUPO		With SQ3->Q3_GRUPO
				Replace TRA->TR_DEPTO		With SQ3->Q3_DEPTO
				Replace TRA->TR_CARGO		With SQ3->Q3_CARGO
				Replace TRA->TR_VALOR		With RA4->RA4_VALOR
				Replace TRA->TR_HORAS		With RA4->RA4_HORAS 
				Replace TRA->TR_DTINI		With RA4->RA4_DATAIN
				Replace TRA->TR_DTFIM		With RA4->RA4_DATAFI
	 			MsUnlock()
	 			lReal := .T.
		Endif
	
		dbSelectArea("RA4")
		DbSetOrder(2)
    	dbSkip()
	EndDo
		                             
	// Verifica se existe Planejamento qdo. nao tiver Realizado.
	If !lReal
    	Tr030PlanRP()
 	EndIf
	
	dbSelectArea("RA1")
	dbSetOrder(1)
    dbSkip()
EndDo
         
Tr030Print(oReport)

Return Nil

/*

Ŀ
Funo     Tr030Print  Autor  Eduardo Ju           Data  04.07.06 
Ĵ
Descrio  Funcao que imprime os dados do planejamento x realizado    
Ĵ
Sintaxe    Tr030Print()                                               
Ĵ
Uso        TRMR030                                                    
ٱ

*/   
Function Tr030Print(oReport)

Local lRet 	:= .T.
Local nVx	:= 0
Local Det	:= ""
       
Local oSection1 := oReport:Section(1)
Local oSection2 := oReport:Section(1):Section(1)
Local oBreak

Private cCurso	:= ""
Private cCC		:= ""
Private cGrupo 	:= ""
Private cCargo	:= ""
Private nVezes	:= 0
Private nCont	:= 0

// Define se sera impresso horas, valor ou ambos                   
If MV_PAR17 == 3  
	nVezes := 2
Else
	nVezes := 1
EndIf		                   

//Ŀ
// Troca do Titulo do Relatorio 
// 
cAno := STR(Year(MV_PAR05))
If !(AllTrim(oReport:Title())==AllTrim(STR0011))
	cTitle	:= oReport:Title() + " em " + IIF(MV_PAR17 == 2,"Horas","Valor") + " - Ano: " + Alltrim(cAno)
	cTitAux	:= oReport:Title()
Else
	cTitle := STR0011 + " em " + IIF(MV_PAR17 == 2,"Horas","Valor") + " - Ano: " + Alltrim(cAno)
	cTitAux	:= STR0011
Endif
oReport:SetTitle(cTitle) 

//-- Quebrar pagina por tipo de dados (Hora ou Valor)
DEFINE BREAK oBreak 	OF oReport WHEN {|| cQual } TITLE STR0001
oBreak:SetPageBreak(.T.)                
oBreak:OnBreak({|| oReport:SetTitle(cTitAux + " em Horas - Ano: " + Alltrim(cAno)) })

For nVx:= 1 To nVezes
             
	If nVezes == 1
		cQual := IIF(MV_PAR17 ==1,"V","H")
	Else
		cQual := IIF(nVx==1,"V","H")
	EndIf
                              
	dbSelectArea("TRA")
	dbGotop()
		
	oReport:SetMeter(RecCount())
	                                  
	While !Eof()
	
		oReport:IncMeter()
		
		If oReport:Cancel()
			Exit
		EndIf
                       
		If lRet
			lRet:= .F.
			If nOrdem == 1
				oSection1:Cell("I3_CC"):Disable()
				oSection1:Cell("I3_DESC"):Disable()
				oSection1:Cell("Q0_GRUPO"):Disable()
				oSection1:Cell("Q0_DESCRIC"):Disable()
				oSection1:Cell("QB_DEPTO"):Disable()
				oSection1:Cell("QB_DESCRIC"):Disable()
				oSection1:Cell("Q3_CARGO"):Disable()
				oSection1:Cell("Q3_DESCSUM"):Disable() 
			ElseIf nOrdem == 2
				cCC	  := TRA->TR_CC	
				TRPosition():New(oSection1,"SI3",1,{|| RhFilial("SI3", TRA->TR_FILIAL) + cCC})   		
				oSection1:Cell("Q0_GRUPO"):Disable()
				oSection1:Cell("Q0_DESCRIC"):Disable()
				oSection1:Cell("QB_DEPTO"):Disable()
				oSection1:Cell("QB_DESCRIC"):Disable()
				oSection1:Cell("Q3_CARGO"):Disable()
				oSection1:Cell("Q3_DESCSUM"):Disable()				
			ElseIf nOrdem == 3			
				cGrupo:= TRA->TR_GRUPO+TRA->TR_DEPTO 
   			TRPosition():New(oSection1,"SQ0",1,{|| RhFilial("SQ0", TRA->TR_FILIAL) + Substr(cGrupo,1,2)}) 
				TRPosition():New(oSection1,"SQB",1,{|| RhFilial("SQB", TRA->TR_FILIAL) + Substr(cGrupo,3,3)})  
				oSection1:Cell("I3_CC"):Disable()
				oSection1:Cell("I3_DESC"):Disable()
				oSection1:Cell("Q3_CARGO"):Disable()
				oSection1:Cell("Q3_DESCSUM"):Disable()
			ElseIf nOrdem == 4
				cCargo:= TRA->TR_CARGO 
				TRPosition():New(oSection1,"SQ3",1,{|| RhFilial("SQ3", TRA->TR_FILIAL) + cCargo}) 
				oSection1:Cell("I3_CC"):Disable()
				oSection1:Cell("I3_DESC"):Disable()
				oSection1:Cell("Q0_GRUPO"):Disable()
				oSection1:Cell("Q0_DESCRIC"):Disable()
				oSection1:Cell("QB_DEPTO"):Disable()
				oSection1:Cell("QB_DESCRIC"):Disable()
			EndIf	
			cCurso := TRA->TR_CURSO          
		EndIf   
		
		TRPosition():New(oSection1,"RA1",1,{|| RhFilial("RA1", TRA->TR_FILIAL) + cCurso}) 	
							
		If nOrdem == 1				// Curso		
		   	If cCurso # TRA->TR_CURSO
		   		
		   		oSection1:Init()
		   		oSection1:Printline()
		   		oSection1:Finish()
		   		
				Tr030RPVerPlan(oSection2)
				cCurso  := TRA->TR_CURSO 
			EndIf	
			Tr030Sum(oReport)
		ElseIf nOrdem == 2 		// Centro de Custo
			If cCC # TRA->TR_CC .Or. cCurso # TRA->TR_CURSO  
			   
			 	oSection1:Init()
		   		oSection1:Printline()
		   		oSection1:Finish()
			               
				Tr030RPVerPlan(oSection2)
				If cCC # TRA->TR_CC
					cCC := TRA->TR_CC         
				EndIf
				cCurso := TRA->TR_CURSO
			EndIf	
			Tr030Sum(oReport)
		ElseIf nOrdem == 3		// Grupo+Depto
			If cGrupo # TRA->TR_GRUPO+TRA->TR_DEPTO .Or. cCurso # TRA->TR_CURSO
			 
				oSection1:Init()
		   		oSection1:Printline()
		   		oSection1:Finish()
			
				Tr030RPVerPlan(oSection2)
				If cGrupo # TRA->TR_GRUPO+TRA->TR_DEPTO   
					cGrupo	:= TRA->TR_GRUPO+TRA->TR_DEPTO
				EndIf	
				cCurso  := TRA->TR_CURSO 				
			EndIf	
			Tr030Sum(oReport)
		ElseIf nOrdem == 4		// Cargo
			If cCargo # TRA->TR_CARGO .Or. cCurso # TRA->TR_CURSO
			
				oSection1:Init()
		   		oSection1:Printline()
		   		oSection1:Finish()
			
				Tr030RPVerPlan(oSection2)
				If cCargo # TRA->TR_CARGO
					cCargo	:= TRA->TR_CARGO				
				EndIf
				cCurso  := TRA->TR_CURSO 
			EndIf	
			Tr030Sum(oReport)
		EndIf

		dbSelectArea("TRA")
		dbSkip()
	EndDo
	
	If !lRet
		oSection1:Init()
  		oSection1:Printline()
 		oSection1:Finish()
		Tr030RPVerPlan(oSection2)
		lRet := .T.
	EndIf	    

Next nVx	      


//Ŀ
// Termino do Relatorio                                         
//
dbSelectArea("TRA")
dbCloseArea()
fErase(cArq + OrdBagExt())
fErase(cArqDbf + GetDBExtension())

oReport:Section(1):Finish()            	//Fecha Section1

Return Nil

/*

Ŀ
Funo     TR30IMPRE   Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio  Imprime as linhas de detalhes do relatorios                 
Ĵ
Sintaxe    TR30IMPRE                                                  
Ĵ
Uso        TRMR030                                                    
ٱ

*/    
Static Function TR30IMPRE(aTotais,oSection)

Local nx		:= 0
Local nTotal	:= 0
Local nTotFunc	:= 0     

dbSelectArea("RA1")
dbSetOrder(1)
cFil := xFilial("RA1")
dbSeek(cFil+cCurso)

If cQual == "V"                           
	    
	oSection:Init()	//Secao 2    

	oSection:Cell("CURSOS"):SetValue(STR0037)	//PLANEJADO 
	For nx:=1 To nQuantos
		If nx == nQuantos
			If nTotal+aVlPlan[nx] < aTotais[1]
				aVlPlan[nx] += aTotais[1] - (nTotal+aVlPlan[nx])
			EndIf
			If nTotFunc+aNrPlan[nx] < aTotais[3]
				aNrPlan[nx] += aTotais[3] - (nTotFunc+aNrPlan[nx])
			EndIf
		EndIf 
		
		nTotal   := nTotal   + aVlPlan[nx]		
		nTotFunc := nTotFunc + aNrPlan[nx]

		Do Case
			Case aMeses[nx] == 1 
				oSection:Cell("JANEIRO"):Enable()
				oSection:Cell("FUNCJAN"):Enable()
				oSection:Cell("JANEIRO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCJAN"):SetValue(aNrPlan[nx])
			Case aMeses[nx] == 2   
				oSection:Cell("FEVEREIRO"):Enable()
				oSection:Cell("FUNCFEV"):Enable()
		   		oSection:Cell("FEVEREIRO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCFEV"):SetValue(aNrPlan[nx])
			Case aMeses[nx] == 3 
				oSection:Cell("MARCO"):Enable()
				oSection:Cell("FUNCMAR"):Enable()
				oSection:Cell("MARCO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCMAR"):SetValue(aNrPlan[nx])
			Case aMeses[nx] == 4  
				oSection:Cell("ABRIL"):Enable()
				oSection:Cell("FUNCABR"):Enable()
				oSection:Cell("ABRIL"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCABR"):SetValue(aNrPlan[nx])
			Case aMeses[nx] == 5   
				oSection:Cell("MAIO"):Enable()
				oSection:Cell("FUNCMAI"):Enable()
				oSection:Cell("MAIO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCMAI"):SetValue(aNrPlan[nx])	
			Case aMeses[nx] == 6   
				oSection:Cell("JUNHO"):Enable()
				oSection:Cell("FUNCJUN"):Enable()
				oSection:Cell("JUNHO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCJUN"):SetValue(aNrPlan[nx])
			Case aMeses[nx] == 7   
				oSection:Cell("JULHO"):Enable()
				oSection:Cell("FUNCJUL"):Enable()
				oSection:Cell("JULHO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCJUL"):SetValue(aNrPlan[nx]) 
			Case aMeses[nx] == 8
				oSection:Cell("AGOSTO"):Enable()
				oSection:Cell("FUNCAGO"):Enable()
				oSection:Cell("AGOSTO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCAGO"):SetValue(aNrPlan[nx]) 	
			Case aMeses[nx] == 9                                                            
				oSection:Cell("SETEMBRO"):Enable()
				oSection:Cell("FUNCSET"):Enable()
				oSection:Cell("SETEMBRO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCSET"):SetValue(aNrPlan[nx]) 
			Case aMeses[nx] == 10 
				oSection:Cell("OUTUBRO"):Enable()
				oSection:Cell("FUNCOUT"):Enable()
				oSection:Cell("OUTUBRO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCOUT"):SetValue(aNrPlan[nx]) 
			Case aMeses[nx] == 11    
				oSection:Cell("NOVEMBRO"):Enable()
				oSection:Cell("FUNCNOV"):Enable()
				oSection:Cell("NOVEMBRO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCNOV"):SetValue(aNrPlan[nx]) 
			Case aMeses[nx] == 12    
				oSection:Cell("DEZEMBRO"):Enable()
				oSection:Cell("FUNCDEZ"):Enable()
				oSection:Cell("DEZEMBRO"):SetValue(aVlPlan[nx])
				oSection:Cell("FUNCDEZ"):SetValue(aNrPlan[nx])		
		End Case
	
	Next nx
	
	oSection:Cell("TOTAL"):SetValue(nTotal)
	oSection:Cell("FUNC"):SetValue(nTotFunc) 
	
	oSection:PrintLine()	//Secao 2
	                                         
	// Imprime a linha dos dados do realizado
	nTotal :=0
	nTotFunc :=0
	
	//oSection:Init()	//Secao 2
	
	oSection:Cell("CURSOS"):SetValue(STR0039)//REALIZADO
	
	For nx:=1 To nQuantos
	
		nTotal   := nTotal   + aVlReal[nx]    
		nTotFunc := nTotFunc + aNrReal[nx]
		Do Case
			Case aMeses[nx] == 1 
				oSection:Cell("JANEIRO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCJAN"):SetValue(aNrReal[nx])
			Case aMeses[nx] == 2   
		   		oSection:Cell("FEVEREIRO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCFEV"):SetValue(aNrReal[nx])
			Case aMeses[nx] == 3 
				oSection:Cell("MARCO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCMAR"):SetValue(aNrReal[nx])
			Case aMeses[nx] == 4  
				oSection:Cell("ABRIL"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCABR"):SetValue(aNrReal[nx])
			Case aMeses[nx] == 5   
				oSection:Cell("MAIO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCMAI"):SetValue(aNrReal[nx])	
			Case aMeses[nx] == 6   
				oSection:Cell("JUNHO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCJUN"):SetValue(aNrReal[nx])
			Case aMeses[nx] == 7   
				oSection:Cell("JULHO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCJUL"):SetValue(aNrReal[nx]) 
			Case aMeses[nx] == 8
				oSection:Cell("AGOSTO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCAGO"):SetValue(aNrReal[nx]) 	
			Case aMeses[nx] == 9                                                            
				oSection:Cell("SETEMBRO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCSET"):SetValue(aNrReal[nx]) 
			Case aMeses[nx] == 10 
				oSection:Cell("OUTUBRO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCOUT"):SetValue(aNrReal[nx]) 
			Case aMeses[nx] == 11    
				oSection:Cell("NOVEMBRO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCNOV"):SetValue(aNrReal[nx]) 
			Case aMeses[nx] == 12    
				oSection:Cell("DEZEMBRO"):SetValue(aVlReal[nx])
				oSection:Cell("FUNCDEZ"):SetValue(aNrReal[nx])		
		End Case           		          
		
	Next nx

	oSection:Cell("TOTAL"):SetValue(nTotal)
	oSection:Cell("FUNC"):SetValue(nTotFunc)		

	oSection:Printline()	//Secao 2
Else      

	oSection:Init()	//Secao 2
	
	oSection:Cell("CURSOS"):SetValue(STR0037)//PLANEJADO
	
	For nx:=1 To nQuantos
		If nx == nQuantos
			If nTotal+aHrPlan[nx] < aTotais[2]
				aHrPlan[nx] += aTotais[2] - (nTotal+aHrPlan[nx])
			EndIf
			If nTotFunc+aNrPlan[nx] < aTotais[3]
				aNrPlan[nx] += aTotais[3] - (nTotFunc+aNrPlan[nx])
			EndIf
		EndIf
		
		nTotal   := nTotal   + aHrPlan[nx]
		nTotFunc := nTotFunc + aNrPlan[nx]
		
		Do Case
			Case aMeses[nx] == 1 
				oSection:Cell("JANEIRO"):Enable()
				oSection:Cell("FUNCJAN"):Enable()
				oSection:Cell("JANEIRO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCJAN"):SetValue(aNrPlan[nx])
			Case aMeses[nx] == 2   
				oSection:Cell("FEVEREIRO"):Enable()
				oSection:Cell("FUNCFEV"):Enable()
		   		oSection:Cell("FEVEREIRO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCFEV"):SetValue(aNrPlan[nx])
			Case aMeses[nx] == 3 
				oSection:Cell("MARCO"):Enable()
				oSection:Cell("FUNCMAR"):Enable()
				oSection:Cell("MARCO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCMAR"):SetValue(aNrPlan[nx])
			Case aMeses[nx] == 4  
				oSection:Cell("ABRIL"):Enable()
				oSection:Cell("FUNCABR"):Enable()
				oSection:Cell("ABRIL"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCABR"):SetValue(aNrPlan[nx])
			Case aMeses[nx] == 5   
				oSection:Cell("MAIO"):Enable()
				oSection:Cell("FUNCMAI"):Enable()
				oSection:Cell("MAIO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCMAI"):SetValue(aNrPlan[nx])	
			Case aMeses[nx] == 6   
				oSection:Cell("JUNHO"):Enable()
				oSection:Cell("FUNCJUN"):Enable()
				oSection:Cell("JUNHO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCJUN"):SetValue(aNrPlan[nx])
			Case aMeses[nx] == 7   
				oSection:Cell("JULHO"):Enable()
				oSection:Cell("FUNCJUL"):Enable()
				oSection:Cell("JULHO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCJUL"):SetValue(aNrPlan[nx]) 
			Case aMeses[nx] == 8
				oSection:Cell("AGOSTO"):Enable()
				oSection:Cell("FUNCAGO"):Enable()
				oSection:Cell("AGOSTO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCAGO"):SetValue(aNrPlan[nx]) 	
			Case aMeses[nx] == 9                                                            
				oSection:Cell("SETEMBRO"):Enable()
				oSection:Cell("FUNCSET"):Enable()
				oSection:Cell("SETEMBRO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCSET"):SetValue(aNrPlan[nx]) 
			Case aMeses[nx] == 10 
				oSection:Cell("OUTUBRO"):Enable()
				oSection:Cell("FUNCOUT"):Enable()
				oSection:Cell("OUTUBRO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCOUT"):SetValue(aNrPlan[nx]) 
			Case aMeses[nx] == 11    
				oSection:Cell("NOVEMBRO"):Enable()
				oSection:Cell("FUNCNOV"):Enable()
				oSection:Cell("NOVEMBRO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCNOV"):SetValue(aNrPlan[nx]) 
			Case aMeses[nx] == 12    
				oSection:Cell("DEZEMBRO"):Enable()
				oSection:Cell("FUNCDEZ"):Enable()
				oSection:Cell("DEZEMBRO"):SetValue(aHrPlan[nx])
				oSection:Cell("FUNCDEZ"):SetValue(aNrPlan[nx])		
		End Case
				
	Next nx      
	
	oSection:Cell("TOTAL"):SetValue(nTotal)
	oSection:Cell("FUNC"):SetValue(nTotFunc)
	
    oSection:Printline()	//Secao 2
                                         
	// Imprime a linha dos dados do realizado
	nTotal  := 0
	nTotFunc:= 0

	//oSection:Init()	//Secao 2
	
	oSection:Cell("CURSOS"):SetValue(STR0039)//REALIZADO
	
	For nx:=1 To nQuantos

		nTotal   := nTotal   + aHrReal[nx]
		nTotFunc := nTotFunc + aNrReal[nx]
		
		Do Case
			Case aMeses[nx] == 1 
				oSection:Cell("JANEIRO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCJAN"):SetValue(aNrReal[nx])
			Case aMeses[nx] == 2   
		   		oSection:Cell("FEVEREIRO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCFEV"):SetValue(aNrReal[nx])
			Case aMeses[nx] == 3 
				oSection:Cell("MARCO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCMAR"):SetValue(aNrReal[nx])
			Case aMeses[nx] == 4  
				oSection:Cell("ABRIL"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCABR"):SetValue(aNrReal[nx])
			Case aMeses[nx] == 5   
				oSection:Cell("MAIO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCMAI"):SetValue(aNrReal[nx])	
			Case aMeses[nx] == 6   
				oSection:Cell("JUNHO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCJUN"):SetValue(aNrReal[nx])
			Case aMeses[nx] == 7   
				oSection:Cell("JULHO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCJUL"):SetValue(aNrReal[nx]) 
			Case aMeses[nx] == 8
				oSection:Cell("AGOSTO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCAGO"):SetValue(aNrReal[nx]) 	
			Case aMeses[nx] == 9                                                            
				oSection:Cell("SETEMBRO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCSET"):SetValue(aNrReal[nx]) 
			Case aMeses[nx] == 10 
				oSection:Cell("OUTUBRO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCOUT"):SetValue(aNrReal[nx]) 
			Case aMeses[nx] == 11    
				oSection:Cell("NOVEMBRO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCNOV"):SetValue(aNrReal[nx]) 
			Case aMeses[nx] == 12    
				oSection:Cell("DEZEMBRO"):SetValue(aHrReal[nx])
				oSection:Cell("FUNCDEZ"):SetValue(aNrReal[nx])		
		End Case
		
	Next nx                  
	
	oSection:Cell("TOTAL"):SetValue(nTotal)
	oSection:Cell("FUNC"):SetValue(nTotFunc)
	
	oSection:Printline()	//Secao 2

EndIf              
   
oSection:Finish()	//Fecha Section2

Return Nil

/*

Ŀ
Funo     FZeraRP	   Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio  Zera as variaveis do relatorio                             
Ĵ
Sintaxe    FZeraRP()                                                  
Ĵ
Uso        TRMR030                                                    
ٱ

*/
Function FZeraRP(oReport)

AFill(aVlReal,0)
AFill(aHrReal,0)
AFill(aNrReal,0)
AFill(aVlPlan,0)
AFill(aHrPlan,0)
AFill(aNrPlan,0)

Return Nil			

/*

Ŀ
Funcao    Tr030Sum ()  Autor  Eduardo Ju           Data  04.07.06 
Ĵ
Descrio Soma os valores de curso,horas e nr funcionario             
Ĵ
Sintaxe   Tr030Sum(oReport)                                           
Ĵ
Uso        TRMR030                                                    
ٱ

*/
Function Tr030Sum(oReport)

Local nMes := 0
Local nPos := 0

//Ler o getmv
//1- INICIO
//2- FIM
//3- RATEADO
// Se considerado o valor do custo do treinamento conforme definido no MV_PLANEJ
// Se for:  1- Sera considerado todo o custo do treinamento no inicio do curso.
// 			2- Sera considerado todo o custo do treinamento no fim do curso.
//			3- Sera dividido entre o mes inicial e mes final

If nMvPlan = 1			// Inicio
	nMes := Month(TRA->TR_DTINI)
ElseIf nMvPlan = 2		// Fim
	// Verifico se a data final do curso esta dentro do periodo selecionado
	If TRA->TR_DTFIM <= MV_PAR05
		nMes := Month(TRA->TR_DTFIM)
	EndIf	
ElseIf nMvPlan = 3		// Rateado	
	Tr30RateioRP(TRA->TR_DTINI,TRA->TR_DTFIM,TRA->TR_VALOR,TRA->TR_HORAS,1,"R")
EndIf   

nPos := Ascan(aMeses,nMes)

If nMvPlan # 3
	If nMes > 0 .And. nPos > 0
		aVlReal[nPos] += TRA->TR_VALOR
		aHrReal[nPos] += TRA->TR_HORAS
		If TRA->TR_VALOR > 0 .Or. TRA->TR_HORAS > 0
			aNrReal[nPos] += 1	
		EndIf
	EndIf
EndIf										

Return

/*


Ŀ
Funo    Tr030VerPlan Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio Verifica os val. custo, horas e nr func planej para curso   
Ĵ
Sintaxe   Tr030VerPlan                                                
Ĵ
Uso       TRMR030                                                     
ٱ

*/
Function Tr030RPVerPlan(oSection)

Local aSaveArea := GetArea()
Local nMes		:= 0 
Local aTotais[3]

aFill(aTotais,0)
                  
dbSelectArea("RA8")
dbSetOrder(2)
If dbSeek(xFilial("RA8")+cCurso)
	While !Eof() .and. xFilial("RA8")+cCurso == RA8->RA8_FILIAL+RA8->RA8_CURSO
	
		// Ordem 2 - Centro de custo  
		// Ordem 3 - Grupo+Depto
		// Ordem 4 - Cargo
		If (nOrdem == 2 .And. cCC    # RA8->RA8_CC) .Or.;
		   (nOrdem == 3 .And. cGrupo # RA8->RA8_GRUPO+RA8->RA8_DEPTO) .Or.;
		   (nOrdem == 4 .And. cCargo # RA8->RA8_CARGO)
		   dbSkip()
		   Loop
		EndIf		    	

		// Verifica periodos
		If 	RA8->RA8_DATADE < MV_PAR05 .Or. ;
			RA8->RA8_DATADE > MV_PAR06        
			dbSkip()
			Loop
		EndIf	
					            
		// Planejamento 
		If RA8->RA8_PLANEJ < MV_PAR03 .Or.;
		   RA8->RA8_PLANEJ > MV_PAR04
		   dbSkip()
		   Loop
		EndIf		   
		 
		// Centro de Custo			
		If RA8->RA8_CC < MV_PAR15 .Or.;
		   RA8->RA8_CC > MV_PAR16
		   dbSkip()
		   Loop
		EndIf        
		
		// Grupo+Departamento
		If RA8->RA8_GRUPO+RA8->RA8_DEPTO < MV_PAR11+MV_PAR13 .Or.;
		   RA8->RA8_GRUPO+RA8->RA8_DEPTO > MV_PAR12+MV_PAR14
		   dbSkip()
		   Loop
		EndIf                
		
		// Rateia planejamento 1-Sim 2-Nao
		If MV_PAR18 == 1 	 
			Tr30RateioRP(RA8->RA8_DATADE,RA8->RA8_DATAAT,RA8->RA8_VALOR,RA8->RA8_HORAS,RA8->RA8_NFUNC,"P")
		Else            
			// Coloca os custos no final do mes em que foi planejado
			nMes := Month(RA8->RA8_DATAAT)
			nPos := Ascan(aMeses,nMes)
			If nPos > 0
			    aVlPlan[nPos] += RA8->RA8_VALOR
				aNrPlan[nPos] += RA8->RA8_NFUNC
				aHrPlan[nPos] += RA8->RA8_HORAS
			EndIf	
		EndIf	
		
		aTotais[1] := aTotais[1] + RA8->RA8_VALOR
		aTotais[2] := aTotais[2] + RA8->RA8_HORAS
		aTotais[3] := aTotais[3] + RA8->RA8_NFUNC		
				    
		dbSelectArea("RA8")
		dbSetOrder(2)				                            
		dbSkip()		
	EndDo
EndIf

RestArea(aSaveArea)

TR30IMPRE(aTotais, oSection)

FZeraRP(oSection)      

Return Nil

/*

Ŀ
Funo     Tr30MesesRP Autor  Eduardo Ju           Data  05.07.06 
Ĵ
Descrio  Meses                                                      
Ĵ
Sintaxe    Tr30MesesRP()                                              
Ĵ
Uso        TRMR030                                                    
ٱ

*/
Function Tr30MesesRP()

Local nMes		:= 0
Local nAno		:= 0
Local nMuda		:= 0
Local nx		:= 0                     
                   
nMes := Month(MV_PAR05)
nAno := Year(MV_PAR05)

If Year(MV_PAR05) == Year(MV_PAR06)
	nQuantos := Month(MV_PAR06) - Month(MV_PAR05)
	nMuda    := 0
Else            
	nMuda    := (12 - Month(MV_PAR05))+ 2
	nQuantos := (12 - Month(MV_PAR05))+ Month(MV_PAR06)	
EndIf

nQuantos:= nQuantos + 1
//"CURSO			                JAN/2000 FUNC| FEV/2000 FUNC| MAR/2000 FUNC| ABR/2000 FUNC| MAI/2000 FUNC| JUN/2000 FUNC| JUL/2000 FUNC| AGO/2000 FUNC| SET/2000 FUNC| OUT/2000 FUNC| NOV/2000 FUNC| DEZ/2000 FUNC!      TOTAL   FUNC"		
//"123451234567890123456789012345678123456789012345                                                                                                                                                                               

For nx := 1 To nQuantos 
	If nx # 1
		nMes:= nMes + 1
	EndIf
	If nMuda == nx
		nAno := Year(MV_PAR06)
		nMes := 1
	EndIf		
	Aadd(aMeses,nMes)
Next nx          

Return .T.
        
/*

Ŀ
Funo     Tr30RateioRP Autor  Cristina Ogura      Data  04.07.06 
Ĵ
Descrio  Calcula o rateio de valores e horas                        
Ĵ
Sintaxe    Tr30RateioRP()                                             
Ĵ
Uso        TRMR030                                                    
ٱ

*/
Function Tr30RateioRP(dInicio,dFim,nValor,nHoras,nFunc,cTipo)

Local nDias		:= 0
Local nVezes	:= 0
Local nAno		:= 0
Local nVlDias	:= 0
Local nHrDias	:= 0
Local nNrDias	:= 0
Local dMonta
Local cString	:= ""  
Local nCValor	:= 0
Local nCHoras	:= 0
Local nCFunc	:= 0			// Valores Calculados
Local nTValor	:= 0
Local nTHoras	:= 0
Local nTFunc	:= 0			// Totais dos valores dos meses
Local nDif 		:= 0
Local nx		:= 0

// Sao verificadas todas as possibilidades:
// Datas iguais : 15/02/99 a 15/02/99
// MMAAAA iguais: 15/02/99 a 25/02/99
// AAAA iguais  : 15/02/99 a 20/03/99
// AAAA diferen.: 21/09/99 a 03/02/99

nDias := dFim - dInicio + 1 

If nDias == 0
	nDias := 1
EndIf
	
nVlDias := Round(nValor / nDias,2)
nHrDias := Round(nHoras / nDias,2)
nNrDias := Round(nFunc  / nDias,2)

nMes    := Month(dInicio)                
nAno    := Year(dInicio)

If Year(dInicio) == Year(dFim)
	nVezes := Month(dFim) - Month(dInicio) + 1
Else                          
    nVezes := (12 - Month(dInicio)) + Month(dFim)
EndIf			
		
For nx := 1 To nVezes
	If nVezes == 1
		If dInicio == dFim
			nDias := 1
		ElseIf Year(dInicio) == Year(dFim) .And.;
			   Month(dInicio)== Month(dFim)
			nDias := Day(dFim)
		Else	   	
			nDias := Day(dInicio)
		EndIf
	Else	
		If nx== nVezes
			nDias := Day(dFim)	
		Else
			// Montar a data para verificar o ultimo dia do mes 
			cString:= "'01/"+StrZero(nMes,2)+"/"+Substr(Str(nAno,4),3,2)+"'"
			dMonta 	:= CtoD(cString)
			nDias 	:= f_ultdia(dMonta)			
			If nx == 1
				nDias := nDias - Day(dInicio) + 1
			EndIf				
		EndIf            
	EndIf

	nCValor := Round(nVlDias * nDias,2)
	nCHoras := Round(nHrDias * nDias,2)
	nCFunc  := Round(nNrDias * nDias,2)
	        
	nPos   := Ascan(aMeses,nMes)

	If nPos > 0	
		// Somando para obter o total do curso
		nTValor := nTValor + nCValor
		nTHoras := nTHoras + nCHoras
		nTFunc  := nTFunc  + nCFunc
		
		// Acerto dos totais 
		If nx== nVezes                   
			nDif := Round(Abs(nValor - nTValor),0)			
			If nTValor < nValor
				nCValor := nCValor + nDif
			ElseIf nTValor > nValor
				nCValor := nCValor - nDif
			EndIf					 
			nDif := Round(Abs(nHoras - nTHoras),0)		
			If nTHoras < nHoras
				nCHoras := nCHoras + nDif
			ElseIf nTHoras > nHoras
				nCHoras := nCHoras - nDif
			EndIf	                     
			nDif := Round(Abs(nFunc - nTFunc),0)
			If nTFunc < nFunc
				nCFunc := nCFunc + nDif
			ElseIf nTfunc > nFunc                   
				nCFunc := nCFunc - nDif
			EndIf	
		EndIf

		If cTipo == "P"
			aVlPlan[nPos] += Round(nCValor,0)
			aHrPlan[nPos] += Round(nCHoras,0)
			aNrPlan[nPos] += Round(nCFunc,0)
		Else
			aVlReal[nPos] += Round(nCValor,0)
			aHrReal[nPos] += Round(nCHoras,0)
			aNrReal[nPos] += Round(nCFunc,0)
		EndIf
	EndIf
			
	nMes := nMes + 1
	
	If nMes == 13
		nMes := 1
		nAno := Year(dFim)
	EndIf
			
Next nx

Return .T.

/*


Ŀ
Funo    Tr030PlanRP  Autor  Emerson Grassi Rocha Data  25/02/02 
Ĵ
Descrio Cria registro em branco no Real qdo tiver Planej. s/ Real.  
Ĵ
Sintaxe   Tr030PlanRP                                          	      
Ĵ
Uso       TRMR030                                                     
ٱ

*/
Function Tr030PlanRP()  

Local aSaveArea := GetArea()
                  
dbSelectArea("RA8")
dbSetOrder(2)
If dbSeek(xFilial("RA8")+RA1->RA1_CURSO)
	While !Eof() .and. xFilial("RA8")+RA1->RA1_CURSO == RA8->RA8_FILIAL+RA8->RA8_CURSO
	
		// Verifica periodos
		If 	RA8->RA8_DATADE < MV_PAR05 .Or. ;
			RA8->RA8_DATADE > MV_PAR06        
			dbSkip()
			Loop
		EndIf	
					            
		// Planejamento 
		If RA8->RA8_PLANEJ < MV_PAR03 .Or.;
		   RA8->RA8_PLANEJ > MV_PAR04
		   dbSkip()
		   Loop
		EndIf		   
		 
		// Centro de Custo			
		If RA8->RA8_CC < MV_PAR15 .Or.;
		   RA8->RA8_CC > MV_PAR16
		   dbSkip()
		   Loop
		EndIf        
		
		// Grupo+Departamento
		If RA8->RA8_GRUPO+RA8->RA8_DEPTO < MV_PAR11+MV_PAR13 .Or.;
		   RA8->RA8_GRUPO+RA8->RA8_DEPTO > MV_PAR12+MV_PAR14
		   dbSkip()
		   Loop
		EndIf                
         
		// Registro de Realizado zerado para buscar Planejado
 		RecLock("TRA",.T.)
			Replace TRA->TR_FILIAL		With RA8->RA8_FILIAL
			Replace TRA->TR_CC			With ""
			Replace TRA->TR_CURSO		With RA1->RA1_CURSO
			Replace TRA->TR_GRUPO		With ""
			Replace TRA->TR_DEPTO		With ""
			Replace TRA->TR_CARGO		With ""
			Replace TRA->TR_VALOR		With 0
			Replace TRA->TR_HORAS		With 0
			Replace TRA->TR_DTINI		With RA8->RA8_DATADE
			Replace TRA->TR_DTFIM		With RA8->RA8_DATAAT
		MsUnlock()         
		
		dbSelectArea("RA8")		
		dbSkip()		
	EndDo
EndIf

RestArea(aSaveArea)

Return Nil

/*
PROGRAMA FONTE ORIGINAL ABAIXO
*/

/*


Ŀ
Programa   TRMR030R3 Autor  Cristina Ogura         Data  16.03.99 
Ĵ
Descrio  Planejado x Realizado                                      
Ĵ
Sintaxe    TRMR030R3                                                  
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Emerson G.R.27/05/04xxxxxxTratam. Cargo do Funcionario - fGetCargo()
Emerson G.R.24/07/06103298Considerar tambem funcionarios Demitidos. 
ٱ

*/
Function TRMR030R3()

Local cDesc1  := STR0001 //"Planejado x Realizado"
Local cDesc2  := STR0002 //"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  := STR0003 //"usurio."
Local cString := "RA4"  			             		//-- alias do arquivo principal (Base)
Local aOrd    := { STR0004,STR0005,STR0006,STR0007 } 	//"Curso"###"Centro de Custo"###"Grupo+Depto"###"Cargo"
Local nMes 	  := 0

//Ŀ
// Define Variaveis (Basicas)                                   
//
Private aReturn  := { STR0008,1,STR0009,2,2,1,"",1 } //"Zebrado"###"Administrao"
Private NomeProg := "TRMR030"
Private aLinha   := {}
Private nLastKey := 0
Private cPerg    := "TRX030"
Private lEnd     := .F.
Private wCabec0  := 1
Private wCabec1  := ""
Private wCabec2  := ""
Private wCabec3  := ""
Private Colunas  := 132
Private at_Prg   := "TRMR030"
Private Contfl   := 1
Private Li       := 0
Private nPag     := 0
Private nTamanho := "G"
Private cTit     := STR0010 //"Planejado x Realizado"
Private aCabec   := {}
Private nMvPlan  := GetMV("MV_CUSTCUR") // Somar o custo do curso na 1-Dt Inicio Curso0 2-Dt Fim do curso 3-Ratear pelos dias
Private nQuantos := 0
Private aMeses	 := {}
//Ŀ
// Verifica as perguntas selecionadas                           
//
pergunte("TRX030",.F.)

Titulo   := STR0011   //"Planejamento dos Cursos

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial  De                               
// MV_PAR02        //  Filial  Ate                              
// MV_PAR03        //  Planejamento De                          
// MV_PAR04        //  Planejamento Ate                         
// MV_PAR05        //  Periodo De                               
// MV_PAR06        //  Periodo Ate                              
// MV_PAR07        //  Curso De                                 
// MV_PAR08        //  Curso Ate                                
// MV_PAR09        //  Cargo De                                 
// MV_PAR10        //  Cargo Ate                                
// MV_PAR11        //  Grupo De                                 
// MV_PAR12        //  Grupo Ate                                
// MV_PAR13        //  Departamento De                          
// MV_PAR14        //  Departamento Ate                         
// MV_PAR15        //  Centro de Custo De                       
// MV_PAR16        //  Centro de Custo Ate                      
// MV_PAR17        //  Imprimir por Horas Valor Ambos           
// MV_PAR18        //  Rateia planejamento Sim/Nao              
//
//Ŀ
// Envia controle para a funcao SETPRINT                        
//
WnRel :="TRMR030"	//-- Nome Default do relatorio em Disco.
WnRel :=SetPrint(cString,WnRel,cPerg,cTit,cDesc1,cDesc2,cDesc3,.F.,aOrd, .T., nTamanho)

// Valida os periodos do parametro
If 	MV_PAR05 > MV_PAR06 .Or.;
	(MV_PAR06 - MV_PAR05) > 365
	Help("",1,"Tr030Data")	// Verifique as datas do periodo
	Return .F.
EndIf

// Monta as strings do cabecalho
Tr030Meses()

If nLastKey == 27
   Return
Endif

SetDefault(aReturn,cString)

If nLastKey == 27
   Return
Endif
                        
RptStatus({|lEnd| Tr030Relat(@lEnd,wnRel,cString)},cTit)

Return Nil
        
/*


Ŀ
Funo     Tr030Relat  Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio  Funcao principal do programa de Realizado x Planejado      
Ĵ
Sintaxe    Tr030Relat                                                 
Ĵ
Uso        TRMA030                                                    
ٱ

*/                   
Function Tr030Relat()
Local aFields 	:= {}
Local cIndCond	:= ""
Local cFor		:= ""
Local cCodPlan  := ""
Local cFil		:= "" 
Local cAuxFil	:= ""
Local cAcessaRA1:= &("{ || " + ChkRH(FunName(),"RA1","2") + "}")
Local cAcessaRA4:= &("{ || " + ChkRH(FunName(),"RA4","2") + "}")
Local lReal		:= .F.
Local cCargo	:= ""

Private aVlReal[nQuantos]
Private aHrReal[nQuantos]
Private aNrReal[nQuantos]
Private aVlPlan[nQuantos]
Private aHrPlan[nQuantos]
Private aNrPlan[nQuantos]

Private cArqDbf	:= ""
Private cArq	:= ""
Private nOrdem 	:= aReturn[8]
               
FZera()

// Variaveis do relatorio
lRet := .T.
cArqDBF   := CriaTrab(NIL,.f.)                                                

// Cria arquivo que sera armazenado os dados dos cursos
AADD(aFields,{"TR_FILIAL", "C", FWGETTAMFILIAL,          0                        } )
AADD(aFields,{"TR_CC"     ,"C", TamSx3("RA_CC")[1],      TamSx3("RA_CC")[2]       } )
AADD(aFields,{"TR_CURSO"  ,"C", TamSx3("RA4_CURSO")[1],  TamSx3("RA4_CURSO")[2]   } )
AADD(aFields,{"TR_DTINI"  ,"D", TamSx3("RA4_DATAIN")[1], TamSx3("RA4_DATAIN")[2]  } )
AADD(aFields,{"TR_DTFIM"  ,"D", TamSx3("RA4_DATAFI")[1], TamSx3("RA4_DATAFI")[2]  } )
AADD(aFields,{"TR_GRUPO"  ,"C", TamSx3("Q3_GRUPO")[1],   TamSx3("Q3_GRUPO")[2]    } )
AADD(aFields,{"TR_DEPTO"  ,"C", TamSx3("Q3_DEPTO")[1],   TamSx3("Q3_DEPTO")[2]    } )
AADD(aFields,{"TR_CARGO"  ,"C", TamSx3("Q3_CARGO")[1],   TamSx3("Q3_CARGO")[2]    } )
AADD(aFields,{"TR_VALOR"  ,"N", TamSx3("RA4_VALOR")[1],  TamSx3("RA4_VALOR")[2]   } )
AADD(aFields,{"TR_HORAS"  ,"N", TamSx3("RA4_HORAS")[1],  TamSx3("RA4_HORAS")[2]   } )

                      
dbCreate(cArqDbf,aFields)
dbUseArea(.T., NIL, cArqDbf, "TRA", .F.)

If nOrdem == 1 		// Planejamento
	cIndCond := "TR_FILIAL + TR_CURSO"
ElseIf nOrdem == 2	// Centro de Custo
	cIndCond := "TR_FILIAL + TR_CC + TR_CURSO"
ElseIf nOrdem == 3	// Grupo + Departamento	
	cIndCond := "TR_FILIAL + TR_GRUPO + TR_DEPTO + TR_CURSO"
ElseIf nOrdem == 4	// Cargo
	cIndCond := "TR_FILIAL + TR_CARGO + TR_CURSO"
EndIf

cArq := CriaTrab(NIL,.f.)
IndRegua("TRA",cArq,cIndCond, NIL, NIL, STR0012) //"Selecionando Registros..."
dbGoTop()

dbSelectArea("RA1")
dbSetOrder(1)
cFil := xFilial("RA1", MV_PAR01)
dbSeek(cFil+MV_PAR07,.T.)

While !Eof() .And. RA1->RA1_FILIAL <= MV_PAR02 
	If RA1->RA1_CURSO > MV_PAR08
		dbSkip()
		Loop
	EndIf
    
	If !Eval(cAcessaRA1)
		dbSkip()  
		Loop
	EndIf
	
	//Verifica os cursos realizados
    dbSelectArea("RA4")
    dbSetOrder(2)                                                
    lReal := .F.
    If dbSeek(xFilial("RA4")+RA1->RA1_CURSO)
    	While !Eof() .And. xFilial("RA4")+RA1->RA1_CURSO == RA4->RA4_FILIAL+RA4->RA4_CURSO

 			If !Eval(cAcessaRA4)
				dbSkip()  
				Loop
			EndIf    	        
			
		    If 	(RA4->RA4_DATAIN < MV_PAR05) .Or. ;    
				(RA4->RA4_DATAIN > MV_PAR06) 
	   			dbSkip()
    			Loop
			EndIf
			
			// Verifica o funcionario
			dbSelectArea("SRA")
			dbSetOrder(1)                                     
			cFil := xFilial("SRA", RA4->RA4_FILIAL)
			If dbSeek(cFil+RA4->RA4_MAT)
				If 	(SRA->RA_CC < MV_PAR15) .Or.;
					(SRA->RA_CC > MV_PAR16)
				   	 
					 dbSelectArea("RA4")
					 dbSetOrder(2)
					 dbSkip()
					 Loop
				EndIf

				cCargo := fGetCargo(SRA->RA_MAT,SRA->RA_FILIAL)
				
				If cCargo < MV_PAR09 .Or. cCargo > MV_PAR10
					 
					dbSelectArea("RA4")
					dbSetOrder(2)
					dbSkip()
					Loop
				EndIf
					
				dbSelectArea( "SQ3" )
				dbSetOrder(1)
				cFil := xFilial("SQ3", SRA->RA_FILIAL)
				If dbSeek(cFil + cCargo + SRA->RA_CC) .Or. dbSeek(cFil + cCargo)
					If	SQ3->Q3_GRUPO < MV_PAR11 .Or.;
						SQ3->Q3_GRUPO > MV_PAR12 .Or.;
						SQ3->Q3_DEPTO < MV_PAR13 .Or.;
						SQ3->Q3_DEPTO > MV_PAR14
					
						dbSelectArea("RA4")
						dbSetOrder(2)
						dbSkip()
						Loop
					EndIf
				EndIf
						
		 		RecLock("TRA",.T.)
					Replace TRA->TR_FILIAL		With SRA->RA_FILIAL
					Replace TRA->TR_CC			With SRA->RA_CC
					Replace TRA->TR_CURSO		With RA4->RA4_CURSO
					Replace TRA->TR_GRUPO		With SQ3->Q3_GRUPO
					Replace TRA->TR_DEPTO		With SQ3->Q3_DEPTO
					Replace TRA->TR_CARGO		With SQ3->Q3_CARGO
					Replace TRA->TR_VALOR		With RA4->RA4_VALOR
					Replace TRA->TR_HORAS		With RA4->RA4_HORAS 
					Replace TRA->TR_DTINI		With RA4->RA4_DATAIN
					Replace TRA->TR_DTFIM		With RA4->RA4_DATAFI
	 			MsUnlock()
	 			lReal := .T.
			Endif
			
			dbSelectArea("RA4")
			dbSetOrder(2)
	        dbSkip()
        EndDo
	EndIf		                             
		                             
	// Verifica se existe Planejamento qdo. nao tiver Realizado.
	If !lReal
    	Tr030Plan()
 	EndIf
	
	dbSelectArea("RA1")
	dbSetOrder(1)
    dbSkip()
EndDo
         
Tr030Imprime()

Return Nil

/*


Ŀ
Funo     Tr030Imprim Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio  Funcao que imprime os dados do planejamento x realizado    
Ĵ
Sintaxe    Tr030Imprime()                                             
Ĵ
Uso        TRMA030                                                    
ٱ

*/   
Function Tr030Imprime()
Local lRet 	:= .T.
Local nVx	:= 0
Local Det	:= ""
       
Private cCurso	:= ""
Private cCC		:= ""
Private cGrupo 	:= ""
Private cCargo	:= ""
Private nVezes	:= 0
Private nCont	:= 0
Private cQual	:= ""

// Define se sera impresso horas, valor ou ambos                   
If MV_PAR17 == 3
	nVezes := 2
Else
	nVezes := 1
EndIf		                   

For nVx:= 1 To nVezes
             
	If nVezes == 1
		cQual := IIF(MV_PAR17 ==1,"V","H")
	Else
		cQual := IIF(nVx==1,"V","H")
	EndIf		
                              
	dbSelectArea("TRA")
	dbGotop()
		                                  
	While !Eof()

		If lRet
			lRet:= .F.
			If nOrdem == 2
				cCC	  := TRA->TR_CC
			ElseIf nOrdem == 3			
				cGrupo:= TRA->TR_GRUPO+TRA->TR_DEPTO
			ElseIf nOrdem == 4
				cCargo:= TRA->TR_CARGO
			EndIf	
			cCurso := TRA->TR_CURSO          
			FImpCab()
		EndIf		

		If nOrdem == 1				// Curso		
		   If cCurso # TRA->TR_CURSO
				Tr030VerPlan()       
				cCurso  := TRA->TR_CURSO 
			EndIf	
			Tr030Somar()
		ElseIf nOrdem == 2 		// Centro de Custo
			If cCC # TRA->TR_CC .Or.;
			   cCurso # TRA->TR_CURSO                 
				Tr030VerPlan()
				If cCC # TRA->TR_CC
					cCC := TRA->TR_CC
					FImpCab()          
				EndIf
				cCurso := TRA->TR_CURSO
			EndIf	
			Tr030Somar()
		ElseIf nOrdem == 3		// Grupo+Depto
			If cGrupo # TRA->TR_GRUPO+TRA->TR_DEPTO .Or. ;
			   cCurso # TRA->TR_CURSO
				Tr030VerPlan()
				If cGrupo # TRA->TR_GRUPO+TRA->TR_DEPTO   
					cGrupo	:= TRA->TR_GRUPO+TRA->TR_DEPTO
					FImpCab()
				EndIf	
				cCurso  := TRA->TR_CURSO 				
			EndIf	
			Tr030Somar()
		ElseIf nOrdem == 4		// Cargo
			If cCargo # TRA->TR_CARGO .Or. ;
			   cCurso # TRA->TR_CURSO
				Tr030VerPlan()
				If cCargo # TRA->TR_CARGO
					cCargo	:= TRA->TR_CARGO				
					FImpCab()
				EndIf
				cCurso  := TRA->TR_CURSO 
			EndIf	
			Tr030Somar()
		EndIf

		dbSelectArea("TRA")
		dbSkip()
	EndDo
	
	If !lRet
		Tr030VerPlan()
	EndIf	    

	DET:=""
	IMPR(DET,"F")

	DET  :=""
	lRet := .T.
Next nVx	      

//Ŀ
// Termino do Relatorio                                         
//
dbSelectArea("TRA")
dbCloseArea()
fErase(cArq + OrdBagExt())
fErase(cArqDbf + GetDBExtension())

dbSelectArea("SRA")
dbSetOrder(1)

dbSelectArea("RA4")
dbSetOrder(1)

dbSelectArea("SQ3") 
dbSetOrder(1)

dbSelectArea("RA1")
dbSetOrder(1)

Set Device To Screen

If aReturn[5] == 1
   Set Printer To
   Commit
   ourspool(wnrel)
Endif

MS_FLUSH()

Return Nil
                      
/*


Ŀ
Funo     FImpCab 	   Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio  Imprime cabecalho do relatorio                             
Ĵ
Sintaxe    Fimpcab                                                    
Ĵ
Uso        TRMA030                                                    
ٱ

*/
// Imprime Cabecalho do relatorio
Static Function fImpCab()
Local aSaveArea := GetArea()
Local cFil		:= ""
Local nx		:= 0
Local Det		:= ""        

If nOrdem == 2
	dbSelectArea("SI3")
	dbSetOrder(1)
	cFil := xFilial("SI3")
	dbSeek(cFil+cCC)                                
	DET := STR0013+	cCC+"-"+SI3->I3_DESC		//"Centro de Custo: "
ElseIf nOrdem == 3
	dbSelectArea("SQ0")
	dbSetOrder(1)
	cFil := xFilial("SQO")
	dbSeek(cFil+Substr(cGrupo,1,2))
	dbSelectArea("SQB")
	dbSetOrder(1)
	cFil := xFilial("SQB")
	dbSeek(cFil+Substr(cGrupo,3,3))
	DET := STR0014+": "+Substr(cGrupo,1,2)+"-"+SQ0->Q0_DESCRIC+Space(01)+STR0015+": "+Substr(cGrupo,3,3)+"-"+SQB->QB_DESCRIC	//"Grupo: "###"Depto.: "
ElseIf nOrdem == 4
	dbSelectArea("SQ3")
	dbSetOrder(1)
	cFil := xFilial("SQ3")
	dbSeek(cFil+cCargo)
	DET := STR0016+cCargo+"-"+SQ3->Q3_DESCSUM		//"Cargo: "
EndIf

IMPR(DET,"C")  
DET:=""
IMPR(DET,"C")

If cQual == "H"
	DET	:= Space(26)+Repl("-",93)+Space(02)+STR0017+Space(02)+Repl("-",92)	//"HORAS"
Else
	DET := Space(26)+Repl("-",90)+Space(02)+STR0018+Space(02)+Repl("-",92)	//"VALORES"
EndIf		

IMPR(DET,"C") 
DET:=""
For nx:=1 To Len(aCabec)
	DET+=aCabec[nx]
Next nx			    

IMPR(DET,"C")			
DET :=""     
IMPR(DET,"C")

RestArea(aSaveArea)

Return Nil

/*


Ŀ
Funo     FImpDet 	   Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio  Imprime as linhas de detalhes do relatorios                 
Ĵ
Sintaxe    FImpDet                                                    
Ĵ
Uso        TRMR030                                                    
ٱ

*/    
Function FImpDet(aTotais)
Local nx		:= 0
Local nTotal	:= 0
Local nTotFunc	:= 0
Local Det		:= ""
                   
If LI >= 60
	fImpCab()
EndIf              

dbSelectArea("RA1")
dbSetOrder(1)
cFil := xFilial("RA1")
dbSeek(cFil+cCurso)

// Imprime a linha dos dados do planejado
DET :=""
DET := cCurso+"-"+Substr(RA1->RA1_DESC,1,20)+ Space(01)+STR0019		//"PLANEJ."

If cQual == "V"                           
// VALOR
//"CURSO			               JAN/2000 FUNC|FEV/2000 FUNC|MAR/2000 FUNC|ABR/2000 FUNC|MAI/2000 FUNC|JUN/2000 FUNC|JUL/2000 FUNC|AGO/2000 FUNC|SET/2000 FUNC|OUT/2000 FUNC|NOV/2000 FUNC|DEZ/2000 FUNC!     TOTAL   FUNC"					
//XXXX-XXXXXXXXXXXXXXXXXXXX PLANEJ.9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999!999999.999 999999"
//                          REALIZ.9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999!999999.999 999999"        					
	For nx:=1 To nQuantos
		If nx == nQuantos
			If nTotal+aVlPlan[nx] < aTotais[1]
				aVlPlan[nx] += aTotais[1] - (nTotal+aVlPlan[nx])
			EndIf
			If nTotFunc+aNrPlan[nx] < aTotais[3]
				aNrPlan[nx] += aTotais[3] - (nTotFunc+aNrPlan[nx])
			EndIf
		EndIf

		DET := DET + Transform(aVlPlan[nx],"99999999")+Space(01) 
		DET := DET + Transform(aNrPlan[nx],"9999") + "|"
		nTotal   := nTotal   + aVlPlan[nx]		
		nTotFunc := nTotFunc + aNrPlan[nx]
	Next nx
	DET := DET + Transform(nTotal,"9999999999") + Space(01)
	DET := DET + Transform(nTotFunc,"999999") + "|"
	IMPR(DET,"C")
                                         
	// Imprime a linha dos dados do realizado
	nTotal :=0
	nTotFunc :=0
	DET :=""
	DET := Space(26) + STR0020	//"REALIZ."
	For nx:=1 To nQuantos
		DET := DET + Transform(aVlReal[nx],"99999999")+Space(01)
		DET := DET + Transform(aNrReal[nx],"9999") + "|"
		nTotal   := nTotal   + aVlReal[nx]    
		nTotFunc := nTotFunc + aNrReal[nx]
	Next nx
	DET := DET + Transform(nTotal,"9999999999") + Space(01)
	DET := DET + Transform(nTotFunc,"999999") + "|"
	IMPR(DET,"C")
Else      
	//"CURSO			               JAN/2000 FUNC|FEV/2000 FUNC|MAR/2000 FUNC|ABR/2000 FUNC|MAI/2000 FUNC|JUN/2000 FUNC|JUL/2000 FUNC|AGO/2000 FUNC|SET/2000 FUNC|OUT/2000 FUNC|NOV/2000 FUNC|DEZ/2000 FUNC!     TOTAL   FUNC"					
	//XXXX-XXXXXXXXXXXXXXXXXXXX PLANEJ.9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999!999999.999 999999"
	//                          REALIZ.9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999|9999.999 9999!999999.999 999999"        					

	For nx:=1 To nQuantos
		If nx == nQuantos
			If nTotal+aHrPlan[nx] < aTotais[2]
				aHrPlan[nx] += aTotais[2] - (nTotal+aHrPlan[nx])
			EndIf
			If nTotFunc+aNrPlan[nx] < aTotais[3]
				aNrPlan[nx] += aTotais[3] - (nTotFunc+aNrPlan[nx])
			EndIf
		EndIf

		DET := DET + Transform(aHrPlan[nx],"99999999") + Space(01)
		DET := DET + Transform(aNrPlan[nx],"9999") + "|"
		nTotal   := nTotal   + aHrPlan[nx]
		nTotFunc := nTotFunc + aNrPlan[nx]
	Next nx      
	DET := DET + Transform(nTotal,"9999999999") + Space(01)
	DET := DET + Transform(nTotFunc,"999999") + "|"
	IMPR(DET,"C")
                                         
	// Imprime a linha dos dados do realizado
	nTotal  := 0
	nTotFunc:= 0
	DET :=""                           
	DET := Space(26) + STR0021	//"REALIZ."
	For nx:=1 To nQuantos
		DET := DET + Transform(aHrReal[nx],"99999999") + Space(01)
		DET := DET + Transform(aNrReal[nx],"9999") + "|"
		nTotal   := nTotal   + aHrReal[nx]
		nTotFunc := nTotFunc + aNrReal[nx]
	Next nx                  
	DET := DET + Transform(nTotal,"9999999999") + Space(01) 
	DET := DET + Transform(nTotFunc,"999999") + "|"
	IMPR(DET,"C")
EndIf              

DET:=""
IMPR(DET,"C")
   
Return Nil

/*


Ŀ
Funo     FZera	   Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio  Zera as variaveis do relatorio                             
Ĵ
Sintaxe    FZera()                                                    
Ĵ
Uso        TRMR030                                                    
ٱ

*/
Function FZera()
AFill(aVlReal,0)
AFill(aHrReal,0)
AFill(aNrReal,0)
AFill(aVlPlan,0)
AFill(aHrPlan,0)
AFill(aNrPlan,0)
Return Nil			

/*


Ŀ
Funo    Tr030Somar   Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio Soma os valores de curso,horas e nr funcionario             
Ĵ
Sintaxe   Tr030Somar                                                  
Ĵ
Uso        TRMR030                                                    
ٱ

*/
Function TR030Somar()
Local nMes :=0
Local nPos :=0

//Ler o getmv
//1- INICIO
//2- FIM
//3- RATEADO
// Se considerado o valor do custo do treinamento conforme definido no MV_PLANEJ
// Se for:  1- Sera considerado todo o custo do treinamento no inicio do curso.
// 			2- Sera considerado todo o custo do treinamento no fim do curso.
//			3- Sera dividido entre o mes inicial e mes final

If nMvPlan = 1			// Inicio
	nMes := Month(TRA->TR_DTINI)
ElseIf nMvPlan = 2		// Fim
	// Verifico se a data final do curso esta dentro do periodo selecionado
	If TRA->TR_DTFIM <= MV_PAR05
		nMes := Month(TRA->TR_DTFIM)
	EndIf	
ElseIf nMvPlan = 3		// Rateado	
	Tr030Rateio(TRA->TR_DTINI,TRA->TR_DTFIM,TRA->TR_VALOR,TRA->TR_HORAS,1,"R")
EndIf   

nPos := Ascan(aMeses,nMes)

If nMvPlan # 3
	If nMes > 0 .And. nPos > 0
		aVlReal[nPos] += TRA->TR_VALOR
		aHrReal[nPos] += TRA->TR_HORAS
		If TRA->TR_VALOR > 0 .Or. TRA->TR_HORAS > 0
			aNrReal[nPos] += 1	
		EndIf
	EndIf
EndIf										

Return

/*


Ŀ
Funo    Tr030VerPlan Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio Verifica os val. custo, horas e nr func planej para curso   
Ĵ
Sintaxe   Tr030VerPlan                                                
Ĵ
Uso       TRMR030                                                     
ٱ

*/
Function Tr030VerPlan()
Local aSaveArea := GetArea()
Local nMes		:= 0 
Local aTotais[3]

aFill(aTotais,0)
                  
dbSelectArea("RA8")
dbSetOrder(2)
If dbSeek(xFilial("RA8")+cCurso)
	While !Eof() .and. xFilial("RA8")+cCurso == RA8->RA8_FILIAL+RA8->RA8_CURSO
	
		// Ordem 2 - Centro de custo  
		// Ordem 3 - Grupo+Depto
		// Ordem 4 - Cargo
		If (nOrdem == 2 .And. cCC    # RA8->RA8_CC) .Or.;
		   (nOrdem == 3 .And. cGrupo # RA8->RA8_GRUPO+RA8->RA8_DEPTO) .Or.;
		   (nOrdem == 4 .And. cCargo # RA8->RA8_CARGO)
		   dbSkip()
		   Loop
		EndIf		    	

		// Verifica periodos
		If 	RA8->RA8_DATADE < MV_PAR05 .Or. ;
			RA8->RA8_DATADE > MV_PAR06        
			dbSkip()
			Loop
		EndIf	
					            
		// Planejamento 
		If RA8->RA8_PLANEJ < MV_PAR03 .Or.;
		   RA8->RA8_PLANEJ > MV_PAR04
		   dbSkip()
		   Loop
		EndIf		   
		 
		// Centro de Custo			
		If RA8->RA8_CC < MV_PAR15 .Or.;
		   RA8->RA8_CC > MV_PAR16
		   dbSkip()
		   Loop
		EndIf        
		
		// Grupo+Departamento
		If RA8->RA8_GRUPO+RA8->RA8_DEPTO < MV_PAR11+MV_PAR13 .Or.;
		   RA8->RA8_GRUPO+RA8->RA8_DEPTO > MV_PAR12+MV_PAR14
		   dbSkip()
		   Loop
		EndIf                
		
		// Rateia planejamento 1-Sim 2-Nao
		If MV_PAR18 == 1 	 
			Tr030Rateio(RA8->RA8_DATADE,RA8->RA8_DATAAT,RA8->RA8_VALOR,RA8->RA8_HORAS,RA8->RA8_NFUNC,"P")
		Else            
			// Coloca os custos no final do mes em que foi planejado
			nMes := Month(RA8->RA8_DATAAT)
			nPos := Ascan(aMeses,nMes)
			If nPos > 0
			    aVlPlan[nPos] += RA8->RA8_VALOR
				aNrPlan[nPos] += RA8->RA8_NFUNC
				aHrPlan[nPos] += RA8->RA8_HORAS
			EndIf	
		EndIf	
		
		aTotais[1] := aTotais[1] + RA8->RA8_VALOR
		aTotais[2] := aTotais[2] + RA8->RA8_HORAS
		aTotais[3] := aTotais[3] + RA8->RA8_NFUNC		
				    
		dbSelectArea("RA8")
		dbSetOrder(2)				                            
		dbSkip()		
	EndDo
EndIf

RestArea(aSaveArea)

FImpDet(aTotais)
FZera()      

Return Nil

/*


Ŀ
Funo     Tr030Meses  Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio  Monta o cabec de meses do relatorio, conforme param seleci 
Ĵ
Sintaxe    Tr030Meses()                                               
Ĵ
Uso        TRMR030                                                    
ٱ

*/
Function Tr030Meses()
Local aGuarda	:= {STR0022,STR0023,STR0024,STR0025,STR0026,STR0027,STR0028,STR0029,STR0030,STR0031,STR0032,STR0033}	//"JAN/"###"FEV/"###"MAR/"###"ABR/"###"MAI/"###"JUN/"###"JUL/"###"AGO/"###"SET/"###"OUT/"###"NOV/"###"DEZ/"
Local nMes		:= 0
Local nAno		:= 0
Local cString	:= ""
Local nMuda		:= 0
Local nx		:= 0
                       
aCabec:={}
                   
nMes := Month(MV_PAR05)
nAno := Year(MV_PAR05)

If Year(MV_PAR05) == Year(MV_PAR06)
	nQuantos := Month(MV_PAR06) - Month(MV_PAR05)
	nMuda    := 0
Else            
	nMuda    := (12 - Month(MV_PAR05))+ 2
	nQuantos := (12 - Month(MV_PAR05))+ Month(MV_PAR06)	
EndIf

cString := STR0034+Space(28)	//"CURSO"                      
Aadd(aCabec,cString) 

nQuantos:= nQuantos + 1
//"CURSO			                JAN/2000 FUNC| FEV/2000 FUNC| MAR/2000 FUNC| ABR/2000 FUNC| MAI/2000 FUNC| JUN/2000 FUNC| JUL/2000 FUNC| AGO/2000 FUNC| SET/2000 FUNC| OUT/2000 FUNC| NOV/2000 FUNC| DEZ/2000 FUNC!      TOTAL   FUNC"		
//"123451234567890123456789012345678123456789012345                                                                                                                                                                               

For nx := 1 To nQuantos 
	If nx # 1
		nMes:= nMes + 1
	EndIf
	If nMuda == nx
		nAno := Year(MV_PAR06)
		nMes := 1
	EndIf		
	cString := aGuarda[nMes]+Str(nAno,4)+Space(01)+STR0035	//"FUNC|"
	Aadd(aCabec,cString)	
	Aadd(aMeses,nMes)
Next nx
          
cString := Space(05)+STR0038+Space(03)+STR0035		//"TOTAL"###"FUNC|"
Aadd(aCabec,cString)   

Return .T.
        
/*


Ŀ
Funo     Tr030Rateio Autor  Cristina Ogura       Data  10.01.00 
Ĵ
Descrio  Calcula o rateio de valores e horas                        
Ĵ
Sintaxe    Tr030Meses()                                               
Ĵ
Uso        TRMR030                                                    
ٱ

*/
Function Tr030Rateio(dInicio,dFim,nValor,nHoras,nFunc,cTipo)
Local nDias		:= 0
Local nVezes	:= 0
Local nAno		:= 0
Local nVlDias	:= 0
Local nHrDias	:= 0
Local nNrDias	:= 0
Local dMonta
Local cString	:= ""  
Local nCValor	:= 0
Local nCHoras	:= 0
Local nCFunc	:= 0			// Valores Calculados
Local nTValor	:= 0
Local nTHoras	:= 0
Local nTFunc	:= 0			// Totais dos valores dos meses
Local nDif 		:= 0
Local nx		:= 0

// Sao verificadas todas as possibilidades:
// Datas iguais : 15/02/99 a 15/02/99
// MMAAAA iguais: 15/02/99 a 25/02/99
// AAAA iguais  : 15/02/99 a 20/03/99
// AAAA diferen.: 21/09/99 a 03/02/99

nDias := dFim - dInicio + 1 

If nDias == 0
	nDias := 1
EndIf
	
nVlDias := Round(nValor / nDias,2)
nHrDias := Round(nHoras / nDias,2)
nNrDias := Round(nFunc  / nDias,2)

nMes    := Month(dInicio)                
nAno    := Year(dInicio)

If Year(dInicio) == Year(dFim)
	nVezes := Month(dFim) - Month(dInicio) + 1
Else                          
    nVezes := (12 - Month(dInicio)) + Month(dFim)
EndIf			
		
For nx := 1 To nVezes
	If nVezes == 1
		If dInicio == dFim
			nDias := 1
		ElseIf Year(dInicio) == Year(dFim) .And.;
			   Month(dInicio)== Month(dFim)
			nDias := Day(dFim)
		Else	   	
			nDias := Day(dInicio)
		EndIf
	Else	
		If nx== nVezes
			nDias := Day(dFim)	
		Else
			// Montar a data para verificar o ultimo dia do mes 
			cString:= "'01/"+StrZero(nMes,2)+"/"+Substr(Str(nAno,4),3,2)+"'"
			dMonta 	:= CtoD(cString)
			nDias 	:= f_ultdia(dMonta)			
			If nx == 1
				nDias := nDias - Day(dInicio) + 1
			EndIf				
		EndIf            
	EndIf

	nCValor := Round(nVlDias * nDias,2)
	nCHoras := Round(nHrDias * nDias,2)
	nCFunc  := Round(nNrDias * nDias,2)
	        
	nPos   := Ascan(aMeses,nMes)

	If nPos > 0	
		// Somando para obter o total do curso
		nTValor := nTValor + nCValor
		nTHoras := nTHoras + nCHoras
		nTFunc  := nTFunc  + nCFunc
		
		// Acerto dos totais 
		If nx== nVezes                   
			nDif := Round(Abs(nValor - nTValor),0)			
			If nTValor < nValor
				nCValor := nCValor + nDif
			ElseIf nTValor > nValor
				nCValor := nCValor - nDif
			EndIf					 
			nDif := Round(Abs(nHoras - nTHoras),0)		
			If nTHoras < nHoras
				nCHoras := nCHoras + nDif
			ElseIf nTHoras > nHoras
				nCHoras := nCHoras - nDif
			EndIf	                     
			nDif := Round(Abs(nFunc - nTFunc),0)
			If nTFunc < nFunc
				nCFunc := nCFunc + nDif
			ElseIf nTfunc > nFunc                   
				nCFunc := nCFunc - nDif
			EndIf	
		EndIf

		If cTipo == "P"
			aVlPlan[nPos] += Round(nCValor,0)
			aHrPlan[nPos] += Round(nCHoras,0)
			aNrPlan[nPos] += Round(nCFunc,0)
		Else
			aVlReal[nPos] += Round(nCValor,0)
			aHrReal[nPos] += Round(nCHoras,0)
			aNrReal[nPos] += Round(nCFunc,0)
		EndIf
	EndIf
			
	nMes := nMes + 1
	
	If nMes == 13
		nMes := 1
		nAno := Year(dFim)
	EndIf
			
Next nx

Return .T.

/*


Ŀ
Funo    Tr030Plan	   Autor  Emerson Grassi Rocha Data  25/02/02 
Ĵ
Descrio Cria registro em branco no Real qdo tiver Planej. s/ Real.  
Ĵ
Sintaxe   Tr030Plan                                           	      
Ĵ
Uso       TRMR030                                                     
ٱ

*/
Function Tr030Plan()
Local aSaveArea := GetArea()
                  
dbSelectArea("RA8")
dbSetOrder(2)
If dbSeek(xFilial("RA8")+RA1->RA1_CURSO)
	While !Eof() .and. xFilial("RA8")+RA1->RA1_CURSO == RA8->RA8_FILIAL+RA8->RA8_CURSO
	
		// Verifica periodos
		If 	RA8->RA8_DATADE < MV_PAR05 .Or. ;
			RA8->RA8_DATADE > MV_PAR06        
			dbSkip()
			Loop
		EndIf	
					            
		// Planejamento 
		If RA8->RA8_PLANEJ < MV_PAR03 .Or.;
		   RA8->RA8_PLANEJ > MV_PAR04
		   dbSkip()
		   Loop
		EndIf		   
		 
		// Centro de Custo			
		If RA8->RA8_CC < MV_PAR15 .Or.;
		   RA8->RA8_CC > MV_PAR16
		   dbSkip()
		   Loop
		EndIf        
		
		// Grupo+Departamento
		If RA8->RA8_GRUPO+RA8->RA8_DEPTO < MV_PAR11+MV_PAR13 .Or.;
		   RA8->RA8_GRUPO+RA8->RA8_DEPTO > MV_PAR12+MV_PAR14
		   dbSkip()
		   Loop
		EndIf                
         
		// Registro de Realizado zerado para buscar Planejado
 		RecLock("TRA",.T.)
			Replace TRA->TR_FILIAL		With RA8->RA8_FILIAL
			Replace TRA->TR_CC			With ""
			Replace TRA->TR_CURSO		With RA1->RA1_CURSO
			Replace TRA->TR_GRUPO		With ""
			Replace TRA->TR_DEPTO		With ""
			Replace TRA->TR_CARGO		With ""
			Replace TRA->TR_VALOR		With 0
			Replace TRA->TR_HORAS		With 0
			Replace TRA->TR_DTINI		With RA8->RA8_DATADE
			Replace TRA->TR_DTFIM		With RA8->RA8_DATAAT
		MsUnlock()         
		
		dbSelectArea("RA8")		
		dbSkip()		
	EndDo
EndIf

RestArea(aSaveArea)

Return Nil
