#INCLUDE "PROTHEUS.CH"
#INCLUDE "TRMR050.CH" 

/*

Ŀ
Funo     TRMR050   Autor  Eduardo Ju             Data  13/06/06 
Ĵ
Descrio  Relatorio de Cursos por Entidade.	                      
Ĵ
Sintaxe    TRMR050(void)                                              
Ĵ
 Uso       Generico                                                   
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Luiz Gustavo02/02/07      Retiradas funcoes de ajuste de dicionario.
ٱ

Ŀ
Programador   Data      FNC              Motivo da Alteracao                      
ĳ
Rogerio R.   29/07/200900000018271/2009Compatibilizacao dos fontes para aumento do
                                       campo filial e gesto corporativa.         
ٱ

*/
Function TRMR050()

Local oReport
Local aArea 		:= GetArea()
Private Titulo 		:= oemToAnsi(STR0001) 
Private cAliasQry	:= ""

If FindFunction("TRepInUse") .And. TRepInUse()	//Verifica se relatorio personalizal esta disponivel
	//Ŀ
	// Verifica as perguntas selecionadas                           
	//
	Pergunte("TR050R",.f.)
	oReport := ReportDef()
	oReport:PrintDialog()	
Else
	TRMR050R3()	
EndIf  

RestArea( aArea )

Return

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  13.06.06 
Ĵ
Descrio Definicao do Componente de Impressao do Relatorio           
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function ReportDef()

Local oReport
Local oSection1
Local oSection2         
Local oSection3
Local oSection4    

Private aOrd    := {OemToAnsi(STR0014),OemToAnsi(STR0004) }	//--  Entidade # Curso 
					
//Ŀ
//Criacao do componente de impressao                                      
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
	oReport:=TReport():New("TRMR050",STR0007,"TR050R",{|oReport| PrintReport(oReport)},oemtoAnsi(STR0015) )			//""Este relatorio efetua a impressao  dos cursos disponiveis por entidade "
	oReport:SetTotalInLine(.F.) //Totaliza em linha
	oReport:SetLandscape()

	//Ŀ
	// Tipo a imprimir: 1-Entidade/Curso                  
	// 
		//Ŀ
		// Criacao da Primeira Secao:
		// 
		oSection1 := TRSection():New(oReport,STR0017,{"RA6"},/*aOrd*/ ,/*Campos do SX3*/,/*Campos do SIX*/)	//"Por Entidade/Curso"
		oSection1:SetTotalInLine(.F.)
	
			//Ŀ
			// Tipo a imprimir: 1-Entidade/Curso 2-Curso/Entidade 
			// 
			TRCell():New(oSection1,"RA6_ENTIDA","RA6")										//Codigo da Entidade  
			TRCell():New(oSection1,"RA0_DESC"  ,"RA0")											//Descricao da Entidade 

			TRPosition():New(oSection1,"RA0",1,{|| RHFilial( "RA0", (cAliasQry)->RA6_FILIAL)  + (cAliasQry)->RA6_ENTIDA }) 
		
		//Ŀ
		// Criacao da Segunda Secao: 
		//
		oSection2 := TRSection():New(oSection1,oemtoAnsi(STR0004) ,{"RA6","RA1"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//"Curso"
		oSection2:SetTotalInLine(.F.)
		
			TRCell():New(oSection2,"RA6_CURSO","RA6")										//Codigo do Curso  
			TRCell():New(oSection2,"RA1_DESC" ,"RA1")										//Descricao do Curso 
			TRCell():New(oSection2,"RA6_DURACA","RA6") 				//Duracao 
			TRCell():New(oSection2,"RA6_UNID"  ,"RA6")  		//Unid. Duracao   
			TRCell():New(oSection2,"RA6_VALOR" ,"RA6")      		//Valor do Curso
			TRCell():New(oSection2,"RA6_CONTEU","RA6",,,110)		//Conteudo Programatico 

			TRPosition():New(oSection2,"RA1",1,{|| RHFilial("RA1", (cAliasQry)->RA6_FILIAL ) + (cAliasQry)->RA6_CURSO }) 

	//Ŀ
	// Tipo a imprimir: 2-Curso/Entidade                  
	// 
		//Ŀ
		// Criacao da Primeira Secao:
		// 
		oSection3 := TRSection():New(oReport,STR0018,{"RA1"},aOrd ,/*Campos do SX3*/,/*Campos do SIX*/)	//"Por Curso/Entidade"
		oSection3:SetTotalInLine(.F.) 
		
			TRCell():New(oSection3,"RA1_CURSO","RA1") 										//Codigo do Curso 
			TRCell():New(oSection3,"RA1_DESC" ,"RA1")										//Descricao do Curso
		
			//TRPosition():New(oSection3,"RA1",1,{|| RHFilial("RA1", RA6->RA6_FILIAL ) + RA6->RA6_CURSO }) 

		//Ŀ
		// Criacao da Segunda Secao: 
		//
		oSection4 := TRSection():New(oSection3,oemtoAnsi(STR0004) ,{"RA6","RA0"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//"Curso"
		oSection4:SetTotalInLine(.F.)
	
			TRCell():New(oSection4,"RA6_ENTIDA","RA6")									//Codigo da Entidade  
			TRCell():New(oSection4,"RA0_DESC"  ,"RA0")									//Descricao da Entidade 
			TRCell():New(oSection4,"RA6_DURACA","RA6")					 				//Duracao 
			TRCell():New(oSection4,"RA6_UNID"  ,"RA6")  								//Unid. Duracao   
			TRCell():New(oSection4,"RA6_VALOR" ,"RA6")      							//Valor do Curso
			TRCell():New(oSection4,"RA6_CONTEU","RA6",,,110)							//Conteudo Programatico 

			#IFDEF TOP
				TRPosition():New(oSection4,"RA0",1,{|| RHFilial("RA0",(cAliasQry)->RA6_FILIAL ) + (cAliasQry)->RA6_ENTIDA })
			#ELSE
				TRPosition():New(oSection4,"RA0",1,{|| RHFilial("RA0",RA6->RA6_FILIAL ) + RA6->RA6_ENTIDA })
			#ENDIF
		
		
//Ŀ
//Criacao da celulas da secao do relatorio                                
//TRCell():New                                                            
//ExpO1 : Objeto TSection que a secao pertence                            
//ExpC2 : Nome da celula do relatrio. O SX3 ser consultado              
//ExpC3 : Nome da tabela de referencia da celula                          
//ExpC4 : Titulo da celula                                                
//        Default : X3Titulo()                                            
//ExpC5 : Picture                                                         
//        Default : X3_PICTURE                                            
//ExpC6 : Tamanho                                                         
//        Default : X3_TAMANHO                                            
//ExpL7 : Informe se o tamanho esta em pixel                              
//        Default : False                                                 
//ExpB8 : Bloco de cdigo para impressao.                                 
//        Default : ExpC2                                                 
//

Return oReport

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  13.06.06 
Ĵ
Descrio Impressao do Relatorio (Custo do Treinamento)               
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function PrintReport(oReport)

Local oSection1 := If(MV_PAR05 == 1, oReport:Section(1), oReport:Section(2))
Local oSection2 := oSection1:Section(1) 
Local cFiltro 	:= "" 
Local cFilRA1	:= ""
Local cFilRA0	:= ""
Local cFilRA6	:= ""

#IFDEF TOP
	Local lQuery    := .F. 
#ENDIF


oSection2:SetTotalText({|| OemToAnsi(STR0016) } )

If MV_PAR05 == 1
	TRFunction():New(oSection2:Cell("RA6_CURSO"),/*cId*/,"COUNT",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
Else
	TRFunction():New(oSection2:Cell("RA6_ENTIDA"),/*cId*/,"COUNT",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
EndIf                                                                                                 

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial?                                  
// MV_PAR02        //  Curso?                                   
// MV_PAR03        //  Entidade?                                
// MV_PAR04        //  Impr.1 Item p/Folha?                     
// MV_PAR05        //  Tipo a imprimir?                         
// MV_PAR06        //  Cont.Programatico?                       
// 

//Ŀ
// Personaliza titulos                                          
//
Titulo := If(AllTrim(oReport:Title())==AllTrim(Titulo),Titulo ,oReport:Title()  ) 
oReport:SetTitle(Titulo)

//Ŀ
// Imprime Item por Pagina   
//
If MV_PAR04 == 1   		
	If MV_PAR05 == 1  
		oBreak := TRBreak():New(oSection1,oSection1:Cell("RA6_ENTIDA"),"",.F.)
	Else
		oBreak := TRBreak():New(oSection1,oSection1:Cell("RA1_CURSO"),"",.F.) 	
	EndIf 
	oBreak:SetPageBreak(.T.) //Salta Pagina		
EndIf

//Ŀ
// Suprimir Conteudo Programatico  
//
If MV_PAR06 <> 1
	oSection2:Cell("RA6_CONTEU"):Disable()
Else
	oSection2:Cell("RA6_CONTEU"):SetLineBreak()		//Impressao de campo Memo
EndIf

#IFNDEF TOP
	//Ŀ
	// Transforma parametros Range em expressao (intervalo) 
	//
	MakeAdvplExpr("TR050R")	 
	
	If MV_PAR05 == 1  
		cAliasQry	:= "RA6"
	Else
		cAliasQry	:= "RA1"
	Endif	

	dbSelectArea(cAliasQry)
	oSection1:SetIdxOrder(1)
	oSection2:SetIdxOrder(1)
	
	If !Empty(MV_PAR01)
		cFiltro:= MV_PAR01
	EndIf  
	
	If !Empty(MV_PAR02)
		cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
		cFiltro += MV_PAR02
	EndIf  
	       
	If !Empty(MV_PAR03)
		cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
		cFiltro += MV_PAR03
	EndIf  
	
	oSection1:SetFilter(cFiltro)
	       
	//Ŀ
	// Condicao para Impressao   
	// 
	If MV_PAR05 == 1
		oSection2:SetRelation({|| (cAliasQry)->(RA6_FILIAL) + (cAliasQry)->(RA6_ENTIDA) + (cAliasQry)->(RA6_CURSO) },"RA6",1,.T.)
		oSection2:SetParentFilter({|cParam| (cAliasQry)->(RA6_FILIAL+ RA6_ENTIDA ) == cParam},{|| (cAliasQry)->(RA6_FILIAL+RA6_ENTIDA) })	
	Else 
		oSection2:SetRelation({|| (cAliasQry)->(RA1_FILIAL) + (cAliasQry)->(RA1_CURSO) },"RA6",2,.T.)
		oSection2:SetParentFilter({|cParam| RA6->(RA6_FILIAL+RA6_CURSO)  == cParam},{|| (cAliasQry)->(RA1_FILIAL+RA1_CURSO ) })
	EndIf
	                              
	oReport:SetMeter( (cAliasQry)->(RecCount()))
	oSection1:Print() //Imprimir 
#ELSE	                     
	
	//Ŀ
	// Transforma parametros Range em expressao SQL 
	//
	MakeSqlExpr("TR050R")
	
	cAliasQry	:= GetNextAlias()	
	
	//-- Filtragem do relatrio
	//-- Query do relatrio da secao 1
	lQuery := .T. 
	
	//Ŀ
	// Tipo a imprimir: 1-Entidade/Curso 2-Curso/Entidade 
	//
	If MV_PAR05 == 1  
		cOrder := "%RA6_FILIAL,RA6_ENTIDA,RA6_CURSO%" 
	Else		
		cOrder := "%RA1_FILIAL,RA1_CURSO,RA6_ENTIDA%" 	       
	EndIf		
	
	oSection1:BeginQuery()	
	
	cFilRA1 := "%RA1.RA1_FILIAL  = " + IIf(Empty(xFilial("RA1")), "'" + Space(FWGETTAMFILIAL) + "'", "RA6.RA6_FILIAL") + "%"
	cFilRA0	:= "%RA0.RA0_FILIAL  = " + IIf(Empty(xFilial("RA0")), "'" + Space(FWGETTAMFILIAL) + "'", "RA6.RA6_FILIAL") + "%"	
	cFilRA6 := "%RA6.RA6_FILIAL  = " + IIf(Empty(xFilial("RA6")), "'" + Space(FWGETTAMFILIAL) + "'", "RA1.RA1_FILIAL") + "%"

	If MV_PAR05 == 1  

		BeginSql Alias cAliasQry
			SELECT	RA1_FILIAL,RA6_FILIAL,RA6_CURSO,RA1_DESC,RA6_ENTIDA,RA0_DESC,RA6_DURACA,RA6_UNID,RA6_VALOR,RA6_CONTEU	
			FROM 	%table:RA6% RA6  
			LEFT JOIN %table:RA1% RA1
			ON    %exp:cFilRA1%    					//- RA1_FILIAL = %xFilial:RA1%
				  AND RA1_CURSO = RA6_CURSO
				  AND RA1.%NotDel%
			LEFT JOIN %table:RA0% RA0               
			ON    %exp:cFilRA0%    						// RA0_FILIAL = %xFilial:RA6%
				  AND RA0_ENTIDA = RA6_ENTIDA
				  AND RA0.%NotDel%
		
			WHERE  RA6.%NotDel%
			ORDER BY %Exp:cOrder%                 		
		EndSql

	Else

		BeginSql Alias cAliasQry	
			SELECT	RA1_FILIAL,RA1_CURSO,RA1_DESC,RA6_FILIAL,RA6_CURSO,RA6_ENTIDA,RA6_DURACA,RA6_UNID,RA6_VALOR,RA6_CONTEU	
			FROM 	%table:RA1% RA1  
			LEFT JOIN %table:RA6% RA6
			ON    %exp:cFilRA6%    					//- RA1_FILIAL = %xFilial:RA1%
				  AND RA1_CURSO = RA6_CURSO
				  AND RA6.%NotDel%
		
			WHERE  RA1.%NotDel%
			ORDER BY %Exp:cOrder%                 		
		EndSql
		
	Endif		
			
		
	//Ŀ
	//Metodo EndQuery ( Classe TRSection )                                    
	//Prepara o relatrio para executar o Embedded SQL.                       
	//ExpA1 : Array com os parametros do tipo Range                           
	//
	oSection1:EndQuery({MV_PAR01,MV_PAR02,MV_PAR03})	/*Array com os parametros do tipo Range*/
		
	//Ŀ
	// Utiliza a query do Pai  
	//
	oSection2:SetParentQuery()
	
	//Ŀ
	// Condicao para Impressao   
	// 
	If MV_PAR05 == 1
		oSection2:SetParentFilter({|cParam| (cAliasQry)->(RA6_FILIAL+ RA6_ENTIDA ) == cParam},{|| (cAliasQry)->(RA6_FILIAL+RA6_ENTIDA) })	
	Else   
		oSection2:SetParentFilter({|cParam| (cAliasQry)->(RA6_FILIAL+RA6_CURSO)  == cParam},{|| (cAliasQry)->(RA1_FILIAL+RA1_CURSO) })
	EndIf
	                              
	//Ŀ
	// Inicio da impressao do fluxo do relatrio 
	//
	oReport:SetMeter( (cAliasQry)->(RecCount()))
	
	oSection1:Print()	 //Imprimir
#ENDIF

Return Nil


























//=========>>>>>>> Daqui para baixo, trata-se do release 3 e anterior.
/*

Ŀ
Funo     TRMR050R3 Autor  Emeron Grassi Rocha    Data  26/07/01 
Ĵ
Descrio  Relatorio de Cursos por Entidade.	                      
Ĵ
Sintaxe    TRMR050(void)                                              
Ĵ
 Uso       Generico                                                   
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
			   			    										  
ٱ

*/
Function TRMR050R3()

Local cString := "RA6"       	// Alias do arquivo principal (Base)
Local cDesc1  := STR0001		//"Relatorio de Cursos por Entidade"
Local cDesc2  := STR0002		//"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  := STR0003		//"usurio."

Private aReturn  := {STR0005,1,STR0006,2,2,1,"",1 }		//"Zebrado"###"Administrao"
Private NomeProg := "TRMR050"
Private aLinha   := {}
Private nLastKey := 0
Private cPerg    := "TRR50B"

//Ŀ
// Variaveis Utilizadas na funcao IMPR                          
//
Private Titulo   := STR0001		//"Relatorio de Cursos por Entidade"
Private Colunas  := 132
Private AT_PRG   := "TRR50B"
Private wCabec0  := 1
Private wCabec1  := ""
Private Contfl   := 1
Private Li       := 0
Private nTamanho := "M"

pergunte("TRR50B",.F.)
//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial  De                               
// MV_PAR02        //  Filial  Ate                              
// MV_PAR03        //  Curso De                                 
// MV_PAR04        //  Curso Ate                                
// MV_PAR05        //  Entidade De                              
// MV_PAR06        //  Entidade Ate                             
// MV_PAR07        //  Impr. uma Entidade/Curso por folha S/N   
// MV_PAR08        //  Tipo: 1-Entidade/Cursos 2-Curso/Entidades
// MV_PAR09        //  Impr. Conteudo Programatico S/N 		 
//

wnrel:="TRMR050"		//Nome Default do relatorio em Disco
wnrel:=SetPrint(cString,wnrel,cPerg,@Titulo,cDesc1,cDesc2,cDesc3,.F.,,.F.,ntamanho)

If nLastKey = 27
	Return
EndIf

SetDefault(aReturn,cString)

If nLastKey = 27
	Return
EndIf

RptStatus({|lEnd| Tr050Imp(@lEnd,wnRel,cString)},Titulo)

Return

/*


Ŀ
Funo     Tr050Imp  Autor  Emerson Grassi Rocha   Data  26/07/01 
Ĵ
Descrio  Funcao que imprime os cursos/Entidades                     
Ĵ
Sintaxe    Tr050Imp(lEnd,wnRel,cString)                               
Ĵ
Parametros lEnd        - Ao do Codelock                             
           wnRel       - Ttulo do relatrio                          
           cString     - Mensagem			                          
Ĵ
 Uso       TRMR050                                                    
ٱ

*/
Static Function Tr050Imp(lEnd,WnRel,cString )

Local cDet
Local lImp	    := .F.
Local cEntida, cCurso, cCmp, cCod, cDuracao
Local cAuxDet, nLinha, nBegin
Local cAcessaRA6:= &("{ || " + ChkRH(FunName(),"RA6","2") + "}")

dbSelectArea("RA6")
cFil := xFilial("RA6" ,MV_PAR01)

If MV_PAR08 == 1		// Por Entidade
	dbSetOrder(1)
	wcabec1 := STR0008	//"COD.   CURSO                                    DURACAO UN    VALOR "
	dbSeek(cFil + MV_PAR05 , .T.)
	cInicio  := "RA6->RA6_FILIAL + RA6->RA6_ENTIDA"
	cFim     := MV_PAR02 + MV_PAR06

Else                	// Por Curso
	dbSetOrder(2) 
	wcabec1 := STR0009	//"COD.   ENTIDADE                                 DURACAO UN    VALOR "
	dbSeek(cFil + MV_PAR03 , .T.)
	cInicio  := "RA6->RA6_FILIAL + RA6->RA6_CURSO"
	cFim     := MV_PAR02 + MV_PAR04
EndIf

If RA6->RA6_FILIAL > MV_PAR02
	Help("",1,"TRR050FILI")			// Nao existe curso neste intervalo de filial
	Return Nil
EndIf

SetRegua(RA6->(RecCount()))

While !Eof() .And. &cInicio <= cFim

	IncRegua()
	
	If lEnd
		Exit
	EndIf
               
	If !Eval(cAcessaRA6)
		dbSkip()  
		Loop
	EndIf
	
	If MV_PAR08 == 1	// Por Entidade
		If	RA6->RA6_CURSO < MV_PAR03 .Or. RA6->RA6_CURSO > MV_PAR04		// Curso DE/ATE
			dbSkip()
			Loop
		EndIf	
		cEntida	:= RA6->RA6_ENTIDA
		cDescEnt:= FDesc("RA0",cEntida,"RA0->RA0_DESC",40)
		cDet 	:= STR0010 + cEntida + " - " + cDescEnt //"ENTIDADE: "

        cCod 	:= cEntida
        cCmp	:= "RA6->RA6_ENTIDA"
		
	Else				// Por Curso
		If	RA6->RA6_ENTIDA < MV_PAR05 .Or. RA6->RA6_ENTIDA > MV_PAR06	// Material DE/ATE
			dbSkip()
			Loop
		EndIf	
		cCurso	:= RA6->RA6_CURSO
		cDescCur:= FDesc("RA1",cCurso,"RA1->RA1_DESC",40)
		cDet 	:= STR0011 + cCurso + " - " + cDescCur //"CURSO: "
		
        cCod 	:= cCurso
        cCmp	:= "RA6->RA6_CURSO"
	EndIf
	
	lImp 	:= .T.
	
	IMPR(cDet,"C")
	IMPR("","C")
				
	While &cCmp  == cCod

	//"COD.   CURSO                                    DURACAO UN    VALOR "
	// 1234 - 1234567890123456789012345678901234567890 123456   1  123456789012
	                      
		If MV_PAR08 == 1 	// Por Entidade
			cDescCur	:= PadR(FDesc("RA1",RA6->RA6_CURSO,"RA1->RA1_DESC",40),40)
			cDet 		:= RA6->RA6_CURSO + " - " + cDescCur + SPACE(01)			
		Else				// Por Curso                   
			cDescEnt	:= PadR(FDesc("RA0",RA6->RA6_ENTIDA,"RA0->RA0_DESC",40),40)
			cDet 		:= RA6->RA6_ENTIDA + " - " + cDescEnt + SPACE(01)
		EndIf
		
		cDuracao:= STR(RA6->RA6_DURACA,7,2)
		
		cDet 	+= Transform(cDuracao,"9999.99")+ SPACE(01) 
		cDet 	+= RA6->RA6_UNID + SPACE(01)
		cDet 	+= STR(RA6->RA6_VALOR,12,2) + SPACE(01)
		
		IMPR(cDet,"C")

		If MV_PAR09 == 1 //Imprime Conteudo Programatico
            IMPR("","C")
			cDet := STR0012		//"     CONTEUDO PROGRAMATICO "
			IMPR(cDet,"C")
			
			cAuxDet := RA6->RA6_CONTEU	// Campo memo do Conteudo Programatico.
			nLinha	:= MLCount(cAuxDet,80)

			If nLinha > 0
				For nBegin := 1 To nLinha
					cDet := Space(08)+Memoline(cAuxDet,80,nBegin,,.T.)
					IMPR(cDet,"C")
				Next nBegin
			Else
				cDet := Space(08) + STR0013	//" *** Conteudo Programatico nao preenchido *** "
				IMPR(cDet,"C")	
			EndIf	
			IMPR("","C")
		EndIf
	
		dbSelectArea("RA6")
		dbSkip()	
    EndDo
    
	IMPR(__PrtThinLine(),"C")     
    IMPR("","C")
    
	// Imprime uma Entidade/Curso por folha
	If MV_PAR07 == 1 .And. !Eof() 		// 1- Sim
		IMPR("","P")
	EndIf

EndDo

If lImp
	Impr("","F")
EndIf	

dbSelectArea("RA6")
dbSetOrder(1)

If aReturn[5] = 1
	Set Printer To
	Commit
	ourspool(wnrel)
Endif

MS_FLUSH()

Return Nil
