#INCLUDE "PROTHEUS.CH"
#INCLUDE "TRMR080.CH"

/*

Ŀ
Programa   TRMR080   Autor  Eduardo Ju             Data  03/06/06 
Ĵ
Descrio  Relatorio de Planejamentos.                                
Ĵ
Sintaxe    TRMR080                                                    
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
			   			   										  
ٱ

Ŀ
Programador   Data      FNC              Motivo da Alteracao                      
ĳ
Rogerio R.   29/07/200900000018271/2009Compatibilizacao dos fontes para aumento do
                                       campo filial e gesto corporativa.          
Luciana S.   10/08/201100000016958/2011Ajuste na exibicao dos titulos do relatorio
ٱ

*/
Function TRMR080()

Local oReport
Local aArea := GetArea()

If FindFunction("TRepInUse") .And. TRepInUse()	//Verifica se relatorio personalizal esta disponivel
	//Ŀ
	// Verifica as perguntas selecionadas                           
	//
	pergunte("TRR080",.F.)
	oReport := ReportDef()
	oReport:PrintDialog()	
Else
	TRMR080R3()	
EndIf  

RestArea( aArea )

Return

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  03.06.06 
Ĵ
Descrio Definicao do Componente de Impressao do Relatorio           
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function ReportDef()

Local oReport
Local oSection1
Local oSection2

//Ŀ
//Criacao do componente de impressao                                      
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
oReport:=TReport():New("TRMR080",STR0001,"TRR080",{|oReport| PrintReport(oReport)},STR0022)	//"Custo de Treinamento"#"Ser impresso de acordo com os parametros solicitados pelo usuario"
oReport:SetTotalInLine(.F.) //Totaliza em linha

//Ŀ
//Criacao da celulas da secao do relatorio                                
//TRCell():New                                                            
//ExpO1 : Objeto TSection que a secao pertence                            
//ExpC2 : Nome da celula do relatrio. O SX3 ser consultado              
//ExpC3 : Nome da tabela de referencia da celula                          
//ExpC4 : Titulo da celula                                                
//        Default : X3Titulo()                                            
//ExpC5 : Picture                                                         
//        Default : X3_PICTURE                                            
//ExpC6 : Tamanho                                                         
//        Default : X3_TAMANHO                                            
//ExpL7 : Informe se o tamanho esta em pixel                              
//        Default : False                                                 
//ExpB8 : Bloco de cdigo para impressao.                                 
//        Default : ExpC2                                                 
//
//Ŀ
// Criacao da Primeira Secao:
// 
oSection1 := TRSection():New(oReport,STR0021,{"RA8"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//"Solicitao de Treinamento"
oSection1:SetTotalInLine(.F.)
TRCell():New(oSection1,"RA8_FILIAL","RA8",STR0010)	//Codigo da Filial do Planejamento 
TRCell():New(oSection1,"RA8_PLANEJ","RA8",)		//Codigo do Planejamento
TRCell():New(oSection1,"RA8_DESC","RA8",STR0011)	//Descricao do Planejamento

//Ŀ
// Criacao da Segunda Secao: 
//
oSection2 := TRSection():New(oSection1,STR0020,{"RA8","RA1","SRA"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//"Solicitao de Treinamento"	
oSection2:SetTotalInLine(.F.) 
TRCell():New(oSection2,"RA8_CURSO","RA8",STR0012,,15,.T.)	//Codigo do Curso   
TRCell():New(oSection2,"RA1_DESC","RA1","",,35,.T.)	  			//Descricao do Curso
TRCell():New(oSection2,"RA8_NFUNC","RA8",STR0013,,15,.T.)	//Numero de Funcionarios
TRCell():New(oSection2,"RA8_VALOR","RA8",,"@E 999,999,999.99",20,.T.)			//Valor
TRCell():New(oSection2,"RA8_HORAS","RA8",STR0014,,15,.T.)	//Horas Treinamento 
TRCell():New(oSection2,"RA8_DATA","RA8",STR0015,,20,.T.)	//Data do Planejamento
TRCell():New(oSection2,"RA8_DATADE","RA8",STR0016,,20,.T.)	//Periodo Inicial
TRCell():New(oSection2,"RA8_DATAAT","RA8",STR0017,,20,.T.)	//Periodo Final
TRCell():New(oSection2,"RA8_MAT","RA8",STR0018,,15,.T.)	//Numero de Funcionarios
TRCell():New(oSection2,"RA8_NOME","RA8",STR0019,,40,.T.)	//Nome do Funcionario

TRPosition():New(oSection2,"RA1",1,{|| xFilial("RA1") + RA8->RA8_CURSO}) 
TRPosition():New(oSection2,"SRA",1,{|| xFilial("SRA") + RA8->RA8_MAT})

//Ŀ
// Total de Planejamento  
// 
oSection2:SetTotalText({|| STR0008})	//Total do Planejamento   
TRFunction():New(oSection2:Cell("RA8_NFUNC"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,/*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection2:Cell("RA8_VALOR"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,/*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection2:Cell("RA8_HORAS" ),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,/*lEndReport*/,/*lEndPage*/)

Return oReport

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  30.05.06 
Ĵ
Descrio Impressao do Relatorio (Custo do Treinamento)               
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function PrintReport(oReport)

Local cAcessaRA1:= &("{ || " + ChkRH(FunName(),"RA1","2") + "}")
Local cAcessaRA8:= &("{ || " + ChkRH(FunName(),"RA8","2") + "}")
Local oSection1 := oReport:Section(1)
Local oSection2 := oReport:Section(1):Section(1)  
Local cFiltro := ""

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial  De                               
// MV_PAR02        //  Filial  Ate                              
// MV_PAR03        //  Planejamento De                          
// MV_PAR04        //  Planejamento Ate                         
// MV_PAR05        //  Periodo De                               
// MV_PAR06        //  Periodo Ate                              
// MV_PAR07        //  Curso De                                 
// MV_PAR08        //  Curso Ate                                
//

If !Empty(xFilial("RA8"))
	cFiltro += "RA8_FILIAL >= '" + MV_PAR01 + "' .AND. "
	cFiltro += "RA8_FILIAL <= '" + MV_PAR02 + "' .AND. "
EndIf

cFiltro += "RA8_PLANEJ >= '" + MV_PAR03 + "' .AND. "
cFiltro += "RA8_PLANEJ <= '" + MV_PAR04 + "' .AND. "
cFiltro += "Dtos(RA8_DATADE) >= '" + Dtos(MV_PAR05) + "' .AND. "
cFiltro += "Dtos(RA8_DATADE) <= '" + Dtos(MV_PAR06) + "' .AND. "
cFiltro += "RA8_CURSO >= '" + MV_PAR07 + "' .AND. "
cFiltro += "RA8_CURSO <= '" + MV_PAR08 + "'    
 
oSection1:SetFilter(cFiltro)
oSection2:SetParentFilter({|cParam| RA8->RA8_PLANEJ == cParam},{|| RA8->RA8_PLANEJ})
oSection1:SetLineCondition(cAcessaRA8)
oSection2:SetLineCondition(cAcessaRA1)

oReport:SetMeter(RA8->(LastRec()))
oSection1:Print()

Return Nil

/*

Ŀ
Programa   TRMR080R3 Autor  Emerson Grassi Rocha   Data  27/02/02 
Ĵ
Descrio  Relatorio de Planejamentos.                                
Ĵ
Sintaxe    TRMR080                                                    
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
			   			   										  
ٱ

*/
Function TRMR080R3()

Local cDesc1	:= STR0001 //"Planejamento de Cursos"
Local cDesc2	:= STR0002 //"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  	:= STR0003 //"usurio."
Local cString 	:= "RA8"  			             		//-- alias do arquivo principal (Base)

//Ŀ
// Define Variaveis (Basicas)                                   
//
Private aReturn  := { STR0004,1,STR0005,2,2,1,"",1 } //"Zebrado"###"Administrao"
Private NomeProg := "TRMR080"
Private nLastKey := 0
Private cPerg    := "TRR080"
Private lEnd     := .F.
Private wCabec0  := 1
Private wCabec1  := ""
Private wCabec2  := ""
Private wCabec3  := ""
Private Colunas  := 220
Private at_Prg   := "TRMR080"
Private Contfl   := 1
Private Li       := 0
Private nPag     := 0
Private nTamanho := "G"
Private cTit     := STR0001 //"Planejamento de Cursos"

//Ŀ
// Verifica as perguntas selecionadas                           
//
pergunte("TRR080",.F.)

Titulo  := STR0001	//"Planejamento de Cursos"
wCabec1 := STR0007	//"Curso                                 N.Func.     Valor     Horas  Dt.Plan.   Dt.Inic.   Dt. Final  Responsavel "

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial  De                               
// MV_PAR02        //  Filial  Ate                              
// MV_PAR03        //  Planejamento De                          
// MV_PAR04        //  Planejamento Ate                         
// MV_PAR05        //  Periodo De                               
// MV_PAR06        //  Periodo Ate                              
// MV_PAR07        //  Curso De                                 
// MV_PAR08        //  Curso Ate                                
//
//Ŀ
// Envia controle para a funcao SETPRINT                        
//
WnRel :="TRMR080"	//-- Nome Default do relatorio em Disco.
WnRel :=SetPrint(cString,WnRel,cPerg,cTit,cDesc1,cDesc2,cDesc3,.F.,, .T., nTamanho)

If nLastKey == 27
	Return
Endif

SetDefault(aReturn,cString)

If nLastKey == 27
	Return
Endif

RptStatus({|lEnd| Tr080Relat(@lEnd,wnRel,cString)},cTit)

Return Nil

/*


Ŀ
Funo     Tr080Relat  Autor  Emerson Grassi Rocha Data  27/02/02 
Ĵ
Descrio  Funcao principal do Relatorio de Planejamentos.			  
Ĵ
Sintaxe    Tr080Relat                                                 
Ĵ
Uso        TRMA080                                                    
ٱ

*/
Function Tr080Relat()
Local cFil		:= ""
Local cInicio	:= "", cFim :=""
Local cAcessaRA1:= &("{ || " + ChkRH(FunName(),"RA1","2") + "}")
Local cAcessaRA8:= &("{ || " + ChkRH(FunName(),"RA8","2") + "}")
Local cPlanej 	:= ""
Local lFirst 	:= .T.
Local nTotFun 	:= nTotVal	:= nTotHor	:= 0
Local nTotFunG	:= nTotValG	:= nTotHorG	:= 0
			
dbSelectArea("RA8")
dbSetOrder(1)
cFil := xFilial("RA8", MV_PAR01)
dbSeek(cFil+MV_PAR03,.T.)
While !Eof() .and.	RA8->RA8_FILIAL <= MV_PAR02 .And.;
					RA8->RA8_PLANEJ <= MV_PAR04

	If !Eval(cAcessaRA8)
		dbSelectArea("RA8")
		dbSkip()
		Loop
	EndIf
			
	// Verifica periodos
	If 	RA8->RA8_DATADE < MV_PAR05 .Or. ;
		RA8->RA8_DATADE > MV_PAR06
		dbSkip()
		Loop
	EndIf

	// Cursos
	If RA8->RA8_CURSO < MV_PAR07 .Or.;
		RA8->RA8_CURSO > MV_PAR08
		dbSkip()
		Loop
	EndIf

	dbSelectArea("RA1")
	dbSetOrder(1)
	cFil := xFilial("RA1")
	dbSeek(cFil+RA8->RA8_CURSO)
	
	If !Eval(cAcessaRA1)
		dbSelectArea("RA8")
		dbSkip()
		Loop
	EndIf
	
	// Planejamento
	If cPlanej != RA8->RA8_PLANEJ
		If lFirst  
			lFirst := .F.
		Else      
			IMPR(__PrtThinLine(),"C")       
			DET := STR0008 //"Total do Planejamento: "
			DET += Space(16)
			DET += Str(nTotFun,7,0) + Space(1)
			DET += Str(nTotVal,12,2) + Space(1)
			DET += Str(nTotHor,7,2)
            IMPR(DET,"C")
   			IMPR(__PrtThinLine(),"C")     

			nTotFunG	+= nTotFun
			nTotValG	+= nTotVal
			nTotHorG	+= nTotHor
			
            nTotFun := nTotVal := nTotHor := 0
            
			IMPR("","C")
		EndIf
		
		DET := STR0006+RA8->RA8_FILIAL+" / "+RA8->RA8_PLANEJ+" - "+RA8->RA8_DESC //"Filial / Planejamento: "
		IMPR(DET,"C")            
		cPlanej := RA8->RA8_PLANEJ
	EndIf
	
	// Detalhe
	DET := Space(1)+RA8->RA8_CURSO+" - "+Left(RA1->RA1_DESC,40)+Space(1)
	DET += STR(RA8->RA8_NFUNC,7,0)+Space(1)
	DET += STR(RA8->RA8_VALOR,12,2)+Space(1)
	DET += STR(RA8->RA8_HORAS,7,2)+Space(1)
	DET += If(__SetCentury(),Dtoc(RA8->RA8_DATA),Dtoc(RA8->RA8_DATA)+Space(2)) +Space(1)
	DET += If(__SetCentury(),Dtoc(RA8->RA8_DATADE),Dtoc(RA8->RA8_DATADE)+Space(2)) +Space(1)
	DET += If(__SetCentury(),Dtoc(RA8->RA8_DATAAT),Dtoc(RA8->RA8_DATAAT)+Space(2)) +Space(1)
	DET += RA8->RA8_MAT+"-"+RA8->RA8_NOME

	IMPR(DET,"C")
	
	nTotFun += RA8->RA8_NFUNC
	nTotVal	+= RA8->RA8_VALOR
	nTotHor	+= RA8->RA8_HORAS
	
	dbSelectArea("RA8")
	dbSkip()
EndDo

IMPR(__PrtThinLine(),"C")       
DET := STR0008 //"Total do Planejamento: "
DET += Space(16)
DET += Str(nTotFun,7,0) + Space(1)
DET += Str(nTotVal,12,2) + Space(1)
DET += Str(nTotHor,7,2)
IMPR(DET,"C")
IMPR(__PrtThinLine(),"C")     

nTotFunG	+= nTotFun
nTotValG	+= nTotVal
nTotHorG	+= nTotHor

IMPR(__PrtThinLine(),"C")       
DET := STR0009 //"Total Geral: "
DET += Space(26)
DET += Str(nTotFunG,7,0) + Space(1)
DET += Str(nTotValG,12,2) + Space(1)
DET += Str(nTotHorG,7,2)
IMPR(DET,"C")
IMPR(__PrtThinLine(),"C")     

DET:=""
IMPR(DET,"F")

//Ŀ
// Termino do Relatorio                                         
//

dbSelectArea("RA1")
dbSetOrder(1)

dbSelectArea("RA8")
dbSetOrder(1)

Set Device To Screen

If aReturn[5] == 1
	Set Printer To
	Commit
	ourspool(wnrel)
Endif

MS_FLUSH()

Return Nil
