#INCLUDE "PROTHEUS.CH"
#INCLUDE "TRMR090.CH"

/*

Ŀ
Programa   TRMR090   Autor  Eduardo Ju             Data  05/06/06 
Ĵ
Descrio  Relatorio de Calendario de Cursos.                         
Ĵ
Sintaxe    TRMR090                                                    
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Luiz Gustavo02/02/07      Retiradas funcoes de ajuste de dicionario.
ٱ

Ŀ
Programador   Data      FNC              Motivo da Alteracao                      
ĳ
Rogerio R.   29/07/200900000018271/2009Compatibilizacao dos fontes para aumento do
                                       campo filial e gesto corporativa.         
ٱ

*/
Function TRMR090()

Local oReport
Local aArea := GetArea()

If FindFunction("TRepInUse") .And. TRepInUse()	//Verifica se relatorio personalizal esta disponivel
	Pergunte("TR090R",.F.)
	oReport := ReportDef()
	oReport:PrintDialog()	  
Else
	TRMR090R3()	
EndIf  

RestArea( aArea )

Return

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  05.06.06 
Ĵ
Descrio Definicao do Componente de Impressao do Relatorio           
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function ReportDef()

Local oReport
Local oSection1
Local oSection2
Local cAliasQry := GetNextAlias()

//Ŀ
//Criacao do componente de impressao                                      
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
oReport:=TReport():New("TRMR090",STR0001,"TR090R",{|oReport| PrintReport(oReport,cAliasQry)},STR0001+" "+STR0002+" "+STR0003)	//"Calendario de Cursos"#"Ser impresso de acordo com os parametros solicitados pelo usuario"
oReport:SetTotalInLine(.F.) //Totaliza em linha
oReport:SetLandScape(.T.) 

//Ŀ
//Criacao da celulas da secao do relatorio                                
//TRCell():New                                                            
//ExpO1 : Objeto TSection que a secao pertence                            
//ExpC2 : Nome da celula do relatrio. O SX3 ser consultado              
//ExpC3 : Nome da tabela de referencia da celula                          
//ExpC4 : Titulo da celula                                                
//        Default : X3Titulo()                                            
//ExpC5 : Picture                                                         
//        Default : X3_PICTURE                                            
//ExpC6 : Tamanho                                                         
//        Default : X3_TAMANHO                                            
//ExpL7 : Informe se o tamanho esta em pixel                              
//        Default : False                                                 
//ExpB8 : Bloco de cdigo para impressao.                                 
//        Default : ExpC2                                                 
//
//Ŀ
// Criacao da Primeira Secao:
// 
oSection1 := TRSection():New(oReport,STR0011,{"RA2"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//"Calendario"
oSection1:SetTotalInLine(.F.)
TRCell():New(oSection1,"RA2_CALEND","RA2",STR0011)	//Codigo do Calendario 
TRCell():New(oSection1,"RA2_DESC","RA2","")		//Descricao do Calendario

//Ŀ
// Criacao da Segunda Secao: 
//
oSection2 := TRSection():New(oSection1,STR0012,{"RA2","RA1","RA9","RA0","RA7"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/) //Curso
oSection2:SetTotalInLine(.F.) 
TRCell():New(oSection2,"RA2_CURSO","RA2") 			//Codigo do Curso   
TRCell():New(oSection2,"RA1_DESC","RA1")			//Descricao do Curso
TRCell():New(oSection2,"RA2_TURMA","RA2")			//Turma
TRCell():New(oSection2,"RA2_DATAIN","RA2")			//Data Inicial
TRCell():New(oSection2,"RA2_DATAFI","RA2")			//Data Final
TRCell():New(oSection2,"RA2_ENTIDA","RA2")			//Codigo da Entidade
TRCell():New(oSection2,"RA0_DESC","RA0")			//Descricao da Entidade
TRCell():New(oSection2,"RA2_INSTRU","RA2")			//Codigo do Instrutor
TRCell():New(oSection2,"RA7_NOME","RA7")			//Nome do Instrutor
TRCell():New(oSection2,"RA2_HORARI","RA2")			//Horario 
TRCell():New(oSection2,"RA2_DURACA","RA2")			//Duracao
TRCell():New(oSection2,"RA2_UNDURA","RA2")			//Unidade de Duracao
TRCell():New(oSection2,"RA2_VAGAS","RA2",STR0017)	//Numero de Vagas
TRCell():New(oSection2,"RA2_RESERV","RA2",STR0018)	//Numero de Vagas Reservadas
TRCell():New(oSection2,"RA2_LOCAL","RA2")			//Local
TRCell():New(oSection2,"RA2_CUSTO","RA2",STR0019)	//Custo Estimado
TRCell():New(oSection2,"RA2_HORAS","RA2")			//Horas
//TRCell():New(oSection2,"RA2_REALIZ","RA2",STR0020)	 //Situacao do Treinamento  
oCell := TRCell():New(oSection2,"RA2_REALIZ","RA2",STR0020)	//Situacao do Treinamento
oCell:SetCBox("S="+STR0008+";N="+STR0009)

TRCell():New(oSection2,"RA2_SINON","RA2",STR0021)	//Codigo do Sinonimo do Curso    
TRCell():New(oSection2,"RA9_DESCR","RA9")			//Descricao do Sinonimo do Curso                                               

#IFNDEF TOP   
	TRPosition():New(oSection2,"RA1",1,{|| RhFilial("RA1",RA2->RA2_FILIAL) + RA2->RA2_CURSO}) 
	TRPosition():New(oSection2,"RA9",1,{|| RhFilial("RA9",RA2->RA2_FILIAL) + RA2->RA2_SINON}) 
	TRPosition():New(oSection2,"RA0",1,{|| RhFilial("RA0",RA2->RA2_FILIAL) + RA2->RA2_ENTIDA}) 
	TRPosition():New(oSection2,"RA7",1,{|| RhFilial("RA7",RA2->RA2_FILIAL) + RA2->RA2_INSTRU})
#ENDIF	 

oSection2:SetTotalText({|| "Total de Cursos" })  
TRFunction():New(oSection2:Cell("RA2_CURSO"),/*cId*/,"COUNT",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,/*lEndReport*/,/*lEndPage*/)

Return oReport

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  30.05.06 
Ĵ
Descrio Impressao do Relatorio (Custo do Treinamento)               
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function PrintReport(oReport,cAliasQry)

Local oSection1 := oReport:Section(1)
Local oSection2 := oReport:Section(1):Section(1) 

#IFNDEF TOP
	Local cAcessaRA1:= &("{ || " + ChkRH(FunName(),"RA1","2") + "}")
	Local cAcessaRA2:= &("{ || " + ChkRH(FunName(),"RA2","2") + "}") 
	Local cFiltro := "" 
#ELSE
	Local lQuery    := .F. 
	Local cWhere	:= ""
	Local cOrder	:= ""
	Local cFilRA1   := ""
	Local cFilRA9   := ""
	Local cFilRA0   := ""
#ENDIF

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial                                   
// MV_PAR02        //  Calendario                               
// MV_PAR03        //  Curso                                    
// MV_PAR04        //  Turma                                    
// MV_PAR05        //  Periodo                                  
// MV_PAR06        //  Entidade                                 
// MV_PAR07        //  Instrutor                                
// MV_PAR08        //  Treinamento (Aberto-Baixado-Ambos)       
// MV_PAR09        //  Impr.Sinonimo Curso (Sim ou Nao)         
//

#IFNDEF TOP
	//Ŀ
	// Transforma parametros Range em expressao (intervalo) 
	//
	MakeAdvplExpr("TR090R")	                                  
	
	If !Empty(MV_PAR01)
		cFiltro:= MV_PAR01
	EndIf  
	
	If !Empty(MV_PAR02)  
		cFiltro += IIF(!Empty(cFiltro)," .And. ","")
		cFiltro += MV_PAR02
	EndIf  
	       
	If !Empty(MV_PAR03)
		cFiltro += IIF(!Empty(cFiltro)," .And. ","")
		cFiltro += MV_PAR03 
	EndIf  
	
	If !Empty(MV_PAR04)
		cFiltro += IIF(!Empty(cFiltro)," .And. ","")
		cFiltro += MV_PAR04 
	EndIf  
	
	If !Empty(MV_PAR05)   
		cFiltro += IIF(!Empty(cFiltro)," .And. ","")
		cFiltro += MV_PAR05 
	EndIf                 
	
	If !Empty(MV_PAR06)   
		cFiltro += IIF(!Empty(cFiltro)," .And. ","")
		cFiltro += MV_PAR06 
	EndIf                  
	
	//Ŀ
	// Treinamento Aberto-Baixado-Ambos 
	//
	If MV_PAR08 == 1	//Aberto  
		cFiltro += IIF(!Empty(cFiltro)," .And. RA2_REALIZ <> 'S'","RA2_REALIZ <> 'S'")
	ElseIf MV_PAR08 == 2 //Baixado
		cFiltro += IIF(!Empty(cFiltro)," .And. RA2_REALIZ = 'S'","RA2_REALIZ = 'S'")
	EndIf	   
	
	If !Empty(MV_PAR07)   
		cFiltro += IIF(!Empty(cFiltro)," .And. ","")
		cFiltro += MV_PAR07 
	EndIf  
	
	oSection1:SetFilter(cFiltro)
	       
	//Ŀ
	// Condicao para Impressao   
	//
	oSection2:SetParentFilter({|cParam| RA2->RA2_CALEND == cParam},{|| RA2->RA2_CALEND})
	
	oSection1:SetLineCondition(cAcessaRA1)
	oSection2:SetLineCondition(cAcessaRA2)
	
	oReport:SetMeter(RA2->(RecCount()))
	
	//Ŀ
	// Suprimir o Sinonimo do Curso  
	//
	If MV_PAR09 <> 1
		oSection2:Cell("RA2_SINON"):Disable()
		oSection2:Cell("RA9_DESCR"):Disable()
	EndIf                                  
	
	oSection1:Print() //Imprimir 

#ELSE	
	//Ŀ
	// Transforma parametros Range em expressao SQL 
	//
	MakeSqlExpr("TR090R")    

	//-- Filtragem do relatrio
	//-- Query do relatrio da secao 1
	lQuery := .T.          
	cOrder := "%RA2_FILIAL,RA2_CALEND,RA2_CURSO%"   

	//Ŀ
	// Treinamento Aberto-Baixado-Ambos 
	//	          
	cWhere := "%%"
	If MV_PAR08 == 1	//Aberto  
		cWhere := "%RA2_REALIZ <> 'S' AND%"
	ElseIf MV_PAR08 == 2 //Baixado
		cWhere := "%RA2_REALIZ = 'S' AND%"
	EndIf           
	
	oReport:Section(1):BeginQuery()	
    
	cFilRA1 := "%AND RA1.RA1_FILIAL  = " + IIf(Empty(xFilial("RA1")), "'" + Space(FWGETTAMFILIAL) + "'", "RA2.RA2_FILIAL") + "%"
	cFilRA9 := "%AND RA9.RA9_FILIAL  = " + IIf(Empty(xFilial("RA9")), "'" + Space(FWGETTAMFILIAL) + "'", "RA2.RA2_FILIAL") + "%"
	cFilRA0	:= "%AND RA0.RA0_FILIAL  = " + IIf(Empty(xFilial("RA0")), "'" + Space(FWGETTAMFILIAL) + "'", "RA2.RA2_FILIAL") + "%"

	
	
	BeginSql Alias cAliasQry
		SELECT	RA2_CALEND,RA2_DESC,RA2_CURSO,RA1_DESC,RA2_TURMA,RA2_DATAIN,RA2_DATAFI,RA2_ENTIDA,
				RA0_DESC,RA2_INSTRU,RA7_NOME,RA2_HORARI,RA2_DURACA,RA2_UNDURA,RA2_VAGAS,RA2_RESERV,
				RA2_LOCAL,RA2_CUSTO,RA2_HORAS,RA2_REALIZ,RA2_SINON,RA9_DESCR		
		FROM 	%table:RA2% RA2  
		LEFT JOIN %table:RA1% RA1
			ON RA1_CURSO = RA2_CURSO
			AND RA1.%NotDel%
			%exp:cFilRA1%              
		LEFT JOIN %table:RA9% RA9
			ON RA9_SINONI   = RA2_SINON
			AND RA9.%NotDel%
			%exp:cFilRA9%
		LEFT JOIN %table:RA0% RA0
			ON RA0_ENTIDA = RA2_ENTIDA
			AND RA0.%NotDel%		
			%exp:cFilRA0%
		LEFT JOIN %table:RA7% RA7
			ON RA7_INSTRU = RA2_INSTRU
			AND RA7.%NotDel%  
		//WHERE RA2_FILIAL = %xFilial:RA2% AND  	
		  WHERE	%exp:cWhere%
			RA2.%NotDel%   										
		ORDER BY %Exp:cOrder%                 		
	EndSql
	
	//Ŀ
	//Metodo EndQuery ( Classe TRSection )                                    
	//Prepara o relatrio para executar o Embedded SQL.                       
	//ExpA1 : Array com os parametros do tipo Range                           
	//
	oReport:Section(1):EndQuery({MV_PAR01,MV_PAR02,MV_PAR03,MV_PAR04,MV_PAR05,MV_PAR06,MV_PAR07})	//*Array com os parametros do tipo Range*
		
	//-- Inicio da impressao do fluxo do relatrio
	oReport:SetMeter(RA2->(LastRec()))

	//-- Utiliza a query do Pai
	oSection2:SetParentQuery()
	oSection2:SetParentFilter( { |cParam| (cAliasQry)->RA2_CALEND == cParam },{ || (cAliasQry)->RA2_CALEND })
	
	//Ŀ
	// Suprimir o Sinonimo do Curso  
	//
	If MV_PAR09 <> 1
		oSection2:Cell("RA2_SINON"):Disable()
		oSection2:Cell("RA9_DESCR"):Disable()
	EndIf                                  
	
	oSection1:Print()	 //Imprimir
#ENDIF

Return Nil   

/*

Ŀ
Programa   TRMR090R3 Autor  Emerson Grassi Rocha   Data  05/03/02 
Ĵ
Descrio  Relatorio de Calendario de Cursos.                         
Ĵ
Sintaxe    TRMR090R3                                                  
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
			   			   										  
ٱ

*/
Function TRMR090R3()

Local cDesc1	:= STR0001 //"Calendario de Cursos"
Local cDesc2	:= STR0002 //"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  	:= STR0003 //"usurio."
Local cString 	:= "RA2"  			             		//-- alias do arquivo principal (Base)

//Ŀ
// Define Variaveis (Basicas)                                   
//
Private aReturn  := { STR0004,1,STR0005,2,2,1,"",1 } //"Zebrado"###"Administrao"
Private NomeProg := "TRMR090"
Private nLastKey := 0
Private cPerg    := "TRR090"
Private lEnd     := .F.
Private wCabec0  := 1
Private wCabec1  := ""
Private wCabec2  := ""
Private wCabec3  := ""
Private Colunas  := 220
Private at_Prg   := "TRMR090"
Private Contfl   := 1
Private Li       := 0
Private nPag     := 0
Private nTamanho := "G"
Private nChar	 := 15
Private cTit     := STR0001 //"Calendario de Cursos"

//Ŀ
// Verifica as perguntas selecionadas                           
//
pergunte("TRR090",.F.)

Titulo  := STR0001	//"Calendario de Cursos"
wCabec1 := STR0007	//"  Curso                    Turma Dt.Inicial Dt. Final  Entidade                   Instrutor                   Horario              Duracao Vagas Reservas Local                Custo       Horas  Responsavel          Situacao"

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial  De                               
// MV_PAR02        //  Filial  Ate                              
// MV_PAR03        //  Calendario De                            
// MV_PAR04        //  Calendario Ate                           
// MV_PAR05        //  Curso De		                         
// MV_PAR06        //  Curso Ate		                         
// MV_PAR07        //  Turma De		                         
// MV_PAR08        //  Turma Ate		                         
// MV_PAR09        //  Periodo De                               
// MV_PAR10        //  Periodo Ate                              
// MV_PAR11        //  Entidade De                              
// MV_PAR12        //  Entidade Ate                             
// MV_PAR13        //  Instrutor De                             
// MV_PAR14        //  Instrutor Ate                            
// MV_PAR15        //  Treinamento: 1-Aberto 2-Baixado 3-Ambos  
// MV_PAR16       	//  Imprime Sinonimo de Curso S/N 			 
//
//Ŀ
// Envia controle para a funcao SETPRINT                        
//
WnRel :="TRMR090"	//-- Nome Default do relatorio em Disco.
WnRel :=SetPrint(cString,WnRel,cPerg,cTit,cDesc1,cDesc2,cDesc3,.F.,,.F., nTamanho)

If nLastKey == 27
	Return
Endif

SetDefault(aReturn,cString)

If nLastKey == 27
	Return
Endif

RptStatus({|lEnd| Tr090Relat(@lEnd,wnRel,cString)},cTit)

Return Nil

/*


Ŀ
Funo     Tr090Relat  Autor  Emerson Grassi Rocha Data  05/03/02 
Ĵ
Descrio  Funcao principal do Relatorio de Cursos.					  
Ĵ
Sintaxe    Tr090Relat                                                 
Ĵ
Uso        TRMA090                                                    
ٱ

*/
Function Tr090Relat()
Local cFil		:= ""
Local cAcessaRA1:= &("{ || " + ChkRH(FunName(),"RA1","2") + "}")
Local cAcessaRA2:= &("{ || " + ChkRH(FunName(),"RA2","2") + "}")
Local cCalend 	:= ""
Local lFirst 	:= .T.
Local cDuracao  := "" 
Local cHoras    := ""
			
dbSelectArea("RA2")
dbSetOrder(1)
cFil := xFilial("RA2", MV_PAR01)
dbSeek(cFil+MV_PAR03,.T.)
While !Eof() .and.	RA2->RA2_FILIAL <= MV_PAR02 .And.;
					RA2->RA2_CALEND <= MV_PAR04
	
	// Cursos
	If RA2->RA2_CURSO < MV_PAR05 .Or.;
		RA2->RA2_CURSO > MV_PAR06
		dbSkip()
		Loop
	EndIf

	// Turmas
	If RA2->RA2_TURMA < MV_PAR07 .Or.;
		RA2->RA2_TURMA > MV_PAR08
		dbSkip()
		Loop
	EndIf

	// Verifica periodos
	If 	RA2->RA2_DATAIN < MV_PAR09 .Or. ;
		RA2->RA2_DATAIN > MV_PAR10
		dbSkip()
		Loop
	EndIf

	// Entidade
	If RA2->RA2_ENTIDA < MV_PAR11 .Or.;
		RA2->RA2_ENTIDA > MV_PAR12
		dbSkip()
		Loop
	EndIf

	// Instrutor
	If RA2->RA2_INSTRU < MV_PAR13 .Or.;
		RA2->RA2_INSTRU > MV_PAR14
		dbSkip()
		Loop
	EndIf

	// 1-Aberto 2-Baixado 3-Ambos
	If 	(MV_PAR15 == 1 .And. RA2->RA2_REALIZ == "S") .Or.;
		(MV_PAR15 == 2 .And. RA2->RA2_REALIZ != "S")
		dbSkip()
		Loop
	EndIf

	dbSelectArea("RA1")
	dbSetOrder(1)
	cFil := xFilial("RA1")
	dbSeek(cFil+RA2->RA2_CURSO)
	
	If !Eval(cAcessaRA1)
	
		dbSelectArea("RA2")
		dbSkip()
		Loop
	EndIf
	
	// Calendario
	If cCalend != RA2->RA2_CALEND
		If lFirst  
			lFirst := .F.
		Else      
			IMPR(__PrtThinLine(),"C")       
		EndIf
		
		DET := STR0006+RA2->RA2_CALEND+" - "+RA2->RA2_DESC //"Calendario: "
		IMPR(DET,"C")
		IMPR("","C")            
		cCalend := RA2->RA2_CALEND
	EndIf

	cDuracao:= Str(RA2->RA2_DURACA,7,2)
	cHoras  := Str(RA2->RA2_HORAS,7,2)
	
	DET := Space(1)+RA2->RA2_CURSO+"-"+Fdesc("RA1",RA2->RA2_CURSO,"RA1_DESC",20)+Space(2)
	DET += RA2->RA2_TURMA+Space(2)
	DET += If(__SetCentury(),Dtoc(RA2->RA2_DATAIN),Dtoc(RA2->RA2_DATAIN)+Space(2)) +Space(1)
	DET += If(__SetCentury(),Dtoc(RA2->RA2_DATAFI),Dtoc(RA2->RA2_DATAFI)+Space(2)) +Space(1)
	DET += RA2->RA2_ENTIDA+"-"+Fdesc("RA0",RA2->RA2_ENTIDA,"RA0_DESC",20)+Space(1)
	DET += RA2->RA2_INSTRU+"-"+Fdesc("RA7",RA2->RA2_INSTRU,"RA7_NOME",20)+Space(1)
	DET += Left(RA2->RA2_HORARI,20)+Space(1)
	DET += Transform(cDuracao,"9999.99")+Space(1)+RA2->RA2_UNDURA+Space(1)
	DET += Str(RA2->RA2_VAGAS,4,0)+Space(2)
	DET += Str(RA2->RA2_RESERV,4,0)+Space(5)
	DET += Left(RA2->RA2_LOCAL,30)+Space(1)
	DET += Str(RA2->RA2_CUSTO,12,2)+Space(1)
	DET += Transform(cHoras,"9999.99")+Space(1)
	DET += If(RA2->RA2_REALIZ == "S",STR0008,STR0009)+Space(1)	//"BAIXADO"#"ABERTO"

	IMPR(DET,"C")

	If MV_PAR16 == 1	//Imprime Sinonimo
		DET := Space(6)+STR0010+RA2->RA2_SINON+"-"+Fdesc("RA9",RA2->RA2_SINON,"RA9_DESCR") //"Sinonimo do Curso: "
		IMPR(DET,"C")		
	EndIf
			
	dbSelectArea("RA2")
	dbSkip()
EndDo

//Ŀ
// Termino do Relatorio                                         
//
IMPR(__PrtThinLine(),"C")       
IMPR("","F")

dbSelectArea("RA1")
dbSetOrder(1)

dbSelectArea("RA2")
dbSetOrder(1)

Set Device To Screen

If aReturn[5] == 1
	Set Printer To
	Commit
	ourspool(wnrel)
Endif

MS_FLUSH()

Return Nil
