#INCLUDE "PROTHEUS.CH"
#INCLUDE "CSAR020.CH"    
#INCLUDE "report.ch"

/*


Ŀ
Funo     CSAR020   Autor  Marina Shimano         Data  17.04.00 
Ĵ
Descrio  Relatorio de Graduacao de Fatores X Funcionarios           
Ĵ
Sintaxe    CSAR020(void)                                              
Ĵ
 Uso       Generico                                                   
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Emerson G.R.27/05/04xxxxxxTratam. Cargo do Funcionario - fGetCargo()
Eduardo Ju  29/11/04075557Inclusao do Parametro Grau De/Grau Ate.   
ٱ

Ŀ
Programador   Data      FNC              Motivo da Alteracao                      
ĳ
Rogerio R.   29/07/200900000018278/2009Compatibilizacao dos fontes para aumento do
                                       campo filial e gesto corporativa.         
ٱ
Francisco Jr 23/10/200900000025338/2009Compatibilizacao dos fontes para aumento do
                                       campo filial e gesto corporativa.         
ٱ
Aldo Jr      01/03/201100000004048/2011Conversao do relatorio para TReport        
Alex Fagundes10/06/201100000014297/2011Alterada a informacao da Data Nascimento   
                                       considerada no relatorio.                  
Tiago Malta  18/07/201100000004048/2011Ajustes na query e nas perguntas.          
Luciana S.   10/08/201100000016958/2011Ajuste na exibicao dos titulos do relatorio
ٱ

*/
Function CSAR020()
Local	oReport   
Local	aArea 	:= GetArea()
Private	cString	:= "SRA"				// alias do arquivo principal (Base)
Private	cPerg	:= "CSR20R"

Private aOrd    := {STR0007}
Private cTitulo	:= OemToAnsi(STR0001)	//"Relatorio de Graduacao de Fatores X Funcionarios"


If FindFunction("TRepInUse") .And. TRepInUse()

	//Ŀ
	// Ajusta as perguntas para TReport         
	//
	TAjustaSx1()
	//Ŀ
	// Verifica as perguntas selecionadas       
	//
	Pergunte(cPerg,.F.)

    oReport := ReportDef()
    oReport:PrintDialog()

Else
 	CSAR020R3()
EndIF    

RestArea( aArea )

Return


/*


ͻ
Funcao    CSAR020RDEFAutor  Microsiga            Data   24/12/10  
͹
Desc.     Definicao Relatorio                                         
͹
Uso        AP                                                         
ͼ


*/
Static Function ReportDef()

//Ŀ
// Variaveis Utilizadas na descricao do relatorio               
//   
Local oReport 
Local cDesc1	:= OemToAnsi(STR0001) + OemToAnsi(STR0002) + OemToAnsi(STR0003) //"Relatorio de Graduacao de Fatores X Funcionarios" ### "Ser impresso de acordo com os parametros solicitados pelo"  ### "usurio."

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial                                   
// MV_PAR02        //  Grupo De                                 
// MV_PAR03        //  Centro Custo De                                                          
// MV_PAR04        //  Cargo De                                 
// MV_PAR05        //  Matricula De                             
// MV_PAR06        //  Nome De                                  
// MV_PAR07        //  Fator de Graduacao De                    
// MV_PAR08       	//  Grau De                                  
// MV_PAR09        //  Situacao                                 
// MV_PAR10        //  Categoria                                
// MV_PAR11        //  Imprimir Pontos S/N                      
// MV_PAR12       	//  Imprime Desc. Detalhada do Fator S/N 	 
// MV_PAR13       	//  Imprime Observacao do Fator Funcion. S/N 
//

//Ŀ
//Criacao dos componentes de impressao                                    
//
DEFINE REPORT oReport NAME "CSAR020" TITLE cTitulo PARAMETER cPerg ACTION {|oReport| R020Imp(oReport)} DESCRIPTION OemtoAnsi(STR0039) TOTAL IN COLUMN	 //"Este programa emite Relatorio de Graduacao de Fatores X Funcionarios.
                                                                                           
Return(oReport)

/*


ͻ
Funcao    R020IMP    Autor  Microsiga            Data   24/12/10  
͹
Desc.     Tratamento de secao, query, e impressao                     
͹
Uso        AP                                                         
ͼ


*/
Static Function R020IMP(oReport) 

//Ŀ
// Secoes Relatorio              							     
// 
Local oSection1 := oReport:Section(1)  			
Local oSection2 := oReport:Section(1):Section(1)     
Local oSection3 := oReport:Section(1):Section(2)	
Local oSection4 := oReport:Section(1):Section(3)  
Local oSection5 := oReport:Section(1):Section(4)  
Local oSection6 := oReport:Section(1):Section(5)  
Local oSection7 := oReport:Section(1):Section(6)
    
//Ŀ
// Variaveis Utilizadas nas secoes						         
// 
Local oBreak	:= Nil 	//Objeto Quebra Utilizado no Totalizador  	
Local oBreak2	:= Nil 	//Objeto Quebra Utilizado na Quebra de Pagina  

Local cQry1	:= ""  		//Fitro sobre Situacao Folha utilizado na QRY1
Local cQry2	:= ""		//Fitro sobre Categoria Funcionario utilizado na QRY1

Local cWhere := ""		//Condicao a ser utilizada na Query
Local cFilSRACTT := ""
Local cFilSRASQV := ""
Local cFilSRASQ0 := ""
Local cFilSRASQ1 := ""
Local cFilSRASQ2 := ""
Local cFilSRASQ3 := ""
Local cFilSRASQ4 := ""
Local cFilSRASQ8 := ""
Local cExpSQ4    := ""
Local cExpSQ8    := ""

Local cSit1	:= MV_PAR09 //Situacao Folha
Local cSit2 := MV_PAR10	//Categoria Funcionario

Local nRegX	:= 0       	//Contador
    
//Ŀ
//Secao Grupo            							             
// 
oSection1 := TRSection():New(oReport		,OEMTOANSI(STR0024),{"SQ0"})//"Ctr Funcionarios
 	
TRCell():New(oSection1,"Q3_GRUPO" 	,"SQ3"	,OEMTOANSI(STR0025))//"Cod.Grupo:"
TRCell():New(oSection1,"Q0_DESCRIC"	,"SQ0"	,OEMTOANSI(STR0026))//"Descricao"

oBreak2 := TRBreak():New(oSection1,{||(cAliasQry)->Q3_GRUPO},,.T.) 	
oBreak2:SetPageBreak(.T.)

//Ŀ
//Secao CC            							                 
//  
oSection2 := TRSection():New(oSection1,"",{"SRA", "CTT"})	
   	
TRCell():New(oSection2,"RA_CC" 		,"SRA"	,OEMTOANSI(STR0027))//"Cod.Centro de Custo"
TRCell():New(oSection2,"CTT_DESC01"	,"CTT"	,OEMTOANSI(STR0026))//"Descricao"

oSection2:SetLeftMargin(3) 
    
//Ŀ
//Secao Cargo          							             
//  
oSection3 := TRSection():New(oSection2,"",{"SRA", "SQ3"})	                    	

TRCell():New(oSection3,"RA_CARGO" 	,"SRA"	,OemToAnsi(STR0028))//"Cod.Cargo"
TRCell():New(oSection3,"Q3_DESCSUM"	,"SQ3"	,OemToAnsi(STR0026))//"Descricao"

oSection3:SetLeftMargin(6) 
    
//Ŀ
//Secao Funcionario           							         
//  
oSection4 := TRSection():New(oSection3,"",{"SRA"})	
   	
TRCell():New(oSection4,"RA_MAT"   	,"SRA"	,OEMTOANSI(STR0029),,30,.T.)//"Cod.Matricula"
TRCell():New(oSection4,"RA_NOME" 	,"SRA"	,OEMTOANSI(STR0030))//"Nome"
TRCell():New(oSection4,"RA_NASC"	,"SRA"	,OEMTOANSI(STR0031),,15,.T.)//"Dt.Nasc"
TRCell():New(oSection4,"RA_ADMISSA"	,"SRA"	,OEMTOANSI(STR0032),,15,.T.)//"Dt.Admis"
TRCell():New(oSection4,"RA_ESTCIVI"	,"SRA"	,OEMTOANSI(STR0033),X3PICTURE("X5_DESCRI"),TAMSX3("X5_DESCRI")[1],,{|| TRMDESC("SX5","33"+(cAliasQry)->RA_ESTCIVI,"SX5->X5_DESCRI")})//"Est.Civil"

oBreak := TRBreak():New(oSection4,{||(cAliasQry)->RA_FILIAL +(cAliasQry)->RA_CC + (cAliasQry)->RA_MAT },SPACE(150) + STR0034,.F.)//" T O T A L: "

oSection4:SetLeftMargin(9) 
    
//Ŀ
//Secao Fator e Grau         							         
//  
oSection5 := TRSection():New(oSection4,"",{"SQ8","SQV"})	

TRCell():New(oSection5,"Q4_FATOR"	,"SQ4" 	,OEMTOANSI(STR0035))
TRCell():New(oSection5,"QV_DESCFAT"	,"SQV"	,OEMTOANSI(STR0036))//"Fator Necessario"
TRCell():New(oSection5,"Q4_GRAU"  	,"SQ4"	,OEMTOANSI(STR0035))//"Cod."                                                                     
TRCell():New(oSection5,"QV_DESCGRA"	,"SQV"	,OEMTOANSI(STR0037))//"Graduao Funcionario."
TRCell():New(oSection5,"Q8_PONTOS"	,"SQ8"	,OEMTOANSI(STR0038),,,,{|| IIF(!Empty((cAliasQry)->Q2_PONTOSI),(cAliasQry)->Q2_PONTOSI,(cAliasQry)->Q8_PONTOS )}) //"Pontos."

TRFunction():New(oSection5:Cell("Q8_PONTOS") ,,"SUM",oBreak,SPACE(18),,,.F.,.F.)

oSection5:SetLeftMargin(12)  
         
//Ŀ
//Secao Descricao Detalhada Fator        						 
//  	
oSection6 := TRSection():New(oSection5,"",{"SQ1","SQ8"})	

TRCell():New(oSection6,"Q1_DESCDET"	,"SQ1"	,OEMTOANSI(STR0013),X3PICTURE("YP_TEXTO"),TAMSX3("YP_TEXTO")[1],,;//"DESCRICAO DETALHADA DO FATOR"
  	{|| IIF(!Empty( MSMM((cAliasQry)->Q1_DESCDET,,,,3)),MSMM((cAliasQry)->Q1_DESCDET,,,,3),OEMTOANSI(STR0016))})		//" *** Nao tem nenhuma Observacao para este Fator *** "
   	
TRCell():New(oSection6,"Q8_OBS"		,"SQ8" 	,OEMTOANSI(STR0015),X3PICTURE("YP_TEXTO"),TAMSX3("YP_TEXTO")[1],,;//"OBSERVACAO FATOR DO FUNCIONARIO"
  	{|| IIF(!Empty( MSMM((cAliasQry)->Q8_OBS,,,,3)),MSMM((cAliasQry)->Q8_OBS,,,,3),OEMTOANSI(STR0014))})				//" *** Nao existe Descricao detalhada do Fator *** "
  
oSection6:Cell("Q1_DESCDET"):SetLineBreak()
oSection6:Cell("Q8_OBS"):SetLineBreak()   	
  	
oSection6:SetLeftMargin(15)   

cAliasQry := GetNextAlias()

//Ŀ
//Fitro sobre Situacao Folha utilizado na QRY1                  
//  
For nRegX:=1 to Len(cSit1)
	cQry1 += "'"+Subs(cSit1,nRegX,1)+"'"
	If ( nRegX+1 ) <= Len(cSit1)
		cQry1 += "," 
	Endif
Next nRegX     

//Ŀ
// Fitro sobre Categoria Funcionario utilizado na QRY1          
//  	
For nRegX:=1 to Len(cSit2)
	cQry2 += "'"+Subs(cSit2,nRegX,1)+"'"
	If ( nRegX+1 ) <= Len(cSit2)
		cQry2 += "," 
	Endif
Next nRegX     

//Ŀ
// Imprimir Pontos? 				1=S, 2=N	 	             
//  
If MV_PAR11 = 2
	oSection5:Cell("Q8_PONTOS"):Disable()	 	
EndIf
   
//Ŀ
// Imprimir Fator Detalhado? 		1=S, 2=N			         
//  
If MV_PAR12 = 2
	oSection6:Cell("Q1_DESCDET"):Disable()	
EndIf 
      
//Ŀ
// Observacao Fator Funcionario? 	1=S, 2=N		             |
//  
If MV_PAR13 = 2
	oSection6:Cell("Q8_OBS"):Disable()	
Endif
     
//Ŀ
// 						   cAliasQry                         |
//

//Transforma parametros do tipo Range em expressao ADVPL para ser utilizada no filtro
MakeSqlExpr(cPerg)

oSection1:BeginQuery() 

// Monta o Where da query devido ter a particularidade das filiais das tabelas serem exclusivas ou compartilhadas
cWhere := "% RA_SITFOLH IN ("+ cQry1 + ") AND "
cWhere += "RA_CATFUNC IN ("+ cQry2 + ") AND "	
cWhere += "SRA.D_E_L_E_T_ = ' ' "
cWhere += " %"

cFilSRACTT:= "%" + FWJoinFilial("SRA", "CTT") + "%"
cFilSRASQV:= "%" + FWJoinFilial("SRA", "SQV") + "%"
cFilSRASQ0:= "%" + FWJoinFilial("SRA", "SQ0") + "%"
cFilSRASQ1:= "%" + FWJoinFilial("SRA", "SQ1") + "%"
cFilSRASQ2:= "%" + FWJoinFilial("SRA", "SQ2") + "%"
cFilSRASQ3:= "%" + FWJoinFilial("SRA", "SQ3") + "%"
cFilSRASQ4:= FWJoinFilial("SRA", "SQ4")
cFilSRASQ8:= FWJoinFilial("SRA", "SQ8")

cExpSQ4 := "%" + cFilSRASQ4
If !Empty(MV_PAR07)
	cExpSQ4 += " AND " + MV_PAR07
Endif
cExpSQ4 += "%"

cExpSQ8 := "%" + cFilSRASQ8
If !Empty(MV_PAR08)
	cExpSQ8 += " AND " + MV_PAR08
Endif
cExpSQ8 += "%"


BEGINSQL ALIAS cAliasQry

	SELECT 
	SRA.RA_CC,SRA.RA_CARGO,SRA.RA_MAT,SRA.RA_NOME,SRA.RA_ADMISSA,SRA.RA_NASC,SRA.RA_ESTCIVI,SRA.RA_SITFOLH,SRA.RA_CATFUNC,SRA.RA_FILIAL,
	CTT.CTT_FILIAL,CTT.CTT_CUSTO,CTT.CTT_DESC01,
	SQV.QV_DESCFAT,SQV.QV_DESCGRA,
	SQ0.Q0_GRUPO,SQ0.Q0_DESCRIC,
	SQ1.Q1_DESCDET,
	SQ2.Q2_PONTOSI,
	SQ3.Q3_GRUPO,SQ3.Q3_CC,SQ3.Q3_CARGO,SQ3.Q3_DESCSUM,
	SQ4.Q4_CARGO,SQ4.Q4_FATOR,SQ4.Q4_GRAU ,SQ4.Q4_GRUPO,
	SQ8.Q8_FILIAL,SQ8.Q8_FATOR,SQ8.Q8_GRAU,SQ8.Q8_PONTOS,SQ8.Q8_OBS
	
	FROM %table:SRA% SRA
	INNER JOIN %table:CTT% CTT ON SRA.RA_CC = CTT.CTT_CUSTO AND CTT.%NotDel% AND %exp:cFilSRACTT%
	INNER JOIN %table:SQ3% SQ3 ON (SRA.RA_CARGO = SQ3.Q3_CARGO OR (SRA.RA_CARGO = SQ3.Q3_CARGO AND SRA.RA_CC = Q3_CC ))  AND SQ3.%NotDel% AND %exp:cFilSRASQ3%
	INNER JOIN %table:SQ0% SQ0 ON SQ3.Q3_GRUPO = SQ0.Q0_GRUPO  AND SQ0.%NotDel% AND %exp:cFilSRASQ0%

	LEFT JOIN %table:SQ4% SQ4 ON (SQ4.Q4_CARGO = SQ3.Q3_CARGO OR (SQ4.Q4_CARGO = SQ3.Q3_CARGO AND SQ4.Q4_CC = SQ3.Q3_CC)) AND SQ4.%NotDel% AND %exp:cExpSQ4%
	LEFT JOIN %table:SQ8% SQ8 ON SQ8.Q8_MAT = SRA.RA_MAT AND SQ8.Q8_FATOR = SQ4.Q4_FATOR  AND SQ8.%NotDel% AND %exp:cExpSQ8%
	LEFT JOIN %table:SQV% SQV ON SQ8.Q8_GRAU = SQV.QV_GRAU AND SQ8.Q8_FATOR = SQV.QV_FATOR  AND SQV.%NotDel% AND %exp:cFilSRASQV% // SQ4.Q4_FATOR = SQV.QV_FATOR
	LEFT JOIN %table:SQ2% SQ2 ON SQ2.Q2_GRUPO = SQ3.Q3_GRUPO AND SQ2.Q2_FATOR = SQ8.Q8_FATOR AND SQ2.Q2_GRAU = SQ8.Q8_GRAU AND SQ2.%NotDel% AND %exp:cFilSRASQ2%
	LEFT JOIN %table:SQ1% SQ1 ON SQ1.Q1_GRUPO = SQ4.Q4_GRUPO AND SQ1.Q1_FATOR = SQ4.Q4_FATOR  AND SQ1.%NotDel% AND %exp:cFilSRASQ1%

	WHERE %exp:cWhere%	

	ORDER BY RA_FILIAL,Q3_GRUPO,RA_CC,RA_CARGO,RA_MAT

EndSql                                                                      
oSection1:EndQuery({MV_PAR01, MV_PAR02, MV_PAR03, MV_PAR04, MV_PAR05, MV_PAR06} )//Array com os parametros do tipo Range

//Ŀ
//Filtro Filial e Grupo para CC		                         
//  
oSection2:SetParentFilter({|cParam|(cAliasQry)->RA_FILIAL + (cAliasQry)->Q3_GRUPO == cParam },{||(cAliasQry)->RA_FILIAL + (cAliasQry)->Q3_GRUPO})

//Ŀ
//Filtro Filial,Grupo e CC para Cargo		                     
//  
oSection3:SetParentFilter({|cParam|(cAliasQry)->RA_FILIAL + (cAliasQry)->Q3_GRUPO + (cAliasQry)->RA_CC  == cParam },{||(cAliasQry)->RA_FILIAL + (cAliasQry)->Q3_GRUPO + (cAliasQry)->RA_CC})

//Ŀ
//Filtro Filial,Grupo,CC e Cargo para Mat.Func              	 
//
oSection4:SetParentFilter({|cParam|(cAliasQry)->RA_FILIAL + (cAliasQry)->Q3_GRUPO + (cAliasQry)->RA_CC + (cAliasQry)->RA_CARGO  == cParam },{||(cAliasQry)->RA_FILIAL + (cAliasQry)->Q3_GRUPO + (cAliasQry)->RA_CC + (cAliasQry)->RA_CARGO})

//Ŀ
//Filtro Filial,Grupo,CC, Cargo e Mat.Func para Fator    		 
//
oSection5:SetParentFilter({|cParam|(cAliasQry)->RA_FILIAL + (cAliasQry)->Q3_GRUPO + (cAliasQry)->RA_CC + (cAliasQry)->RA_CARGO + (cAliasQry)->RA_MAT  == cParam },{||(cAliasQry)->RA_FILIAL + (cAliasQry)->Q3_GRUPO + (cAliasQry)->RA_CC + (cAliasQry)->RA_CARGO + (cAliasQry)->RA_MAT })

//Ŀ
//Filtro Filial,Grupo,CC, Cargo, Mat.Func e Fator para Descricao
//
oSection6:SetParentFilter({|cParam|(cAliasQry)->RA_FILIAL + (cAliasQry)->Q3_GRUPO + (cAliasQry)->RA_CC + (cAliasQry)->RA_CARGO + (cAliasQry)->RA_MAT + (cAliasQry)->Q8_FATOR  == cParam }	,{||(cAliasQry)->RA_FILIAL + (cAliasQry)->Q3_GRUPO + (cAliasQry)->RA_CC + (cAliasQry)->RA_CARGO + (cAliasQry)->RA_MAT + (cAliasQry)->Q8_FATOR})

oSection2:SetParentQuery()		
oSection3:SetParentQuery()
oSection4:SetParentQuery()
oSection5:SetParentQuery()
oSection6:SetParentQuery()


//-- Define o total da regua da tela de processamento do relatorio
oReport:SetMeter( 100 )  

If Empty(MV_PAR07) 
	oSection5:Disable()
	oSection6:Disable()	
Endif

oSection1:Print()
	
Return Nil


//==========>>>>>>>>> Daqui para baixo, trata-se do Release 3
/*


Ŀ
Funo     CSAR020   Autor  Marina Shimano         Data  17.04.00 
Ĵ
Descrio  Relatorio de Graduacao de Fatores X Funcionarios           
Ĵ
Sintaxe    CSAR020(void)                                              
Ĵ
 Uso       Generico                                                   
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Emerson G.R.27/05/04xxxxxxTratam. Cargo do Funcionario - fGetCargo()
Eduardo Ju  29/11/04075557Inclusao do Parametro Grau De/Grau Ate.   
ٱ

*/
Function CSAR020R3()
//Ŀ
// Define Variaveis Locais (Basicas)                            
//
Local cString 	:= "SRA"  	// Alias do arquivo principal (Base)
Local cDesc1  	:= STR0001	//"Relatorio de Graduacao de Fatores X Funcionarios"
Local cDesc2  	:= STR0002	//"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  	:= STR0003	//"usurio."
Local aOrd    	:= {}

//Ŀ
// Define Variaveis Private(Basicas)                            
//
Private aReturn  := {STR0004,1,STR0005,2,2,1,"",1 }		//"Zebrado"###"Administrao"
Private NomeProg := "CSAR020"
Private aLinha   := {}
Private nLastKey := 0
Private cPerg    := "CSR020"

//Ŀ
// Variaveis Utilizadas na funcao IMPR                          
//
Private Titulo   := STR0001					//"Relatorio de Graduacao de Fatores X Funcionarios"
Private Colunas  := 132
Private AT_PRG   := "CSR020"
Private wCabec0  := 1
Private wCabec1  := ""
Private Contfl   := 1
Private Li       := 0
Private nTamanho := "M"

//Ŀ
// Verifica as perguntas selecionadas                           
//
//Retirar na Proxima versao           

pergunte("CSR020",.F.)

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial De                                
// MV_PAR02        //  Filial Ate                               
// MV_PAR03        //  Grupo De                                 
// MV_PAR04        //  Grupo Ate                                
// MV_PAR05        //  Centro Custo De                                                          
// MV_PAR06        //  Centro Custo Ate                         
// MV_PAR07        //  Cargo De                                 
// MV_PAR08        //  Cargo Ate                                
// MV_PAR09        //  Matricula De                             
// MV_PAR10        //  Matricula Ate                            
// MV_PAR11        //  Nome De                                  
// MV_PAR12        //  Nome Ate                                 
// MV_PAR13        //  Fator de Graduacao De                    
// MV_PAR14        //  Fator de Graduacao Ate                   
// MV_PAR15        //  Situacao                                 
// MV_PAR16        //  Categoria                                
// MV_PAR17        //  Imprimir Pontos S/N                      
// MV_PAR18       	//  Imprime Desc. Detalhada do Fator S/N 	 
// MV_PAR19       	//  Imprime Observacao do Fator Funcion. S/N 
// MV_PAR20       	//  Grau De                                  
// MV_PAR21       	//  Grau Ate                                 
//

//Ŀ
// Envia controle para a funcao SETPRINT                        
//
wnrel:="CSAR020"            //Nome Default do relatorio em Disco
wnrel:=SetPrint(cString,wnrel,cPerg,@Titulo,cDesc1,cDesc2,cDesc3,.F.,aOrd,,nTamanho)

If nLastKey = 27
	Return
EndIf

SetDefault(aReturn,cString)

If nLastKey = 27
	Return
EndIf

RptStatus({|lEnd| Cs020Imp(@lEnd,wnRel,cString)},Titulo)

Return

/*


Ŀ
Funo     CS020Imp  Autor                         Data  17.04.00 
Ĵ
Descrio  Funcao que imprime os fatores dos funcionarios             
Ĵ
Sintaxe    Cs020Imp(lEnd,wnRel,cString)                               
Ĵ
Parametros lEnd        - Ao do Codelock                             
           wnRel       - Ttulo do relatrio                          
           cString     - Mensagem  			                          
Ĵ
 Uso       CSAR020                                                    
ٱ

*/
Static Function Cs020Imp(lEnd,WnRel,cString )
Local cGrupo	:= ""
Local cCcusto	:= ""
Local cDepto	:= ""
Local cDescGrupo:= ""
Local cEstCivil	:= ""
//Local cDtNasc	:= ""
//Local cDtAdmi	:= ""
Local cAuxGrupo	:= ""
Local cAuxCC	:= ""
Local cAuxCargo	:= ""
Local cArqTemp	:= ""
Local cNtxTemp	:= ""
Local aFator	:= {}
Local aCampos	:= {}
Local cDet		:= ""
Local cAuxDet	:= ""
Local cDescCargo:= ""
Local l1Vez		:= .T.
Local cFil		:= ""
Local lImp 		:= .F.
Local cAcessaSRA:= &("{ || " + ChkRH(FunName(),"SRA","2") + "}")
Local nBegin	:= 0
Local nLinha	:= 0
Local nx		:= 0
Local nFuncs  	:= 0 
Local cCargo	:= ""
Local lCabecF 	:= .F.

Private cInicio	:= ""
Private cFim	:= ""

//Ŀ
// Cria arquivo temporrio.                                     
//
aCampos := { { "TR_FILIAL"  ,"C", FWGETTAMFILIAL, 0 } ,;
             { "TR_GRUPO"   ,"C", TamSX3("Q3_GRUPO")[1],    TamSX3("Q3_GRUPO")[2]   } ,;
             { "TR_DGRUPO"  ,"C", TamSX3("Q0_DESCRIC")[1],  TamSX3("Q0_DESCRIC")[2] } ,;
             { "TR_CC"      ,"C", TamSX3("RA_CC")[1],       TamSX3("RA_CC")[2]      } ,;
             { "TR_DCC"     ,"C", TamSX3("CTT_DESC01")[1],  TamSX3("CTT_DESC01")[2] } ,;
             { "TR_MAT"     ,"C", TamSX3("RA_MAT")[1],      TamSX3("RA_MAT")[2]     } ,;
             { "TR_NOME"    ,"C", TamSX3("RA_NOME")[1],     TamSX3("RA_NOME")[2]    } ,;
             { "TR_ESTCIV"  ,"C", TamSX3("RA_ESTCIVI")[1],  TamSX3("RA_ESTCIVI")[2] } ,;
             { "TR_DESTCI"  ,"C", 30,                       0                       } ,;
             { "TR_DTNASC"  ,"D", TamSX3("RA_NASC")[1],     TamSX3("RA_NASC")[2]    } ,;
             { "TR_DTADMI"  ,"D", TamSX3("RA_ADMISSA")[1],  TamSX3("RA_ADMISSA")[2] } ,;
             { "TR_CARGO"   ,"C", TamSX3("RA_CARGO")[1],    TamSX3("RA_CARGO")[2]   } ,;
             { "TR_DCARGO"	,"C", TamSX3("Q3_DESCSUM")[1],  TamSX3("Q3_DESCSUM")[2] } }
             
cArqTemp := CriaTrab(aCampos)
cNtxTemp := CriaTrab(NIL,.f.)
dbUseArea(.T.,,cArqTemp,"TRB",if(.F. .OR. .F.,!.F., NIL),.F.)
IndRegua("TRB",cNtxTemp,"TR_FILIAL+TR_GRUPO+TR_CC+TR_CARGO",,,"Selecionando Registros...")

dbSelectArea("SRA")
dbSetOrder(1)
wcabec0 := 1
wcabec1 := Space(10) + STR0006	 //" MATR. NOME                           DT.NASC. DT.ADMIS EST.CIVIL"
					             // 123456 123456789012345678901234567890 12345678 12345678 1-123456789012345 

cFil := xFilial("SRA", MV_PAR01)
dbSeek(cFil+MV_PAR09,.T.)

cInicio		:= "SRA->RA_FILIAL + SRA->RA_MAT"
cFim		:= MV_PAR02 + MV_PAR10
cSituacao 	:= MV_PAR15
cCategoria	:= MV_PAR16
SetRegua(RecCount())

While !Eof() .And. &cInicio <= cFim                

	IncRegua()
	
	If !Eval(cAcessaSRA)
		dbSkip()  
		Loop
	EndIf
	
	If lEnd
		@Prow()+1,0 PSAY cCancel		
		Exit
	EndIf

    cCargo := fGetCargo(SRA->RA_MAT)
    
	//Ŀ
	// Consiste Parametrizacao do Intervalo de Impressao            
	//
	If  (SRA->RA_NOME 	< MV_PAR11)	.Or. (SRA->RA_NOME 	> MV_PAR12)	.Or. ;
		(SRA->RA_MAT 	< MV_PAR09)	.Or. (SRA->RA_MAT 	> MV_PAR10)	.Or. ;
		(SRA->RA_CC 	< MV_PAR05)	.Or. (SRA->RA_CC 	> MV_PAR06)	.Or. ;
		(cCargo		 	< MV_PAR07) .Or. (cCargo		> MV_PAR08)
		dbSkip()
		Loop
	EndIf
	
	//Ŀ
	// Verifica Situacao e Categoria do Funcionario                 
	//
	If !( SRA->RA_SITFOLH $ cSituacao ) .OR. !( SRA->RA_CATFUNC $ cCategoria )
		dbSelectArea( "SRA" )
		dbSkip()
		Loop
	Endif
	
	cEstCivil	:= Substr(TrmDesc("SX5","33"+SRA->RA_ESTCIVI,"SX5->X5_DESCRI"),1,15)
	//cDtNasc 	:= DtoC(SRA->RA_NASC)
	//cDtAdmi 	:= DtoC(SRA->RA_ADMISSA)

	//Verifica o filtro do Centro de Custo
	dbSelectArea("CTT")
	dbSetOrder(1)	
	cFil := xFilial("CTT", SRA->RA_FILIAL)	//Verifica se arquivo exclusivo
	If dbSeek(cFil+SRA->RA_CC)
		If CTT->CTT_CUSTO < MV_PAR05 .Or. CTT->CTT_CUSTO > MV_PAR06
  			dbSelectArea("SRA")
			dbSkip()
			Loop
		EndIf	
		cCcusto := CTT->CTT_DESC01
	Else
		dbSelectArea( "SRA" )
		dbSkip()
		Loop
	EndIf
	    
	//Verifica o filtro do Grupo
	dbSelectArea("SQ3")
	dbSetOrder(1)      
	cFil := xFilial("SQ3", SRA->RA_FILIAL)	//Verifica se arquivo exclusivo	
	If dbSeek(cFil+cCargo+SRA->RA_CC) .Or. dbSeek(cFil+cCargo)
		If SQ3->Q3_GRUPO < MV_PAR03 .Or. SQ3->Q3_GRUPO > MV_PAR04
			dbSelectArea("SRA")
			dbSkip()
			Loop
		EndIf	
		cGrupo := SQ3->Q3_GRUPO
		cFil := xFilial("SQ0", SRA->RA_FILIAL)	//Verifica se arquivo exclusivo			
	Else
		dbSelectArea( "SRA" )
		dbSkip()
		Loop
	EndIf 
	       
	FMontaFator(,,cCargo,SRA->RA_MAT,@cGrupo,@cDepto,@aFator,SRA->RA_CC)	                 

	If cGrupo < MV_PAR03 .Or. cGrupo > MV_PAR04
		dbSelectArea("SRA")
		dbSkip()
		Loop
	EndIf	
    cDescGrupo := If( SQ0->( dbSeek( xFilial("SQ0") + cGrupo ) ) , SQ0->Q0_DESCRIC ,Space(15) )		
    
	//Ŀ
	// Considera-se somente os 'fatores/grau dos funcionarios' informados pelo Usuario. 
	//
	nfator := 0            
	For nx := 1 To Len(aFator)
		If 	(aFator[nx][1] >= MV_PAR13 .And. aFator[nx][1] <= MV_PAR14) .And.;
			(aFator[nx][6] >= MV_PAR20 .And. aFator[nx][6] <= MV_PAR21	)		
			nfator++
		EndIf 
	Next nx	
	
	If (!Empty(MV_PAR13) .And. nfator == 0) .Or.;
		(!Empty(MV_PAR20) .And. nfator == 0)
		dbSelectArea("SRA")
		dbSkip()  
		Loop
	EndIf		
	
	RecLock("TRB",.T.)	           
		Replace TR_FILIAL  WITH SRA->RA_FILIAL
		Replace	TR_GRUPO   WITH cGrupo
		Replace	TR_DGRUPO  WITH cDescGrupo         
		Replace TR_CC      WITH SRA->RA_CC
		Replace TR_DCC     WITH cCcusto
		Replace TR_MAT     WITH SRA->RA_MAT
		Replace TR_NOME    WITH SRA->RA_NOME
		Replace TR_ESTCIV  WITH SRA->RA_ESTCIVI
		Replace TR_DESTCI  WITH cEstCivil
        //Replace TR_DTNASC  WITH cDtNasc
        //Replace TR_DTADMI  WITH cDtAdmi
        Replace TR_DTNASC  WITH SRA->RA_NASC
        Replace TR_DTADMI  WITH SRA->RA_ADMISSA
		Replace TR_CARGO   WITH cCargo
		Replace TR_DCARGO  WITH SQ3->Q3_DESCSUM
	MsUnlock()
	
	dbSelectArea("SRA")
	dbSetOrder(1)
	dbSkip()
EndDo	

// Se for a primeira vez
l1Vez		:= .T.
cAuxGrupo 	:= Replicate("!", GetSx3Cache("Q3_GRUPO", "X3_TAMANHO"))
cAuxCC		:= Replicate("!", GetSx3Cache("RA_CC", "X3_TAMANHO"))
cAuxCargo	:= Replicate("!", GetSx3Cache("RA_CARGO", "X3_TAMANHO"))

dbSelectArea("TRB")
dbGotop()
SetRegua(RecCount())

While !Eof()
	lImp := .T.
	IncRegua()
	
	If 	cAuxGrupo != TR_GRUPO
		If cAuxGrupo != Replicate("!", GetSx3Cache("Q3_GRUPO", "X3_TAMANHO"))
			IMPR("","P")	// Salta Pagina
		EndIf
		cDet := STR0007 + Space(01) + TR_GRUPO	 + Space(01)+ "-" + Space(01)+TR_DGRUPO // "Grupo :"
		IMPR(cDet,"C")
		cDet := Repl("-",Colunas)
		IMPR(cDet,"C")		
		cDet := Space(05) + STR0008 + Space(01) + TR_CC + Space(01)+ "-" + Space(01)+ TR_DCC  // "Centro de Custo :"
		IMPR(cDet,"C")		
		cDet := Repl("-",Colunas)
		IMPR(cDet,"C")		
		cDet := Space(10) + STR0009 + Space(01) + TR_CARGO + Space(01)+ "-" + Space(01)+ TR_DCARGO // "Cargo :"
		IMPR(cDet,"C")
		cDet := Repl("-",Colunas)
		IMPR(cDet,"C")		
		cAuxGrupo 	:= TR_GRUPO
		cAuxCC		:= TR_CC
		cAuxCargo	:= TR_CARGO
		
	ElseIf cAuxCC != TR_CC	
		cDet := Space(05) + STR0008 + Space(01) + TR_CC + Space(01)+ "-" +Space(01)+ TR_DCC // "Centro de Custo :"
		IMPR(cDet,"C")		
		cDet := Repl("-",Colunas)
		IMPR(cDet,"C")
		cDet := Space(10) + STR0009 + Space(01) + TR_CARGO + Space(01)+"-"+ Space(01)+ TR_DCARGO // "Cargo :"
		IMPR(cDet,"C")
		cDet := Repl("-",Colunas)
		IMPR(cDet,"C")
		cAuxCC		:= TR_CC
		cAuxCargo	:= TR_CARGO
		
	ElseIf cAuxCargo != TR_CARGO	 
		cDet := Space(10) + STR0009 + Space(01) + TR_CARGO + Space(01)+ "-" +Space(01)+ TR_DCARGO// "Cargo :"
		IMPR(cDet,"C")
		cDet := Repl("-",Colunas)
		IMPR(cDet,"C")		
		cAuxCargo	:= TR_CARGO
	EndIf

	cDet := Space(10) + TR_MAT + Space(02) + TR_NOME + Space(02) + DtoC(TR_DTNASC) + Space(03) + DtoC(TR_DTADMI) + Space(04) + TR_ESTCIV + "-" + TR_DESTCI
	IMPR(cDet,"C")

	FMontaFator(,,TR_CARGO,TR_MAT,@cGrupo,@cDepto,@aFator,TR_CC)
	nFuncs  := 0 
	
	lCabecF:= .F.	

	For nx := 1 To Len(aFator)			                                    
		If 	(aFator[nx][1] >= MV_PAR13 .And. aFator[nx][1] <= MV_PAR14) .And.;
			(aFator[nx][6] >= MV_PAR20 .And. aFator[nx][6] <= MV_PAR21	)	
	
			//Ŀ
			// Imprime Cabecalho dos Fatores Somente Qdo tem Fator Cadastrado 
			//
			If !Empty(aFator[nx][1])
				If !lCabecF
					If MV_PAR17 ==1  //Sim
						cDet := Space(15)+STR0011 // "FATOR NECESSARIO                  GRADUACAO FUNCIONARIO              PONTOS"
					Else
						cDet := Space(15)+STR0010 // "FATOR NECESSARIO                  GRADUACAO FUNCIONARIO"
					EndIf				
					IMPR(cDet,"C")
					lCabecF := .T.
				EndIf			
			EndIf
				
			// Soma os totais de Pontos dos Funcionarios
			nFuncs	:= nFuncs  + aFator[nx][8]		             
						
			cDet := Space(15)+aFator[nx][1]+ Space(01)+aFator[nx][2]+ Space(01)+aFator[nx][6]+Space(01)+aFator[nx][7]+Space(01)
	        If MV_PAR17 == 1 // Sim
				cDet := cDet + Transform(aFator[nx][8],"@E 9999.99")
			EndIf
			IMPR(cDet,"C")
			cDet :=""
			
			//Ŀ
			// Impressao da Descricao Detalhada do Fator. 
			//
			If MV_PAR18 == 1		// Sim
			
				dbSelectArea("SQ1")
				dbSetOrder(1)
				cFil := xFilial("SQ1", TRB->TR_FILIAL)
				dbSeek(cFil + aFator[nX][9] + aFator[nX][1])
				
				cDet	:= Space(18) + STR0013	//"DESCRICAO DETALHADA DO FATOR"
				IMPR(cDet,"C")
			
				cDescDet := MSMM(SQ1->Q1_DESCDET,,,,3)	
			
				nLinha	:= MLCount(cDescDet,112)
				If nLinha > 0				
					For nBegin := 1 To nLinha
						cDet := Space(20)+ Memoline(cDescDet,112,nBegin,,.T.)
						IMPR(cDet,"C")
					Next nBegin
				Else
					cDet := Space(17)+ STR0014	//" *** Nao existe Descricao detalhada do Fator *** "
					IMPR(cDet,"C")
				EndIf
				cDet := ""
				IMPR(cDet,"C")
			EndIf
	
			//Ŀ
			// Impressao da Observacao do Fator (Funcion.)
			//
			If MV_PAR19 == 1		// Sim
			
				dbSelectArea("SQ8")                               
				dbSetOrder(1)
				cFil := xFilial("SQ8", TRB->TR_FILIAL)
				dbSeek(cFil + TRB->TR_MAT + aFator[nX][1])		
	
				cDet	:= Space(18) + STR0015	//"OBSERVACAO FATOR DO FUNCIONARIO"
				IMPR(cDet,"C")
			
				cDescDet := MSMM(SQ8->Q8_OBS,,,,3)	
			
				nLinha	:= MLCount(cDescDet,112)
				If nLinha > 0				
					For nBegin := 1 To nLinha
						cDet := Space(20)+ Memoline(cDescDet,112,nBegin,,.T.)
						IMPR(cDet,"C")
					Next nBegin
				Else
					cDet := Space(17)+ STR0016	//" *** Nao tem nenhuma Observacao para este Fator *** "
					IMPR(cDet,"C")
				EndIf
				cDet := ""
				IMPR(cDet,"C")
			EndIf
		EndIf			
	Next nx
	
	If 	MV_PAR17==1
		cDet := STR0012 + Space(15)+ Transform(nFuncs,"@E 9999.99")	// "T O T A L :"
		IMPR(cDet,"C")	
	EndIf                             
	
	cDet := Repl("-",Colunas)
	IMPR(cDet,"C")
	
	dbSelectArea("TRB")
	dbSkip()
	
EndDo

If lImp
	Impr("","F")
EndIf	

If Select("TRB") != 0
    TRB->(dbCloseArea() )
    FErase(cArqTemp + GetDBExtension() )
    FErase(cNtxTemp + OrdBagExt() )
Endif

dbSelectArea("SRA")
Set Filter to 
dbSetOrder(1)

If aReturn[5] = 1
	Set Printer To
	Commit
	ourspool(wnrel)
Endif

MS_FLUSH()

Return Nil



/*


Ŀ
Funo     AjustaSx1      Autor  Aldo Marini       Data 22/03/2011
Ĵ
Descrio  Ajusta SX1                                                 
Ĵ
 Uso       CSAR020 - TReport                                          
ٱ

*/
Static Function TAjustaSx1()

//Ŀ
// Variaveis utilizadas para parametros                         
// MV_PAR01        //  Filial                                   
// MV_PAR02        //  Grupo De                                 
// MV_PAR03        //  Centro Custo De                                                          
// MV_PAR04        //  Cargo De                                 
// MV_PAR05        //  Matricula De                             
// MV_PAR06        //  Nome De                                  
// MV_PAR07        //  Fator de Graduacao De                    
// MV_PAR08       	//  Grau De                                  
// MV_PAR09        //  Situacao                                 
// MV_PAR10        //  Categoria                                
// MV_PAR11        //  Imprimir Pontos S/N                      
// MV_PAR12       	//  Imprime Desc. Detalhada do Fator S/N 	 
// MV_PAR13       	//  Imprime Observacao do Fator Funcion. S/N 
//

Local aRegs		:= {}
Local aHelp		:= {}
Local aHelpE	:= {}
Local aHelpI	:= {}   
Local cHelp		:= ""

aHelp := {	"Informe intervalo de filiais que ",;
			"deseja considerar para impressao ",;
			"do relatorio." }
aHelpE:= {	"Informe intervalo de sucursales ",;
			"que desea considerar para impresion ",;
			"del informe." }
aHelpI:= {	"Enter branch range to be considered ",;
			"to print report." }
cHelp := ".RHFILIAL."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)	 
/*
Ŀ
           Grupo  Ordem Pergunta Portugues  Pergunta Espanhol Pergunta Ingles Variavel Tipo Tamanho Decimal Presel GSC   Valid  Var01      Def01 DefSPA1 DefEng1 Cnt01       Var02 Def02 DefSpa2 DefEng2 Cnt02 Var03 Def03 DefSpa3 DefEng3 Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04  Var05  Def05  DefSpa5 DefEng5 Cnt05 XF3   GrgSxg cPyme aHelpPor aHelpEng aHelpSpa cHelp       
*/
Aadd(aRegs,{cPerg,"01" ,"Filial ?"         ,"Sucursal ?"    ,"Branch?"      ,"MV_CH1","C" ,99     ,0     ,0     ,"R"  ,""    ,"MV_PAR01",""   ,""     ,""     ,"RA_FILIAL",""  ,""   ,""     ,""     ,""   ,""   ,""   ,""    ,""     ,""   ,""   ,""   ,""     ,""     ,""   ,""    ,""    ,""     ,""     ,""   ,"XM0",""    ,"S"  ,""     ,""      ,""      ,cHelp})


aHelp := {	"Informe intervalo de Grupos ",;
			"que deseja considerar para impresso ",;
			"do relatrio." }
aHelpE:= {	"Informe el intervalo de Grupos ",;
			"costo que desea considerar para ",;
			"imprimir el informe." }
aHelpI:= {	"Enter Group range considered ",;
			"for printing report." }
cHelp := ".RHGRUPR."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)	 
/*
Ŀ
           Grupo  Ordem Pergunta Portugues  Pergunta Espanhol   Pergunta Ingles  Variavel Tipo Tamanho  Decimal Presel  GSC   Valid   Var01      Def01 DefSPA1  DefEng1  Cnt01   Var02  Def02  DefSpa2 DefEng2 Cnt02 Var03 Def03  DefSpa3  DefEng3  Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04  Var05  Def05  DefSpa5 DefEng5 Cnt05  XF3  GrgSxg  cPyme aHelpPor aHelpEng aHelpSpa cHelp  
*/
Aadd(aRegs,{cPerg,"02" ,"Grupo ?"			,"Grupo ?"			,"Grupo ?"		,"MV_CH2","C" ,99      ,0      ,0     ,"R"  ,""     ,"MV_PAR02",""    ,""      ,""     ,"Q0_GRUPO",""    ,""   ,""     ,""     	,""  ,""   ,""    ,""      ,""      ,""   ,""   ,""   ,""     ,""     ,""   ,""    ,""    ,""     ,""     ,""   ,"SQ0",""  ,"S"  ,""      ,""      ,""     ,cHelp})

aHelp := {	"Informe intervalo de Centros de Custo ",;
			"que deseja considerar para impresso",;
			"do relatrio." }
aHelpE:= {	"Informe el intervalo de centros de ",;
			"costo que desea considerar para ",;
			"imprimir el informe." }
aHelpI:= {	"Enter Cost Center range considered ",;
			"for printing report." }
cHelp := ".RHCCUSTO."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)	 
/*
Ŀ
           Grupo  Ordem Pergunta Portugues  Pergunta Espanhol   Pergunta Ingles  Variavel Tipo Tamanho  Decimal Presel  GSC   Valid   Var01      Def01 DefSPA1  DefEng1  Cnt01   Var02  Def02  DefSpa2 DefEng2 Cnt02 Var03 Def03  DefSpa3  DefEng3  Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04  Var05  Def05  DefSpa5 DefEng5 Cnt05  XF3  GrgSxg  cPyme aHelpPor aHelpEng aHelpSpa cHelp  
*/
Aadd(aRegs,{cPerg,"03" ,"Centro de Custo ?","Centro de Costo ?","Cost Center ?","MV_CH3","C" ,99      ,0      ,0     ,"R"  ,""     ,"MV_PAR03",""    ,""      ,""     ,"RA_CC",""    ,""   ,""     ,""     ,""  ,""   ,""    ,""      ,""      ,""   ,""   ,""   ,""     ,""     ,""   ,""    ,""    ,""     ,""     ,""   ,"CTT","004"  ,"S"  ,""      ,""      ,""     ,cHelp})

aHelp := {	"Informe intervalo de cargos que",;
			"deseja considerar para ",;
			"impresso do Relatrio." }
aHelpE:= {	"Informe intervalo de cargos que",;
			"desea considerar para la ",;
			"impresion del Informe." }
aHelpI:= {	"Inform the position interval to",;
			"be considered to print the ",;
			"Report." }
cHelp := ".RHCARGO."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)
/*
Ŀ
           Grupo  Ordem Pergunta Portugues  Pergunta Espanhol   Pergunta Ingles  Variavel Tipo Tamanho  Decimal Presel  GSC   Valid   Var01      Def01 DefSPA1  DefEng1  Cnt01   Var02  Def02  DefSpa2 DefEng2 Cnt02 Var03 Def03  DefSpa3  DefEng3  Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04  Var05  Def05  DefSpa5 DefEng5 Cnt05  XF3  GrgSxg  cPyme aHelpPor aHelpEng aHelpSpa cHelp  
*/

Aadd(aRegs,{cPerg,"04"	,"Cargo  ?"			,"Cargo ?"  		,"Position    ?","mv_ch4"  			,"C"	,99			,0		,0		,"R"	,""				,"MV_PAR04"	,""			   		,""					,""					,"RA_CARGO"		,""		,""					,""					,""				,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,"SQ3"	,"","S"	,{}			,{}			,{}			,cHelp})

aHelp := {	"Informe intervalo de matrculas que ",;
			"deseja considerar para impresso do ",;
			"relatrio." }
aHelpE:= {	"Informe el intervalo de matriculas ",;
			"que desea considerar para imprimir ",;
			"el informe." }
aHelpI:= {	"Enter the registration interval to be ",;
			"considered to print the report." }
cHelp := ".RHMATRIC."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)	 
/*
Ŀ
           Grupo  Ordem Pergunta Portugues Pergunta Espanhol Pergunta Ingles   Variavel  Tipo  Tamanho Decimal Presel GSC   Valid   Var01      Def01  DefSPA1  DefEng1  Cnt01   Var02  Def02 DefSpa2 DefEng2 Cnt02 Var03 Def03  DefSpa3  DefEng3  Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04  Var05  Def05  DefSpa5 DefEng5 Cnt05  XF3     GrgSxg  cPyme aHelpPor aHelpEng  aHelpSpa cHelp  
*/
Aadd(aRegs,{cPerg,"05" ,"Matrcula ?"     ,"Matricula ?"   ,"Registration ?" ,"MV_CH5" ,"C"  ,99     ,0     ,0     ,"R"  ,""     ,"MV_PAR05",""    ,""      ,""     ,"RA_MAT",""    ,""   ,""     ,""     ,""  ,""   ,""    ,""      ,""      ,""   ,""   ,""   ,""     ,""     ,""   ,""    ,""    ,""     ,""     ,""   ,"SRA05",""    ,"S" ,""      ,""      ,""       ,cHelp})


aHelp := {	"Informe intervalo de nomes de funcio-",;
			"nrios que deseja considerar para im-",;
			"presso do relatrio." }
aHelpE:= {	"Informe el intervalo de nombres de ",;
			"empleados que desea considerar para ",;
			"imprimir el informe." }
aHelpI:= {	"Enter the employee names interval ",;
			"to be considered to print the report." }
cHelp := ".RHNOME."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)	 
/*
Ŀ
           Grupo  Ordem Pergunta Portugues  Pergunta Espanhol  Pergunta Ingles  Variavel  Tipo Tamanho Decimal Presel GSC   Valid   Var01      Def01  DefSPA1  DefEng1 Cnt01     Var02  Def02 DefSpa2 DefEng2 Cnt02 Var03 Def03 DefSpa3 DefEng3 Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04 Var05  Def05 DefSpa5 DefEng5 Cnt05 XF3 GrgSxg  cPyme aHelpPor aHelpEng aHelpSpa cHelp  
*/
Aadd(aRegs,{cPerg,"06" ,"Nome ?"           ,"Nombre ?"       ,"Name?"         ,"MV_CH6" ,"C" ,99     ,0     ,0     ,"R"  ,""     ,"MV_PAR06",""    ,""      ,""     ,"RA_NOME",""    ,""   ,""     ,""     ,""  ,""   ,""   ,""     ,""    ,""   ,""   ,""   ,""     ,""     ,""   ,""   ,""    ,""    ,""     ,""   ,"" ,""    ,"S"   ,""     ,""      ,""      ,cHelp})

aHelp := {	"Informe ou Selecione o Cdigo ",;   
			"do Fator de Graduao  para ",;
			" Filtro dos dados.   " }
aHelpE:= {	"Informe o Seleccione el Codigo ",;  
			" del Factor de Graduacion para ",;
			"Filtro de los datos.   " }
aHelpI:= {	"Inform or Select the Graduation ",;  
			" Factor Code to Filter ",;
			"data.  " }
cHelp := ".RHFATGR."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)
/*
Ŀ
           Grupo  Ordem Pergunta Portugues  Pergunta Espanhol  Pergunta Ingles  Variavel  Tipo Tamanho Decimal Presel GSC   Valid   Var01      Def01  DefSPA1  DefEng1 Cnt01     Var02  Def02 DefSpa2 DefEng2 Cnt02 Var03 Def03 DefSpa3 DefEng3 Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04 Var05  Def05 DefSpa5 DefEng5 Cnt05 XF3 GrgSxg  cPyme aHelpPor aHelpEng aHelpSpa cHelp  
*/
Aadd(aRegs,{cPerg,"07"	,"Fator Graduacao  ?","Factor Graduac. ?"  ,"Grad. Factor?","mv_ch7"  			,"C"	,99			,0		,0		,"R"	,""				,"MV_PAR07"	,""					,""					,""					,"Q4_FATOR"		,""		,""					,""					,""				,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,"SQV"	,"","S",aHelp  ,aHelpI   ,aHelpE  ,cHelp})

aHelp := {	"Informe o codigo do grau ",;     
			"dos fatores de graduacao  que sera ",;
			"impresso no relatorio.  " }
aHelpE:= {	"Informe o Seleccione el Codigo del grado",;   
			" de los factores de graduacion que se ",;
			"imprimira en el informe.  " }
aHelpI:= {	"Inform or Select the Graduation ",;
			" Factor level Code to ",;
			" print the report." }
cHelp := ".RHGRFAT."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)
/*
Ŀ
           Grupo  Ordem Pergunta Portugues  Pergunta Espanhol  Pergunta Ingles  Variavel  Tipo Tamanho Decimal Presel GSC   Valid   Var01      Def01  DefSPA1  DefEng1 Cnt01     Var02  Def02 DefSpa2 DefEng2 Cnt02 Var03 Def03 DefSpa3 DefEng3 Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04 Var05  Def05 DefSpa5 DefEng5 Cnt05 XF3 GrgSxg  cPyme aHelpPor aHelpEng aHelpSpa cHelp  
*/
Aadd(aRegs,{cPerg,"08"	,"Grau ?" ,"Nivel ? "  ,"Level ?","mv_ch8"  			,"C"	,99			,0		,0		,"R"	,""				,"MV_PAR08"	,""					,""					,""					,"Q8_GRAU"		,""		,""					,""					,""				,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S",aHelp  ,aHelpI   ,aHelpE  ,cHelp})

aHelp := {	"Informe ou Selecione as Situaes ",;
			"dos Funcionrios para Filtro dos ",;
			"dados." }
aHelpE:= {	"Informe o seleccione las situaciones ",;
			"de los empleados para filtrar los datos." }
aHelpI:= {	"Enter or select the employees status ",;
			"to filter the data." }
cHelp := ".RHSITUA."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)	 
/*
Ŀ
           Grupo  Ordem Pergunta Portugues  Pergunta Espanhol  Pergunta Ingles  Variavel  Tipo  Tamanho Decimal Presel  GSC  Valid         Var01      Def01  DefSPA1  DefEng1  Cnt01  Var02  Def02 DefSpa2 DefEng2 Cnt02 Var03 Def03  DefSpa3  DefEng3  Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04  Var05  Def05  DefSpa5 DefEng5 Cnt05  XF3 GrgSxg cPyme aHelpPor aHelpEng  aHelpSpa cHelp   
*/
Aadd(aRegs,{cPerg,"09" ,"Situaes ?"      ,"Situaciones ?"  ,"Status ?"      ,"MV_CH9" ,"C"  ,6      ,0     ,0      ,"G" ,"fSituacao()","MV_PAR09",""    ,""      ,""     ,""    ,""    ,""   ,""     ,""     ,""  ,""   ,""    ,""      ,""      ,""   ,""   ,""   ,""     ,""     ,""   ,""    ,""    ,""     ,""     ,""   ,""  ,""    ,"S"  ,""      ,""      ,""      ,cHelp})


aHelp := {	"Informe ou Selecione as Categorias ",;
			"dos Funcionrios para Filtro dos dados." }
aHelpE:= {	"Informe o seleccione las categorias ",;
			"de los empleados en el filtro de los ",;
			"datos." }
aHelpI:= {	"Indicate or select the employees ",;
			"categories to filter the data." }
cHelp := ".RHCATEG."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)	 
/*
Ŀ
           Grupo  Ordem Pergunta Portugues Pergunta Espanhol Pergunta Ingles Variavel Tipo Tamanho  Decimal Presel  GSC   Valid          Var01      Def01 DefSPA1  DefEng1  Cnt01  Var02  Def02 DefSpa2 DefEng2 Cnt02 Var03 Def03  DefSpa3  DefEng3  Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04  Var05  Def05  DefSpa5 DefEng5 Cnt05  XF3 GrgSxg cPyme aHelpPor aHelpEng aHelpSpa cHelp    
*/
Aadd(aRegs,{cPerg,"10" ,"Categorias ?"    ,"Categorias ?"  ,"Classes ?"    ,"MV_CHA","C" ,18      ,0      ,0     ,"G"  ,"fCategoria()","MV_PAR10",""    ,""      ,""     ,""   ,""    ,""   ,""     ,""     ,""  ,""   ,""    ,""      ,""      ,""   ,""   ,""   ,""     ,""     ,""   ,""    ,""    ,""     ,""     ,""   ,""  ,""    ,"S"  ,""     ,""      ,""      ,cHelp})

aHelp := {	"Informe ou Selecione as Categorias ",;
			"dos Funcionrios para Filtro dos dados." }
aHelpE:= {	"Informe o seleccione las categorias ",;
			"de los empleados en el filtro de los ",;
			"datos." }
aHelpI:= {	"Indicate or select the employees ",;
			"categories to filter the data." }
cHelp := ".RHCATEG."
PutSX1Help("P"+cHelp,aHelp,aHelpI,aHelpE)	 
/*
Ŀ
           Grupo  Ordem Pergunta Portugues Pergunta Espanhol Pergunta Ingles Variavel Tipo Tamanho  Decimal Presel  GSC   Valid          Var01      Def01 DefSPA1  DefEng1  Cnt01  Var02  Def02 DefSpa2 DefEng2 Cnt02 Var03 Def03  DefSpa3  DefEng3  Cnt03 Var04 Def04 DefSpa4 DefEng4 Cnt04  Var05  Def05  DefSpa5 DefEng5 Cnt05  XF3 GrgSxg cPyme aHelpPor aHelpEng aHelpSpa cHelp    
*/
Aadd(aRegs,{cPerg	,"11"	,"Imprimir Pontos ?"		,"Imprimir Puntos ?" 			,"Print Points?"			,"mv_chb","N"	,1			,0		,1		,"C"	,""				,"MV_PAR11"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".CSR02017."})
Aadd(aRegs,{cPerg	,"12"	,"Impr. Fator Detalhado ? "	,"Impr. Factor Detallado ? " 	,"Print detailed factor ? "	,"mv_chc","N"	,1			,0		,1		,"C"	,""				,"MV_PAR12"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".CSR02018."})
Aadd(aRegs,{cPerg	,"13"	,"Obs. Fator Funcionario ?"	,"Obs. Factor empleado ?   " 	,"Employee factor observ.?"	,"mv_chd","N"	,1			,0		,1		,"C"	,""				,"MV_PAR13"	,"Sim"				,"Si"				,"Yes"				,""	   			,""		,"Nao"				,"No"				,"No"			,""			,""		,""					,""					,""				,""		,""		,""			,""			,""			,""		,""     ,""			,""			,""			,""		,""	,"","S"	,{}			,{}			,{}			,".CSR02019."})

ValidPerg(aRegs,"CSR20R",.F.)

Return Nil
