#INCLUDE "Protheus.ch"
#INCLUDE "CSAR040.CH"      

/*


Ŀ
Programa   CSAR040   Autor  Eduardo Ju             Data  07/08/06 
Ĵ
Descrio  Relatorio de Pontuacao de Funcionarios                     
Ĵ
Sintaxe    CSAR040                                                    
Ĵ            
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
Francisco Jr13/10/0925338/Compatibilizacao para uso Corporativo     
ٱ

*/  

Function CSAR040()

Local oReport
Local aArea := GetArea()
Private nTotFunc 	:= 0 
Private nTotCarg 	:= 0

If FindFunction("TRepInUse") .And. TRepInUse()	//Verifica se relatorio personalizavel esta disponivel
	//Ŀ
	// Verifica as perguntas selecionadas                           
	//
	
	Pergunte("CSR40R",.F.)
	oReport := ReportDef()
	oReport:PrintDialog()	
Else
	CSAR040R3()	
EndIf  

RestArea( aArea )

Return

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  07/08/06 
Ĵ
Descrio Definicao do Componente de Impressao do Relatorio           
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function ReportDef()

Local oReport
Local oSection1	
Local aOrdem    := {}

//Ŀ
//Criacao do componente de impressao                                      
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
oReport:=TReport():New("CSAR040",STR0001,"CSR40R",{|oReport| PrintReport(oReport)},OemToAnsi(STR0025)+" - "+STR0002+" "+STR0003)	//"Relao de Pontos do Cargo e do Funcionrio"#"Ser impresso de acordo com os parametros solicitados pelo usuario"
Pergunte("CSR40R",.F.)

Aadd( aOrdem, STR0004)	// "Filial + Matricula"
Aadd( aOrdem, STR0005)	// "Nome"                 
Aadd( aOrdem, STR0006)	// "C.Custo+Nome"         
Aadd( aOrdem, STR0007)	// "Funcao + Nome" 
//-- Foi desabilitada a ordem por pontos pois na R4 nao tem como ordernar por pontos.
//Aadd( aOrdem, STR0008)	// "Pontos"

//Ŀ
// Criacao da Primeira Secao: "Pontuacao do Funcionario" 
// 
oSection1 := TRSection():New(oReport,STR0013,{"SRA","SQ8","SQ3","SQ4"},aOrdem,/*Campos do SX3*/,/*Campos do SIX*/)	
oSection1:SetTotalInLine(.F.)  
oSection1:SetHeaderBreak(.T.)    

TRCell():New(oSection1,"RA_FILIAL","SRA")					//Filial do Funcionario
TRCell():New(oSection1,"RA_MAT","SRA",STR0019)				//Matricula do Funcionario
TRCell():New(oSection1,"RA_NOME","SRA","")					//Nome do Funcionario
TRCell():New(oSection1,"Q4_PONTOS","SQ4",STR0020,,,,{|| Cs040TotCarg() })//Pontos do Cargo 
TRCell():New(oSection1,"Q8_PONTOS","SQ8",STR0021,,10,,{|| Cs040TotFunc() })//Pontos do Funcionario 
TRCell():New(oSection1,"NUM_ANOS","   ",STR0022,,10,,{|| Cs040Anos() }) //Meses/Anos Trabalhados
TRCell():New(oSection1,"VARIAC","   ",STR0023,"@E 999.99",8,,{|| Round((nTotFunc/nTotCarg ) *100,2) }) //Meses/Anos Trabalhados

#IFNDEF TOP
	TRPosition():New(oSection1,"SQ3",1,{|| RhFilial("SQ3",SRA->RA_FILIAL) + SRA->RA_CARGO})
	TRPosition():New(oSection1,"SI3",1,{|| RhFilial("SI3",SRA->RA_FILIAL) + SRA->RA_CC})   
	TRPosition():New(oSection1,"SQ4",2,{|| RhFilial("SQ4",SRA->RA_FILIAL) + SRA->RA_CARGO + SRA->RA_CC})
	TRPosition():New(oSection1,"SQ8",1,{|| RhFilial("SQ8",SRA->RA_FILIAL) + SRA->RA_MAT})
#ENDIF	

//Ŀ
// Total de Funcionarios  
// 
oSection1:SetTotalText({|| STR0024})	//Total de Funcionarios   
TRFunction():New(oSection1:Cell("RA_MAT"),/*cId*/,"COUNT",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection1:Cell("Q4_PONTOS"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,"@E 9999.99",/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection1:Cell("Q8_PONTOS"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)

Return oReport 

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  07.08.06 
Ĵ
Descrio Impressao do Relatorio                                      
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function PrintReport(oReport)

Local oSection1 := oReport:Section(1)
Local nOrdem  	:= osection1:GetOrder()
Local cFiltro   := "" 
Local cArq1   	:= ""
Local cArq2  	:= ""
Local cArq3   	:= ""
Local cArq4   	:= ""
Local cArq5   	:= ""
Local cInd		:= ""

//Ŀ
// Variaveis utilizadas para parametros                                          
// mv_par01        //  Filial?                                                   
// mv_par02        //  Centro de Custo ?                                         
// mv_par03        //  Funcao?                                                   
// mv_par04        //  Dt.Admissao?                                              
// mv_par05        //  Listar Func.com? 1-Pontos Acima; 2-Pontos Abaixo; 3-Ambos 
// 

//Ŀ
// Transforma parametros Range em expressao (intervalo) 
//
MakeAdvplExpr("CSR40R")	                                  

If !Empty(mv_par01)	//RA_FILIAL
	cFiltro:= mv_par01
EndIf  

If !Empty(mv_par02)	//RA_CC
	cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
	cFiltro += mv_par02
EndIf  

If !Empty(mv_par03) //RA_CODFUNC
	cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
	cFiltro += mv_par03
EndIf

If !Empty(mv_par04) //RA_ADMISSA
	cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
	cFiltro += mv_par04
EndIf              
           
cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
cFiltro += 'RA_SITFOLH $ "'+ " *A*F" + '"	
    
//Ŀ
// Ordem do Relatorio    
// 1-Filial+Matricula   
// 2-Nome               
// 3-C.Custo + Nome     
// 4-Funcao + Nome      
// 5-Pontos do Cargo    
//
//Obs.: Nao sera considerado Ordem 5 no RP-R4
//cInd := 'TR_PONCAR'
//cArq5 := CriaTrab(Nil, .F.)                                                 
//IndRegua("SRA",cArq5,cInd,,,STR0018) //"Selecionando Registros..." 

If nOrdem == 1
	cInd := 'RA_FILIAL + RA_MAT'
ElseIf nOrdem == 2
	cInd := 'RA_NOME'
ElseIf nOrdem == 3
	cInd := 'RA_CC + RA_NOME'
ElseIf nOrdem == 4
	cInd := 'RA_CODFUNC + RA_NOME'
EndIf

oSection1:SetFilter(cFiltro, cInd) 
 
DbSelectArea("SRA")
DbSetOrder(nOrdem)

//Ŀ
// Listar Func.com? 1-Pontos Acima; 2-Pontos Abaixo; 3-Ambos 
//
If mv_par05 == 1
	oSection1:SetLineCondition({|| oSection1:EvalCell(), mv_par05 == 1 .And. oSection1:Cell("VARIAC"):GetValue(.T.) >= 100 })
ElseIf mv_par05 == 2
	oSection1:SetLineCondition({|| oSection1:EvalCell(), mv_par05 == 2 .And. oSection1:Cell("VARIAC"):GetValue(.T.) <= 100 })	   	
EndIf	

oReport:SetMeter(SRA->(LastRec()))	
oSection1:Print() //Imprimir  	

Return Nil

/*

Ŀ
Funcao    Cs040Anos()  Autor  Eduardo Ju           Data  07.08.06 
Ĵ
Descricao  Calcula Tempo de Servico no Emprego Atual                  
Ĵ
Parametros                                                            
Ĵ
 Uso       CSAR040                                                    
ٱ

*/
Static Function Cs040Anos() 

Local nMeses 	:= 0
Local cSvAlias 	:= Alias()

If !Empty(SRA->RA_DEMISSA)
	nMeses := SRA->RA_DEMISSA - SRA->RA_ADMISSA	
Else
	nMeses := dDataBase - SRA->RA_ADMISSA
Endif	
	
nMeses := Noround(nMeses/365,2)

DbSelectArea(cSvAlias)

Return nMeses 

/*

Ŀ
Funcao    Cs040TotCarg Autor  Eduardo Ju           Data  07.08.06 
Ĵ
Descricao Somatoria da Pontuacao do Cargo.                            
Ĵ
Parametros                                                            
Ĵ
 Uso       CSAR040                                                    
ٱ

*/
Static Function Cs040TotCarg()

Local nx		:= 0
Local cSvAlias 	:= Alias()
Local aFator	:= {}   

nTotCarg := 0

FMontaFator(SRA->RA_FILIAL,SRA->RA_CODFUNC,,SRA->RA_MAT,,,@aFator,SRA->RA_CC)

For nx := 1 To Len(aFator)
	nTotCarg := nTotCarg + aFator[nx][5]	//5 Pontos do Cargo		
Next nx

DbSelectArea(cSvAlias)

Return nTotCarg        

/*

Ŀ
Funo    Cs040TotFunc Autor  Eduardo Ju           Data  07.08.06 
Ĵ
Descrio Somatoria da Pontuacao do Funcionario                       
Ĵ
Parametros                                                            
Ĵ
 Uso       CSAR040                                                    
ٱ

*/
Static Function Cs040TotFunc()

Local nx			:= 0
Local cSvAlias 		:= Alias()
Local aFator		:= {}  

nTotFunc 	:= 0

FMontaFator(SRA->RA_FILIAL,SRA->RA_CODFUNC,,SRA->RA_MAT,,,@aFator,SRA->RA_CC)

For nx := 1 To Len(aFator)
	nTotFunc := nTotFunc + aFator[nx][8]	//8 Pontos do Funcionario
Next nx

DbSelectArea(cSvAlias)

Return nTotFunc



/*


Ŀ
Funo	  CSAR040R3 Autor  R.H. - Cristina  Ogura Data  02.10.00 
Ĵ
Descrio  Relatorio de Pontuacao de Funcionarios	      			  
Ĵ
Sintaxe	  CSAR040R3(void)											  
Ĵ
 		ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.			  
Ĵ
Programador  Data	 BOPS   Motivo da Alteracao			 		  
Ĵ
			   			   										  
ٱ

*/
Function CSAR040R3()

Local cDesc1  := STR0001		//"Relao de Pontos do Cargo e do Funcionrio"
Local cDesc2  := STR0002		//"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  := STR0003		//"usuario."
Local cString := "SRA"
Local aOrd	:= {STR0004,STR0005 ,STR0006,STR0007,STR0008}  //"Filial + Matricula"###"Nome"###"C.Custo+Nome"###"Funcao + Nome"###"Pontos"

Private aReturn  := {STR0009,1,STR0010,2,2,1,"",1 } //"Zebrado"###"Administrao"
Private NomeProg := "CSAR040"
Private aLinha	 := {}
Private nLastKey := 0
Private cPerg	 := "CSR040"
Private nOrdem 	 := 1
        
Private AT_PRG	 := "CSAR040"
Private wCabec0  := 2
Private wCabec1  := STR0011		//"                                             Pontuacao    No.   "
Private wCabec2  := STR0012		//"Fil. Matric Nome do Funcionario            Cargo.  Func.  Anos   %Func."
Private Contfl   := 1
Private Li		 := 0
Private nTamanho := "P"
Private TITULO   := Upper(STR0013)		//" PONTUACAO DE FUNCIONARIOS "

Private cFilDe, cFilAte, cCCDe, cCCAte, cFunDe, cFunAte
Private dDtDe, dDtAte, nTipo

pergunte("CSR040",.F.)             

//Ŀ
// Variaveis utilizadas na pergunte                                 
// mv_par01				// Filial De                             
// mv_par02				// Filial Ate                            
// mv_par03				// Centro de Custo De                    
// mv_par04				// Centro de Custo Ate                   
// mv_par05				// Funcao De                             
// mv_par06				// Funcao Ate                            
// mv_par07				// Dt Admissao De                        
// mv_par08				// Dt Admissao Ate                       
// mv_par09 				// Lista Func. com 	1-Pontos Acima       
//                             		        2-Pontos Abaixo      
// 											3-Ambos				 
//

//Ŀ
// Envia controle para a funcao SETPRINT						 
//
wnrel:="CSAR040"            //Nome Default do relatorio em Disco
wnrel:=SetPrint(cString,wnrel,cPerg,@TITULO,cDesc1,cDesc2,cDesc3,.F.,aOrd)

//Ŀ
// Carregando variaveis mv_par?? para Variaveis do Sistema.	 
//
If(!Empty(mv_par01),cFilDe:=mv_par01,cFilDe:=Space(FWGetTamFilial))
If(!Empty(mv_par02),cFilAte:=mv_par02,cFilAte:=Replicate("Z", FWGetTamFilial))
If(!Empty(mv_par03),cCCDe:=mv_par03,cCCDe:="         ")
If(!Empty(mv_par04),cCCAte:=mv_par04,cCCAte:="999999999")
If(!Empty(mv_par05),cFunDe:=mv_par05,cFunDe:="    ")
If(!Empty(mv_par06),cFunAte:=mv_par06,cFunAte:="9999")
If(!Empty(mv_par07),dDtDe:=mv_par07,dDtDe:=CTOD("01/01/00"))
If(!Empty(mv_par08),dDtAte:=mv_par08,dDtAte:=CTOD("31/12/00"))
If(!Empty(mv_par09),nTipo:=mv_par09,nTipo:=3)

nOrdem  := aReturn[8]

If 	nLastKey == 27
	Return Nil
EndIf

SetDefault(aReturn,cString)

If 	nLastKey == 27
	Return Nil
EndIf

RptStatus({|lEnd| Cs040Imp()},TITULO)

Return

/*


Ŀ
Funo	  CS040Imp  Autor  R.H. - Cristina Ogura  Data  02.10.00 
Ĵ
Descrio  Imprime a  Pontuacao dos  Funcionarios 					  
Ĵ
Sintaxe	  Cs040Imp()												  
Ĵ
 Uso       Generico 											  	  
ٱ

*/
Function Cs040Imp()
Local nMeses	:= 0
Local nNecessar := 0
Local nAtingido := 0
Local aFields  	:= {}
Local aFator	:= {}
Local cAcessaSRA:= &("{ || " + ChkRH(FunName(),"SRA","2") + "}")
Local nx		:= 0

Private cArqFec := "PONTOS" + GetDBExtension()
Private cArqNtx, cTRPNtx

Aadd(aFields,{"TR_FILIAL"	,"C",FWGETTAMFILIAL,0})
Aadd(aFields,{"TR_MAT"		,"C",06,0})          
Aadd(aFields,{"TR_NOME"		,"C",30,0})          
Aadd(aFields,{"TR_CC"		,"C",09,0})          
Aadd(aFields,{"TR_PONCAR"	,"N",06,2})          
Aadd(aFields,{"TR_PONFUN"	,"N",06,2})          
Aadd(aFields,{"TR_TEMPO"	,"N",08,2})          
Aadd(aFields,{"TR_FUNCAO"	,"C",04,0})          
Aadd(aFields,{"TR_VARIAC"	,"N",06,2})          

dbCreate(cArqFec,aFields)

DbUseArea(.T.,,cArqFec,"TRP",.F.)

dbSelectArea("TRP")      

cIndCond:= "TR_FILIAL + TR_MAT"
cArqNtx := CriaTrab(NIL,.f.)
cFor 	:= ""

IndRegua("TRP",cArqNtx,cIndCond,,cFor,STR0016)		//"Selecionando Registros..."

dbGoTop()

dbSelectArea("SRA")
dbSetOrder(7)
dbGoTop()

SetRegua(SRA->(RecCount()))

cFuncao := "!!!!"

While	! Eof()                          

	nAtingido := 0
	nMeses    := 0

	//Ŀ
	// Movimenta Regua de Processamento                             
	//
	IncRegua()
	
	If 	SRA->RA_SITFOLH$ 'D*E*T' 	.Or.;
		SRA->RA_ADMISSA < dDtDe 	.Or.;
		SRA->RA_ADMISSA > dDtAte 	.Or.;
		SRA->RA_FILIAL < cFilDe 	.Or.;
		SRA->RA_FILIAL > cFilAte 	.Or.;
		SRA->RA_CC < cCcDe 			.Or.;
		SRA->RA_CC > cCcAte 		.Or.;
		SRA->RA_CODFUNC < cFunDe 	.Or.;
		SRA->RA_CODFUNC > cFunAte
		dbSkip()
		Loop
	EndIf
	
	If !Eval(cAcessaSRA)
		dbSkip()  
		Loop
	EndIf
	
	nNecessar  	:= 0	
	nAtingido 	:= 0
	
	FMontaFator(SRA->RA_FILIAL,SRA->RA_CODFUNC,,SRA->RA_MAT,,,@aFator,SRA->RA_CC)
	
	For nx := 1 To Len(aFator)
		nNecessar := nNecessar + aFator[nx][5]			
		nAtingido := nAtingido + aFator[nx][8]	
	Next nx
 
	// Calcula Tempo de Servico de emprego atual
	dbSelectArea("SRA")
	If !Empty(SRA->RA_DEMISSA)
		nMeses := SRA->RA_DEMISSA - SRA->RA_ADMISSA	
	Else
		nMeses := dDataBase - SRA->RA_ADMISSA
	Endif	
	
	nMeses := Noround(nMeses/365,2)

	// Grava Arquivo Temporrio de pontuacao   
	dbSelectArea( "TRP" )
	RecLock( "TRP",.T. )
		TRP->TR_FILIAL	:= SRA->RA_FILIAL
		TRP->TR_MAT		:= SRA->RA_MAT
		TRP->TR_NOME	:= SRA->RA_NOME
		TRP->TR_CC		:= SRA->RA_CC
		TRP->TR_PONCAR	:= nNecessar
		TRP->TR_PONFUN	:= nAtingido	
		TRP->TR_VARIAC	:= Round((nAtingido / nNecessar) * 100,2)	
		TRP->TR_TEMPO	:= nMeses
		TRP->TR_FUNCAO	:= SRA->RA_CODFUNC
	MsUnLock()

	dbSelectArea( "SRA" )
	dbSkip()
Enddo

//--Impressao do Relatorio
FImpPon()

//--Termino do Relatorio                                         
IMPR("","F")

Set Device To Screen                  

dbSelectArea("TRP")
dbCloseArea()
fErase(cArqNtx + OrdBagExt())
fErase(cArqFec)

fErase(cTRPNtx + OrdBagExt())

dbSelectArea("SRA")
dbSetOrder(1)

If aReturn[5] == 1
	Set Printer To
	Commit
	ourspool(wnrel)
EndIf

MS_FLUSH()

Return

/*


Ŀ
Funo	  FImpPon   Autor  R.H. - Cristina Ogura  Data  02.10.00 
Ĵ
Descrio  Imprime a  Pontuacao dos  Funcionarios 					  
Ĵ
Sintaxe	  FImpPon() 												  
Ĵ
 Uso       CSAR040  											  	  
ٱ

*/
Static Function FImpPon()
Local nTotCar := 0.00
Local nTotFun := 0.00
Local nFunc   := 0

dbSelectArea("TRP")
If 	nOrdem == 1
	cIndCond:= "TR_FILIAL + TR_MAT"
ElseIf nOrdem == 2
	cIndCond := "TR_NOME"
ElseIf nOrdem == 3
	cIndCond := "TR_CC + TR_NOME"
Elseif nOrdem == 4
	cIndCond := "TR_FUNCAO + TR_NOME"
Elseif nOrdem == 5
	cIndCond := "TR_PONCAR"
Endif			

cTRPNtx  := CriaTrab(NIL,.f.)
IndRegua("TRP",cTRPNtx,cIndCond,,,STR0016)		//"Selecionando Registros..."
dbGoTop()

SetRegua(TRP->(RecCount()))

While ! Eof()

	IncRegua()
	
	If 	(nTipo == 1 .And. TRP->TR_VARIAC >= 100.00) .Or. ;
		(nTipo == 2 .And. TRP->TR_VARIAC <= 100.00) .Or. ;
		nTipo = 3

		cDet:= " "+TRP->TR_FILIAL+Space(2)+TRP->TR_MAT+Space(1)+TRP->TR_NOME+Space(1)
		cDet+=	Transform(TRP->TR_PONCAR,"999.99")+Space(01)
		cDet+=	Transform(TRP->TR_PONFUN,"999.99")+Space(01)
		cDet+=	Transform(TRP->TR_TEMPO,"999.99")+Space(02)
		cDet+= 	Transform(TRP->TR_VARIAC,"999.99")
					
		IMPR(cDet,"C")
		
		nTotCar := nTotCar + TRP->TR_PONCAR
		nTotFun := nTotFun + TRP->TR_PONFUN
		nFunc   := nFunc + 1

	EndIf
	
	dbSelectArea("TRP")
	dbSkip()
EndDo

IMPR(" ","C")
IMPR(Repl("-",78),"C")
cDet := Space(15)+STR0014+Transform(nFunc,"99999")			//"Total de Funcionarios           : "
IMPR(cDet,"C")

cDet := Space(15)+STR0015+Transform(nTotCar,"@E 99,999.99")	//"Total de Pontos do Cargo        : "
IMPR(cDet,"C")

cDet := Space(15)+STR0017+Transform(nTotFun,"@E 99,999.99")	//"Total de Pontos Funcionarios    : "
IMPR(cDet,"C")

IMPR(Repl("-",78),"C")

Return 			
