#INCLUDE "Protheus.ch"
#INCLUDE "CSAR050.CH"  

/*


Ŀ
Programa   CSAR050   Autor  Eduardo Ju             Data   09/08/06  
Ĵ
Descricao  Relatorio de Aumento Programado dos funcionarios             
Ĵ
Sintaxe    CSAR050(void)                                                
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.               
Ĵ
Programador  Data      BOPS   Motivo da Alteracao                     
Ĵ
Tania       27/09/2006100336Acertos no Ajusta do SX1, inclusao das con
                            sultas F3, e helps das perguntas.         
Alexandre J.30/10/2007133146Ajuste no conteudo a ser passado na funo
Conselvan                   DescCC(), quando seleciona a opo de     
                            ordenao por Centro de Custo.            
Leandro Dr. 22/05/2009008040Ajuste para inclusao do campo CARGO.       
Francisco Jr13/09/2009025338Compatibilizar para versao corporativa.   
Ĵ
Programador  Data      FNC	   Motivo da Alteracao						
Ĵ
Luis Ricardo15/03/2011004349Ajuste na funcao Cs050Imp para nao gerar	
Cinalli                /2011error.log da var FWGetTamFilial na impres.
                            normal. Na personalizavel nao ocorre.		
Raquel Hager19/03/2012005333Ajuste para impressao correta do campo    
		           TEPWF5 /2012|X5_DESCRI a depender do idioma utilizado  
		                       pela localizacao atraves da funcao           
		                       fDescSX5 em RHLIBSX3.                     
ٱ

*/  

Function CSAR050()

Local oReport
Local aArea := GetArea()

If !(VerificaRB7())
	MsgInfo(STR0026)
	Return
EndIf           

If FindFunction("TRepInUse") .And. TRepInUse()	//Verifica se relatorio personalizavel esta disponivel
	//Ŀ
	// Verifica as perguntas selecionadas                           
	//
	
	Pergunte("CSR50R",.F.)
	oReport := ReportDef()
	oReport:PrintDialog()	
Else
	CSAR050R3()	
EndIf  

RestArea( aArea )

Return

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  09.08.06 
Ĵ
Descrio Definicao do Componente de Impressao do Relatorio           
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function ReportDef()

Local oReport
Local oSection1	
Local oSection2
Local aOrdem    := {}  
Local cAliasQry := GetNextAlias() 
Local cAliAsRB7 := cAliasQry
Local cAliasSRA := cAliasQry  
Local cAliasSRJ := cAliasQry
Local cAliasSI3 := cAliasQry
Local cAliasSQ3 := cAliasQry 
Local cAliasSX5 := cAliasQry    

#IFNDEF TOP   
	cAliasRB7 := "RB7"
	cAliasSRA := "SRA" 
	cAliasSRJ := "SRJ"
	cAliasSI3 := "SI3"
	cAliasSQ3 := "SQ3"
	cAliasSX5 := "SX5" 	
#ENDIF	

//Ŀ
//Criacao do componente de impressao                                      
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
oReport:=TReport():New("CSAR050",STR0009,"CSR50R",{|oReport| PrintReport(oReport,cAliasQry)},STR0002+" "+STR0003)	// "Aumentos Salariais Programado"#"Ser impresso de acordo com os parametros solicitados pelo usuario"
Pergunte("CSR50R",.F.)

Aadd( aOrdem, STR0004)	// "Matricula"
Aadd( aOrdem, STR0005)	// "Funcao"                 
Aadd( aOrdem, STR0006)	// "Centro de Custo"         

//Ŀ
// Criacao da Primeira Secao: "Pontuacao do Funcionario" 
// 
oSection1 := TRSection():New(oReport,STR0020,{cAliasSRA,cAliasSRJ,cAliasSI3},aOrdem,/*Campos do SX3*/,/*Campos do SIX*/)	//Funcionario	
oSection1:SetTotalInLine(.T.)  
oSection1:SetHeaderBreak(.T.)   

TRCell():New(oSection1,"RA_FILIAL",cAliasSRA)					//Filial do Funcionario
TRCell():New(oSection1,"RA_MAT",cAliasSRA)						//Matricula do Funcionario
TRCell():New(oSection1,"RA_NOME",cAliasSRA,"")					//Nome do Funcionario
TRCell():New(oSection1,"RA_SALARIO",cAliasSRA)					//Salario do Funcionario
TRCell():New(oSection1,"RA_CATFUNC",cAliasSRA,STR0021)	   		//Categoria Funcional do Funcionario
TRCell():New(oSection1,"RA_CODFUNC",cAliasSRA,STR0022)			//Funcao do Funcionario
TRCell():New(oSection1,"RJ_DESC",cAliasSRJ,"")					//Descricao da Funcao do Funcionario   
TRCell():New(oSection1,"RA_CC",cAliasSRA)						//Centro De Custo do Funcionario
TRCell():New(oSection1,"I3_DESC",cAliasSI3,"") 		   		//Descricao do CC

#IFNDEF TOP  
	TRPosition():New(oSection1,"SRJ",1,{|| xFilial("SRJ") + SRA->RA_CODFUNC})
	TRPosition():New(oSection1,"SI3",1,{|| xFilial("SI3") + SRA->RA_CC})
#ENDIF	

//Ŀ
// Criacao da Segunda Secao: Aumento Programado 
//
oSection2 := TRSection():New(oSection1,STR0009,{cAliasRB7,cAliasSX5},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)		//Aumento Programado
oSection2:SetTotalInLine(.T.)  
oSection2:SetHeaderBreak(.T.)
oSection2:SetLeftMargin(3)	//Identacao da Secao
       
TRCell():New(oSection2,"RB7_DATALT","RB7",STR0023)				//Data da Alteracao Salarial
TRCell():New(oSection2,"RB7_TPALT","RB7",STR0024)				//Tipo da Alteracao Salarial 
TRCell():New(oSection2,fDescSX5(2),"SX5","",,20)				//Descricao do Tipo da Alteracao Salarial 
TRCell():New(oSection2,"RB7_PERCEN","RB7")						//Aumento em %
TRCell():New(oSection2,"RB7_SALARI","RB7")						//Salario 
TRCell():New(oSection2,"RB7_CATEG","RB7",STR0021)				//Categoria Funcional   
TRCell():New(oSection2,"RB7_FUNCAO","RB7",STR0022)				//Codigo da Funcao
TRCell():New(oSection2,"RJ_DESC","SRJ","")						//Descricao da Funcao 
TRCell():New(oSection2,"RB7_CARGO","RB7",STR0025)				//Codigo do Cargo
TRCell():New(oSection2,"Q3_DESCSUM","SQ3","")					//Descricao do Cargo
TRCell():New(oSection2,"RB7_ATUALI","RB7")						//Atualizado (Sim ou Nao)
         
#IFNDEF TOP 
	TRPosition():New(oSection2,"SX5",1,{|| xFilial("SX5") + "41" + RB7->RB7_TPALT})
	TRPosition():New(oSection2,"SRJ",1,{|| xFilial("SRJ") + RB7->RB7_FUNCAO})
#ENDIF

Return oReport 

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  09.08.06 
Ĵ
Descrio Impressao do Relatorio                                      
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function PrintReport(oReport,cAliasQry)

Local oSection1 := oReport:Section(1)
Local oSection2 := oReport:Section(1):Section(1)  
Local nOrdem  	:= osection1:GetOrder()      
Local cCampo  := "%" + fDescSX5(2) + "%"   

#IFDEF TOP
	Local lQuery    := .F. 
	Local cOrder	:= "" 
	Local cSitQuery	:= ""
#ELSE
	Local cFiltroSRA:= ""
	Local cFiltroRB7:= ""
	Local cIndCond	:= "" 
#ENDIF

//Ŀ
// Variaveis utilizadas para parametros                                          
// mv_par01        //  Filial?                                                   
// mv_par02        //  Centro de Custo ?                                         
// mv_par03        //  Funcao?                                                   
// mv_par04        //  Dt.Admissao?                                              
// mv_par05        //  Periodo?                                                  
// mv_par06        //  Listar? 1-Ja atualizados; 2-No atualizados; 3-Ambos      
// 

#IFNDEF TOP
	//Ŀ
	// Transforma parametros Range em expressao (intervalo) 
	//
	MakeAdvplExpr("CSR50R")	                                  
	
	If !Empty(mv_par01)	//RA_FILIAL
	cFiltroSRA:= mv_par01 + ' .And. '
	EndIf  
	
	If !Empty(mv_par02)	//RA_CC
	cFiltroSRA += mv_par02 + ' .And. '
	EndIf  
	
	If !Empty(mv_par03)	//RA_CODFUNC
	cFiltroSRA += mv_par03 + ' .And. '
	EndIf  
	
	If !Empty(mv_par04)	//RA_ADMISSA
	cFiltroSRA += mv_par04 + ' .And. '
	EndIf  	

	cFiltroSRA += 'RA_SITFOLH $ "'+ " *A*F" + '"	
	
	If !Empty(mv_par05)	//RB7_DATALT
	cFiltroRB7 += mv_par05
	EndIf  
	
	//Ŀ
	// Ordem do Relatorio   
	//
	If nOrdem == 1	
		oSection1:SetIdxOrder(1)	//Matricula
	ElseIf nOrdem == 2
	 	oSection1:SetIdxOrder(7)	//Funcao
	ElseIf nOrdem == 3
		oSection1:SetIdxOrder(2)	//Centro de Custo	
	EndIf
	
	//Ŀ
	// Filtro para a Tabela Principal da Secao Pai  
	//
	oSection1:SetFilter(cFiltroSRA)	  
	//Ŀ
	// Filtro para a Tabela Secundaria da Secao Filha  
	//
	oSection1:SetFilter(cFiltroRB7,,,"RB7")	
	
	//Ŀ
	// Condicao para Impressao   
	//
	oSection1:SetLineCondition({|| RB7->(DbSeek(SRA->RA_FILIAL + SRA->RA_MAT)) }) 
	
	//Ŀ
	// Listar: 1-Ja atualizados; 2-No atualizados; 3-Ambos  
	//   
	If mv_par06 == 1
   		oSection2:SetLineCondition({|| RB7->RB7_ATUALI == "S" }) 
   	ElseIf mv_par06 == 2	
   		oSection2:SetLineCondition({|| RB7->RB7_ATUALI == "N" }) 	
   	EndIf			
	 
	oSection2:SetRelation({|| SRA->RA_FILIAL + SRA->RA_MAT},"RB7",1,.T.)    
	
	oSection2:SetParentFilter({|cParam| RB7->RB7_FILIAL+RB7->RB7_MAT == cParam},{|| SRA->RA_FILIAL+SRA->RA_MAT})
		                              
	oReport:SetMeter(SRA->(LastRec()))

	oSection1:Print() //Imprimir 
	
#ELSE	
	//Ŀ
	// Transforma parametros Range em expressao SQL 
	//
	MakeSqlExpr("CSR50R")    
	
	//-- Filtragem do relatrio
	//-- Query do relatrio da secao 1
	lQuery := .T.         

	If nOrdem == 1  
		cOrder := "%RA_FILIAL,RA_MAT%" 
	ElseIf nOrdem == 2		
		cOrder := "%RA_FILIAL,RA_CODFUNC%" 	       
	ElseIf nOrdem == 3
		cOrder := "%RA_FILIAL,RA_CC,RA_MAT%"
	EndIf		

	//Ŀ
	// Situacao do Funcionario  
	//	
	cSitQuery += "%' ','A','F'%" 
		                                           
	oReport:Section(1):BeginQuery()	

	BeginSql Alias cAliasQry	
		SELECT	RA_FILIAL,RA_MAT,RA_NOME,RA_SALARIO,RA_CATFUNC,RA_CODFUNC,RJ_DESC,
				RA_CC,RA_CARGO,I3_DESC,RB7_DATALT,RB7_FILIAL,RB7_MAT,RB7_TPALT,%exp:cCampo%,RB7_PERCEN,RB7_SALARI,
				RB7_CATEG,RB7_FUNCAO,RJ_DESC,RB7_ATUALI,RB7_CARGO,Q3_DESCSUM
		FROM 	%table:SRA% SRA
		LEFT JOIN %table:SRJ% SRJ
			ON RJ_FILIAL = %xFilial:SQ3%
			AND RJ_FUNCAO = RA_CODFUNC
			AND SRJ.%NotDel%			
		LEFT JOIN %table:SI3% SI3
			ON I3_FILIAL = %xFilial:SI3%
			AND I3_CUSTO = RA_CC
			AND SI3.%NotDel%
		LEFT JOIN %table:RB7% RB7
			ON RB7_FILIAL = RA_FILIAL
			AND RB7_MAT = RA_MAT
			AND RB7.%NotDel% 
		LEFT JOIN %table:SQ3% SQ3
			ON Q3_FILIAL = %xFilial:SQ3%
			AND Q3_CARGO = RB7_CARGO
			AND Q3_CC = RA_CC
			AND SQ3.%NotDel% 			
		LEFT JOIN %table:SX5% SX5
			ON X5_FILIAL = %xFilial:SX5%
			AND X5_TABELA = '41'
			AND X5_CHAVE = RB7_TPALT
			AND SX5.%NotDel%		
			
		WHERE SRA.RA_SITFOLH IN (%exp:Upper(cSitQuery)%) AND  
			SRA.%NotDel%   													
		ORDER BY %Exp:cOrder%                 				
	EndSql
	
	//Ŀ
	//Metodo EndQuery ( Classe TRSection )                                    
	//Prepara o relatrio para executar o Embedded SQL.                       
	//ExpA1 : Array com os parametros do tipo Range                           
	//
	oReport:Section(1):EndQuery({mv_par01,mv_par02,mv_par03,mv_par04,mv_par05})	/*Array com os parametros do tipo Range*/
		
	//Ŀ
	// Inicio da impressao do fluxo do relatrio 
	//
	oReport:SetMeter(SRA->(LastRec()))

	//Ŀ
	// Utiliza a query do Pai  
	//
	oSection2:SetParentQuery()                              
	
	//Ŀ
	// Listar: 1-Ja atualizados; 2-No atualizados; 3-Ambos  
	//
	If mv_par06 == 1	
   		oSection2:SetLineCondition({|| (cAliasQry)->RB7_ATUALI == "S" }) 
   	ElseIf mv_par06 == 2	
   		oSection2:SetLineCondition({|| (cAliasQry)->RB7_ATUALI == "N" }) 	
   	EndIf			
	 	
	oSection2:SetParentFilter({|cParam| (cAliasQry)->RB7_FILIAL+(cAliasQry)->RB7_MAT == cParam},{|| (cAliasQry)->RA_FILIAL+(cAliasQry)->RA_MAT})
	
	oSection1:Print()	 //Imprimir
#ENDIF

Return Nil


/*

Ŀ
Funo	  CSAR050R3 Autor  R.H. - Cristina  Ogura Data  02.10.00 
Ĵ
Descrio  Relatorio de Aumento Programado dos funcionarios			  
Ĵ
Sintaxe	  CSAR050R3(void)											  
Ĵ
 		ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.			  
Ĵ
Programador  Data	 BOPS   Motivo da Alteracao			 		  
Ĵ
Emerson G.R.17/01/03xxxxxxAumentar Picture de valores salariais.    
ٱ

*/
Function CSAR050R3()  

Local cDesc1  	:= STR0001		//"Relao de Aumentos Salariais Programados para os Funcionarios."
Local cDesc2  	:= STR0002		//"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  	:= STR0003		//"usuario."
Local cString 	:= "SRA"
Local aOrd		:= {STR0004,STR0005,STR0006}  //"Matricula"###"Funcao"###"Centro de Custo"

Private aReturn  := {STR0007,1,STR0008,2,2,1,"",1 } //"Zebrado"###"Administrao"
Private NomeProg := "CSAR050"
Private aLinha	 := {}
Private nLastKey := 0
Private cPerg	 := "CSR050"
Private nOrdem 	 := 1
        
Private AT_PRG	 := "CSAR050"
Private wCabec0  := 1
Private wCabec1  := ""			//"FIL MATRIC NOME DO FUNCIONARIO                SALARIO CAT FUNCAO                    CENTRO DE CUSTO"
								//  99 999999-123456789012345678901234567890 99999999999 123 1234-12345678901234567890 123456789-123456789012345678901234567890
Private Contfl   := 1
Private Li		 := 0
Private nTamanho := "M"
Private TITULO   := STR0009		//" Aumentos salariais programado"

Private cFilDe, cFilAte, cCCDe, cCCAte, cFunDe, cFunAte
Private dDtDe, dDtAte, nTipo, dDtAdmitDe, dDtAdmitAte

//+--------------------------------------------------------------+
// Verifica as perguntas selecionadas                           
//+--------------------------------------------------------------+        

pergunte("CSR050",.F.)             

//Ŀ
// Variaveis utilizadas na pergunte                                 
// mv_par01				// Filial De                             
// mv_par02				// Filial Ate                            
// mv_par03				// Centro de Custo De                    
// mv_par04				// Centro de Custo Ate                   
// mv_par05				// Funcao De                             
// mv_par06				// Funcao Ate                            
// mv_par07				// Periodo De                            
// mv_par08				// Periodo Ate                           
// mv_par09 				// Lista   1-Ja Atualizado      		 
//                             	   2-Nao Atualizados    		 
// 								   3-Ambos	     				 
// mv_par10				// Data Admissao De                      
// mv_par11				// Data Admissao Ate                     
//

//Ŀ
// Envia controle para a funcao SETPRINT						 
//
wnrel:="CSAR050"            //Nome Default do relatorio em Disco
wnrel:=SetPrint(cString,wnrel,cPerg,@TITULO,cDesc1,cDesc2,cDesc3,.F.,aOrd)

//Ŀ
// Carregando variaveis mv_par?? para Variaveis do Sistema.	 
//
cFilDe	:=	If(!Empty(mv_par01),mv_par01,Space(FWGetTamFilial))
cFilAte	:=	If(!Empty(mv_par02),mv_par02,Replicate("Z", fWGetTamFilial))
cCCDe	:=	If(!Empty(mv_par03),mv_par03,"         ")
cCCAte	:=	If(!Empty(mv_par04),mv_par04,"999999999")
cFunDe	:=	If(!Empty(mv_par05),mv_par05,"    ")
cFunAte	:=	If(!Empty(mv_par06),mv_par06,"9999")
dDtDe	:=	If(!Empty(mv_par07),mv_par07,CTOD("01/01/00"))
dDtAte	:=	If(!Empty(mv_par08),mv_par08,CTOD("31/12/00"))
nTipo	:=	If(!Empty(mv_par09),mv_par09,3)
dDtAdmitDe := If(!Empty(mv_par10),mv_par10,CTOD("01/01/00"))
dDtAdmitAte:= If(!Empty(mv_par11),mv_par11,CTOD("31/12/00"))

If 	dDtDe > dDtAte
    Help("",1,"Cs050Data")
    Return Nil
EndIf    

nOrdem  := aReturn[8]

If 	nLastKey == 27
	Return Nil
EndIf

SetDefault(aReturn,cString)

If 	nLastKey == 27
	Return Nil
EndIf

RptStatus({|lEnd| Cs050Imp()},TITULO)

Return

/*


Ŀ
Funo	  CS050Imp  Autor  R.H. - Cristina Ogura  Data  02.10.00 
Ĵ
Descrio  Imprime os aumentos programados dos funcionarios			  
Ĵ
Sintaxe	  Cs050Imp()												  
Ĵ
 Uso       Generico 											  	  
ٱ

*/
Function Cs050Imp()
Local cAcessaRB7:= &("{ || " + ChkRH(FunName(),"RB7","2") + "}")
Local aFields:={}

Private cArqFec := "AUMENTOS"+GetDBExtension()
Private cArqNtx, cTRPNtx

Aadd(aFields,{"TR_FILIAL"	,"C",FWGETTAMFILIAL,0})
Aadd(aFields,{"TR_MAT"		,"C",06,0})          
Aadd(aFields,{"TR_NOME"		,"C",30,0})          
Aadd(aFields,{"TR_FUNCAO"	,"C",05,0})          
Aadd(aFields,{"TR_PERCEN"	,"N",06,2})          
Aadd(aFields,{"TR_SALARI"	,"N",12,2})          
Aadd(aFields,{"TR_CATEG"	,"C",01,0})          
Aadd(aFields,{"TR_CC"		,"C",09,0})          
Aadd(aFields,{"TR_DTALT"	,"D",08,0})          
Aadd(aFields,{"TR_TPALT"	,"C",03,0})          
Aadd(aFields,{"TR_PSAL"		,"N",12,2})          
Aadd(aFields,{"TR_PCATEG"	,"C",01,0})          
Aadd(aFields,{"TR_ATUALIZ"	,"C",01,0})          
Aadd(aFields,{"TR_PFUNCAO"	,"C",05,0})          
Aadd(aFields,{"TR_CARGO"	,"C",05,0})

dbCreate(cArqFec,aFields)
DbUseArea(.T.,,cArqFec,"TRP",.F.)

dbSelectArea("TRP")      

cIndCond:= "TR_FILIAL + TR_MAT"
cArqNtx := CriaTrab(NIL,.f.)
cFor 	:= ""

IndRegua("TRP",cArqNtx,cIndCond,,cFor,STR0010)		//"Selecionando Registros..."

dbGoTop()

dbSelectArea("RB7")
dbSetOrder(1)
dbGoTop()

SetRegua(RB7->(RecCount()))

While	! Eof()

	If !Eval(cAcessaRB7)
		dbSkip()  
		Loop
	EndIf      
	
	If 	RB7->RB7_DATALT  < dDtDe 	.Or.;
		RB7->RB7_DATALT  > dDtAte
		dbSkip()
		Loop
	EndIf	
		
	If	(nTipo=1 .And. RB7->RB7_ATUALI#"S") .Or.;
		(nTipo=2 .And. RB7->RB7_ATUALI="S")
		dbSkip()
		Loop
	EndIf	
	
	dbSelectArea("SRA")
	dbSetOrder(1)
	If 	!dbSeek(RB7->RB7_FILIAL+RB7->RB7_MAT)
	
		dbSelectArea("RB7")
		dbSkip()
		Loop
	EndIf
	
	If 	SRA->RA_SITFOLH$ 'D*E*T' 	.Or.;
		SRA->RA_ADMISSA < dDtAdmitDe 	.Or.;
		SRA->RA_ADMISSA > dDtAdmitAte .Or.;
		SRA->RA_FILIAL < cFilDe 	.Or.;
		SRA->RA_FILIAL > cFilAte 	.Or.;
		SRA->RA_CC < cCcDe 			.Or.;
		SRA->RA_CC > cCcAte 		.Or.;
		SRA->RA_CODFUNC < cFunDe 	.Or.;
		SRA->RA_CODFUNC > cFunAte

		dbSelectArea("RB7")
		dbSkip()
		Loop
	EndIf
	
	IncRegua()
	
	// Grava Arquivo Temporrio de pontuacao   
	dbSelectArea( "TRP" )
	RecLock( "TRP",.T. )
		TRP->TR_FILIAL	:= SRA->RA_FILIAL
		TRP->TR_MAT		:= SRA->RA_MAT
		TRP->TR_NOME	:= SRA->RA_NOME
		TRP->TR_FUNCAO	:= SRA->RA_CODFUNC
		TRP->TR_PERCEN := RB7->RB7_PERCEN 
		TRP->TR_SALARI	:= SRA->RA_SALARIO
		TRP->TR_CATEG	:= SRA->RA_CATFUNC		
		TRP->TR_CC		:= SRA->RA_CC				
		TRP->TR_DTALT	:= RB7->RB7_DATALT
		TRP->TR_TPALT	:= RB7->RB7_TPALT
		TRP->TR_PSAL	:= RB7->RB7_SALARI
		TRP->TR_PCATEG	:= RB7->RB7_CATEG
		TRP->TR_ATUALIZ	:= RB7->RB7_ATUALI
		TRP->TR_PFUNCAO	:= RB7->RB7_FUNCAO		
		If RB7->( Type("RB7_CARGO") ) # "U"
			TRP->TR_CARGO	:= RB7->RB7_CARGO
		EndIf

	MsUnLock()

	dbSelectArea("RB7")
	dbSkip()
Enddo

//--Impressao do Relatorio
FImpAum()

//--Termino do Relatorio                                         
IMPR("","F")

Set Device To Screen                  

dbSelectArea("TRP")
dbCloseArea()
fErase(cArqNtx + OrdBagExt())
fErase(cArqFec)

fErase(cTRPNtx + OrdBagExt())

dbSelectArea("SRA")
dbSetOrder(1)

If aReturn[5] == 1
	Set Printer To
	Commit
	ourspool(wnrel)
EndIf

MS_FLUSH()

Return

/*


Ŀ
Funo	  FImpAum   Autor  R.H. - Cristina Ogura  Data  02.10.00 
Ĵ
Descrio  Imprime os aumentos programados        					  
Ĵ
Sintaxe	  FImpAum() 												  
Ĵ
 Uso       CSAR050  											  	  
ٱ

*/
Static Function FImpAum()
Local cAuxCC	:= "!!!!!!!!!", cAuxFuncao:="!!!!"
Local cDet		:= ""                                 
Local cDescTp	:= ""     
Local lAtua     := .F.
Local l1Vez 	:= .T.
Local cDtAlt	:= ""

dbSelectArea("TRP")
If 	nOrdem == 1
	cIndCond:= "TR_FILIAL+TR_MAT+DTOS(TR_DTALT)"
	wCabec1	:= STR0011			//"FIL MATRIC NOME DO FUNCIONARIO                SALARIO CAT FUNCAO                     CENTRO DE CUSTO"
								//  99 999999-123456789012345678901234567890 99999999999 123 12345-12345678901234567890 123456789-123456789012345678901234567890
ElseIf nOrdem == 2
	cIndCond := "TR_FILIAL+TR_FUNCAO+TR_MAT+DTOS(TR_DTALT)"
	wCabec1 := STR0012 			//"FIL MATRIC NOME DO FUNCIONARIO                SALARIO CAT CENTRO DE CUSTO"
ElseIf nOrdem == 3
	cIndCond := "TR_FILIAL+TR_CC+TR_MAT+DTOS(TR_DTALT)"
	wCabec1	:= STR0013			//"FIL MATRIC NOME DO FUNCIONARIO                SALARIO CAT FUNCAO"
Endif			

cTRPNtx  := CriaTrab(NIL,.f.)
IndRegua("TRP",cTRPNtx,cIndCond,,,STR0014)		//"Selecionando Registros..."
dbGoTop()

SetRegua(TRP->(RecCount()))

While ! Eof()                          

	IncRegua()                                
	
	lAtua:= .F.   
	
	If 	!l1Vez	
		cDet := ""
		IMPR(cDet,"C")			
	EndIf
	
	If l1Vez	
		l1Vez := .F.
	EndIf
	
	If 	nOrdem ==1    
		cArq	:= "TRP->TR_FILIAL+TRP->TR_MAT"
		cChave	:= TRP->TR_FILIAL+TRP->TR_MAT
		//"Fil Matric Nome do Funcionario            Salario        Cat Funcao                    Centro de Custo"
		//  99 999999-123456789012345678901234567890 99999999999999 123 1234-12345678901234567890 123456789-123456789012345678901234567890
		cDet:= 	Space(01)+TRP->TR_FILIAL+Space(1)+TRP->TR_MAT+Space(1)+Substr(TRP->TR_NOME,1,29)+Space(1)
		cDet+=	Transform(TRP->TR_SALARI,"@E 999,999,999.99")+Space(01)
		cDet+=	TRP->TR_CATEG+Space(03)+TRP->TR_FUNCAO+"-"+DescFun(TRP->TR_FUNCAO+TRP->TR_FILIAL)+Space(01) 
		cDet+= 	TRP->TR_CC+"-"+Space(01)+DescCC(TRP->TR_CC,TRP->TR_FILIAL)					
		IMPR(cDet,"C")
		IMPR("","C")

	ElseIf nOrdem ==2                             
		cArq	:= "TRP->TR_FILIAL+TRP->TR_FUNCAO+TRP->TR_MAT"
		cChave	:= TRP->TR_FILIAL+TRP->TR_FUNCAO+TRP->TR_MAT
		If 	cAuxFuncao # TRP->TR_FUNCAO
			cDet	:= STR0015 + TRP->TR_FUNCAO+"-"+DescFun(TRP->TR_FUNCAO+TRP->TR_FILIAL)		//"FUNCAO: "
			IMPR(cDet,"C")
			cAuxFuncao	:= TRP->TR_FUNCAO
		EndIf	
		//"Fil Matric Nome do Funcionario            Salario     Cat Centro de Custo"
		//  99 999999-123456789012345678901234567890 99999999999 123 1234-12345678901234567890 123456789-123456789012345678901234567890
		cDet:= 	Space(01)+TRP->TR_FILIAL+Space(1)+TRP->TR_MAT+Space(1)+Substr(TRP->TR_NOME,1,29)+Space(1)
		cDet+=	Transform(TRP->TR_SALARI,"@E 999,999,999.99")+Space(01)
		cDet+=	TRP->TR_CATEG+Space(03)
		cDet+= 	TRP->TR_CC+"-"+Space(01)+DescCC(TRP->TR_CC,TRP->TR_FILIAL)					
		IMPR(cDet,"C")  
		IMPR("","C")

	ElseIf nOrdem ==3                                          
		cArq	:= "TRP->TR_FILIAL+TRP->TR_CC+TRP->TR_MAT"
		cChave	:= TRP->TR_FILIAL+TRP->TR_CC+TRP->TR_MAT
		If 	cAuxCC # TRP->TR_CC
			cDet	:= STR0016 + TRP->TR_CC+"-"+Space(01)+DescCC(TRP->TR_CC,TRP->TR_FILIAL)	//"CENTRO DE CUSTO: "
			IMPR(cDet,"C")
			cAuxCC	:= TRP->TR_CC
		EndIf	
		//"Fil Matric Nome do Funcionario            Salario     Cat Funcao"                   
		//  99 999999-123456789012345678901234567890 99999999999 123 1234-12345678901234567890 
		cDet:= 	Space(01)+TRP->TR_FILIAL+Space(1)+TRP->TR_MAT+Space(1)+Substr(TRP->TR_NOME,1,29)+Space(1)
		cDet+=	Transform(TRP->TR_SALARI,"@E 999,999,999.99")+Space(01)
		cDet+=	TRP->TR_CATEG+Space(03)+TRP->TR_FUNCAO+"-"+DescFun(TRP->TR_FUNCAO+TRP->TR_FILIAL)+Space(01) 
		IMPR(cDet,"C")
		IMPR("","C")
	EndIf
	
	cDet	:= 	STR0017		//	"    DT.AUMENTO TP.AUMENTO                     SALARIO CAT FUNCAO                    CARGO                      ATUALIZADO"
//								"    99/99/99   001-123456789012345       999999999999 123 1234-12345678901234567890 12345-12345678901234567890 123
    IMPR(cDet,"C")
                      
   	cDtAlt := 	If(__SetCentury(),DTOC(TRP->TR_DTALT),DTOC(TRP->TR_DTALT)+Space(2))
   	
    cDet	:= Space(04)+cDtAlt+Space(01)
   cDet+= TRP->TR_TPALT+"-"+Subst(FDesc("X41","41"+TRP->TR_TPALT,fDescSX5(2)),1,15)+Space(6)
   cDet+= Transform(TRP->TR_PERCEN,"@E 999.99")+Space(01)
   cDet+= Transform(TRP->TR_PSAL,"@E 999,999,999.99")+Space(01)
   cDet+= TRP->TR_PCATEG+Space(03)+TRP->TR_PFUNCAO+"-"+DescFun(TRP->TR_PFUNCAO,TRP->TR_FILIAL)
   cDet+= Space(01)+TRP->TR_CARGO+"-"+Subst(fDesc("SQ3",TRP->TR_CARGO,"Q3_DESCSUM"),1,20)
   cDet+= Space(01) + If(TRP->TR_ATUALIZ="S",STR0018,STR0019)	//"SIM"###"NAO"
    IMPR(cDet,"C")    
	
	While !Eof() .And. &cArq == cChave
	
		IncRegua()                     
		        
		If 	lAtua                                    
		
			cDtAlt := 	If(__SetCentury(),DTOC(TRP->TR_DTALT),DTOC(TRP->TR_DTALT)+Space(2))
			
		    cDet	:= Space(04)+cDtAlt+Space(01)
		   cDet+= TRP->TR_TPALT+"-"+Subst(FDesc("X41","41"+TRP->TR_TPALT,fDescSX5(2)),1,15)+Space(13)
			cDet+= Transform(TRP->TR_PERCEN,"@E 999.99")+Space(01)
		   cDet+= Transform(TRP->TR_PSAL,"@E 999,999,999.99")+Space(01)
		   cDet+= TRP->TR_PCATEG+Space(03)+TRP->TR_PFUNCAO+"-"+DescFun(TRP->TR_PFUNCAO,TRP->TR_FILIAL)
		   cDet+= Space(01)+TRP->TR_CARGO+"-"+Subst(fDesc("SQ3",TRP->TR_CARGO,"Q3_DESCSUM"),1,20)
		   cDet+= Space(01) + If(TRP->TR_ATUALIZ="S",STR0018,STR0019)	//"SIM"###"NAO"
		    IMPR(cDet,"C")
		EndIf

		lAtua	:= .T.
		dbSkip()
		
	EndDo	
	IMPR(__PrtThinLine(),"C")     
EndDo

Return 			

Static Function VerificaRB7()
Local aArea := GetArea()
Local lRet := .T.

DbSelectArea("SX3")
DbSetOrder(2)

If !dbSeek("RB7_CARGO")
	lRet := .F.
EndIf

RestArea(aArea)

Return lRet