#INCLUDE "Protheus.ch"
#INCLUDE "CSAR060.CH"

/*

Ŀ
Funcao	  CSAR060   Autor  Eduardo Ju             Data  11.08.06 
Ĵ
Descricao  Relatorio de Quadro de Vagas de uma empresa.     		  
Ĵ
Sintaxe	  CSAR060(void)											  
Ĵ
 		ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.			  
Ĵ
Programador  Data	 BOPS   Motivo da Alteracao			 		  
Ĵ
Marcelo     05/06/08145816Correcao da funcao PrintReport p/ imprimir
                          corretamente em ambientes codebase.       
Leandro Dr. 16/03/09005777Correcao na utilizacao do percentual de   
                          encargos na soma c/ o Valor Previsto.      
Fco Junior  13/10/09025338Compatibilizacao versao  Corporativa.     
Allyson M.  05/05/1009831/Correcao do filtro do relatorio R3 p/ que 
                      2010seja possivel filtro por CC.     		  
Luis Artuso 20/11/12026392Correcao na query que gera o arquivo tem- 
                      2012porario.                        		  
ٱ

*/ 

Function CSAR060()

Local oReport
Local aArea := GetArea()

Private cAliasQry := "RBD"

If FindFunction("TRepInUse") .And. TRepInUse()	//Verifica se relatorio personalizavel esta disponivel
	//Ŀ
	// Verifica as perguntas selecionadas                           
	//
 
	Pergunte("CSR60R",.F.)
	oReport := ReportDef()
	oReport:PrintDialog()	              
Else
	CSAR060R3()	
EndIf  

RestArea( aArea )

Return

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  11.08.06 
Ĵ
Descrio Definicao do Componente de Impressao do Relatorio           
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function ReportDef()

Local oReport
Local oSection1	
Local oSection2
Local oSection3	
Local oSection4
Local aOrd	  := {STR0004}  		//"Centro de Custo"

//Ŀ
//Criacao do componente de impressao                                      
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
oReport:=TReport():New("CSAR060",STR0008,"CSR60R",{|oReport| PrintReport(oReport)},STR0022)	// "Quadro de Funcionarios"#"Ser impresso de acordo com os parametros solicitados pelo usuario"
Pergunte("CSR60R",.F.)
 
//******************* Relatorio Analitico **********************
//Ŀ
// Criacao da Primeira Secao: "Quadro Funcionario Por Funo" 
// 
oSection1 := TRSection():New(oReport,STR0015,{"RBD"},aOrd,/*Campos do SX3*/,/*Campos do SIX*/)	//Quadro Funcionario Por Funo
oSection1:SetHeaderBreak(.T.)   

TRCell():New(oSection1,"RBD_FILIAL","RBD")					//Filial 
TRCell():New(oSection1,"RBD_CC","RBD")						//Centro de Custo
TRCell():New(oSection1,"CTT_DESC01","CTT","")				//Descricao do Centro de Custo
TRCell():New(oSection1,"RBD_ANOMES","RBD")					//Ano/Mes

#IFNDEF TOP 
	TRPosition():New(oSection1,"CTT",1,{|| RHFilial('CTT',(cAliasQry)->RBD_FILIAL) + (cAliasQry)->RBD_CC})
#ENDIF

//Ŀ
// Criacao da Segunda Secao: Aumento Programado 
//
oSection2 := TRSection():New(oSection1,STR0023,{"RBD"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)		//Aumento Programado
oSection2:SetTotalInLine(.F.)  
oSection2:SetHeaderBreak(.T.)
oSection2:SetLeftMargin(3)	//Identacao da Secao

TRCell():New(oSection2,"RBD_FUNCAO","RBD")					//Funcao
TRCell():New(oSection2,"RJ_DESC","SRJ","")					//Descricao da Funcao
TRCell():New(oSection2,"RBD_VLATUA","RBD")					//Valor do Salario Atual
TRCell():New(oSection2,"RBD_VLPREV","RBD")					//Valor do Salario Previsto
TRCell():New(oSection2,"ATUAENCARG","   ",STR0016,TM(99999999,12,MsDecimais(1)),,,{|| If(mv_par04 <= 0,(cAliasQry)->RBD_VLATUA,(cAliasQry)->RBD_VLATUA * (1+ (mv_par04 /100)) ) })	//Valor do Salario Atual + Encargos
TRCell():New(oSection2,"PREVENCARG","   ",STR0017,TM(99999999,12,MsDecimais(1)),,,{|| If(mv_par04 <= 0,(cAliasQry)->RBD_VLPREV,(cAliasQry)->RBD_VLPREV * (1+ (mv_par04 /100)) ) })//Valor do Salario Previsto + Encargos
TRCell():New(oSection2,"RBD_VLAPRO","RBD")					//Valor Aprovado
TRCell():New(oSection2,"RBD_QTATUA","RBD")					//Nr. Funcionario Atual
TRCell():New(oSection2,"RBD_QTPREV","RBD")					//Nr. Funcionario Previsto
TRCell():New(oSection2,"RBD_QTAPRO","RBD")					//Nr. Funcionario Aprovado

oSection2:SetTotalText({|| STR0018 + oSection1:Cell("RBD_ANOMES"):GetValue(.T.)})  

TRFunction():New(oSection2:Cell("RBD_VLATUA"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection2:Cell("RBD_VLPREV"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection2:Cell("ATUAENCARG"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection2:Cell("PREVENCARG"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection2:Cell("RBD_VLAPRO"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection2:Cell("RBD_QTATUA"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection2:Cell("RBD_QTPREV"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)
TRFunction():New(oSection2:Cell("RBD_QTAPRO"),/*cId*/,"SUM",/*oBreak*/,/*cTitle*/,/*cPicture*/,/*uFormula*/,/*lEndSection*/,.F./*lEndReport*/,/*lEndPage*/)

#IFNDEF TOP 
	TRPosition():New(oSection2,"SRJ",1,{|| xFilial("SRJ") + (cAliasQry)->RBD_FUNCAO})
#ENDIF

//********************** Relatorio Sintetico ************************
//Ŀ
// Criacao da Primeira Secao: "Cadastro de Quadro de Funcionarios" 
// 
oSection3 := TRSection():New(oReport,STR0019,{"RB8"},/*aOrdem,/*Campos do SX3*/,/*Campos do SIX*/)	//"Cadastro de Quadro de Funcionarios"	
oSection3:SetTotalInLine(.T.)  
oSection3:SetHeaderBreak(.T.)   

TRCell():New(oSection3,"RB8_FILIAL","RB8")					//Filial 
TRCell():New(oSection3,"RB8_CC","RB8")						//Centro de Custo
TRCell():New(oSection3,"CTT_DESC01","CTT","")					//Descricao do Centro de Custo
#IFNDEF TOP 
	TRPosition():New(oSection3,"CTT",1,{|| RHFilial('CTT',(cAliasQry)->RB8_FILIAL) + (cAliasQry)->RB8_CC})
#ENDIF

//Ŀ
// Criacao da Segunda Secao: Aumento Programado 
//
oSection4 := TRSection():New(oSection3,STR0024,{"RB8"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)		//Aumento Programado
oSection4:SetHeaderBreak(.T.)
oSection4:SetLeftMargin(3)	//Identacao da Secao

TRCell():New(oSection4,"RB8_ANOMES","RB8")					//Ano/Mes
TRCell():New(oSection4,"RB8_VLATUA","RB8")					//Valor do Salario Atual
TRCell():New(oSection4,"RB8_VLPREV","RB8")					//Valor do Salario Previsto
TRCell():New(oSection4,"RB8_VLATUA","RB8",STR0016,,,,{|| If(mv_par04 <= 0,(cAliasQry)->RB8_VLATUA,(cAliasQry)->RB8_VLATUA * (1+ (mv_par04 /100)) ) })	//Valor do Salario Atual + Encargos
TRCell():New(oSection4,"RB8_VLPREV","RB8",STR0017,,,,{|| If(mv_par04 <= 0,(cAliasQry)->RB8_VLPREV,(cAliasQry)->RB8_VLPREV * (1+ (mv_par04 /100)) ) })	//Valor do Salario Previsto + Encargos
TRCell():New(oSection4,"RB8_NRATUA","RB8",STR0020)			//Nr. Funcionario Atual
TRCell():New(oSection4,"RB8_NRPREV","RB8",STR0021)			//Nr. Funcionario Previsto

Return oReport 

/*

Ŀ
Funo    ReportDef()  Autor  Eduardo Ju           Data  11.08.06 
Ĵ
Descrio Impressao do Relatorio                                      
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function PrintReport(oReport)

Local oSection1 := If ( mv_par05 = 1,oReport:Section(1),oReport:Section(2) )	//Analitico#Sintetico
Local oSection2 := oSection1:Section(1)
Local lAcesso	:=	.F. // Tabela compartilhada ou Exclusiva
Local lGeraString	:=	.T.
Local nIni	:= 0
Local nAnd	:= 0
Local nFim	:= 0
Local cPar01	:=	""
Local nTamFil	:=	0
Local nTamPar	:= 0	

#IFDEF TOP
	Local lQuery    := .F. 
	Local cOrder	:= "" 
	Local cSitQuery	:= ""
#ELSE
	Local cFiltro:= ""
#ENDIF

//Ŀ
// Variaveis utilizadas para parametros                                          
// mv_par01        //  Filial?                                                   
// mv_par02        //  Centro de Custo ?                                         
// mv_par03        //  Ano/Mes?                                                  
// mv_par04        // % Encargos?                                                
// mv_par05        //  Imprimir: 1-Analitico; 2-Sintetico?                       
// 

If mv_par05 == 1  
	cAliasQry := "RBD"
Else
	cAliasQry := "RB8"
Endif	
#IFNDEF TOP

	//Ŀ
	// Transforma parametros Range em expressao (intervalo) 
	//
	MakeAdvplExpr("CSR60R")	                                  	

	If !Empty(mv_par01)	//RBD_FILIAL
		mv_par01 := If(xFilial(cAliasQry) == Space(FWGetTamFilial), Space(FWGetTamFilial), xFilial(cAliasQry))
		cFiltro += mv_par01 
	EndIf  
	
	If !Empty(mv_par02)	//RBD_CC
		cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
		cFiltro += mv_par02
	EndIf  
	
	If !Empty(mv_par03)	//RBD_ANOMES
		cFiltro += Iif(!Empty(cFiltro)," .AND. ","")
		cFiltro += mv_par03
	EndIf  
	
	//Ŀ
	// Filtro para a Tabela Principal da Secao Pai  
	//
	oSection1:SetFilter(cFiltro)	  
	
	If mv_par05 == 1	//Analitico
		oSection2:SetParentFilter({|cParam| (cAliasQry)->RBD_CC + (cAliasQry)->RBD_ANOMES == cParam},{|| (cAliasQry)->RBD_CC + (cAliasQry)->RBD_ANOMES})
  		oReport:SetMeter((cAliasQry)->(LastRec()))
  	Else
	  	oSection2:SetParentFilter({|cParam| (cAliasQry)->RB8_CC == cParam},{|| (cAliasQry)->RB8_CC})
  		oReport:SetMeter((cAliasQry)->(LastRec()))	
	EndIf 
	
	oSection1:Print() //Imprimir 
	
#ELSE

	lAcesso	:=	FWModeAccess(cAliasQry)	== "C" // Verifica se a tabela eh compartilhada.
	
	If ( lAcesso )
	              
		nTamFil	:=	LEN(ALLTRIM(xFilial(cAliasQry)))
		nTamPar	:=	LEN(MV_PAR01)
		cPar01	:= 	""
		nIni	:= 0
		nFim	:= 0
		
		Do While ( lGeraString )

			nIni	:=	nFim
			++nFim

			If ( (EMPTY(SUBSTR(MV_PAR01 , nFim , 1))) .OR. (nFim > nTamPar ) )
			    	
				lGeraString	:=	.F.
				
			Else
				
				nAnd	:= 0
				Do While ( (!SUBSTR(MV_PAR01 , nFim++ , 1) == ";") .AND. (nFim <= nTamPar ) )
				
					If ( SUBSTR(MV_PAR01 , nFim , 1) == "-")
					
						nAnd	:= nFim // Guarda a posicao do separador "E" da Query.
					
					EndIf
										
				EndDo
				
				If ( nAnd == 0 )			
					
					cPar01	+=	SUBSTR( MV_PAR01 , ++nIni , nTamFil ) + ";"
				
				Else				
					
					cPar01	+=	SUBSTR( MV_PAR01 , ++nIni , nTamFil ) + SUBSTR( MV_PAR01 , nAnd , nTamFil + 1 ) + ";"	
				
				EndIf
			
			EndIf
						
		EndDo
				
		MV_PAR01	:=	cPar01
		
	EndIf
	//Ŀ
	// Transforma parametros Range em expressao SQL 
	//
	MakeSqlExpr("CSR60R")    
	 
	cAliasQry := GetNextAlias()
	//-- Filtragem do relatrio
	//-- Query do relatrio da secao 1
	lQuery := .T.         
		                                           
	//oReport:Section(1):BeginQuery()	
	Begin Report Query oSection1
	
 	If mv_par05 == 1	//Analitico
 	
 		cOrder := "%RBD_FILIAL,RBD_CC%" 

		BeginSql Alias cAliasQry	
			SELECT RBD_FILIAL,RBD_CC,CTT_DESC01,RBD_ANOMES,RBD_FUNCAO,RJ_DESC,RBD_VLATUA,RBD_VLPREV,RBD_VLAPRO,RBD_QTATUA,RBD_QTPREV,RBD_QTAPRO
			FROM 	%table:RBD% RBD 
			LEFT JOIN %table:CTT% CTT
				ON CTT_FILIAL = %xFilial:CTT%
				AND CTT_CUSTO = RBD_CC
				AND CTT.%NotDel%
			LEFT JOIN %table:SRJ% SRJ
				ON RJ_FILIAL = %xFilial:SRJ%
				AND RJ_FUNCAO = RBD_FUNCAO
				AND SRJ.%NotDel%				
			WHERE RBD_FILIAL = %xFilial:RBD% AND
				RBD.%NotDel%   													
			ORDER BY %Exp:cOrder%                 				
		EndSql
	
	Else
	
		cOrder := "%RB8_FILIAL,RB8_CC%" 

		BeginSql Alias cAliasQry	
			SELECT RB8_FILIAL,RB8_CC,CTT_DESC01,RB8_ANOMES,RB8_VLATUA,RB8_VLPREV,RB8_NRATUA,RB8_NRPREV
			FROM 	%table:RB8% RB8 
			LEFT JOIN %table:CTT% CTT
				ON CTT_FILIAL = %xFilial:CTT%
				AND CTT_CUSTO = RB8_CC
				AND CTT.%NotDel%
			WHERE RB8_FILIAL = %xFilial:RB8% AND
				RB8.%NotDel%   													
			ORDER BY %Exp:cOrder%                 				
		EndSql
	
	EndIf

	//Ŀ
	//Metodo EndQuery ( Classe TRSection )                                    
	//Prepara o relatrio para executar o Embedded SQL.                       
	//ExpA1 : Array com os parametros do tipo Range                           
	//
//	oReport:Section(1):EndQuery({mv_par01,mv_par02})	/*Array com os parametros do tipo Range*/
	END REPORT QUERY oSection1 PARAM mv_par01, mv_par02, mv_par03		
	//Ŀ
	// Utiliza a query do Pai  
	//
	oSection2:SetParentQuery()                                
	
	//Ŀ
	// Inicio da impressao do fluxo do relatrio 
	//     
	If mv_par05 == 1	//Analitico
		oSection2:SetParentFilter({|cParam| (cAliasQry)->RBD_FILIAL+(cAliasQry)->RBD_CC + (cAliasQry)->RBD_ANOMES == cParam},{|| (cAliasQry)->RBD_FILIAL+(cAliasQry)->RBD_CC + (cAliasQry)->RBD_ANOMES})
  		oReport:SetMeter((cAliasQry)->(LastRec()))
  	Else	//Sintetico
	  	oSection2:SetParentFilter({|cParam| (cAliasQry)->RB8_CC == cParam},{|| (cAliasQry)->RB8_CC})
  		oReport:SetMeter((cAliasQry)->(LastRec()))	
	EndIf
	
	oSection1:Print()	 //Imprimir
#ENDIF

Return Nil      

/*

Ŀ
Funcao    Cs60rFilial  Autor  Eduardo Ju           Data  14/08/06 
Ĵ
Descricao Conteudo do X1_CNT01 do parametro mv_par01 *X1_GRUPO CSR60R 
Ĵ
Parametros                                                            
Ĵ
 Uso       CSAR060                                                    
ٱ

*/
Function Cs60rFilial()

Local cSvAlias 	:= Alias()
Local cX1_CNT01 := ''

If mv_par05 == 1
	cX1_CNT01 := 'RBD_FILIAL'
Else 
	cX1_CNT01 := 'RB8_FILIAL'
EndIf	

DbSelectArea(cSvAlias)

Return cX1_CNT01

/*

Ŀ
Funcao    Cs60rcc      Autor  Eduardo Ju           Data  14/08/06 
Ĵ
Descricao Conteudo do X1_CNT01 do parametro mv_par02 *X1_GRUPO CSR60R 
Ĵ
Parametros                                                            
Ĵ
 Uso       CSAR060                                                    
ٱ

*/
Function Cs60rcc()

Local cSvAlias 	:= Alias()
Local cX1_CNT01 := ''

If mv_par05 == 1
	cX1_CNT01 := 'RBD_CC'
Else 
	cX1_CNT01 := 'RB8_CC'
EndIf	

DbSelectArea(cSvAlias)

Return cX1_CNT01         

/*

Ŀ
Funcao    Cs60ranomes  Autor  Eduardo Ju           Data  14/08/06 
Ĵ
Descricao Conteudo do X1_CNT01 do parametro mv_par01 *X1_GRUPO CSR60R 
Ĵ
Parametros                                                            
Ĵ
 Uso       CSAR060                                                    
ٱ

*/
Function Cs60ranomes()

Local cSvAlias 	:= Alias()
Local cX1_CNT01 := ''

If mv_par05 == 1
	cX1_CNT01 := 'RBD_ANOMES'
Else 
	cX1_CNT01 := 'RB8_ANOMES'
EndIf	

DbSelectArea(cSvAlias)

Return cX1_CNT01
   

/*

Ŀ
Funo	  CSAR060   Autor  R.H. - Cristina  Ogura Data  02.10.00 
Ĵ
Descrio  Relatorio de Quadro de Vagas de uma empresa.     		  
Ĵ
Sintaxe	  CSAR060(void)											  
Ĵ
 		ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.			  
Ĵ
Programador  Data	 BOPS   Motivo da Alteracao			 		  
Ĵ
                          										  
ٱ

*/
Function CSAR060R3()

Local cDesc1  := STR0001		//"Relao do Quadro de Funcionarios de uma Empresa."
Local cDesc2  := STR0002		//"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  := STR0003		//"usuario."
Local cString := "RB8"
Local cAux	  := ""
Local aOrd	  := {STR0004}  		//"Centro de Custo"
Local aMeses  := {}

Private nImprime := 0
Private aReturn  := {STR0005,1,STR0006,2,2,1,"",1 } //"Zebrado"###"Administrao"
Private NomeProg := "CSAR060"
Private aLinha	 := {}
Private nLastKey := 0
Private cPerg	 := "CSR060"
Private nOrdem 	 := 1
Private AT_PRG	 := "CSAR060"
Private wCabec0  := 1
Private wCabec1	 := STR0007 	//"     ANO/MES     VL ATUAL  VL PREVISTO  VL ATUAL+ENCARG  VL PREV+ENCARG  NR ATUAL  NR PREVISTO"
								//      9999/01 123456789012 123456789012     123456789012    123456789012    123456       123456
Private Contfl  := 1
Private Li		:= 0
Private nTamanho:= "M"
Private TITULO  := STR0008		//" Quadro de Funcionarios "
Private cFilDe	:= ""
Private cFilAte	:= ""
Private cCCDe	:= ""
Private cCCAte	:= ""
Private cDtDe	:= ""
Private cDtAte	:= ""
Private nPercent:= 0
Private cAlias	:= ""

//Ŀ
// Verifica as perguntas selecionadas                           
//
pergunte("CSR060",.F.)

//Ŀ
// Variaveis utilizadas na pergunte                                 
// mv_par01				// Filial De                             
// mv_par02				// Filial Ate                            
// mv_par03				// Centro de Custo De                    
// mv_par04				// Centro de Custo Ate                   
// mv_par05				// Ano/Mes De                            
// mv_par06				// Ano/Mes Ate                           
// mv_par07				// % Custo do Funcionario                
// mv_par08				// Imprime: 1 - Analitico / 2- Sintetico 
//

cAlias := "RB8"

//Ŀ
// Envia controle para a funcao SETPRINT						 
//
wnrel	:= "CSAR060"            //Nome Default do relatorio em Disco
wnrel	:= SetPrint(cAlias,wnrel,cPerg,@TITULO,cDesc1,cDesc2,cDesc3,.F.,aOrd)

//Ŀ
// Carregando variaveis mv_par?? para Variaveis do Sistema.	 
//
cFilDe	:= mv_par01
cFilAte	:= mv_par02
cCCDe	:= mv_par03
cCCAte	:= mv_par04
cDtDe	:= mv_par05
cDtAte	:= mv_par06
nPercent:= mv_par07
nImprime:= mv_par08

cAlias	:= If (nImprime == 2,"RB8","RBD") //Define qual arquivo utilizar/1= Analitico - 2=Sintetico
If mv_par08 == 1                    // 1 - Analitico 2 - Sintetico
	wCabec1	 :=	STR0011	 // ANO/MES    FUNCAO                 VL.ATUAL  VL.PREVISTO  VL.ATUAL+ENCARG  VL.PREV+ENCARG  VL.APROVADO  QT.ATUAL QT.PREV. QT.APROV.//
EndIf

If 	Val(Substr(cDtDe,1,4)) < 1900 .Or.;
	Val(Substr(cDtAte,1,4)) < 1900
	Help("",1,"CSR060ANO")      // Verifique o Ano das perguntes
	Return Nil
EndIf

If	Val(Substr(cDtDe,5,2)) < 1 	.Or.;
	Val(Substr(cDtDe,5,2)) > 12 	.Or.;
	Val(Substr(cDtAte,5,2)) < 1 	.Or.;
	Val(Substr(cDtAte,5,2)) > 12
	Help("",1,"CSR060MES")		// Verifique o Mes das perguntes
	Return Nil
EndIf

If 	cDtDe > cDtAte
	Help("",1,"CSR060MAIO")	// Ano/Mes De deve ser menor que ANO/MES Ate
	Return Nil
EndIf

cAux := cDtDe
While Val( cAux ) <= Val( cDtAte)
	//	Aadd(aMeses,{ cAux , 0 , 0 , 0 , 0 } )	// AnoMes, Nr atual, Nr Previsto, Vl Atual, Vl Previsto
	nMes := Val(Substr(cAux,5,2)) + 1
	nAno := Val(Substr(cAux,1,4))
	If nMes > 12
		cAux := StrZero(nAno + 1,4) + "01"
	Else		//RELATORIO ANALITICO - 1 RBD
		cAux := StrZero(nAno,4) + StrZero(nMes,2)
	EndIf
EndDo

nOrdem  := aReturn[8]

If 	nLastKey == 27
	Return Nil
EndIf

SetDefault(aReturn,cString)

If 	nLastKey == 27
	Return Nil
EndIf

RptStatus({|lEnd| Cs060Imp()},TITULO)

Return

/*


Ŀ
Funo	  CS060Imp  Autor  R.H. - Cristina Ogura  Data  02.10.00 
Ĵ
Descrio  Imprime os quadros de vagas das empresas.          		  
Ĵ
Sintaxe	  Cs060Imp()												  
Ĵ
 Uso       Generico 											  	  
ٱ

*/
Function Cs060Imp()
Local cAcessaRB8:= &("{ || " + ChkRH(FunName(),(cAlias),"2") + "}")
Local cInicio	:= ""
Local cFim		:= ""
Local cFil		:= ""
Local cAuxCC 	:= "!!!!!!!!!"
Local cAuxFun 	:= "!!!!!!!!!"
Local nVlAtual	:= 0
Local nVlPrev 	:= 0
Local nTotCc  	:= 0
Local l1Vez		:= .T.
Local cFunc		:= ""
Local cAli		:= ""
Local nP_VLATUA := nP_VLPREV := nP_VLAPRO := nP_QTATUA := nP_QTPREV := nP_ATU_ENC :=nP_PRE_ENC :=nP_QTAPRO := 0	//Totais Periodo
Local cPE_ANT   := ""
Local cAnoMesAnt:= ""
Local cCC_ANT 	:= ""

Local cPicVlr   := TM(99999999,12,MsDecimais(1))
Local cPicQtd   := "@E 999999"

dbSelectArea(cAlias)
dbSetOrder(1)

//--  Verificando compartilhamento de Arquivos para selecao inicial
cFilDe := If(xFilial(cAlias) == Space(FWGetTamFilial), Space(FWGetTamFilial), xFilial(cAlias))

dbSeek(cFilDe+cCCDe,.T.)

If mv_par08 == 2	//2 - RELATORIO SINTETICO - RB8
	
	cInicio := "RB8->RB8_FILIAL+RB8->RB8_CC"
	cFim    := cFilAte+cCCAte
Else             //1 - RELATORIO ANALITICO - RBD
	cInicio := "RBD->RBD_FILIAL+RBD->RBD_CC
	cFim    := cFilAte+cCCAte
	
EndIf

SetRegua((cAlias)->(RecCount()))
cAnomesAnt:="999"

While	!Eof() .And. &cInicio <= cFim
	
	If !Eval(cAcessaRB8)
		dbSkip()
		Loop
	EndIf

	cAli	:= If (nImprime == 2,"RB8->RB8","RBD->RBD") 

	If &(cAli+"_FILIAL") < cFilDe .Or. &(cAli+"_FILIAL") > cFilAte
		dbSkip()
		Loop
	EndIf
	
	If &(cAli+"_CC") < cCCDe .Or. &(cAli+"_CC") > cCCAte
		dbSkip()
		Loop
	EndIf
	
	If &(cAli+"_ANOMES") < cDtDe .Or. &(cAli+"_ANOMES") > cDtAte
		dbSkip()
		Loop
	EndIf
	
	If mv_par08 == 2		//RELATORIO SINTETICO - 2 RB8
		
		If	RB8->RB8_ANOMES < cDtDe			.Or.;
			RB8->RB8_ANOMES > cDtAte
			dbSkip()
			Loop
		EndIf
	Else 				   //RELATORIO ANALITICO - 1 RBD
		
		If	RBD->RBD_ANOMES < cDtDe			.Or.;
			RBD->RBD_ANOMES > cDtAte
			dbSkip()
			Loop
		EndIf
	EndIf
	
	IncRegua()
	If 	!l1Vez
		cDet := ""
		IMPR(cDet,"C")
	EndIf
	
	//"     ANO/MES     VL ATUAL  VL PREVISTO  VL ATUAL+ENCARG  VL PREV+ENCARG  NR ATUAL  NR PREVISTO"
	//      9999/01 123456789012 123456789012     123456789012    123456789012    123456       123456
	
	If mv_par08 == 2 ////RELATORIO SINTETICO - 2 RB8
		
		If 	cAuxCC # RB8->RB8_CC
			
			If li>52
				Impr("","P")
				
			ElseIf 	!l1Vez
				cDet :=__PrtThinLine()
				IMPR(cDet,"C")
			EndIf
			If  l1Vez
				l1Vez := .F.
			EndIf                       
			
			If xFilial(cAlias) == Space(FWGetTamFilial)
				cDet	:= SPACE(01)+STR0009+RB8->RB8_CC+Space(01)+DescCC(RB8->RB8_CC,xFilial("SI3"),25)	//"Centro de Custo: "
			Else 
				cDet	:= SPACE(01)+STR0010+RB8->RB8_FILIAL+SPACE(05)+STR0009+RB8->RB8_CC+Space(01)+DescCC(RB8->RB8_CC,xFilial("SI3"),25)	//"Centro de Custo: "
			EndIf	
			
			cAuxCC 	:= RB8->RB8_CC
			Impr(cDet,"C")
			cDet 	:= " "
			IMPR(cDet,"C")
		EndIf
		
		
		If	(li > 55 .And. cAuxCC == RB8->RB8_CC)
			
			Impr("","P")
			
			If xFilial(cAlias) == Space(FWGetTamFilial)
				cDet	:= SPACE(01)+STR0009+RB8->RB8_CC+Space(01)+DescCC(RB8->RB8_CC,xFilial("SI3"),25)	//"Centro de Custo: "
			Else
				cDet	:= SPACE(01)+STR0010+RB8->RB8_FILIAL+SPACE(05)+STR0009+RB8->RB8_CC+Space(01)+DescCC(RB8->RB8_CC,xFilial("SI3"),25)	//"Centro de Custo: "
			EndIf	                        
			
			cAuxCC 	:= RB8->RB8_CC
			Impr(cDet,"C")
			cDet 	:= " "
			IMPR(cDet,"C")
		EndIf
		
		If 	nPercent <= 0
			nVlAtual	:= RB8->RB8_VLATUA
			nVlPrev		:= RB8->RB8_VLPREV
		Else
			nVlAtual	:= RB8->RB8_VLATUA * (1+ (nPercent /100))
			nVlPrev		:= RB8->RB8_VLPREV * (1+ (nPercent /100))
		EndIf
		
		cDet:= 	Space(05)+Substr(RB8->RB8_ANOMES,1,4)+"/"+Substr(RB8->RB8_ANOMES,5,2)
		cDet+= 	Space(01)+Transform(RB8->RB8_VLATUA,cPicVlr)
		cDet+= 	Space(01)+Transform(RB8->RB8_VLPREV,cPicVlr)
		cDet+= 	Space(05)+Transform(nVlAtual,cPicVlr)
		cDet+= 	Space(04)+Transform(nVlPrev,cPicVlr)
		cDet+= 	Space(04)+Transform(RB8->RB8_NRATUA,cPicQtd)
		cDet+=	Space(07)+Transform(RB8->RB8_NRPREV,cPicQtd)
		
		IMPR(cDet,"C")
		dbSelectArea("RB8")
		dbSetOrder(1)
		dbSkip()
		
	Else		//RELATORIO ANALITICO - 1 RBD
		
		cFunc	:= RBD->RBD_FUNCAO
		cDet	:= Space(01)+RBD->RBD_FILIAL
		If 	cAuxCC # RBD->RBD_CC
			If	li >= 52
				Impr("","P")
				
			ElseIf 	!l1Vez
				cDet :=__PrtThinLine()
				IMPR(cDet,"C")
			EndIf
			If  l1Vez
				l1Vez := .F.
			EndIf                 
			     
			If xFilial(cAlias) == Space(FWGetTamFilial)
				cDet	:= SPACE(01)+ STR0009 +RBD->RBD_CC+Space(01)+DescCC(RBD->RBD_CC,xFilial("SI3"),25)	//"Centro de Custo: "
			Else
				cDet	:= SPACE(01)+STR0010+RBD->RBD_FILIAL+SPACE(03)+ STR0009 +RBD->RBD_CC+Space(01)+DescCC(RBD->RBD_CC,xFilial("SI3"),25)	//"Centro de Custo: "
			EndIf
				
			cAuxCC 	:= RBD->RBD_CC
			Impr(cDet,"C")
			cDet 	:= ""
			IMPR(cDet,"C")
		EndIf
		If	(li > 55 .And. cAuxCC == RBD->RBD_CC)
			
			Impr("","P")
			
			If xFilial(cAlias) == Space(FWGetTamFilial)			
				cDet	:= SPACE(01)+ STR0009 +RBD->RBD_CC+Space(01)+DescCC(RBD->RBD_CC,xFilial("SI3"),25)	//"Centro de Custo: "
			Else               
				cDet	:= SPACE(01)+STR0010+RBD->RBD_FILIAL+SPACE(03)+ STR0009 +RBD->RBD_CC+Space(01)+DescCC(RBD->RBD_CC,xFilial("SI3"),25)	//"Centro de Custo: "
			EndIf	
			
			cAuxCC 	:= RBD->RBD_CC
			Impr(cDet,"C")
			cDet 	:= ""
			IMPR(cDet,"C")
		EndIf
		
		If 	nPercent <= 0
			nVlAtual	:= RBD->RBD_VLATUA
			nVlPrev		:= RBD->RBD_VLPREV
		Else
			nVlAtual	:= RBD->RBD_VLATUA * (1+ (nPercent /100))
			nVlPrev		:= RBD->RBD_VLPREV * (1+ (nPercent /100))
		EndIf
		
		If  cAnoMesAnt # RBD->RBD_ANOMES .or. cCC_ANT # RBD->RBD_CC
			cAnoMesAnt 	:= RBD->RBD_ANOMES
			cCC_ANT 	:= RBD->RBD_CC
			cDet		:= Space(01)+Substr(RBD->RBD_ANOMES,1,4)+"/"+Substr(RBD->RBD_ANOMES,5,2)
		Else
			cDet:= SPACE(08)
		EndIf
		cDet+= 	Space(01)+cFunc+" - "+FDesc("SRJ",cFunc,"RJ_DESC",20)
		cDet+= 	Space(01)+Transform(RBD->RBD_VLATUA,cPicVlr)
		cDet+= 	Space(01)+Transform(RBD->RBD_VLPREV,cPicVlr)
		cDet+= 	Space(02)+Transform(nVlAtual,cPicVlr)
		cDet+= 	Space(02)+Transform(nVlPrev,cPicVlr)
		cDet+= 	Space(01)+Transform(RBD->RBD_VLAPRO,cPicVlr)
		cDet+= 	Space(02)+Transform(RBD->RBD_QTATUA,cPicQtd)
		cDet+=	Space(03)+Transform(RBD->RBD_QTPREV,cPicQtd)
		cDet+=	Space(04)+Transform(RBD->RBD_QTAPRO,cPicQtd)
		IMPR(cDet,"C")
		
		nP_VLATUA += RBD->RBD_VLATUA
		nP_VLPREV += RBD->RBD_VLPREV
		nP_ATU_ENC+= nVlAtual
		nP_PRE_ENC+= nVlPrev
		nP_VLAPRO += RBD->RBD_VLAPRO
		nP_QTATUA += RBD->RBD_QTATUA
		nP_QTPREV += RBD->RBD_QTPREV
		nP_QTAPRO += RBD->RBD_QTAPRO
		
		cPE_ANT   :=RBD->RBD_ANOMES
		cCC_ANT	  :=RBD->RBD_CC
		
		dbSelectArea("RBD")
		dbSetOrder(1)
		dbSkip()
		
		If cPE_ANT # RBD->RBD_ANOMES .OR.;
			cCC_ANT # RBD->RBD_CC
			
			If Li > 54
				Impr("","P")
			EndIf
			cDet := __PrtThinLine()
			Impr(cDet,"C")
			
			cDet:= 	Space(05)+STR0012	//"Total do Periodo - "
			cDet+= 	Space(01)+Substr(cPE_ANT,1,4)+"/"+Substr(cPE_ANT,5,2)+ Space(09)
			cDet+= 	Space(01)+Transform(nP_VLATUA,cPicVlr)
			cDet+= 	Space(01)+Transform(nP_VLPREV,cPicVlr)
			cDet+= 	Space(02)+Transform(nP_ATU_ENC,cPicVlr)
			cDet+= 	Space(02)+Transform(nP_PRE_ENC,cPicVlr)
			cDet+= 	Space(01)+Transform(nP_VLAPRO,cPicVlr)
			cDet+= 	Space(02)+Transform(nP_QTATUA,cPicQtd)
			cDet+=	Space(03)+Transform(nP_QTPREV,cPicQtd)
			cDet+=	Space(04)+Transform(nP_QTAPRO,cPicQtd)
			Impr(cDet,"C")
			
			cDet := __PrtThinLine()
			Impr(cDet,"C")
			
			nP_VLATUA := 0
			nP_VLPREV := 0
			nP_ATU_ENC:= 0
			nP_PRE_ENC:= 0
			nP_VLAPRO := 0
			nP_QTATUA := 0
			nP_QTPREV := 0
			nP_QTAPRO := 0
			
		EndIf
	Endif
EndDo

//--Termino do Relatorio                                         
IMPR("","F")

Set Device To Screen
dbSelectArea("RBD")
dbSetOrder(1)
dbSelectArea("RB8")
dbSetOrder(1)
If aReturn[5] == 1
	Set Printer To
	Commit
	ourspool(wnrel)
EndIf

MS_FLUSH()

Return
