#INCLUDE "Protheus.CH"
#INCLUDE "CSAR070.CH"        
#INCLUDE "Report.ch"

/*

Ŀ
Funo     CSAR070   Autor  Emerson Grassi Rocha   Data  19/06/2006 
Ĵ
Descrio  Relatorio de Tabela Salarial (Grafico)                       
Ĵ
Sintaxe    CSAR070(void)                                                
Ĵ
Parametros                                                              
Ĵ
 Uso       Generico                                                     
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.               
Ĵ
Programador  Data      BOPS   Motivo da Alteracao                     
Ĵ
Tania       15/09/2006100290Relatorio convertido para o formato perso-
                            nalizavel, para o release 4.               
Luiz Gustavo|30/01/2007MelhorRetiradas funcoes de ajuste de dicionario.
Eduardo Ju  20/03/2007116234Inclusao do Cabecalho da Tab.Salarial: RBR
Eduardo Ju  25/02/2008140473Atualizacao: Impressao do Relatorio em R3.
Francisco Jr22/02/2010002930Tratamento de filiais para Gestao Corpora- 
                        2010tiva.                                     
Allyson M.  09/06/201010199/Ajuste para corrigir a impressao dos valo- 
                        2010res da tabela salarial no relatorio R3.    
ٱ

*/
Function CSAR070()
Local oReport
Local aArea := GetArea()

Private cAliasQry	:= "RBR"

If FindFunction("TRepInUse") .And. TRepInUse()	//Verifica se relatorio personalizal esta disponivel

	pergunte("CSR071",.F.)
	oReport := ReportDef()
	oReport:PrintDialog()	
Else
	CSAR070R3()	
EndIf  

RestArea( aArea )

Return

/*

Ŀ
Funo    ReportDef()  Autor  Emerson Grassi Rocha Data  19/06/06 
Ĵ
Descrio Definicao do Componente de Impressao do Relatorio           
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function ReportDef()

Local oReport
Local oSection1
Local oSection2
Local oSection3
Local aOrdem    := {}

//Ŀ
//Criacao do componente de impressao                                      
//TReport():New                                                           
//ExpC1 : Nome do relatorio                                               
//ExpC2 : Titulo                                                          
//ExpC3 : Pergunte                                                        
//ExpB4 : Bloco de codigo que sera executado na confirmacao da impressao  
//ExpC5 : Descricao                                                       
//
oReport:=TReport():New("CSAR070",STR0001,"CSR071",{|oReport| PrintReport(oReport)},OemToAnsi(STR0014))	
//"Impressao de Tabela Salarial."###"Este relatorio lista a Tabela Salarial conforme Nivel e Classe selecionados pelo usuario."
oReport:SetTotalInLine(.F.) 

//Ŀ
//Criacao da celulas da secao do relatorio                                
//TRCell():New                                                            
//ExpO1 : Objeto TSection que a secao pertence                            
//ExpC2 : Nome da celula do relatrio. O SX3 ser consultado              
//ExpC3 : Nome da tabela de referencia da celula                          
//ExpC4 : Titulo da celula                                                
//        Default : X3Titulo()                                            
//ExpC5 : Picture                                                         
//        Default : X3_PICTURE                                            
//ExpC6 : Tamanho                                                         
//        Default : X3_TAMANHO                                            
//ExpL7 : Informe se o tamanho esta em pixel                              
//        Default : False                                                 
//ExpB8 : Bloco de cdigo para impressao.                                 
//        Default : ExpC2                                                 
//
//Ŀ
// Criacao da Primeira Secao:
// 
oSection1 := TRSection():New(oReport,OemToAnsi(STR0007),{"RBR"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//"Tabela Salarial"
oSection1:SetTotalInLine(.F.)
TRCell():New(oSection1,"RBR_FILIAL","RBR")	//"Filial da Tabela Salarial"
TRCell():New(oSection1,"RBR_TABELA","RBR",STR0011)	//"Codigo da Tabela Salarial"
TRCell():New(oSection1,"RBR_DESCTA","RBR","")		//Descricao da Tabela
TRCell():New(oSection1,"RBR_DTREF","RBR")			//Data de Referencia da Tabela Salarial
TRCell():New(oSection1,"RBR_VLREF","RBR")			//Valor de Referencia da Tabela Salarial
TRCell():New(oSection1,"RBR_APLIC","RBR",STR0017,,12,,{|| If ( (cAliasQry)->RBR_APLIC == "1",STR0018,STR0019 ) }) //"Situacao da Tabela"#"Aplicada"#"No Aplicada" 

oSection1:SetLineStyle()  

//Ŀ
// Criacao da Segunda Secao: 
//
oSection2 := TRSection():New(oSection1,OemToansi(STR0015),{"RB6","RBR","RBF","SQ3"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//Classes e Cargos
oSection2:SetTotalInLine(.F.) 
TRCell():New(oSection2,"RB6_CLASSE","RB6")			//Classe Salarial
TRCell():New(oSection2,"RBF_DESC","RBF","")		//Descricao da Classe
TRCell():New(oSection2,"Q3_CARGO","SQ3",STR0010) 	//Cargo
TRCell():New(oSection2,"Q3_DESCSUM","SQ3","")		//Descricao do Cargo   
oSection2:SetLeftMargin(3)
#IFNDEF TOP                                                                                                       
	TRPosition():New(oSection2,"RB6",3,{|| RhFilial("RB6",RBR->RBR_FILIAL)+RBR->RBR_TABELA+DTOS(RBR->RBR_DTREF)},.T.)
	TRPosition():New(oSection2,"RBF",1,{|| RhFilial("RBF",RB6->RB6_FILIAL)+RB6->RB6_CLASSE},.T.)
#ENDIF	

//Ŀ
// Criacao da Terceira Secao:
//
oSection3 := TrSection():New(oSection1,OemToAnsi(STR0016),{"RB6","RBR"},/*aOrdem*/,/*Campos do SX3*/,/*Campos do SIX*/)	//"Niveis, Faixas e Pontos"
TRCell():New(oSection3,"RB6_NIVEL","RB6",STR0012)	//"Nivel"
TRCell():New(oSection3,"RB6_FAIXA","RB6",STR0013)	//"Faixa"
TRCell():New(oSection3,"RB6_COEFIC","RB6")			//"Coeficiente da Faixa"
TRCell():New(oSection3,"RB6_VALOR","RB6")			//Valor
TRCell():New(oSection3,"RB6_PTOMIN","RB6",STR0009)	//"Pontos"
TRCell():New(oSection3,"RB6_PTOMAX","RB6","")		//
oSection3:SetLeftMargin(5)

#IFNDEF TOP                                                                                                       
	TRPosition():New(oSection3,"RB6",3,{|| RhFilial("RB6",RBR->RBR_FILIAL)+RBR->RBR_TABELA+DTOS(RBR->RBR_DTREF)},.T.)
#ENDIF	

Return oReport

/*

Ŀ
Funo    PrintReport  Autor  Emerson Grassi Rocha Data  19/06/06 
Ĵ
Descrio Impressao do Relatorio (Tabela Salarial)		              
Ĵ
Parametros                                                            
Ĵ
 Uso                                                                  
ٱ

*/
Static Function PrintReport(oReport)

Local cAcessaRBR:= &("{ || " + ChkRH(FunName(),"RBR","2") + "}")
Local oSection1 := oReport:Section(1)
Local oSection2 := oReport:Section(1):Section(1)  
Local oSection3 := oReport:Section(1):Section(2)

Local cTab		:= ""
Local cFilRbf	:= ""
Local cFilRb6	:= ""
Local cFilSq3	:= "" 
Local cAliasSq3	:= ""

//Ŀ
// Variaveis utilizadas na pergunte                                 
// mv_par01				// Filial De                             
// mv_par02				// Filial Ate                            
// mv_par03				// Tabela Salarial De                    
// mv_par04				// Tabela Salarial Ate                   
// mv_par05				// Data de Referencia De                 
// mv_par06				// Data de Referencia Ate                
// mv_par07				// Nivel da Tabela De                    
// mv_par08				// Nivel da Tabela Ate                   
// mv_par09				// Classe Salarial De 					 
// mv_par10				// Classe Salarial Ate 					 
// mv_par11				// Listar Cargos    	 				 
//
Local cFiltro	:= ""
Local lQuery    := .F. 
Local cWhere	:= ""
Local cOrder	:= ""                                                                                  


//Ŀ
// Suprimir os Cargos		      
//
If mv_par11 == 2
	oSection2:Cell("Q3_CARGO"):Disable()
	oSection2:Cell("Q3_DESCSUM"):Disable()
EndIf                   
        


#IFDEF TOP	
	//-- Filtragem do relatrio
	//-- Query do relatrio da secao 1
	lQuery := .T.          
	cAliasQry := GetNextAlias()
	cAliasSq3 := GetNextAlias()
    
	
	cFilRb6 := Iif(RhFilial("RB6",RBR->RBR_FILIAL) == Space(FwGetTamFilial), "%AND RB6.RB6_FILIAL  = '" + Space(FwGetTamFilial) + "'%","%AND RB6.RB6_FILIAL = RBR.RBR_FILIAL%")
	cFilRbf := Iif(RhFilial("RBF",RBR->RBR_FILIAL) == Space(FwGetTamFilial), "%AND RBF.RBF_FILIAL  = '" + Space(FwGetTamFilial) + "'%","%AND RBF.RBF_FILIAL = RBR.RBR_FILIAL%")
	cFilSq3 := Iif(RhFilial("SQ3",RBR->RBR_FILIAL) == Space(FwGetTamFilial), "%AND SQ3.Q3_FILIAL   = '" + Space(FwGetTamFilial) + "'%","%AND SQ3.Q3_FILIAL  = RBR.RBR_FILIAL%")
	
		
	BEGIN REPORT QUERY oSection1

	BeginSql Alias cAliasQry
	
		SELECT 	RBR_FILIAL,RBR_TABELA,RBR_DESCTA,RBR_DTREF,RBR_VLREF,RBR_APLIC,RB6_FILIAL,RB6_TABELA,
				RB6_CLASSE,RBF_DESC,RB6_NIVEL,RB6_COEFIC,RB6_FAIXA,RB6_VALOR,RB6_PTOMIN,RB6_PTOMAX
		FROM 	%table:RBR% RBR
		                                                                                                                
		LEFT JOIN %table:RB6% RB6
			ON  RB6_TABELA = RBR_TABELA %Exp:cFilRb6%
			AND RB6_DTREF = RBR_DTREF
			AND RB6.%NotDel%  
		
		LEFT JOIN %table:RBF% RBF
			ON  RBF_CLASSE = RB6_CLASSE %Exp:cFilRbf%
			AND RBF.%NotDel%  
		WHERE RBR_FILIAL 	>= %Exp:mv_par01% AND RBR_FILIAL 	<= %Exp:mv_par02%
			AND RBR_TABELA 	>= %Exp:mv_par03% AND RBR_TABELA 	<= %Exp:mv_par04%
			AND RBR_DTREF 	>= %Exp:mv_par05% AND RBR_DTREF 	<= %Exp:mv_par06%			
			AND RB6_NIVEL 	>= %Exp:mv_par07% AND RB6_NIVEL 	<= %Exp:mv_par08%
			AND RB6_CLASSE 	>= %Exp:mv_par09% AND RB6_CLASSE	<= %Exp:mv_par10%			
			AND RBR.%NotDel%   										
		ORDER BY RBR_FILIAL,RBR_TABELA,RBR_DTREF,RB6_NIVEL,RB6_FAIXA,RB6_CLASSE
	EndSql

	//Ŀ
	//Metodo EndQuery ( Classe TRSection )                                    
	//Prepara o relatrio para executar o Embedded SQL.                       
	//ExpA1 : Array com os parametros do tipo Range                           
	//
	END REPORT QUERY oSection1 
	
	BEGIN REPORT QUERY oSection2

	BeginSql Alias cAliasSQ3

		SELECT DISTINCT RBR_FILIAL,RBR_TABELA,RBR_DTREF,RB6_CLASSE,Q3_CARGO, Q3_DESCSUM,RBF_DESC
		FROM 	%table:RBR% RBR
		
		LEFT JOIN %table:RB6% RB6   
			ON RB6_TABELA = RBR.RBR_TABELA 	%Exp:cFilRb6% 
			AND RB6_DTREF = RBR.RBR_DTREF
			AND RB6.%NotDel% 
		
		LEFT JOIN %table:SQ3% SQ3
			ON SQ3.Q3_CLASSE = RB6.RB6_CLASSE  %exp:cFilSq3%
			AND SQ3.%NotDel%  	

		LEFT JOIN %table:RBF% RBF   
			ON RBF_CLASSE = RB6.RB6_CLASSE 	%Exp:cFilRbf%
			AND RBF.%NotDel% 
			 			 										
		WHERE RBR_FILIAL	>= %Exp:mv_par01% AND RBR_FILIAL 	<= %Exp:mv_par02% 
			AND RBR_TABELA 	>= %Exp:mv_par03% AND RBR_TABELA 	<= %Exp:mv_par04%
			AND RBR_DTREF 	>= %Exp:mv_par05% AND RBR_DTREF 	<= %Exp:mv_par06%
			AND RB6_NIVEL 	>= %Exp:mv_par07% AND RB6_NIVEL 	<= %Exp:mv_par08%
			AND RB6_CLASSE 	>= %Exp:mv_par09% AND RB6_CLASSE 	<= %Exp:mv_par10%			
			AND RB6.%NotDel%   										
			AND RBR.RBR_TABELA= %report_param: (cAliasQry)->RBR_TABELA%
			AND RBR.RBR_DTREF = %report_param: (cAliasQry)->RBR_DTREF%
			AND RB6_CLASSE = %report_param: (cAliasQry)->RB6_CLASSE%
		ORDER BY RBR_FILIAL,RBR_TABELA,RBR_DTREF,RB6_CLASSE
	EndSql

	//Ŀ
	//Metodo EndQuery ( Classe TRSection )                                    
	//Prepara o relatrio para executar o Embedded SQL.                       
	//ExpA1 : Array com os parametros do tipo Range                           
	//
	END REPORT QUERY oSection2

	oSection3:SetParentQuery()
 	oSection3:SetParentFilter({|cParam| (cAliasQry)->RBR_FILIAL+(cAliasQry)->RBR_TABELA+DTOS((cAliasQry)->(RBR_DTREF))+(cAliasQry)->RB6_CLASSE == cParam},{|| (cAliasQry)->RBR_FILIAL+(cAliasQry)->RBR_TABELA+DTOS((cAliasQry)->(RBR_DTREF))+(cAliasQry)->RB6_CLASSE}) 
	
	lSec1First := .T.
	lSec2First := .T.
	/*oSection1:SetLineCondition({|| If(lSec1First, oSection1:Show(), oSection1:Hide()), ;
											 lSec1First := .F., lSec2First := .T. ,.T. })*/	
	oSection1:SetLineCondition({|| lSec2First := .T., .T. })
	oSection2:SetLineCondition({|| fHideCargo(@oSection2, @lSec2First), 	;
									Iif(mv_par11==2 .And. Empty((cAliasSq3)->RB6_CLASSE),.F.,.T.) })       
	
	dbSelectArea(cAliasQry)
	dbGoTop()

	oReport:SetMeter((cAliasQry)->(LastRec()))

	oSection1:Print()    
	
#ELSE

	cAliasQry := "RB6"    
	cAliasSq3 := "SQ3"
	cFiltro += "RB6_FILIAL >= '" + mv_par02 + "' .AND. "
	cFiltro += "RB6_FILIAL <= '" + mv_par03 + "' .AND. "
	cFiltro += "RB6_TABELA == '" + mv_par01 + "' .AND. "
	cFiltro += "RB6_NIVEL >= '" + mv_par04 + "' .AND. "
	cFiltro += "RB6_NIVEL <= '" + mv_par05 + "' .AND. "   
	cFiltro += "RB6_CLASSE >= '" + mv_par06 + "' .AND. "
	cFiltro += "RB6_CLASSE <= '" + mv_par07 + "'"   
	
	//Define um filtro para a tabela principal da secao
	oSection1:SetFilter(cFiltro)
	RB6->(DbSetOrder(1))

	//-- Condicao de impressao do Processo
	oSection1:SetLineCondition({|| ((cAliasQry)->RB6_TABELA == mv_par01) }) 

	dbSelectArea(cAliasQry)
	dbGoTop()

	oReport:SetMeter((cAliasQry)->(LastRec()))

	If !((cAliasQry)->(Eof()))
	                                  
	   oSection1:Init()		//Tabela
		oSection1:PrintLine()
		oSection1:Finish()
	    	    
	    cTab := (cAliasQry)->RB6_TABELA
	    While !Eof() .And. cTab == (cAliasQry)->RB6_TABELA
	        
			oReport:IncMeter()
			
			If oReport:Cancel()
				Exit
			EndIf
	
			#IFNDEF TOP			
				If !Eval(cAcessaRBR)
					dbSkip()
					Loop
				EndIf
			#ENDIF
	
			cClasse := (cAliasQry)->RB6_CLASSE    
	            
	      oSection2:Init()	//Classe
			oSection2:Cell("RB6_CLASSE"):Show()	 
			oSection2:Cell("RBF_DESC"):Show()				
			        
			If mv_par08 == 1	//Imprime Cargos
				   	
	   		dbSelectArea(cAliasSq3)
	   		dbSetOrder(4)
	   		If (cAliasSq3)->(dbSeek(RhFilial(cAliasSq3,(cAliasQry)->RB6_FILIAL)+cClasse))
		   		While !Eof() .And. (cAliasSq3)->Q3_CLASSE == cClasse
	
		   			oSection2:PrintLine()
						oSection2:Cell("RB6_CLASSE"):Hide()	
						oSection2:Cell("RBF_DESC"):Hide()	
	   				(cAliasSq3)->(dbSkip())
		   		EndDo
		   	Else
					oSection2:PrintLine()		   	
				EndIf
		  Else
				oSection2:PrintLine()		   	
		  EndIF                               
	
		  oSection2:Finish()		
	
			dbSelectArea(cAliasQry)
	
	        oSection3:Init()	//Niveis
		    While !Eof() .And. cTab+cClasse == (cAliasQry)->RB6_TABELA+(cAliasQry)->RB6_CLASSE
				oSection3:PrintLine()
				(cAliasQry)->(dbSkip())
			EndDo	    
			oSection3:Finish()    
			
			oReport:FatLine()
			oReport:SkipLine()
		EndDo
	EndIf
	
#ENDIF
	
Return Nil

/*


Ŀ
Funo    fHideCargo      Autor  Tania Bronzeri    Data 15/09/2006
Ĵ
Descrio  Ajusta opcao do Sx1                                        
ٱ

*/
Function fHideCargo(oSection, lFirst)

Local lRetorno := .T.
	
	If lFirst
		oSection:Cell("RB6_CLASSE"):Show()	 
		oSection:Cell("RBF_DESC"):Show()				
	Else
		oSection:Cell("RB6_CLASSE"):Hide()	 
		oSection:Cell("RBF_DESC"):Hide()				
	EndIf
	
	lFirst := .F.

Return lRetorno

/*

Ŀ
Funo     CSAR070   Autor  Emerson Grassi Rocha   Data  18/08/03 
Ĵ
Descrio  Relatorio de Tabela Salarial 				              
Ĵ
Sintaxe    CSAR070(void)                                              
Ĵ
Parametros                                                            
Ĵ
 Uso       Generico                                                   
Ĵ
         ATUALIZACOES SOFRIDAS DESDE A CONSTRUAO INICIAL.             
Ĵ
Programador  Data    BOPS   Motivo da Alteracao                     
Ĵ
			   			   										  
ٱ

*/
Function CSAR070R3()

//Ŀ
// Define Variaveis Locais(Basicas)                             
//
Local cDesc1  	:= STR0001						//"Impressao de Tabela Salarial."
Local cDesc2  	:= STR0002						//"Ser impresso de acordo com os parametros solicitados pelo"
Local cDesc3  	:= STR0003						//"usurio."
Local cString 	:= "RBR"						// Alias do arquivo principal (Base)

//Ŀ
// Define Variaveis Private(Perguntas)                          
//
Private cFilDe	:=	""
Private cFilAte	:=	""
Private cTabDe	:=	""
Private cTabAte	:=	""
Private dDataDe	:=	Ctod("  /  /  ")
Private dDatAte	:=	Ctod("  /  /  ")
Private cNivDe	:=	""
Private cNivAte	:=	""
Private cClasDe	:=	""
Private cClasAte:=	""
Private lCargos	:= .F.

//Ŀ
// Define Variaveis Private(Basicas)                            
//
Private aReturn := {STR0004, 1,STR0005, 2, 2, 1, "",1 }	//"Zebrado"###"Administrao"
Private NomeProg:= "CSAR070"
Private aLinha  := {}
Private nLastKey:= 0
Private cPerg   := "CSR071"
Private nOrdem  := 0

//Ŀ
// Variaveis Utilizadas na funcao IMPR                          
//
Private Titulo	:= ""
Private AT_PRG  := "CSAR070"
Private wCabec0 := 2
Private wCabec1 := ""
Private wCabec2 := ""   
Private COLUNAS	:= 132
Private CONTFL  := 1
Private LI      := 0
Private nTamanho:= "M"

Pergunte("CSR071",.F.)             
//Ŀ
// Variaveis utilizadas na pergunte                                 
// mv_par01				// Filial De                             
// mv_par02				// Filial Ate                            
// mv_par03				// Tabela Salarial De                    
// mv_par04				// Tabela Salarial Ate                   
// mv_par05				// Data de Referencia De                 
// mv_par06				// Data de Referencia Ate                
// mv_par07				// Nivel da Tabela De                    
// mv_par08				// Nivel da Tabela Ate                   
// mv_par09				// Classe Salarial De 					 
// mv_par10				// Classe Salarial Ate 					 
// mv_par11				// Listar Cargos    	 				 
//
Titulo := STR0006			// "RELATORIO DE TABELA SALARIAL"

//Ŀ
// Envia controle para a funcao SETPRINT                        
//
wnrel:="CSAR070"            //Nome Default do relatorio em Disco
wnrel:=SetPrint(cString,wnrel,cPerg,@Titulo,cDesc1,cDesc2,cDesc3,.F.,,,nTamanho)

cFilDe	:=	If(!Empty(mv_par01),mv_par01,Space(FWGetTamFilial))
cFilAte	:=	If(!Empty(mv_par02),mv_par02,Replicate("Z",FWGetTamFilial))
cTabDe	:=	If(!Empty(mv_par03),mv_par03,"   ")
cTabAte	:=	If(!Empty(mv_par04),mv_par04,"999") 
dDataDe	:=	If(!Empty(mv_par05),mv_par05,Ctod("  /  /  "))
dDatAte	:=	If(!Empty(mv_par06),mv_par06,Ctod("31/12/08")) 
cNivDe	:=	If(!Empty(mv_par07),mv_par07,"  ")
cNivAte	:=	If(!Empty(mv_par08),mv_par08,"99") 
cClasDe	:=	If(!Empty(mv_par09),mv_par09,"   ")
cClasAte:=	If(!Empty(mv_par10),mv_par10,"999") 
lCargos	:=  (mv_par11 == 1)
                          
nOrdem := aReturn[8]
Titulo := STR0006			//"RELATORIO DE TABELA SALARIAL"	

If nLastKey == 27
	Return
EndIf

SetDefault(aReturn,cString)

If nLastKey == 27
	Return
EndIf

RptStatus({|lEnd| Cs070Imp(@lEnd,wnRel,cString)},Titulo)

Return

/*

Ŀ
Funo     CSAR070   Autor  Emerson Grassi Rocha   Data  18/08/03 
Ĵ
Descrio  Impressao Tabela Salarial                                  
Ĵ
Sintaxe    CS070Imp(lEnd,wnRel,cString)                               
Ĵ
Parametros lEnd        - Ao do Codelock                             
           wnRel       - Ttulo do relatrio                          
           cString     - Mensagem			                          
Ĵ
 Uso       CSAR070                                                    
ٱ

*/
Static Function Cs070Imp(lEnd,WnRel,cString)   

Local aSaveArea	:= GetArea()
Local cAcessaRBR:= &("{ || " + ChkRH(FunName(),"RBR","2") + "}")
Local nFaixa	:= 0
Local nX		:= 0
Local nY		:= 0
Local aCargos	:= {}
Local nCarg		:= 0
Local lLin1		:= .T.

dbSelectArea("RBR")
cFil := If(xFilial("RBR") == Space(FWGetTamFilial),Space(FWGetTamFilial),cFilDe)
dbSeek(cFil + cTabDe , .T.)
cInicio  := "RBR->RBR_FILIAL + RBR->RBR_TABELA"
cFim     := cFilAte + cTabAte

SetRegua(RBR->(RecCount()))

While !RBR->(Eof()) .And. &cInicio <= cFim

	IncRegua()
	
	If lEnd
		Exit
	EndIf 
    
   	If !Eval(cAcessaRBR)	//Alterar para RBR -> COLOCAR NO PRIMEIRO WHILE -EDU
		RBR->( dbSkip() )
		Loop
	EndIf
	
    If 	RBR->RBR_FILIAL  		< cFilDe  .Or.;
    	RBR->RBR_FILIAL  		> cFilAte .Or.;
    	RBR->RBR_TABELA  		< cTabDe  .Or.;
    	RBR->RBR_TABELA  		> cTabAte .Or.;
		RBR->RBR_DTREF  		< dDataDe .Or.;
    	RBR->RBR_DTREF 			> dDatAte
    	RBR->( dbSkip() )
    	Loop
    EndIf	              
        
	wCabec1	:= STR0020+": "+RBR->RBR_FILIAL+Space(2)+STR0011+": "+RBR->RBR_TABELA+"-"+RBR->RBR_DESCTA+Space(2)+STR0021+": "+Dtoc(RBR->RBR_DTREF)+Space(02)+STR0022+":"+Alltrim(Transform(RBR->RBR_VLREF,"@E 999,999,999.99"))+Space(2)+STR0017+ ": " + If(RBR->RBR_APLIC == "1",STR0018,STR0019) //Filial#Tabela#Data Refer.#Valor Refer.#Situao
	wCabec2:= STR0008	//"Classe Salarial            Cargos por Classe               Nivel Faixa    Coefic.        Valores                   Pontos   "
 	   
	RB6->( dbSetOrder(3) )  
	RB6->( dbSeek(RBR->RBR_FILIAL+RBR->RBR_TABELA+dToS(RBR->RBR_DTREF)) ) 
	
	While !RB6->(Eof()) .And. RB6->RB6_FILIAL+RB6->RB6_TABELA == RBR->RBR_FILIAL+RBR->RBR_TABELA	
	
	    If 	RB6->RB6_CLASSE < cClasDe .Or.;
	    	RB6->RB6_CLASSE > cClasAte
	    	RB6->( dbSkip() )
	    	Loop
	    EndIf	              
	                                              
		//Ŀ
		// Impressao dos dados da Tabela                                
		//
		cClasse := RB6->RB6_CLASSE
		aCargos	:= {}
		nCarg	:= 0
		   	
	   	If lCargos
			aCargos := Cs070Cargo(cClasse,RB6->RB6_FILIAL)
			nCarg	:= Len(aCargos)
		EndIf     
		
		nX 		:= 0
		lLin1 	:= .T.
		
	   	While RB6->( !Eof() ) .And.;
	   			RB6->RB6_FILIAL+RB6->RB6_TABELA == RBR->RBR_FILIAL+RBR->RBR_TABELA	 .And.;
	   			RB6->RB6_CLASSE == cClasse			
	
		    If 	RB6->RB6_NIVEL < cNivDe  .Or. RB6->RB6_NIVEL > cNivAte  .Or. RB6->RB6_DTREF <> RBR->RBR_DTREF
		    	RB6->( dbSkip() )
		    	Loop
		    EndIf   						  			
	   			
		    nX ++	
	    	cDet := ""
	    	If lLin1                                                    
	    		cDet += RB6->RB6_CLASSE + " - " + Fdesc("RBF",RB6->RB6_CLASSE,"RBF_DESC",20) + Space(01)	 
		        lLin1 := .F.
		    Else 
			    cDet += Space(27)	 	    			    
		    EndIf
	        	        
		    If lCargos .And. nCarg >= nX	// Imprime Cargos	    	
				cDet += aCargos[nX,1]+" - "+aCargos[nX,2]+Space(02)	 
			Else
				cDet += Space(35)
		    EndIf
		                         
		    cDet += RB6->RB6_NIVEL+Space(03)	 

		    If RB6->RB6_TIPOVL == 2 .Or. RB6->RB6_TIPOVL == 4	    
				cDet += cValToChar( StrZero(++nFaixa, 2) )+Space(01)
	        Else
			    cDet += RB6->RB6_FAIXA+Space(01)
			EndIf

		    cDet += STR(RB6->RB6_COEFIC,9,4)+Space(01)
		    
		    If RB6->RB6_TIPOVL == 2 .Or. RB6->RB6_TIPOVL == 4
		    	cDet += STR(RB6->RB6_VALOR,12,2)+" - "
		    	RB6->( dbSkip() )
	   	    	cDet += STR(RB6->RB6_VALOR,12,2)+Space(02)	 
		    Else
		    	cDet += STR(RB6->RB6_VALOR,12,2)+Space(17)	 
		    EndIf
	    	cDet += STR(RB6->RB6_PTOMIN,9,2)+" - "
	    	cDet += STR(RB6->RB6_PTOMAX,9,2)
	    				    
		    Impr(cDet,"C")    
		    
	   		RB6->( dbSkip() )
	   	EndDo   
	   	// Imprimir Restante dos Cargos da Classe
	   	If nCarg > nX
	   		nX++             
	   		For nY := nX to nCarg
	   			cDet := Space(33)
				cDet += aCargos[nY,1]+" - "+aCargos[nY,2]+Space(02)	 
			   	Impr(cDet,"C")
			Next nY
	   	EndIf
	   	
	   	cDet := Repl("-",COLUNAS)
	   	Impr(cDet,"C")
	    	
		dbSelectArea("RB6")
	EndDo

	RBR->( DbSkip() )          
	
	nFaixa := 0

	wCabec1	:= STR0020+": "+RBR->RBR_FILIAL+Space(2)+STR0011+": "+RBR->RBR_TABELA+"-"+RBR->RBR_DESCTA+Space(2)+STR0021+": "+Dtoc(RBR->RBR_DTREF)+Space(02)+STR0022+":"+Alltrim(Transform(RBR->RBR_VLREF,"@E 999,999,999.99"))+Space(2)+STR0017+ ": " + If(RBR->RBR_APLIC == "1",STR0018,STR0019) //Filial#Tabela#Data Refer.#Valor Refer.#Situao
	wCabec2 := STR0008	//"Classe Salarial            Cargos por Classe               Nivel Faixa    Coefic.        Valores                   Pontos   "
	
	Impr("","P")    
EndDo
	
//Ŀ
// Termino do relatorio                                         
//
dbSelectArea("RBR")
dbSetOrder(1)

Set Device To Screen
If aReturn[5] = 1
	Set Printer To
	Commit
	//Ŀ
	// Spool caso Opcao seja de Relatorio, senao sai apresenta-lo.  
	//
	ourspool(wnrel)
Endif

MS_FLUSH()

RestArea(aSaveArea)

Return

/*

Ŀ
Funo    Cs070Cargo Autor  Emerson Grassi Rocha   Data  18/08/03 
Ĵ
Descrio  Retorna Cargos de uma Classe Salarial                      
Ĵ
Sintaxe    CS070Cargo(cClasse)			                              
Ĵ
Parametros cClasse - Classe Salarial		                          
Ĵ
 Uso       CSAR070                                                    
ٱ

*/
Static Function Cs070Cargo(cClasse,cFilCorr)
Local aSaveArea	:= GetArea()
Local aClasse 	:= {}
Local cFilAux	:= ""

DEFAULT cFilCorr	:= cFilAnt

cFilAux		:= If(xFilial("SQ3") == Space(FWGetTamFilial),Space(FWGetTamFilial),cFilCorr)

dbSelectArea("SQ3")
dbSetOrder(4)
dbSeek(cFilAux+cClasse)
While !SQ3->(Eof()) .And. SQ3->Q3_CLASSE == cClasse .And. SQ3->Q3_FILIAL == cFilAux
	Aadd(aClasse, {SQ3->Q3_CARGO, Left(SQ3->Q3_DESCSUM,25)})
	SQ3->(dbSkip())
EndDo

RestArea(aSaveArea)
Return(aClasse)

